<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xmlns:json="http://json.org/">
  <!-- from https://gist.github.com/inancgumus/3ce56ddde6d5c93f3550b3b4cdc6bcb8 -->
  <!-- https://github.com/bramstein/xsltjson/blob/master/conf/xml-to-jsonml.xsl -->
  <xsl:output method="text" omit-xml-declaration="yes" encoding="utf-8"/>

  <xsl:template match="/*[node()]">
    <xsl:apply-templates select="." mode="obj-detect" />
  </xsl:template>

  <xsl:template match="*" mode="detect">
    <xsl:choose>
      <xsl:when test="count(./child::*) > 0 or count(@*) > 0">
        <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="obj-content" />
      </xsl:when>
      <xsl:when test="count(./child::*) = 0">
        <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="value"/>
      </xsl:when>
    </xsl:choose>
    <xsl:if test="count(following-sibling::*) &gt; 0">, </xsl:if>
  </xsl:template>

  <xsl:template match="*" mode="value">
    <xsl:text>"</xsl:text><xsl:apply-templates select="node/@TEXT | text()"/><xsl:text>"</xsl:text>
  </xsl:template>

  <xsl:template match="*" mode="obj-detect">
    {
    <xsl:choose>
      <xsl:when test="count(./child::*) > 0 or count(@*) > 0">
        <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="obj-content" />
      </xsl:when>
      <xsl:when test="count(./child::*) = 0">
        <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="value"/>
      </xsl:when>
    </xsl:choose>
    }
  </xsl:template>

  <!-- objects -->
  <xsl:template match="SEAInfo | StudentLEARelationship | SEAAccountability | SEAFederalFund | xCalendar | xContact | xCourse | xIndividualizedEducationPlan | xLea | xRoster | xSchool | xStaff | xStudent | xTransferIep | AggregateStatisticInfo | AggregateCharacteristicInfo | AggregateStatisticFact | StudentMeal | FoodserviceItem | FoodserviceItemUnit | FoodserviceItemPortion | FoodserviceReimbursementRates | FoodserviceMealPrices | StaffMeal | FoodserviceTransaction | FoodserviceTransactionDetails | FoodserviceTransactionPayMethod | FoodserviceSales | FoodserviceItemSales | FoodserviceMenuPlan | FoodserviceMilkSales | FoodservicePurchaseTransaction | FoodserviceStaffEnrollmentCount | FoodserviceStaffMealCounts | FoodserviceStudentEnrollmentCount | FoodserviceStudentMealCounts | StudentRecordExchange | StudentDemographicRecord | StudentAcademicRecord | StudentSpecialEducationRecord | StudentRecordPackage | MarkValueInfo | MarkInfo | SectionMarkInfo | StudentSectionMarks | GradingCategory | GradingAssignment | GradingAssignmentScore | StudentPeriodAttendance | OfficialStudentPeriodAttendance | StudentGrade | Billing | Payment | EmployeeAssignment | EmployeeContract | EmploymentRecord | EmployeePersonal | EmployeePicture | FinancialAnnual | FinancialBudget | TimeWorked | VendorInfo | W4 | EmployeeWage | LocationInfo | Purchasing | AccountingPeriod | FinancialAccount | FinancialAccountAccountingPeriodLocationInfo | FinancialClass | FinancialIncomeStatement | FinancialTransaction | FiscalYear | ActivityProvider | EmployeeCredit | EmployeeRecertification | EmployeeCredential | ProfessionalDevelopmentActivities | ProfessionalDevelopmentProgram | ProfessionalDevelopmentRegistration | StudentParticipation | StudentPlacement | TestAccommodation | StudentSpecialEducationSummary | StudentCareerTechnical | Assessment | AssessmentItem | ItemCharacteristics | AssessmentSubTest | AssessmentAdministration | AssessmentForm | AssessmentRegistration | StudentResponseSet | StudentScoreSet | AssessmentPackage | LearningStandardDocument | LearningStandardItem | CurriculumStructure | Lesson | Activity | Assignment | LearningResource | LearningResourcePackage | ContentCatalog | PersonRoleAssociation | ResponseToIntervention | RTIResults | LearningStandardAssociation | LibraryPatronStatus | Address | StudentProgramAssociation | StudentActivityInfo | StudentActivityParticipation | DisciplineIncident | CalendarSummary | CalendarDate | StudentAttendanceSummary | AttendanceCodeInfo | RoomInfo | RoomType | SchoolCourseInfo | SchoolInfo | SectionInfo | StaffPersonal | StudentContact | StudentDailyAttendance | StudentPersonal | StudentPicture | StudentSchoolEnrollment | StudentSectionEnrollment | TermInfo | StudentSnapshot | LEAInfo | StaffAssignment | BellSchedule | StudentContactPersonal | StudentContactRelationship | StaffSectionAssignment | StaffEvaluation | SectionCorrelation | SchoolAccountability | LEAAccountability | SchoolFederalFund | LEAFederalFund | StudentMigrant | BusEquipment | BusInfo | BusRouteDetail | BusRouteInfo | BusStopInfo | StudentTransportInfo | BusPositionInfo | Authentication | EnergyUsage | IdMApplication | IdMAuthentication | IdMAuthorization | UserOrganizationAssociation | PersonPrivacyObligationDocument" mode="obj-list">
    <xsl:if test="count(preceding-sibling::*) = 0">
      <xsl:text>[</xsl:text>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="count(./child::*) > 0 or count(@*) > 0">
        <xsl:apply-templates select="." mode="obj-detect" />
      </xsl:when>
    </xsl:choose>
    <xsl:if test="count(following-sibling::*) &gt; 0">, </xsl:if>
    <xsl:if test="count(following-sibling::*) = 0"><xsl:text>]</xsl:text></xsl:if>
  </xsl:template>

  <!-- numeric or boolean -->
  <xsl:template match="GridLocation/Latitude | GridLocation/Longitude | FeeForUse/PerUseCharge | FederalProgram/Code | FederalProgram/FundingAllocation | relationship/contactSequence | metric/accuracyPercentEvaluation | trialCountEvaluation/successCount | trialCountEvaluation/attemptCount | cycle/count | duration/directMinutes | duration/indirectMinutes | dataValue/category | dataValue/value | leastRestrictiveEnvironment/totalMinutesPerWeek | leastRestrictiveEnvironment/inclusionMinutesPerWeek | leastRestrictiveEnvironment/nonInclusionMinutesPerWeek | primaryStaff/percentResponsible | otherStaff/percentResponsible | academicSummary/cumulativeWeightedGpa | academicSummary/termWeightedGpa | academicSummary/classRank | AggregateStatisticFact/Value | FoodserviceItemUnit/GramWeight | FoodserviceItemPortion/ItemPortionQuantity | Rate/Value | Price/Value | FoodserviceTransaction/Tax | ItemQuantity/Value | ItemQuantity/Cost | MenuPlanQuantities/MenuPlanQuantity | SaleQuantity/Value | SaleQuantity/ChargeToChild | PurchaseQuantity/Value | Count/Tax | Count/Value | Race/Proportion | Percentage/Minimum | Percentage/Maximum | Numeric/Precision | Numeric/Scale | Numeric/Low | Numeric/High | ValidMark/NumericEquivalent | Narrative/MaximumSize | MarkData/Percentage | MarkData/Numeric | MarkData/NumericAsDecimal | MarkingPeriod/CourseCreditsAttempted | MarkingPeriod/CourseCreditsEarned | MarkingPeriod/DaysAbsent | MarkingPeriod/DaysPresent | TermPerformance/CreditsAttempted | TermPerformance/CreditsEarned | TermPerformance/GPACreditsAttempted | TermPerformance/GPACreditsEarned | TermPerformance/GPAGradePoints | TermPerformance/GPA | TermPerformance/WeightedGPA | TermPerformance/DaysAbsent | TermPerformance/DaysPresent | AcademicPerformanceSummary/TotalCreditsAttempted | AcademicPerformanceSummary/TotalCreditsEarned | AcademicPerformanceSummary/CumulativeGPACreditsEarned | AcademicPerformanceSummary/CumulativeGradePoints | AcademicPerformanceSummary/CumulativeGPA | AcademicPerformanceSummary/ClassRank | AcademicPerformanceSummary/ClassTotalNumber | StudentParticipationData/StudentSpecialEducationFTE | StudentParticipationData/DaysInParticipation | Mark/Percentage | Mark/Numeric | GradingAssignment/PointsPossible | GradingAssignment/Weight | GradingAssignmentScore/ScorePoints | GradingAssignmentScore/ScorePercent | Grade/Percentage | Grade/Numeric | Grade/OutOf | Grade/Low | Grade/High | Billing/BilledAmount | Payment/ReceivedAmount | EmployeeAssignment/JobFTE | EmployeeContract/BaseSalary | EmployeeContract/ContractDays | EmployeeContract/AssignmentDays | EmploymentRecord/TotalYearsExperience | AnnualItem/Amount | BudgetAccount/BudgetAmount | TimeWorked/RegularHours | TimeWorked/OvertimeHours | W4/FederalAllowancesNumber | W4/StateAllowancesNumber | PayRate/Amount | PayRate/Percentage | PurchasingItem/UnitCost | ExpenseAccount/Amount | EmployeeCredit/Earned | EmployeeRecertification/ActivityHours | EmployeeRecertification/Earned | EmployeeCredential/Salary | EmployeeCredential/TotalYears | EmployeeCredential/UnitYears | Assignment/FTE | ProfessionalDevelopmentActivities/ClockHours | ProfessionalDevelopmentActivities/Credits | ProfessionalDevelopmentActivities/Stipend | ProfessionalDevelopmentRegistration/PaidAmount | ProfessionalDevelopmentRegistration/Stipend | StudentParticipation/StudentSpecialEducationFTE | StudentPlacement/DirectTime | StudentPlacement/IndirectTime | StudentPlacement/TotalServiceDuration | StudentSpecialEducationSummary/StudentSpecialEducationFTE | NeglectedOrDelinquentParticipation/TotalDayCount | NeglectedOrDelinquentParticipation/ConsecutiveDayCount | ItemCharacteristics/PercentCorrect | ItemCharacteristics/SampleSize | Descriptive/SampleSize | Descriptive/PointBiserial | Descriptive/Biserial | Descriptive/DiscriminationIndex | DifferentialItemAnalysis/CMH | DifferentialItemAnalysis/MH | Choice/Responses | AssessmentSubTest/SubTestTier | AssessmentSubTest/NumberOfItems | Item/NumberOfAttempts | Score/NumberOfResponses | StandardHierarchyLevel/Number | CurriculumHierarchyLevel/Number | Lesson/Duration | Activity/Points | ActivityTime/Duration | Activity/MaxAttemptsAllowed | Activity/ActivityWeight | AssignmentTime/Duration | Assignment/MaxAttemptsAllowed | ContentCatalog/Duration | ContentCatalog/Cost | ResponseToIntervention/Tier | FrequencyTime/Duration | TargetObject/AssociationStrength | ItemInfo/Price | FineInfo/Amount | LibraryPatronStatus/NumberOfCheckouts | LibraryPatronStatus/NumberOfOverdues | LibraryPatronStatus/NumberOfFines | LibraryPatronStatus/FineAmount | LibraryPatronStatus/NumberOfRefunds | LibraryPatronStatus/RefundAmount | Action/Duration | IncidentAction/Duration | CalendarSummary/DaysInSession | CalendarSummary/InstructionalMinutes | CalendarSummary/MinutesPerDay | CalendarDate/CalendarDateNumber | StudentAttendance/AttendanceValue | TeacherAttendance/AttendanceValue | AdministratorAttendance/AttendanceValue | StudentAttendanceSummary/StartDay | StudentAttendanceSummary/EndDay | StudentAttendanceSummary/FTE | StudentAttendanceSummary/DaysAttended | StudentAttendanceSummary/ExcusedAbsences | StudentAttendanceSummary/UnexcusedAbsences | StudentAttendanceSummary/DaysTardy | StudentAttendanceSummary/DaysInMembership | StudentAttendanceSummary/ExpectationsMets | StudentAttendanceSummary/ExpectationsNotMets | AttendanceCodeInfo/AbsenceValue | RoomInfo/Size | RoomInfo/Capacity | SchoolCourseInfo/CourseCredits | SCEDCode/AvailableCredit | SCEDCode/SequenceNumber | SCEDCode/SequenceLimit | SchoolCourseInfoOverride/CourseCredits | StudentContact/ContactSequence | StudentSchoolEnrollment/FTE | StudentSectionEnrollment/CreditsAttempted | TermInfo/RelativeDuration | StudentSnapshot/Age | StaffAssignment/JobFTE | BellPeriod/InstructionalMinutes | StudentContactRelationship/ContactSequence | StaffSectionAssignment/PercentResponsible | SchoolFederalFund/SchoolImprovementAllocation | BusInfo/SeatingCapacity | Equipment/Count | BusRouteInfo/MaximumLoad | BusRouteInfo/RouteDistanceLoaded | BusRouteInfo/RouteDistanceTotal | StudentTransportInfo/HomeToSchoolDistance | StudentTransportInfo/WalkToStopDistance | StudentTransportInfo/StopToSchoolDistance | BusPositionInfo/Odometer | BusPositionInfo/Speedometer | ReadingData/Interval | ReadingList/Reading | TimeElement/IsCurrent | RightsElement/Cost | LEARelationshipType/ProvidingInstruction | LEARelationshipType/ProvidingServices | LEARelationshipType/FinanciallyResponsible | session/markingTerm | session/schedulingTerm | phoneNumber/primaryIndicator | relationship/livesWith | relationship/primaryContactIndicator | relationship/emergencyContactIndicator | relationship/financialResponsibilityIndicator | relationship/custodialIndicator | relationship/communicationsIndicator | costSharing/status | decisions/severeDiscrepancyFound | decisions/InsufficientResponseToInterventionFound | decisions/eligibleForSpecificLearningDisabilityFinding | decisions/specificDisabilityIdentified | primaryStaff/teacherOfRecord | otherStaff/teacherOfRecord | demographics/hispanicLatinoEthnicity | phone/primaryIndicator | SchoolCourseInfoData/CoreAcademicCourse | MarkingPeriod/ExcessiveAbsenceIndicator | StudentSectionMarks/IsFinal | StudentPeriodAttendance/ExpectationsMet | EmploymentRecord/Active | VendorInfo/Send1099 | W4/Exempt | StudentParticipation/ExtendedSchoolYear | StudentParticipation/ExtendedDay | StudentParticipation/PrivateNotPlacedByPublic | StudentPlacement/IncludedInSpecialEducationFTE | StudentPlacement/SpecialNeedsTransportation | StudentPlacement/AssistiveTechnology | Accommodation/SpecialMaterials | StudentSpecialEducationSummary/SpecificDisabilityIdentified | AssessmentSubTest/ContainerOnly | Assignment/AddToGradeBookFlag | StudentDailyAttendance/ExpectationsMet" mode="value">
    <xsl:call-template name="encode-numeric-value">
      <xsl:with-param name="value" select="." />
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="* | @*" mode="attrvalue">
    <xsl:text>"</xsl:text><xsl:apply-templates select="."/><xsl:text>"</xsl:text>
  </xsl:template>

  <!-- numeric or boolean attribute -->
  <xsl:template match="NEVERMATCH | NEVERMATCH" mode="attrvalue">
    <xsl:call-template name="encode-numeric-value">
      <xsl:with-param name="value" select="." />
    </xsl:call-template>
  </xsl:template>

  <!-- simple content with attribute -->
  <xsl:template match="Address/StateProvince | Address/StateANSICode | Address/Country | EmailList/Email | SEAContact/PublishInDirectory | SEAInfo/OperationalStatus | EDENInfo/FIPSStateCode | SEAInfo/CTEGraduationRateInclusion | FeeForUse/PerUseCharge | GradeLevel/Code | OtherCodeList/OtherCode | SubjectArea/Code | InterestLevel/Code | BloomsTaxonomyLevels/BloomsTaxonomyLevel | MultipleIntelligences/MultipleIntelligence | InstructionalStrategies/InstructionalStrategy | ResourceTypes/ResourceType | SIF_ExtendedElements/SIF_ExtendedElement | StudentLEARelationship/MembershipType | ResidencyStatus/Code | EntryType/Code | ExitType/Code | ExitStatus/Code | StudentLEARelationship/NonResidentAttendReason | SEAAccountability/HighSchoolGraduationRateIndicatorStatus | AggregateStatisticInfo/CalculationRule | ExclusionRules/ExclusionRule | Location/LocationRefId | AggregateStatisticInfo/Measure | AggregateStatisticFact/Excluded | Amounts/Amount | ElectronicIdList/ElectronicId | FoodserviceItemPortion/ItemPortionType | FoodserviceReimbursementRates/Program | FoodserviceMealPrices/Program | Price/Value | Price/MealType | FoodserviceTransaction/Program | TransactionTypes/TransactionType | FoodserviceTransaction/Amount | FoodserviceTransaction/Tax | FoodserviceTransaction/Voided | FoodserviceSales/Program | SalesAmounts/SalesAmount | FoodserviceItemSales/Program | ItemQuantity/MealType | ItemQuantity/Cost | FoodserviceMenuPlan/Program | MenuPlanQuantities/MenuPlanQuantity | FoodserviceMilkSales/Program | SaleQuantity/ChargeToChild | PurchaseQuantity/MealType | FoodserviceStaffEnrollmentCount/Program | Count/MealType | Count/Amount | Count/Tax | FoodserviceStaffMealCounts/Program | FoodserviceStudentEnrollmentCount/Program | FoodserviceStudentMealCounts/Program | OtherIdList/OtherId | Race/Code | DemographicsData/Gender | EnglishProficiency/Code | Language/Code | Language/LanguageType | DemographicsData/HispanicLatino | DemographicsData/CountryOfBirth | DwellingArrangement/Code | StudentPersonalData/IDEA | StudentPersonalData/Migrant | StudentPersonalData/Title1 | StudentPersonalData/GiftedTalented | StudentPersonalData/EconomicDisadvantage | StudentPersonalData/ELL | StudentPersonalData/Homeless | StudentPersonalData/Section504 | StudentPersonalData/VocationalConcentrator | StudentPersonalData/Immigrant | StudentPersonalData/NeglectedDelinquent | SchoolContact/PublishInDirectory | IdentificationInfoList/IdentificationInfo | StudentSchoolRelationship/MembershipType | StudentSchoolRelationship/NonResidentAttendReason | TermSpan/Code | InstructionalLevel/Code | SchoolCourseInfoData/GraduationRequirement | GradeLevelWhenTaken/Code | MarkingPeriod/CreditType | MediumOfInstruction/Code | TermPerformance/ProgressLevel | AcademicPerformanceSummary/GraduationRateSurveyIndicator | AcademicPerformanceSummary/AcademicTrack | AcademicFocus/Code | AcademicSubject/Code | StudentGradeLevelWhenAssessed/Code | Assessment/TestScoreType | Requirement/Status | ActivityAward/InvolvementCode | ActivityAward/HonorsInformationCode | ActivityAward/DiplomaCredentialHonorsCode | ActivityAward/CredentialConferred | ProgramType/Code | ProgramStatus/Code | ExceptionalityCategory/Code | StudentParticipationData/PlannedAssessmentParticipation | ProgramFundingSource/Code | StudentParticipationData/ManagingPublicAgency | StudentParticipationData/ManagingSchool | StudentParticipationData/GiftedEligibilityCriteria | Service/Code | StudentPlacementData/ServiceCategory | ServiceFundingSource/Code | StudentPlacementData/ServicingPublicAgency | StudentPlacementData/ServicingSchool | StudentPlacementData/SchoolWhereServiceDelivered | ServiceProviderType/Code | FrequencyTime/Code | GradingAssignment/DetailedDescription | StudentPeriodAttendance/AttendanceCode | StudentPeriodAttendance/InstructionalDeliveryMode | Billing/BilledEntity | Billing/BilledAmount | Payment/ReceivedAmount | EmployeeAssignment/PrimaryAssignment | JobClassification/Code | FundingSource/Code | AgeGroup/AgeGroup | TitleList/Title | EmployeeContract/BaseSalary | EmployeeContract/ContractTerm | EmploymentRecord/FullTimeStatus | Demographics/HispanicLatino | Demographics/Gender | Demographics/BirthDateVerification | Demographics/StateOfBirth | Demographics/CountryOfBirth | CountriesOfCitizenship/CountryOfCitizenship | CountriesOfResidency/CountryOfResidency | Demographics/CitizenshipStatus | EmployeePicture/PictureSource | AnnualItem/AccountType | AnnualItem/AccountTypeDetail | AnnualItem/FundType | AnnualItem/ExpenditureArea | AnnualItem/SpecialAmountType | AnnualItem/GLAmountType | BudgetAccount/AccountClass | JobFunction/Code | VendorInfo/FederalTaxId | W4/MaritalStatusRate | W4/StateProvince | PayRate/Amount | LocationInfo/ParentLocationInfo | Purchasing/FormType | PurchasingItem/UnitCost | ExpenseAccount/Amount | FinancialClass/ClassType | FinancialIncomeStatement/Program | FinancialTransaction/Program | EmployeeCredit/Earned | EmployeeRecertification/ActivityType | EmployeeRecertification/Earned | EmployeeCredential/Race | EmployeeCredential/Hispanic | Certification/AreaAuthorized | EmployeeCredential/Salary | EmployeeCredential/Status | EmployeeCredential/Leave | EmployeeCredential/Education | EmployeeCredential/TeachingCredentialType | EmployeeCredential/HighlyQualifiedTeacherIndicator | EmployeeCredential/ParaprofessionalQualificationStatus | EmployeeCredential/TerminationCode | BackgroundCheck/Type | ProfessionalDevelopmentActivities/Stipend | ProfessionalDevelopmentRegistration/RegistrationStatus | ProfessionalDevelopmentRegistration/PaidAmount | ProfessionalDevelopmentRegistration/Stipend | StudentParticipation/ManagingPublicAgency | StudentParticipation/ManagingSchool | PartCTransitionMeetingNotHeldReason/Code | PartCTransitionMeetingOutcome/Code | ReferralSource/Code | ProgramPlanType/Code | LeastRestrictiveEnvironment/Code | ProgramAvailability/Code | ProgramExitReason/Code | StudentParticipation/ProjectedExitReason | StudentParticipation/PlannedAssessmentParticipation | StudentParticipation/TransitionPlanning | StudentParticipation/CertifiedLunchProgram | StudentParticipation/PerkinsLEPStatus | StudentParticipation/TitleIIIAccountabilityProgressStatus | StudentParticipation/TitleIIIImmigrantParticipationStatus | StudentParticipation/NeglectedOrDelinquentAchievementIndicator | StudentParticipation/NeglectedOrDelinquentAcademicOutcomeIndicator | StudentPlacement/ServiceCategory | StudentPlacement/ServicingPublicAgency | StudentPlacement/ServicingSchool | StudentPlacement/SchoolWhereServiceDelivered | ServiceSetting/Code | WhenServiceProvided/Code | StudentPlacement/DirectTime | StudentPlacement/IndirectTime | StudentPlacement/TotalServiceDuration | TestAccommodation/TestType | TestAccommodation/AuthorizedActual | AccommodationCategory/Code | StudentSpecialEducationSummary/PrimaryDisabilityCode | StudentSpecialEducationSummary/EnvironmentForSchoolAge | StudentSpecialEducationSummary/EnvironmentForEarlyChildhood | NeglectedOrDelinquentParticipation/Type | StudentCareerTechnical/EducationCompleter | StudentCareerTechnical/Participant | StudentCareerTechnical/NontraditionalGenderStatus | StudentCareerTechnical/DisplacedHomemaker | StudentCareerTechnical/SingleParentOrSinglePregnantWoman | Assessment/AssessmentIdSystem | AssessmentDescriptors/AssessmentDescriptor | Stimulus/XMLData | Stimulus/TextData | Stimulus/BinaryData | Stem/XMLData | Stem/TextData | Stem/BinaryData | ChoiceContent/XMLData | ChoiceContent/TextData | ChoiceContent/BinaryData | SpecialConditions/SpecialCondition | AssessmentForm/AssessmentType | StudentSpecialConditions/StudentSpecialCondition | StudentGradeLevel/Code | AssessmentGradeLevel/Code | AssessmentStudentSnapshot/HispanicLatino | AssessmentStudentSnapshot/Gender | AssessmentStudentSnapshot/Title1 | AssessmentStudentSnapshot/ELL | StudentParticipation/Indicator | StudentParticipation/ReasonNotCompleting | StudentParticipation/ReasonNotTested | Item/ResponseStatus | AssessmentPackage/XMLData | LearningStandardDocument/Source | LearningStandardDocument/DocumentStatus | StandardSettingBody/Country | StandardSettingBody/StateProvince | RelatedLearningStandardItems/LearningStandardItemRefId | ComponentObjects/ComponentObject | SourceObjects/SourceObject | Lesson/Duration | Author/Email | ActivityTime/Duration | AssignmentTime/Duration | Contact/Email | LearningResource/Location | AssociatedObjects/AssociatedObject | ContentObject/SourceObject | ContentObject/Location | ContentCatalog/LanguageCode | StandardsSettingBody/Country | StandardsSettingBody/StateProvince | ContentCatalog/InstructionalLevel | ContentCatalog/Duration | ContentCatalog/Cost | PersonRoleAssociation/AssociatedRoleRefId | PersonRoleAssociation/Creator | Intervention/InterventionType | Intervention/InterventionDelivery | Measurement/FrequencyofMeasure | FrequencyTime/Duration | LearningStandardAssociation/LearningStandardRefId | LearningStandardAssociation/Creator | ItemInfo/ElectronicId | ItemInfo/Price | FineInfo/Amount | LibraryPatronStatus/FineAmount | LibraryPatronStatus/RefundAmount | Address/AddressType | LocalId/IdType | Address/Subregion | StudentProgramAssociation/EntryType | StudentProgramAssociation/YearGroup | StudentProgramAssociation/ExitStatus | StudentProgramAssociation/ExitType | StudentProgramAssociation/PlacementType | ManagingSchoolLocalId/IdType | StudentActivityType/Code | StudentActivityInfo/CurricularStatus | RecognitionList/Recognition | DisciplineIncident/AgencyReporting | DisciplineIncident/IncidentTime | DisciplineIncident/IncidentLocation | DisciplineIncident/IncidentLocationRefId | IncidentReporter/SIF_RefId | RelatedToList/RelatedTo | WeaponTypeList/WeaponType | IncidentCategory/Code | Offender/SIF_RefId | Offender/Injury | ManifestationDetermination/MeetingHeld | ManifestationDetermination/DueToDisability | Action/Code | Action/ZeroTolerance | Action/FullYearExpulsion | Action/ShortenedExpulsion | Action/PoliceNotification | Action/Arrest | Action/AlternativeEducation | Victim/SIF_RefId | Victim/Injury | IncidentAction/ZeroTolerance | IncidentAction/PoliceNotification | IncidentAction/Arrest | CalendarDateType/Code | StudentAttendance/CountsTowardAttendance | TeacherAttendance/CountsTowardAttendance | AdministratorAttendance/CountsTowardAttendance | InstructionalDeliveryModeList/InstructionalDeliveryMode | StudentAttendanceSummary/Resident | AttendanceCodeInfo/AttendanceType | AttendanceCodeInfo/AttendanceStatus | AttendanceCodeInfo/UsedForDailyAttendance | AttendanceCodeInfo/UsedForPeriodAttendance | SchoolCourseInfo/CourseCredits | SchoolCourseInfo/CoreAcademicCourse | SchoolCourseInfo/GraduationRequirement | SCEDCode/CourseDescription | SCEDCode/CourseLevel | SchoolCourseInfo/DualCredit | SchoolCourseInfo/CTEConcentrator | SchoolInfo/StateProvinceIdSystem | SchoolInfo/OtherLEA | SchoolInfo/SchoolType | SchoolFocusList/SchoolFocus | AddressRefIdList/AddressRefId | SchoolInfo/SessionType | SchoolInfo/Title1Status | SchoolInfo/TitleIProgramType | SchoolInfo/OperationalStatus | SchoolInfo/SchoolImprovementStatus | SchoolInfo/StatePovertyDesignation | SchoolInfo/NationalSchoolLunchProgramStatus | SchoolCharter/ApprovalAgencyType | SchoolCharter/ManagementOrganizationType | SchoolInfo/SharedTimeIndicator | SchoolInfo/VirtualSchoolStatus | LanguageOfInstruction/Code | LocationOfInstruction/Code | SectionInfo/SummerSchool | SchoolCourseInfoOverride/CourseCredits | SectionInfo/CountForAttendance | Relationship/Code | StudentContact/EmployerType | StudentContact/EducationalLevel | ContactFlags/ParentLegalGuardian | ContactFlags/PickupRights | ContactFlags/LivesWith | ContactFlags/AccessToRecords | ContactFlags/EmergencyContact | ContactFlags/HasCustody | ContactFlags/DisciplinaryContact | ContactFlags/PrimaryCareProvider | ContactFlags/Other | StudentDailyAttendance/InstructionalDeliveryMode | AlertMessages/AlertMessage | MedicalAlertMessages/MedicalAlertMessage | RemoteLearningLocationProfile/PrimaryLearningDevice | RemoteLearningLocationProfile/PrimaryLearningDeviceAccess | RemoteLearningLocationProfile/PrimaryLearningDeviceProvider | RemoteLearningLocationProfile/InternetAccess | RemoteLearningLocationProfile/InternetAccessBarrier | RemoteLearningLocationProfile/InternetAccessType | RemoteLearningLocationProfile/InternetPerformance | StudentPersonal/AcceptableUsePolicy | StudentPersonal/IDEA | StudentPersonal/Migrant | StudentPersonal/Title1 | StudentPersonal/GiftedTalented | StudentPersonal/EconomicDisadvantage | StudentPersonal/ELL | StudentPersonal/Homeless | StudentPersonal/HomelessServicedIndicator | StudentPersonal/Section504 | StudentPersonal/VocationalConcentrator | StudentPersonal/Immigrant | StudentPersonal/NeglectedDelinquent | StudentPicture/PictureSource | StudentPicture/OKToPublish | StudentSchoolEnrollment/Homeroom | StudentSchoolEnrollment/Advisor | StudentSchoolEnrollment/Counselor | StudentSchoolEnrollment/Calendar | ExitGradeLevel/Code | StudentSchoolEnrollment/RecordClosureReason | PromotionInfo/PromotionStatus | Promotion/Code | Nonpromotion/Code | StudentSchoolEnrollment/FTPTStatus | StudentSchoolEnrollment/NonResidentAttendReason | ResponsableSchool/Type | ResponsableLEA/Type | StudentSectionEnrollment/CreditsAttempted | StudentSectionEnrollment/DualCredit | StudentSectionEnrollment/CTEConcentrator | TermInfo/MarkingTerm | TermInfo/SchedulingTerm | TermInfo/AttendanceTerm | StudentSnapshot/HispanicLatino | StudentSnapshot/Gender | StudentSnapshot/GraduationAward | StudentSnapshot/GraduationOnTime | HomeEnrollment/Status | HomeEnrollment/Homeroom | HomeEnrollment/FullYearEnrollment | StudentSnapshot/IDEA | StudentSnapshot/Migrant | StudentSnapshot/Title1 | StudentSnapshot/GiftedTalented | StudentSnapshot/EconomicDisadvantage | StudentSnapshot/ELL | StudentSnapshot/Homeless | StudentSnapshot/Section504 | StudentSnapshot/VocationalConcentrator | StudentSnapshot/Immigrant | StudentSnapshot/NeglectedDelinquent | StudentSnapshot/FreeAndReducedStatus | EducationAgencyType/Code | LEAContact/PublishInDirectory | LEAInfo/OperationalStatus | LEAInfo/TitleIProgramType | LEAInfo/TitleIIILanguageInstructionProgramType | StaffAssignment/PrimaryAssignment | TeachingAssignment/Code | StaffAssignment/ItinerantTeacher | BellPeriod/RegularSchoolPeriod | BellPeriod/UseInAttendanceCalculations | StudentContactPersonal/EmployerType | StudentContactPersonal/EducationLevel | StudentContactPersonal/OptOutEmail | StaffSectionAssignment/TeacherOfRecord | Roles/Role | CorrelationType/Code | CorrelationSectionList/CorrelationSection | SchoolAccountability/GunFreeSchoolsActReportingStatus | SchoolAccountability/HighSchoolGraduationRateIndicatorStatus | SchoolAccountability/PersistentlyDangerousStatus | SchoolAccountability/ProficiencyTargetStatusForMath | SchoolAccountability/ProficiencyTargetStatusForReadingAndLanguageArts | SchoolAccountability/SchoolOperationalStatus | SchoolAccountability/ReconstitutedStatus | SchoolAccountability/SchoolImprovementFundsStatus | LEAAccountability/GunFreeSchoolsActReportingStatus | SchoolFederalFund/ConsolidatedMEPFundsStatus | SchoolFederalFund/SchoolImprovementGrantInterventionType | StudentMigrant/ServicesType | StudentMigrant/PrioritizedForServices | StudentMigrant/ContinuationOfServicesReason | StudentMigrant/ContinuationOfServicesStatus | StudentMigrant/EnrollmentType | StudentMigrant/ParticipationStatus | BusRouteInfo/RouteType | BusRouteInfo/RouteDistanceLoaded | BusRouteInfo/RouteDistanceTotal | StudentTransportInfo/Eligibility | StudentTransportInfo/HomeToSchoolDistance | StudentTransportInfo/WalkToStopDistance | StudentTransportInfo/StopToSchoolDistance | StudentTransportInfo/HomeBusRouteDetail | TransferPoint/EmbarkBusRouteDetail | TransferPoint/DisembarkBusRouteDetail | StudentTransportInfo/SchoolBusRouteDetail | StudentTransportInfo/StateAidQualification | StudentTransportInfo/TransportationStatus | StudentTransportInfo/PublicExpense | BusDriver/Status | BusStaff/Status | BusPositionInfo/Odometer | BusPositionInfo/Speedometer | Student/Status | AuthenticationInfo/System | PasswordList/Password | Type/Facility | ReadingData/Measurement | ReadingData/EnergyUnits | ReadingList/Reading | IdMAuthentication/IdentityProviderType | UserOrganizationAssociation/PersonRefId | UserOrganizationAssociation/OrganizationRefId" mode="detect" priority="1">
    <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="obj-content"/>
    <xsl:if test="count(following-sibling::*) &gt; 0">, </xsl:if>
  </xsl:template>

  <!-- list  - takes precedence when list of elements which are simple content with attributes -->
  <xsl:template match="EmailList/Email | PhoneNumberList/PhoneNumber | SEAContactList/SEAContact | AddressList/Address | TimeElements/TimeElement | SpanGaps/SpanGap | Creators/Creator | ModificationHistory/Modified | RightsElements/RightsElement | FeesForUse/FeeForUse | MediaTypes/MediaType | GradeLevels/GradeLevel | OtherCodeList/OtherCode | SubjectAreas/SubjectArea | InterestLevels/InterestLevel | LearningStandardItems/LearningStandardItemRefId | BloomsTaxonomyLevels/BloomsTaxonomyLevel | MultipleIntelligences/MultipleIntelligence | InstructionalStrategies/InstructionalStrategy | LearningObjectives/LearningObjective | ResourceTypes/ResourceType | SIF_ExtendedElements/SIF_ExtendedElement | FederalProgramList/FederalProgram | sessions/session | otherNames/name | otherIds/otherId | otherPhoneNumbers/phoneNumber | otherEmails/email | relationships/relationship | applicableEducationLevels/applicableEducationLevel | transferPermissionList/transmitPermission | background/consentToEvaluation | iepEligibility/evaluationResultList | evaluationResultList/evaluationResult | ideaDisability/disabilityCodeList | ideaDisability/analysis | iepEligibility/eligibilityParticipantReportList | participantReport/role | iepPlan/effectivePeriod | iepPlan/enrollmentGradeLevel | presentLevelPerformance/personal | personal/concerns | personal/evaluation | evaluation/needsList | evaluation/performance | performance/testResultList | evaluation/personalGoalsList | personal/intention | intention/desiredOutcomeList | presentLevelPerformance/academic | academic/deficitList | deficit/academicSubject | deficit/accommodation | academic/summary | accommodationList/accommodation | presentLevelPerformance/functional | functional/disabilityList | disability/disabilityCodeList | disability/accommodation | functional/summary | consequenceOfDisability/specialCategoryList | annualGoalsList/annualGoal | annualGoal/goalType | annualGoal/measurableObjectiveList | measurableObjective/facilitatorList | measurableObjective/measurement | criterion/metric | metric/trialCountEvaluation | annualGoal/independentActionsList | annualGoal/servicesList | service/serviceProvider | service/frequency | frequency/cycle | frequency/duration | annualGoal/coursesList | annualGoal/progressReportList | progressReport/measurement | measurement/dataValuesList | iepPlan/accommodationsList | accommodation/accommodation | accommodation/applicabilityList | iepPlan/standardizedAssessmentResultList | standardizedAssessmentResultList/standardizedAssessmentResult | standardizedAssessmentResult/standardsReference | standardizedAssessmentResult/accommodationList | parentGuardianAuthorization/rejectedPlanElements | rejectedPlanElements/rejectedDetailList | iepPlan/amendmentList | amendmentList/amendment | amendment/changeList | changeList/change | meetingTimes/meetingTime | students/studentReference | otherStaffs/otherStaff | gradeLevels/gradeLevel | otherAssignments/staffPersonAssignment | otherAddresses/name | races/race | otherEnrollments/enrollment | studentContacts/contactPersonRefId | studentContacts/xContact | languages/language | leaList/referenceLea | contactList/referenceContactPerson | staffList/referenceStaffPerson | organizationList/referenceOrganization | historyList/historyItem | ExclusionRules/ExclusionRule | Characteristics/AggregateCharacteristicInfoRefId | HistoricalMealStatus/MealStatus | Amounts/Amount | ElectronicIdList/ElectronicId | Agencies/Agency | Rates/Rate | Prices/Price | TransactionTypes/TransactionType | TransactionPayMethods/TransactionPayMethod | SalesAmounts/SalesAmount | ItemQuantities/ItemQuantity | MenuPlanQuantities/MenuPlanQuantity | SaleQuantities/SaleQuantity | PurchaseQuantities/PurchaseQuantity | Counts/Count | OtherRecords/StudentRecordPackageRefId | OtherIdList/OtherId | OtherNames/Name | RaceList/Race | LanguageList/Language | SchoolAttendanceHistory/SchoolAttended | SchoolContactList/SchoolContact | IdentificationInfoList/IdentificationInfo | MarkingSystems/MarkValueInfoData | Letter/ValidMark | EnrollmentHistory/StudentSchoolEnrollmentData | Courses/Course | SubjectAreaList/SubjectArea | CourseHistory/Term | MarkingPeriods/MarkingPeriod | AcademicPerformanceHistory/TermPerformance | AcademicFoci/AcademicFocus | AcademicSubjects/AcademicSubject | AssessmentPerformanceHistory/Assessment | AdditionalGraduationRequirementPerformanceHistory/Requirement | ActivityAwardHistory/ActivityAward | ExceptionalityCategories/ExceptionalityCategory | StudentParticipationList/StudentParticipationData | ProgramFundingSources/ProgramFundingSource | StudentPlacementList/StudentPlacementData | ServiceFundingSources/ServiceFundingSource | TermMarkLists/MarkInfoList | MarkInfoList/MarkInfoRefId | MarkList/Mark | AgeGroupList/AgeGroup | TitleList/TitleList | CountriesOfCitizenship/CountryOfCitizenship | CountriesOfResidency/CountryOfResidency | AnnualItems/AnnualItem | BudgetAccounts/BudgetAccount | PayRates/PayRate | OtherLEAs/LEAInfoRefId | PurchasingItems/PurchasingItem | ExpenseAccounts/ExpenseAccount | Certifications/Certification | EmployeeCredential/TeachingCredentialType | BackgroundChecks/BackgroundCheck | Assignments/Assignment | PartCTransitionMeetingNotHeldReasons/PartCTransitionMeetingNotHeldReason | PartCTransitionMeetingOutcomes/PartCTransitionMeetingOutcome | AdditionalProgramAvailabilityList/ProgramAvailability | StudentProgramAccommodations/StudentProgramAccommodation | Accommodations/Accommodation | NeglectedOrDelinquentParticipationList/NeglectedOrDelinquentParticipation | AssessmentDescriptors/AssessmentDescriptor | ResponseChoices/Choice | PerformanceLevels/PerformanceLevel | Measurements/Measurement | ResponseChoicePattern/Choice | AssessmentSubTestRefIds/AssessmentSubTestRefId | LearningStandardItemRefIds/LearningStandardItemRefId | SpecialConditions/SpecialCondition | FormNumbers/FormNumber | StudentSpecialConditions/StudentSpecialCondition | Items/Item | Scores/Score | Organizations/Organization | Authors/Author | RelatedLearningStandards/LearningStandardDocumentRefId | PredecessorItems/LearningStandardItemRefId | StatementCodes/StatementCode | Statements/Statement | AlternateIdentificationCodes/AlternateIdentificationCode | RelatedLearningStandardItems/LearningStandardItemRefId | Titles/Title | PredecessorObjects/CurriculumStructureRefId | ComponentObjects/ComponentObject | LearningStandards/LearningStandardItemRefId | SourceObjects/SourceObject | CurriculumStructures/CurriculumStructureRefId | Strategies/Strategy | SupportingActivities/ActivityRefId | LearningResources/LearningResourceRefId | LessonSources/LessonSource | LessonSource/Author | TechnicalRequirements/TechnicalRequirement | SoftwareRequirementList/SoftwareRequirement | EssentialMaterials/EssentialMaterial | Prerequisites/Prerequisite | Students/StudentPersonalRefId | Contacts/Contact | Approvals/Approval | Evaluations/Evaluation | Components/Component | AssociatedObjects/AssociatedObject | LearningStandards/Document | CurriculumHierarchyList/CurriculumHierarchy | InterventionProviderNames/InterventionProviderName | Interventions/Intervention | Baselines/Baseline | Targets/Target | PerformanceIndicators/PerformanceIndicator | Results/Result | TargetObjects/TargetObject | TransactionList/Transaction | FineInfoList/FineInfo | HoldInfoList/HoldInfo | MessageList/Message | FundingSourceList/FundingSource | RecognitionList/Recognition | RelatedToList/RelatedTo | WeaponTypeList/WeaponType | OffenderList/Offender | ActionList/Action | VictimList/Victim | IncidentActionList/IncidentAction | BellScheduleDayList/BellScheduleDay | InstructionalDeliveryModeList/InstructionalDeliveryMode | StaffList/StaffPersonalRefId | SchoolFocusList/SchoolFocus | AddressRefIdList/AddressRefId | ScheduleInfoList/ScheduleInfo | TeacherList/StaffPersonalRefId | SectionRoomList/RoomInfoRefId | MeetingTimeList/MeetingTime | AlertMessages/AlertMessage | MedicalAlertMessages/MedicalAlertMessage | RemoteLearningLocationProfileList/RemoteLearningLocationProfile | ResponsableSchoolList/ResponsableSchool | ResponsableLEAList/ResponsableLEA | ScheduleInfoOverrideList/ScheduleInfoOverride | LEAContactList/LEAContact | TimetableDayList/TimetableDay | TimetablePeriodList/TimetablePeriod | BellPeriodList/BellPeriod | Roles/Role | EvaluationParts/EvaluationPart | CorrelationSectionList/CorrelationSection | EquipmentList/Equipment | TransferPoints/TransferPoint | TelemetryList/Telemetry | BusStaffList/BusStaff | Students/Student | PasswordList/Password | TagList/Tag | ReadingDataList/ReadingData | ReadingList/Reading | FunctionList/Function | IdentityProviderList/IdentityProvider | LocationList/Location | DataDomainObligationList/DataDomainObligation | ShareWithList/ShareWith | DoNotShareWithList/DoNotShareWith | NeverShareWithList/NeverShareWith | PermissionToParticipateList/PermissionToParticipate | ApplicableLawList/ApplicableLaw" mode="detect" priority="2">
  <!-- repeating item may not be wrapped up in a List element (so check names of preceding-siblings) -->
  <xsl:if test="count(preceding-sibling::*) = 0 or not(name(preceding-sibling::*[1]) = name(.))">
      <xsl:text>"</xsl:text><xsl:value-of select="name()"/><xsl:text>" : [</xsl:text>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="count(./child::*) > 0 or count(@*) > 0">
        <xsl:apply-templates select="." mode="obj-content" />
      </xsl:when>
      <xsl:when test="count(./child::*) = 0">
        <xsl:apply-templates select="." mode="value"/>
      </xsl:when>
    </xsl:choose>
    <!-- repeating item may not be wrapped up in a List element (so check names of following-siblings) -->
    <xsl:if test="count(following-sibling::*) &gt; 0 and name(following-sibling::*[1]) = name(.)">, </xsl:if>
    <xsl:if test="count(following-sibling::*) = 0 or not(name(following-sibling::*[1]) = name(.))"><xsl:text>]</xsl:text><xsl:if test="count(following-sibling::*) &gt; 0"><xsl:text>,</xsl:text></xsl:if></xsl:if>
  </xsl:template>  

  <xsl:template match="*" mode="obj-content">
    <xsl:text>{</xsl:text>
    <xsl:apply-templates select="@*" mode="attr" />
    <xsl:if test="count(@*) &gt; 0">, </xsl:if>
    <xsl:apply-templates select="./*" mode="detect" />
    <xsl:if test="count(child::*) = 0 and text() and not(@*)">
      <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="value"/>
    </xsl:if>
    <xsl:if test="count(child::*) = 0 and text() and @*">
      <xsl:text>"value" : </xsl:text><xsl:apply-templates select="." mode="value"/>
    </xsl:if>
    <xsl:if test="count(child::*) = 0 and not(text()) and @*">
      <xsl:text>"value" : ""</xsl:text>
    </xsl:if>
    <xsl:text>}</xsl:text>
    <xsl:if test="position() &lt; last()">, </xsl:if>
  </xsl:template>

  <!-- simple content with attribute -->
  <xsl:template match="Address/StateProvince | Address/StateANSICode | Address/Country | EmailList/Email | SEAContact/PublishInDirectory | SEAInfo/OperationalStatus | EDENInfo/FIPSStateCode | SEAInfo/CTEGraduationRateInclusion | FeeForUse/PerUseCharge | GradeLevel/Code | OtherCodeList/OtherCode | SubjectArea/Code | InterestLevel/Code | BloomsTaxonomyLevels/BloomsTaxonomyLevel | MultipleIntelligences/MultipleIntelligence | InstructionalStrategies/InstructionalStrategy | ResourceTypes/ResourceType | SIF_ExtendedElements/SIF_ExtendedElement | StudentLEARelationship/MembershipType | ResidencyStatus/Code | EntryType/Code | ExitType/Code | ExitStatus/Code | StudentLEARelationship/NonResidentAttendReason | SEAAccountability/HighSchoolGraduationRateIndicatorStatus | AggregateStatisticInfo/CalculationRule | ExclusionRules/ExclusionRule | Location/LocationRefId | AggregateStatisticInfo/Measure | AggregateStatisticFact/Excluded | Amounts/Amount | ElectronicIdList/ElectronicId | FoodserviceItemPortion/ItemPortionType | FoodserviceReimbursementRates/Program | FoodserviceMealPrices/Program | Price/Value | Price/MealType | FoodserviceTransaction/Program | TransactionTypes/TransactionType | FoodserviceTransaction/Amount | FoodserviceTransaction/Tax | FoodserviceTransaction/Voided | FoodserviceSales/Program | SalesAmounts/SalesAmount | FoodserviceItemSales/Program | ItemQuantity/MealType | ItemQuantity/Cost | FoodserviceMenuPlan/Program | MenuPlanQuantities/MenuPlanQuantity | FoodserviceMilkSales/Program | SaleQuantity/ChargeToChild | PurchaseQuantity/MealType | FoodserviceStaffEnrollmentCount/Program | Count/MealType | Count/Amount | Count/Tax | FoodserviceStaffMealCounts/Program | FoodserviceStudentEnrollmentCount/Program | FoodserviceStudentMealCounts/Program | OtherIdList/OtherId | Race/Code | DemographicsData/Gender | EnglishProficiency/Code | Language/Code | Language/LanguageType | DemographicsData/HispanicLatino | DemographicsData/CountryOfBirth | DwellingArrangement/Code | StudentPersonalData/IDEA | StudentPersonalData/Migrant | StudentPersonalData/Title1 | StudentPersonalData/GiftedTalented | StudentPersonalData/EconomicDisadvantage | StudentPersonalData/ELL | StudentPersonalData/Homeless | StudentPersonalData/Section504 | StudentPersonalData/VocationalConcentrator | StudentPersonalData/Immigrant | StudentPersonalData/NeglectedDelinquent | SchoolContact/PublishInDirectory | IdentificationInfoList/IdentificationInfo | StudentSchoolRelationship/MembershipType | StudentSchoolRelationship/NonResidentAttendReason | TermSpan/Code | InstructionalLevel/Code | SchoolCourseInfoData/GraduationRequirement | GradeLevelWhenTaken/Code | MarkingPeriod/CreditType | MediumOfInstruction/Code | TermPerformance/ProgressLevel | AcademicPerformanceSummary/GraduationRateSurveyIndicator | AcademicPerformanceSummary/AcademicTrack | AcademicFocus/Code | AcademicSubject/Code | StudentGradeLevelWhenAssessed/Code | Assessment/TestScoreType | Requirement/Status | ActivityAward/InvolvementCode | ActivityAward/HonorsInformationCode | ActivityAward/DiplomaCredentialHonorsCode | ActivityAward/CredentialConferred | ProgramType/Code | ProgramStatus/Code | ExceptionalityCategory/Code | StudentParticipationData/PlannedAssessmentParticipation | ProgramFundingSource/Code | StudentParticipationData/ManagingPublicAgency | StudentParticipationData/ManagingSchool | StudentParticipationData/GiftedEligibilityCriteria | Service/Code | StudentPlacementData/ServiceCategory | ServiceFundingSource/Code | StudentPlacementData/ServicingPublicAgency | StudentPlacementData/ServicingSchool | StudentPlacementData/SchoolWhereServiceDelivered | ServiceProviderType/Code | FrequencyTime/Code | GradingAssignment/DetailedDescription | StudentPeriodAttendance/AttendanceCode | StudentPeriodAttendance/InstructionalDeliveryMode | Billing/BilledEntity | Billing/BilledAmount | Payment/ReceivedAmount | EmployeeAssignment/PrimaryAssignment | JobClassification/Code | FundingSource/Code | AgeGroup/AgeGroup | TitleList/Title | EmployeeContract/BaseSalary | EmployeeContract/ContractTerm | EmploymentRecord/FullTimeStatus | Demographics/HispanicLatino | Demographics/Gender | Demographics/BirthDateVerification | Demographics/StateOfBirth | Demographics/CountryOfBirth | CountriesOfCitizenship/CountryOfCitizenship | CountriesOfResidency/CountryOfResidency | Demographics/CitizenshipStatus | EmployeePicture/PictureSource | AnnualItem/AccountType | AnnualItem/AccountTypeDetail | AnnualItem/FundType | AnnualItem/ExpenditureArea | AnnualItem/SpecialAmountType | AnnualItem/GLAmountType | BudgetAccount/AccountClass | JobFunction/Code | VendorInfo/FederalTaxId | W4/MaritalStatusRate | W4/StateProvince | PayRate/Amount | LocationInfo/ParentLocationInfo | Purchasing/FormType | PurchasingItem/UnitCost | ExpenseAccount/Amount | FinancialClass/ClassType | FinancialIncomeStatement/Program | FinancialTransaction/Program | EmployeeCredit/Earned | EmployeeRecertification/ActivityType | EmployeeRecertification/Earned | EmployeeCredential/Race | EmployeeCredential/Hispanic | Certification/AreaAuthorized | EmployeeCredential/Salary | EmployeeCredential/Status | EmployeeCredential/Leave | EmployeeCredential/Education | EmployeeCredential/TeachingCredentialType | EmployeeCredential/HighlyQualifiedTeacherIndicator | EmployeeCredential/ParaprofessionalQualificationStatus | EmployeeCredential/TerminationCode | BackgroundCheck/Type | ProfessionalDevelopmentActivities/Stipend | ProfessionalDevelopmentRegistration/RegistrationStatus | ProfessionalDevelopmentRegistration/PaidAmount | ProfessionalDevelopmentRegistration/Stipend | StudentParticipation/ManagingPublicAgency | StudentParticipation/ManagingSchool | PartCTransitionMeetingNotHeldReason/Code | PartCTransitionMeetingOutcome/Code | ReferralSource/Code | ProgramPlanType/Code | LeastRestrictiveEnvironment/Code | ProgramAvailability/Code | ProgramExitReason/Code | StudentParticipation/ProjectedExitReason | StudentParticipation/PlannedAssessmentParticipation | StudentParticipation/TransitionPlanning | StudentParticipation/CertifiedLunchProgram | StudentParticipation/PerkinsLEPStatus | StudentParticipation/TitleIIIAccountabilityProgressStatus | StudentParticipation/TitleIIIImmigrantParticipationStatus | StudentParticipation/NeglectedOrDelinquentAchievementIndicator | StudentParticipation/NeglectedOrDelinquentAcademicOutcomeIndicator | StudentPlacement/ServiceCategory | StudentPlacement/ServicingPublicAgency | StudentPlacement/ServicingSchool | StudentPlacement/SchoolWhereServiceDelivered | ServiceSetting/Code | WhenServiceProvided/Code | StudentPlacement/DirectTime | StudentPlacement/IndirectTime | StudentPlacement/TotalServiceDuration | TestAccommodation/TestType | TestAccommodation/AuthorizedActual | AccommodationCategory/Code | StudentSpecialEducationSummary/PrimaryDisabilityCode | StudentSpecialEducationSummary/EnvironmentForSchoolAge | StudentSpecialEducationSummary/EnvironmentForEarlyChildhood | NeglectedOrDelinquentParticipation/Type | StudentCareerTechnical/EducationCompleter | StudentCareerTechnical/Participant | StudentCareerTechnical/NontraditionalGenderStatus | StudentCareerTechnical/DisplacedHomemaker | StudentCareerTechnical/SingleParentOrSinglePregnantWoman | Assessment/AssessmentIdSystem | AssessmentDescriptors/AssessmentDescriptor | Stimulus/XMLData | Stimulus/TextData | Stimulus/BinaryData | Stem/XMLData | Stem/TextData | Stem/BinaryData | ChoiceContent/XMLData | ChoiceContent/TextData | ChoiceContent/BinaryData | SpecialConditions/SpecialCondition | AssessmentForm/AssessmentType | StudentSpecialConditions/StudentSpecialCondition | StudentGradeLevel/Code | AssessmentGradeLevel/Code | AssessmentStudentSnapshot/HispanicLatino | AssessmentStudentSnapshot/Gender | AssessmentStudentSnapshot/Title1 | AssessmentStudentSnapshot/ELL | StudentParticipation/Indicator | StudentParticipation/ReasonNotCompleting | StudentParticipation/ReasonNotTested | Item/ResponseStatus | AssessmentPackage/XMLData | LearningStandardDocument/Source | LearningStandardDocument/DocumentStatus | StandardSettingBody/Country | StandardSettingBody/StateProvince | RelatedLearningStandardItems/LearningStandardItemRefId | ComponentObjects/ComponentObject | SourceObjects/SourceObject | Lesson/Duration | Author/Email | ActivityTime/Duration | AssignmentTime/Duration | Contact/Email | LearningResource/Location | AssociatedObjects/AssociatedObject | ContentObject/SourceObject | ContentObject/Location | ContentCatalog/LanguageCode | StandardsSettingBody/Country | StandardsSettingBody/StateProvince | ContentCatalog/InstructionalLevel | ContentCatalog/Duration | ContentCatalog/Cost | PersonRoleAssociation/AssociatedRoleRefId | PersonRoleAssociation/Creator | Intervention/InterventionType | Intervention/InterventionDelivery | Measurement/FrequencyofMeasure | FrequencyTime/Duration | LearningStandardAssociation/LearningStandardRefId | LearningStandardAssociation/Creator | ItemInfo/ElectronicId | ItemInfo/Price | FineInfo/Amount | LibraryPatronStatus/FineAmount | LibraryPatronStatus/RefundAmount | Address/AddressType | LocalId/IdType | Address/Subregion | StudentProgramAssociation/EntryType | StudentProgramAssociation/YearGroup | StudentProgramAssociation/ExitStatus | StudentProgramAssociation/ExitType | StudentProgramAssociation/PlacementType | ManagingSchoolLocalId/IdType | StudentActivityType/Code | StudentActivityInfo/CurricularStatus | RecognitionList/Recognition | DisciplineIncident/AgencyReporting | DisciplineIncident/IncidentTime | DisciplineIncident/IncidentLocation | DisciplineIncident/IncidentLocationRefId | IncidentReporter/SIF_RefId | RelatedToList/RelatedTo | WeaponTypeList/WeaponType | IncidentCategory/Code | Offender/SIF_RefId | Offender/Injury | ManifestationDetermination/MeetingHeld | ManifestationDetermination/DueToDisability | Action/Code | Action/ZeroTolerance | Action/FullYearExpulsion | Action/ShortenedExpulsion | Action/PoliceNotification | Action/Arrest | Action/AlternativeEducation | Victim/SIF_RefId | Victim/Injury | IncidentAction/ZeroTolerance | IncidentAction/PoliceNotification | IncidentAction/Arrest | CalendarDateType/Code | StudentAttendance/CountsTowardAttendance | TeacherAttendance/CountsTowardAttendance | AdministratorAttendance/CountsTowardAttendance | InstructionalDeliveryModeList/InstructionalDeliveryMode | StudentAttendanceSummary/Resident | AttendanceCodeInfo/AttendanceType | AttendanceCodeInfo/AttendanceStatus | AttendanceCodeInfo/UsedForDailyAttendance | AttendanceCodeInfo/UsedForPeriodAttendance | SchoolCourseInfo/CourseCredits | SchoolCourseInfo/CoreAcademicCourse | SchoolCourseInfo/GraduationRequirement | SCEDCode/CourseDescription | SCEDCode/CourseLevel | SchoolCourseInfo/DualCredit | SchoolCourseInfo/CTEConcentrator | SchoolInfo/StateProvinceIdSystem | SchoolInfo/OtherLEA | SchoolInfo/SchoolType | SchoolFocusList/SchoolFocus | AddressRefIdList/AddressRefId | SchoolInfo/SessionType | SchoolInfo/Title1Status | SchoolInfo/TitleIProgramType | SchoolInfo/OperationalStatus | SchoolInfo/SchoolImprovementStatus | SchoolInfo/StatePovertyDesignation | SchoolInfo/NationalSchoolLunchProgramStatus | SchoolCharter/ApprovalAgencyType | SchoolCharter/ManagementOrganizationType | SchoolInfo/SharedTimeIndicator | SchoolInfo/VirtualSchoolStatus | LanguageOfInstruction/Code | LocationOfInstruction/Code | SectionInfo/SummerSchool | SchoolCourseInfoOverride/CourseCredits | SectionInfo/CountForAttendance | Relationship/Code | StudentContact/EmployerType | StudentContact/EducationalLevel | ContactFlags/ParentLegalGuardian | ContactFlags/PickupRights | ContactFlags/LivesWith | ContactFlags/AccessToRecords | ContactFlags/EmergencyContact | ContactFlags/HasCustody | ContactFlags/DisciplinaryContact | ContactFlags/PrimaryCareProvider | ContactFlags/Other | StudentDailyAttendance/InstructionalDeliveryMode | AlertMessages/AlertMessage | MedicalAlertMessages/MedicalAlertMessage | RemoteLearningLocationProfile/PrimaryLearningDevice | RemoteLearningLocationProfile/PrimaryLearningDeviceAccess | RemoteLearningLocationProfile/PrimaryLearningDeviceProvider | RemoteLearningLocationProfile/InternetAccess | RemoteLearningLocationProfile/InternetAccessBarrier | RemoteLearningLocationProfile/InternetAccessType | RemoteLearningLocationProfile/InternetPerformance | StudentPersonal/AcceptableUsePolicy | StudentPersonal/IDEA | StudentPersonal/Migrant | StudentPersonal/Title1 | StudentPersonal/GiftedTalented | StudentPersonal/EconomicDisadvantage | StudentPersonal/ELL | StudentPersonal/Homeless | StudentPersonal/HomelessServicedIndicator | StudentPersonal/Section504 | StudentPersonal/VocationalConcentrator | StudentPersonal/Immigrant | StudentPersonal/NeglectedDelinquent | StudentPicture/PictureSource | StudentPicture/OKToPublish | StudentSchoolEnrollment/Homeroom | StudentSchoolEnrollment/Advisor | StudentSchoolEnrollment/Counselor | StudentSchoolEnrollment/Calendar | ExitGradeLevel/Code | StudentSchoolEnrollment/RecordClosureReason | PromotionInfo/PromotionStatus | Promotion/Code | Nonpromotion/Code | StudentSchoolEnrollment/FTPTStatus | StudentSchoolEnrollment/NonResidentAttendReason | ResponsableSchool/Type | ResponsableLEA/Type | StudentSectionEnrollment/CreditsAttempted | StudentSectionEnrollment/DualCredit | StudentSectionEnrollment/CTEConcentrator | TermInfo/MarkingTerm | TermInfo/SchedulingTerm | TermInfo/AttendanceTerm | StudentSnapshot/HispanicLatino | StudentSnapshot/Gender | StudentSnapshot/GraduationAward | StudentSnapshot/GraduationOnTime | HomeEnrollment/Status | HomeEnrollment/Homeroom | HomeEnrollment/FullYearEnrollment | StudentSnapshot/IDEA | StudentSnapshot/Migrant | StudentSnapshot/Title1 | StudentSnapshot/GiftedTalented | StudentSnapshot/EconomicDisadvantage | StudentSnapshot/ELL | StudentSnapshot/Homeless | StudentSnapshot/Section504 | StudentSnapshot/VocationalConcentrator | StudentSnapshot/Immigrant | StudentSnapshot/NeglectedDelinquent | StudentSnapshot/FreeAndReducedStatus | EducationAgencyType/Code | LEAContact/PublishInDirectory | LEAInfo/OperationalStatus | LEAInfo/TitleIProgramType | LEAInfo/TitleIIILanguageInstructionProgramType | StaffAssignment/PrimaryAssignment | TeachingAssignment/Code | StaffAssignment/ItinerantTeacher | BellPeriod/RegularSchoolPeriod | BellPeriod/UseInAttendanceCalculations | StudentContactPersonal/EmployerType | StudentContactPersonal/EducationLevel | StudentContactPersonal/OptOutEmail | StaffSectionAssignment/TeacherOfRecord | Roles/Role | CorrelationType/Code | CorrelationSectionList/CorrelationSection | SchoolAccountability/GunFreeSchoolsActReportingStatus | SchoolAccountability/HighSchoolGraduationRateIndicatorStatus | SchoolAccountability/PersistentlyDangerousStatus | SchoolAccountability/ProficiencyTargetStatusForMath | SchoolAccountability/ProficiencyTargetStatusForReadingAndLanguageArts | SchoolAccountability/SchoolOperationalStatus | SchoolAccountability/ReconstitutedStatus | SchoolAccountability/SchoolImprovementFundsStatus | LEAAccountability/GunFreeSchoolsActReportingStatus | SchoolFederalFund/ConsolidatedMEPFundsStatus | SchoolFederalFund/SchoolImprovementGrantInterventionType | StudentMigrant/ServicesType | StudentMigrant/PrioritizedForServices | StudentMigrant/ContinuationOfServicesReason | StudentMigrant/ContinuationOfServicesStatus | StudentMigrant/EnrollmentType | StudentMigrant/ParticipationStatus | BusRouteInfo/RouteType | BusRouteInfo/RouteDistanceLoaded | BusRouteInfo/RouteDistanceTotal | StudentTransportInfo/Eligibility | StudentTransportInfo/HomeToSchoolDistance | StudentTransportInfo/WalkToStopDistance | StudentTransportInfo/StopToSchoolDistance | StudentTransportInfo/HomeBusRouteDetail | TransferPoint/EmbarkBusRouteDetail | TransferPoint/DisembarkBusRouteDetail | StudentTransportInfo/SchoolBusRouteDetail | StudentTransportInfo/StateAidQualification | StudentTransportInfo/TransportationStatus | StudentTransportInfo/PublicExpense | BusDriver/Status | BusStaff/Status | BusPositionInfo/Odometer | BusPositionInfo/Speedometer | Student/Status | AuthenticationInfo/System | PasswordList/Password | Type/Facility | ReadingData/Measurement | ReadingData/EnergyUnits | ReadingList/Reading | IdMAuthentication/IdentityProviderType | UserOrganizationAssociation/PersonRefId | UserOrganizationAssociation/OrganizationRefId" mode="obj-content">
    <xsl:text>{</xsl:text>
    <xsl:apply-templates select="@*" mode="attr" />
    <xsl:if test="count(@*) &gt; 0">, </xsl:if>
    <xsl:apply-templates select="./*" mode="detect" />
    <xsl:if test="count(child::*) = 0 and text()">
      <xsl:text>"value" : </xsl:text><xsl:apply-templates select="." mode="value"/>
    </xsl:if>
    <xsl:if test="count(child::*) = 0 and not(text())">
      <xsl:text>"value" : ""</xsl:text>
    </xsl:if>
    <xsl:text>}</xsl:text>
    <xsl:if test="position() &lt; last()">, </xsl:if>
  </xsl:template>

  <xsl:template match="@*" mode="attr">
    <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="attrvalue"/>
    <xsl:if test="position() &lt; last()">, </xsl:if>
  </xsl:template>

  <!-- https://github.com/bramstein/xsltjson/blob/master/conf/xml-to-jsonml.xsl -->
  <json:search name="string">
		<json:replace src="\" dst="\\"/>
		<json:replace src="&quot;" dst="\&quot;"/>
		<json:replace src="&#xA;" dst="\n"/>
		<json:replace src="&#xD;" dst="\r"/>
		<json:replace src="&#x9;" dst="\t"/>
		<json:replace src="\n" dst="\n"/>
		<json:replace src="\r" dst="\r"/>
		<json:replace src="\t" dst="\t"/>
  </json:search>

  <xsl:template name="replace-string">
		<xsl:param name="input"/>
		<xsl:param name="src"/>
		<xsl:param name="dst"/>
		<xsl:choose>
			<xsl:when test="contains($input, $src)">
				<xsl:value-of select="concat(substring-before($input, $src), $dst)"/>
				<xsl:call-template name="replace-string">
					<xsl:with-param name="input" select="substring-after($input, $src)"/>
					<xsl:with-param name="src" select="$src"/>
					<xsl:with-param name="dst" select="$dst"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$input"/>
			</xsl:otherwise>
		</xsl:choose>
  </xsl:template>

  <xsl:template name="encode">
		<xsl:param name="input"/>
		<xsl:param name="index">1</xsl:param>

		<xsl:variable name="text">
			<xsl:call-template name="replace-string">
				<xsl:with-param name="input" select="$input"/>
				<xsl:with-param name="src" select="document('')//json:search/json:replace[$index]/@src"/>
				<xsl:with-param name="dst" select="document('')//json:search/json:replace[$index]/@dst"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:choose>
			<xsl:when test="$index &lt; count(document('')//json:search/json:replace)">
				<xsl:call-template name="encode">
					<xsl:with-param name="input" select="$text"/>
					<xsl:with-param name="index" select="$index + 1"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
  </xsl:template>

  <xsl:template name="encode-value">
                <xsl:param name="value"/>
                <!--
                <xsl:choose>
                        <xsl:when test="normalize-space($value) != $value">
                -->
                <!-- no, we always call encode, because we escape  as well -->
                                <xsl:call-template name="encode">
                                        <xsl:with-param name="input" select="$value"/>
                                </xsl:call-template>
                <!--
                        </xsl:when>
                        <xsl:otherwise>
                                <xsl:value-of select="$value"/>
                        </xsl:otherwise>
                </xsl:choose>
                -->
  </xsl:template>

  <xsl:template match="node/@TEXT | text()" name="removeBreaks" priority="10">
    <xsl:call-template name="encode-value">
      <xsl:with-param name="value" select="." />
    </xsl:call-template>
  </xsl:template>

  <xsl:template name="encode-numeric-value">
                <xsl:param name="value"/>
                <xsl:choose>
                        <xsl:when test="substring(normalize-space($value), 1, 1) = '.'">
                                <xsl:text>0</xsl:text><xsl:value-of select="$value"/>
                        </xsl:when>
                        <xsl:otherwise>
                                <xsl:value-of select="$value"/>
                        </xsl:otherwise>
                </xsl:choose>
  </xsl:template>

</xsl:stylesheet>
