<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xmlns:json="http://json.org/">
  <!-- from https://gist.github.com/inancgumus/3ce56ddde6d5c93f3550b3b4cdc6bcb8 -->
  <!-- https://github.com/bramstein/xsltjson/blob/master/conf/xml-to-jsonml.xsl -->
  <xsl:output method="text" omit-xml-declaration="yes" encoding="utf-8"/>

  <xsl:template match="/*[node()]">
    <xsl:apply-templates select="." mode="obj-list" />
  </xsl:template>

  <xsl:template match="*" mode="detect">
    <xsl:choose>
      <xsl:when test="count(./child::*) > 0 or count(@*) > 0">
        <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="obj-content" />
      </xsl:when>
      <xsl:when test="count(./child::*) = 0">
        <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="value"/>
      </xsl:when>
    </xsl:choose>
    <xsl:if test="count(following-sibling::*) &gt; 0">, </xsl:if>
  </xsl:template>

  <xsl:template match="*" mode="value">
    <xsl:text>"</xsl:text><xsl:apply-templates select="node/@TEXT | text()"/><xsl:text>"</xsl:text>
  </xsl:template>

  <xsl:template match="*" mode="obj-detect">
    {
    <xsl:choose>
      <xsl:when test="count(./child::*) > 0 or count(@*) > 0">
        <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="obj-content" />
      </xsl:when>
      <xsl:when test="count(./child::*) = 0">
        <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="value"/>
      </xsl:when>
    </xsl:choose>
    }
  </xsl:template>

  <!-- objects -->
  <xsl:template match="SEAInfo | StudentLEARelationship | SEAAccountability | SEAFederalFund | xCalendar | xContact | xCourse | xIndividualizedEducationPlan | xLea | xRoster | xSchool | xStaff | xStudent | xTransferIep | AggregateStatisticInfo | AggregateCharacteristicInfo | AggregateStatisticFact | StudentMeal | FoodserviceItem | FoodserviceItemUnit | FoodserviceItemPortion | FoodserviceReimbursementRates | FoodserviceMealPrices | StaffMeal | FoodserviceTransaction | FoodserviceTransactionDetails | FoodserviceTransactionPayMethod | FoodserviceSales | FoodserviceItemSales | FoodserviceMenuPlan | FoodserviceMilkSales | FoodservicePurchaseTransaction | FoodserviceStaffEnrollmentCount | FoodserviceStaffMealCounts | FoodserviceStudentEnrollmentCount | FoodserviceStudentMealCounts | StudentRecordExchange | StudentDemographicRecord | StudentAcademicRecord | StudentSpecialEducationRecord | StudentRecordPackage | MarkValueInfo | MarkInfo | SectionMarkInfo | StudentSectionMarks | GradingCategory | GradingAssignment | GradingAssignmentScore | StudentPeriodAttendance | OfficialStudentPeriodAttendance | StudentGrade | Billing | Payment | EmployeeAssignment | EmployeeContract | EmploymentRecord | EmployeePersonal | EmployeePicture | FinancialAnnual | FinancialBudget | TimeWorked | VendorInfo | W4 | EmployeeWage | LocationInfo | Purchasing | AccountingPeriod | FinancialAccount | FinancialAccountAccountingPeriodLocationInfo | FinancialClass | FinancialIncomeStatement | FinancialTransaction | FiscalYear | ActivityProvider | EmployeeCredit | EmployeeRecertification | EmployeeCredential | ProfessionalDevelopmentActivities | ProfessionalDevelopmentProgram | ProfessionalDevelopmentRegistration | StudentParticipation | StudentPlacement | TestAccommodation | StudentSpecialEducationSummary | StudentCareerTechnical | Assessment | AssessmentItem | ItemCharacteristics | AssessmentSubTest | AssessmentAdministration | AssessmentForm | AssessmentRegistration | StudentResponseSet | StudentScoreSet | AssessmentPackage | LearningStandardDocument | LearningStandardItem | CurriculumStructure | Lesson | Activity | Assignment | LearningResource | LearningResourcePackage | ContentCatalog | PersonRoleAssociation | ResponseToIntervention | RTIResults | LearningStandardAssociation | LibraryPatronStatus | Address | StudentProgramAssociation | StudentActivityInfo | StudentActivityParticipation | DisciplineIncident | CalendarSummary | CalendarDate | StudentAttendanceSummary | AttendanceCodeInfo | RoomInfo | RoomType | SchoolCourseInfo | SchoolInfo | SectionInfo | StaffPersonal | StudentContact | StudentDailyAttendance | StudentPersonal | StudentPicture | StudentSchoolEnrollment | StudentSectionEnrollment | TermInfo | StudentSnapshot | LEAInfo | StaffAssignment | BellSchedule | StudentContactPersonal | StudentContactRelationship | StaffSectionAssignment | StaffEvaluation | SectionCorrelation | SchoolAccountability | LEAAccountability | SchoolFederalFund | LEAFederalFund | StudentMigrant | BusEquipment | BusInfo | BusRouteDetail | BusRouteInfo | BusStopInfo | StudentTransportInfo | BusPositionInfo | Authentication | EnergyUsage | IdMApplication | IdMAuthentication | IdMAuthorization | UserOrganizationAssociation | PersonPrivacyObligationDocument" mode="obj-list">
    <xsl:if test="count(preceding-sibling::*) = 0">
      <xsl:text>[</xsl:text>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="count(./child::*) > 0 or count(@*) > 0">
        <xsl:apply-templates select="." mode="obj-detect" />
      </xsl:when>
    </xsl:choose>
    <xsl:if test="count(following-sibling::*) &gt; 0">, </xsl:if>
    <xsl:if test="count(following-sibling::*) = 0"><xsl:text>]</xsl:text></xsl:if>
  </xsl:template>

  <!-- numeric or boolean -->
  <xsl:template match="SEAInfo/CSSOContact/Address/GridLocation/Latitude | SEAInfo/CSSOContact/Address/GridLocation/Longitude | SEAInfo/SEAContactList/SEAContact/ContactInfo/Address/GridLocation/Latitude | SEAInfo/SEAContactList/SEAContact/ContactInfo/Address/GridLocation/Longitude | SEAInfo/AddressList/Address/GridLocation/Latitude | SEAInfo/AddressList/Address/GridLocation/Longitude | SEAInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentLEARelationship/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SEAFederalFund/FederalProgramList/FederalProgram/Code | SEAFederalFund/FederalProgramList/FederalProgram/FundingAllocation | xContact/relationships/relationship/contactSequence | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/measurement/criterion/metric/accuracyPercentEvaluation | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/measurement/criterion/metric/trialCountEvaluation/successCount | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/measurement/criterion/metric/trialCountEvaluation/attemptCount | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/servicesList/service/frequency/cycle/count | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/servicesList/service/frequency/duration/directMinutes | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/servicesList/service/frequency/duration/indirectMinutes | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/progressReportList/progressReport/measurement/dataValuesList/dataValue/category | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/progressReportList/progressReport/measurement/dataValuesList/dataValue/value | xIndividualizedEducationPlan/iepPlan/placement/leastRestrictiveEnvironment/totalMinutesPerWeek | xIndividualizedEducationPlan/iepPlan/placement/leastRestrictiveEnvironment/inclusionMinutesPerWeek | xIndividualizedEducationPlan/iepPlan/placement/leastRestrictiveEnvironment/nonInclusionMinutesPerWeek | xRoster/primaryStaff/percentResponsible | xRoster/otherStaffs/otherStaff/percentResponsible | xStudent/academicSummary/cumulativeWeightedGpa | xStudent/academicSummary/termWeightedGpa | xStudent/academicSummary/classRank | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/measurement/criterion/metric/accuracyPercentEvaluation | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/measurement/criterion/metric/trialCountEvaluation/successCount | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/measurement/criterion/metric/trialCountEvaluation/attemptCount | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/servicesList/service/frequency/cycle/count | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/servicesList/service/frequency/duration/directMinutes | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/servicesList/service/frequency/duration/indirectMinutes | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/progressReportList/progressReport/measurement/dataValuesList/dataValue/category | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/progressReportList/progressReport/measurement/dataValuesList/dataValue/value | xTransferIep/iep/iepPlan/placement/leastRestrictiveEnvironment/totalMinutesPerWeek | xTransferIep/iep/iepPlan/placement/leastRestrictiveEnvironment/inclusionMinutesPerWeek | xTransferIep/iep/iepPlan/placement/leastRestrictiveEnvironment/nonInclusionMinutesPerWeek | AggregateStatisticInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AggregateCharacteristicInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AggregateStatisticFact/Value | AggregateStatisticFact/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentMeal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceItem/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceItemUnit/GramWeight | FoodserviceItemUnit/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceItemPortion/ItemPortionQuantity | FoodserviceItemPortion/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceReimbursementRates/Agencies/Agency/Rates/Rate/Value | FoodserviceReimbursementRates/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceMealPrices/Prices/Price/Value | FoodserviceMealPrices/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffMeal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceTransaction/Tax | FoodserviceTransaction/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceTransactionDetails/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceTransactionPayMethod/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceSales/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceItemSales/ItemQuantities/ItemQuantity/Value | FoodserviceItemSales/ItemQuantities/ItemQuantity/Cost | FoodserviceItemSales/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceMenuPlan/MenuPlanQuantities/MenuPlanQuantity | FoodserviceMenuPlan/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceMilkSales/SaleQuantities/SaleQuantity/Value | FoodserviceMilkSales/SaleQuantities/SaleQuantity/ChargeToChild | FoodserviceMilkSales/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodservicePurchaseTransaction/PurchaseQuantities/PurchaseQuantity/Value | FoodservicePurchaseTransaction/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceStaffEnrollmentCount/Counts/Count/Tax | FoodserviceStaffEnrollmentCount/Counts/Count/Value | FoodserviceStaffEnrollmentCount/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceStaffMealCounts/Counts/Count/Tax | FoodserviceStaffMealCounts/Counts/Count/Value | FoodserviceStaffMealCounts/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceStudentEnrollmentCount/Counts/Count/Tax | FoodserviceStudentEnrollmentCount/Counts/Count/Value | FoodserviceStudentEnrollmentCount/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceStudentMealCounts/Counts/Count/Tax | FoodserviceStudentMealCounts/Counts/Count/Value | FoodserviceStudentMealCounts/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentRecordExchange/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentDemographicRecord/StudentPersonalData/DemographicsData/RaceList/Race/Proportion | StudentDemographicRecord/StudentPersonalData/AddressList/Address/GridLocation/Latitude | StudentDemographicRecord/StudentPersonalData/AddressList/Address/GridLocation/Longitude | StudentDemographicRecord/StudentContactsSummary/ParentGuardian1/AddressList/Address/GridLocation/Latitude | StudentDemographicRecord/StudentContactsSummary/ParentGuardian1/AddressList/Address/GridLocation/Longitude | StudentDemographicRecord/StudentContactsSummary/ParentGuardian2/AddressList/Address/GridLocation/Latitude | StudentDemographicRecord/StudentContactsSummary/ParentGuardian2/AddressList/Address/GridLocation/Longitude | StudentDemographicRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/AddressList/Address/GridLocation/Latitude | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/AddressList/Address/GridLocation/Longitude | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/AddressList/Address/GridLocation/Latitude | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/AddressList/Address/GridLocation/Longitude | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/GridLocation/Latitude | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/GridLocation/Longitude | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/AddressList/Address/GridLocation/Latitude | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/AddressList/Address/GridLocation/Longitude | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData/Percentage/Minimum | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData/Percentage/Maximum | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData/Numeric/Precision | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData/Numeric/Scale | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData/Numeric/Low | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData/Numeric/High | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData/Letter/ValidMark/NumericEquivalent | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData/Narrative/MaximumSize | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/MarkData/Percentage | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/MarkData/Numeric | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/MarkData/NumericAsDecimal | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/CourseCreditsAttempted | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/MarkData/Percentage | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/MarkData/Numeric | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/MarkData/NumericAsDecimal | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/CourseCreditsAttempted | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/CourseCreditsEarned | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/DaysAbsent | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/DaysPresent | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/CreditsAttempted | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/CreditsEarned | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/GPACreditsAttempted | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/GPACreditsEarned | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/GPAGradePoints | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/GPA | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/WeightedGPA | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/DaysAbsent | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/DaysPresent | StudentAcademicRecord/AcademicPerformanceSummary/TotalCreditsAttempted | StudentAcademicRecord/AcademicPerformanceSummary/TotalCreditsEarned | StudentAcademicRecord/AcademicPerformanceSummary/CumulativeGPACreditsEarned | StudentAcademicRecord/AcademicPerformanceSummary/CumulativeGradePoints | StudentAcademicRecord/AcademicPerformanceSummary/CumulativeGPA | StudentAcademicRecord/AcademicPerformanceSummary/ClassRank | StudentAcademicRecord/AcademicPerformanceSummary/ClassTotalNumber | StudentAcademicRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/GridLocation/Latitude | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/GridLocation/Longitude | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/AddressList/Address/GridLocation/Latitude | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/AddressList/Address/GridLocation/Longitude | StudentSpecialEducationRecord/StudentParticipationData/StudentSpecialEducationFTE | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/DaysInParticipation | StudentSpecialEducationRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | MarkValueInfo/Percentage/Minimum | MarkValueInfo/Percentage/Maximum | MarkValueInfo/Numeric/Precision | MarkValueInfo/Numeric/Scale | MarkValueInfo/Numeric/Low | MarkValueInfo/Numeric/High | MarkValueInfo/Letter/ValidMark/NumericEquivalent | MarkValueInfo/Narrative/MaximumSize | MarkValueInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | MarkInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SectionMarkInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSectionMarks/MarkList/Mark/Percentage | StudentSectionMarks/MarkList/Mark/Numeric | StudentSectionMarks/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | GradingCategory/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | GradingAssignment/PointsPossible | GradingAssignment/Weight | GradingAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | GradingAssignmentScore/ScorePoints | GradingAssignmentScore/ScorePercent | GradingAssignmentScore/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentPeriodAttendance/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentGrade/Grade/Percentage | StudentGrade/Grade/Numeric | StudentGrade/Grade/OutOf | StudentGrade/Grade/Low | StudentGrade/Grade/High | StudentGrade/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Billing/BilledAmount | Billing/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Payment/ReceivedAmount | Payment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeAssignment/JobFTE | EmployeeAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeContract/BaseSalary | EmployeeContract/ContractDays | EmployeeContract/AssignmentDays | EmployeeContract/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmploymentRecord/TotalYearsExperience | EmploymentRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeePersonal/Demographics/RaceList/Race/Proportion | EmployeePersonal/AddressList/Address/GridLocation/Latitude | EmployeePersonal/AddressList/Address/GridLocation/Longitude | EmployeePersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeePicture/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialAnnual/AnnualItems/AnnualItem/Amount | FinancialAnnual/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialBudget/BudgetAccounts/BudgetAccount/BudgetAmount | FinancialBudget/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | TimeWorked/RegularHours | TimeWorked/OvertimeHours | TimeWorked/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | VendorInfo/ContactInfo/Address/GridLocation/Latitude | VendorInfo/ContactInfo/Address/GridLocation/Longitude | VendorInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | W4/FederalAllowancesNumber | W4/StateAllowancesNumber | W4/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeWage/PayRates/PayRate/Amount | EmployeeWage/PayRates/PayRate/Percentage | EmployeeWage/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LocationInfo/AddressList/Address/GridLocation/Latitude | LocationInfo/AddressList/Address/GridLocation/Longitude | LocationInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Purchasing/PurchasingItems/PurchasingItem/UnitCost | Purchasing/PurchasingItems/PurchasingItem/ExpenseAccounts/ExpenseAccount/Amount | Purchasing/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AccountingPeriod/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialAccount/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialClass/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialIncomeStatement/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialTransaction/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FiscalYear/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ActivityProvider/Address/GridLocation/Latitude | ActivityProvider/Address/GridLocation/Longitude | ActivityProvider/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeCredit/Earned | EmployeeCredit/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeRecertification/Demographics/RaceList/Race/Proportion | EmployeeRecertification/ActivityHours | EmployeeRecertification/Earned | EmployeeRecertification/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeCredential/Demographics/RaceList/Race/Proportion | EmployeeCredential/Salary | EmployeeCredential/TotalYears | EmployeeCredential/UnitYears | EmployeeCredential/Assignments/Assignment/FTE | EmployeeCredential/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ProfessionalDevelopmentActivities/ClockHours | ProfessionalDevelopmentActivities/Credits | ProfessionalDevelopmentActivities/Stipend | ProfessionalDevelopmentActivities/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ProfessionalDevelopmentProgram/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ProfessionalDevelopmentRegistration/PaidAmount | ProfessionalDevelopmentRegistration/Stipend | ProfessionalDevelopmentRegistration/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentParticipation/StudentSpecialEducationFTE | StudentParticipation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentPlacement/DirectTime | StudentPlacement/IndirectTime | StudentPlacement/TotalServiceDuration | StudentPlacement/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | TestAccommodation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSpecialEducationSummary/StudentSpecialEducationFTE | StudentSpecialEducationSummary/NeglectedOrDelinquentParticipationList/NeglectedOrDelinquentParticipation/TotalDayCount | StudentSpecialEducationSummary/NeglectedOrDelinquentParticipationList/NeglectedOrDelinquentParticipation/ConsecutiveDayCount | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/DaysInParticipation | StudentSpecialEducationSummary/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Assessment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentItem/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ItemCharacteristics/PercentCorrect | ItemCharacteristics/SampleSize | ItemCharacteristics/Descriptive/SampleSize | ItemCharacteristics/Descriptive/PointBiserial | ItemCharacteristics/Descriptive/Biserial | ItemCharacteristics/Descriptive/DiscriminationIndex | ItemCharacteristics/DifferentialItemAnalysis/CMH | ItemCharacteristics/DifferentialItemAnalysis/MH | ItemCharacteristics/ResponseChoicePattern/Choice/Responses | ItemCharacteristics/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentSubTest/SubTestTier | AssessmentSubTest/NumberOfItems | AssessmentSubTest/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentAdministration/Address/GridLocation/Latitude | AssessmentAdministration/Address/GridLocation/Longitude | AssessmentAdministration/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentForm/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentRegistration/AssessmentStudentSnapshot/RaceList/Race/Proportion | AssessmentRegistration/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentResponseSet/Items/Item/NumberOfAttempts | StudentResponseSet/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentScoreSet/Scores/Score/NumberOfResponses | StudentScoreSet/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentPackage/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LearningStandardDocument/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LearningStandardItem/StandardHierarchyLevel/Number | LearningStandardItem/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | CurriculumStructure/CurriculumHierarchyLevel/Number | CurriculumStructure/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Lesson/Duration | Lesson/LessonSources/LessonSource/Author/Address/GridLocation/Latitude | Lesson/LessonSources/LessonSource/Author/Address/GridLocation/Longitude | Lesson/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Activity/Points | Activity/ActivityTime/Duration | Activity/MaxAttemptsAllowed | Activity/ActivityWeight | Activity/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Assignment/AssignmentTime/Duration | Assignment/MaxAttemptsAllowed | Assignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LearningResource/Contacts/Contact/Address/GridLocation/Latitude | LearningResource/Contacts/Contact/Address/GridLocation/Longitude | LearningResource/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ContentCatalog/Duration | ContentCatalog/Cost | ContentCatalog/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | PersonRoleAssociation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ResponseToIntervention/Tier | ResponseToIntervention/FrequencyTime/Duration | ResponseToIntervention/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | RTIResults/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LearningStandardAssociation/TargetObjects/TargetObject/AssociationStrength | LearningStandardAssociation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LibraryPatronStatus/TransactionList/Transaction/ItemInfo/Price | LibraryPatronStatus/TransactionList/Transaction/FineInfoList/FineInfo/Amount | LibraryPatronStatus/NumberOfCheckouts | LibraryPatronStatus/NumberOfOverdues | LibraryPatronStatus/NumberOfFines | LibraryPatronStatus/FineAmount | LibraryPatronStatus/NumberOfRefunds | LibraryPatronStatus/RefundAmount | LibraryPatronStatus/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Address/GridLocation/Latitude | Address/GridLocation/Longitude | StudentActivityInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentActivityParticipation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | DisciplineIncident/OffenderList/Offender/ActionList/Action/Duration | DisciplineIncident/IncidentActionList/IncidentAction/Duration | DisciplineIncident/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | CalendarSummary/DaysInSession | CalendarSummary/InstructionalMinutes | CalendarSummary/MinutesPerDay | CalendarSummary/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | CalendarDate/CalendarDateNumber | CalendarDate/StudentAttendance/AttendanceValue | CalendarDate/TeacherAttendance/AttendanceValue | CalendarDate/AdministratorAttendance/AttendanceValue | CalendarDate/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentAttendanceSummary/StartDay | StudentAttendanceSummary/EndDay | StudentAttendanceSummary/FTE | StudentAttendanceSummary/DaysAttended | StudentAttendanceSummary/ExcusedAbsences | StudentAttendanceSummary/UnexcusedAbsences | StudentAttendanceSummary/DaysTardy | StudentAttendanceSummary/DaysInMembership | StudentAttendanceSummary/ExpectationsMets | StudentAttendanceSummary/ExpectationsNotMets | StudentAttendanceSummary/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AttendanceCodeInfo/AbsenceValue | AttendanceCodeInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | RoomInfo/Size | RoomInfo/Capacity | RoomInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | RoomType/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SchoolCourseInfo/CourseCredits | SchoolCourseInfo/SCEDCode/AvailableCredit | SchoolCourseInfo/SCEDCode/SequenceNumber | SchoolCourseInfo/SCEDCode/SequenceLimit | SchoolCourseInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/Address/GridLocation/Latitude | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/Address/GridLocation/Longitude | SchoolInfo/AddressList/Address/GridLocation/Latitude | SchoolInfo/AddressList/Address/GridLocation/Longitude | SchoolInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SectionInfo/SchoolCourseInfoOverride/CourseCredits | SectionInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffPersonal/Demographics/RaceList/Race/Proportion | StaffPersonal/AddressList/Address/GridLocation/Latitude | StaffPersonal/AddressList/Address/GridLocation/Longitude | StaffPersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentContact/Demographics/RaceList/Race/Proportion | StudentContact/AddressList/Address/GridLocation/Latitude | StudentContact/AddressList/Address/GridLocation/Longitude | StudentContact/ContactSequence | StudentContact/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentDailyAttendance/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentPersonal/Demographics/RaceList/Race/Proportion | StudentPersonal/AddressList/Address/GridLocation/Latitude | StudentPersonal/AddressList/Address/GridLocation/Longitude | StudentPersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentPicture/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSchoolEnrollment/FTE | StudentSchoolEnrollment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSectionEnrollment/CreditsAttempted | StudentSectionEnrollment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | TermInfo/RelativeDuration | TermInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSnapshot/Address/GridLocation/Latitude | StudentSnapshot/Address/GridLocation/Longitude | StudentSnapshot/RaceList/Race/Proportion | StudentSnapshot/Age | StudentSnapshot/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LEAInfo/LEAContactList/LEAContact/ContactInfo/Address/GridLocation/Latitude | LEAInfo/LEAContactList/LEAContact/ContactInfo/Address/GridLocation/Longitude | LEAInfo/AddressList/Address/GridLocation/Latitude | LEAInfo/AddressList/Address/GridLocation/Longitude | LEAInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffAssignment/JobFTE | StaffAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BellSchedule/BellPeriodList/BellPeriod/InstructionalMinutes | BellSchedule/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentContactPersonal/PersonInfo/Demographics/RaceList/Race/Proportion | StudentContactPersonal/PersonInfo/AddressList/Address/GridLocation/Latitude | StudentContactPersonal/PersonInfo/AddressList/Address/GridLocation/Longitude | StudentContactPersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentContactRelationship/ContactSequence | StudentContactRelationship/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffSectionAssignment/PercentResponsible | StaffSectionAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffEvaluation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SectionCorrelation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SchoolFederalFund/SchoolImprovementAllocation | LEAFederalFund/FederalProgramList/FederalProgram/Code | LEAFederalFund/FederalProgramList/FederalProgram/FundingAllocation | BusEquipment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusInfo/SeatingCapacity | BusInfo/EquipmentList/Equipment/Count | BusInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusRouteDetail/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusRouteInfo/MaximumLoad | BusRouteInfo/RouteDistanceLoaded | BusRouteInfo/RouteDistanceTotal | BusRouteInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusStopInfo/GridLocation/Latitude | BusStopInfo/GridLocation/Longitude | BusStopInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentTransportInfo/HomeToSchoolDistance | StudentTransportInfo/WalkToStopDistance | StudentTransportInfo/StopToSchoolDistance | StudentTransportInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusPositionInfo/GridLocation/Latitude | BusPositionInfo/GridLocation/Longitude | BusPositionInfo/Odometer | BusPositionInfo/Speedometer | BusPositionInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Authentication/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EnergyUsage/DataSource/ReadingDataList/ReadingData/Interval | EnergyUsage/DataSource/ReadingDataList/ReadingData/ReadingList/Reading | EnergyUsage/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | IdMApplication/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | IdMAuthentication/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | IdMAuthorization/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | UserOrganizationAssociation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SEAInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | SEAInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | SEAInfo/SIF_Metadata/RightsElements/RightsElement/Cost | StudentLEARelationship/LEARelationshipType/ProvidingInstruction | StudentLEARelationship/LEARelationshipType/ProvidingServices | StudentLEARelationship/LEARelationshipType/FinanciallyResponsible | StudentLEARelationship/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentLEARelationship/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentLEARelationship/SIF_Metadata/RightsElements/RightsElement/Cost | xCalendar/sessions/session/markingTerm | xCalendar/sessions/session/schedulingTerm | xContact/phoneNumber/primaryIndicator | xContact/otherPhoneNumbers/phoneNumber/primaryIndicator | xContact/relationships/relationship/livesWith | xContact/relationships/relationship/primaryContactIndicator | xContact/relationships/relationship/emergencyContactIndicator | xContact/relationships/relationship/financialResponsibilityIndicator | xContact/relationships/relationship/custodialIndicator | xContact/relationships/relationship/communicationsIndicator | xIndividualizedEducationPlan/iepAdministrativeData/costSharing/status | xIndividualizedEducationPlan/iepEligibility/ideaDisability/SpecialDiagnosisJustifications/specificLearningDisability/decisions/severeDiscrepancyFound | xIndividualizedEducationPlan/iepEligibility/ideaDisability/SpecialDiagnosisJustifications/specificLearningDisability/decisions/InsufficientResponseToInterventionFound | xIndividualizedEducationPlan/iepEligibility/ideaDisability/SpecialDiagnosisJustifications/specificLearningDisability/decisions/eligibleForSpecificLearningDisabilityFinding | xIndividualizedEducationPlan/iepEligibility/ideaDisability/decisions/specificDisabilityIdentified | xLea/phoneNumber/primaryIndicator | xLea/otherPhoneNumbers/phoneNumber/primaryIndicator | xRoster/primaryStaff/teacherOfRecord | xRoster/otherStaffs/otherStaff/teacherOfRecord | xSchool/phoneNumber/primaryIndicator | xSchool/otherPhoneNumbers/phoneNumber/primaryIndicator | xStudent/phoneNumber/primaryIndicator | xStudent/otherPhoneNumbers/phoneNumber/primaryIndicator | xStudent/demographics/hispanicLatinoEthnicity | xTransferIep/referenceObjects/organizationList/referenceOrganization/phone/primaryIndicator | xTransferIep/iep/iepAdministrativeData/costSharing/status | xTransferIep/iep/iepEligibility/ideaDisability/SpecialDiagnosisJustifications/specificLearningDisability/decisions/severeDiscrepancyFound | xTransferIep/iep/iepEligibility/ideaDisability/SpecialDiagnosisJustifications/specificLearningDisability/decisions/InsufficientResponseToInterventionFound | xTransferIep/iep/iepEligibility/ideaDisability/SpecialDiagnosisJustifications/specificLearningDisability/decisions/eligibleForSpecificLearningDisabilityFinding | xTransferIep/iep/iepEligibility/ideaDisability/decisions/specificDisabilityIdentified | AggregateStatisticInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | AggregateStatisticInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | AggregateStatisticInfo/SIF_Metadata/RightsElements/RightsElement/Cost | AggregateCharacteristicInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | AggregateCharacteristicInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | AggregateCharacteristicInfo/SIF_Metadata/RightsElements/RightsElement/Cost | AggregateStatisticFact/SIF_Metadata/TimeElements/TimeElement/IsCurrent | AggregateStatisticFact/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | AggregateStatisticFact/SIF_Metadata/RightsElements/RightsElement/Cost | StudentMeal/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentMeal/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentMeal/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceItem/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceItem/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceItem/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceItemUnit/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceItemUnit/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceItemUnit/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceItemPortion/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceItemPortion/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceItemPortion/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceReimbursementRates/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceReimbursementRates/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceReimbursementRates/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceMealPrices/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceMealPrices/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceMealPrices/SIF_Metadata/RightsElements/RightsElement/Cost | StaffMeal/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StaffMeal/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StaffMeal/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceTransaction/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceTransaction/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceTransaction/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceTransactionDetails/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceTransactionDetails/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceTransactionDetails/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceTransactionPayMethod/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceTransactionPayMethod/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceTransactionPayMethod/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceSales/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceSales/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceSales/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceItemSales/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceItemSales/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceItemSales/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceMenuPlan/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceMenuPlan/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceMenuPlan/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceMilkSales/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceMilkSales/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceMilkSales/SIF_Metadata/RightsElements/RightsElement/Cost | FoodservicePurchaseTransaction/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodservicePurchaseTransaction/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodservicePurchaseTransaction/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceStaffEnrollmentCount/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceStaffEnrollmentCount/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceStaffEnrollmentCount/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceStaffMealCounts/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceStaffMealCounts/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceStaffMealCounts/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceStudentEnrollmentCount/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceStudentEnrollmentCount/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceStudentEnrollmentCount/SIF_Metadata/RightsElements/RightsElement/Cost | FoodserviceStudentMealCounts/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FoodserviceStudentMealCounts/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FoodserviceStudentMealCounts/SIF_Metadata/RightsElements/RightsElement/Cost | StudentRecordExchange/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentRecordExchange/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentRecordExchange/SIF_Metadata/RightsElements/RightsElement/Cost | StudentDemographicRecord/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentDemographicRecord/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentDemographicRecord/SIF_Metadata/RightsElements/RightsElement/Cost | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/LEARelationshipType/ProvidingInstruction | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/LEARelationshipType/ProvidingServices | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/LEARelationshipType/FinanciallyResponsible | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/CoreAcademicCourse | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/CoreAcademicCourse | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/ExcessiveAbsenceIndicator | StudentAcademicRecord/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentAcademicRecord/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentAcademicRecord/SIF_Metadata/RightsElements/RightsElement/Cost | StudentSpecialEducationRecord/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentSpecialEducationRecord/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentSpecialEducationRecord/SIF_Metadata/RightsElements/RightsElement/Cost | MarkValueInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | MarkValueInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | MarkValueInfo/SIF_Metadata/RightsElements/RightsElement/Cost | MarkInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | MarkInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | MarkInfo/SIF_Metadata/RightsElements/RightsElement/Cost | SectionMarkInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | SectionMarkInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | SectionMarkInfo/SIF_Metadata/RightsElements/RightsElement/Cost | StudentSectionMarks/IsFinal | StudentSectionMarks/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentSectionMarks/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentSectionMarks/SIF_Metadata/RightsElements/RightsElement/Cost | GradingCategory/SIF_Metadata/TimeElements/TimeElement/IsCurrent | GradingCategory/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | GradingCategory/SIF_Metadata/RightsElements/RightsElement/Cost | GradingAssignment/SIF_Metadata/TimeElements/TimeElement/IsCurrent | GradingAssignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | GradingAssignment/SIF_Metadata/RightsElements/RightsElement/Cost | GradingAssignmentScore/SIF_Metadata/TimeElements/TimeElement/IsCurrent | GradingAssignmentScore/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | GradingAssignmentScore/SIF_Metadata/RightsElements/RightsElement/Cost | StudentPeriodAttendance/ExpectationsMet | StudentPeriodAttendance/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentPeriodAttendance/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentPeriodAttendance/SIF_Metadata/RightsElements/RightsElement/Cost | StudentGrade/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentGrade/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentGrade/SIF_Metadata/RightsElements/RightsElement/Cost | Billing/SIF_Metadata/TimeElements/TimeElement/IsCurrent | Billing/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | Billing/SIF_Metadata/RightsElements/RightsElement/Cost | Payment/SIF_Metadata/TimeElements/TimeElement/IsCurrent | Payment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | Payment/SIF_Metadata/RightsElements/RightsElement/Cost | EmployeeAssignment/SIF_Metadata/TimeElements/TimeElement/IsCurrent | EmployeeAssignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | EmployeeAssignment/SIF_Metadata/RightsElements/RightsElement/Cost | EmployeeContract/SIF_Metadata/TimeElements/TimeElement/IsCurrent | EmployeeContract/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | EmployeeContract/SIF_Metadata/RightsElements/RightsElement/Cost | EmploymentRecord/Active | EmploymentRecord/SIF_Metadata/TimeElements/TimeElement/IsCurrent | EmploymentRecord/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | EmploymentRecord/SIF_Metadata/RightsElements/RightsElement/Cost | EmployeePersonal/SIF_Metadata/TimeElements/TimeElement/IsCurrent | EmployeePersonal/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | EmployeePersonal/SIF_Metadata/RightsElements/RightsElement/Cost | EmployeePicture/SIF_Metadata/TimeElements/TimeElement/IsCurrent | EmployeePicture/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | EmployeePicture/SIF_Metadata/RightsElements/RightsElement/Cost | FinancialAnnual/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FinancialAnnual/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FinancialAnnual/SIF_Metadata/RightsElements/RightsElement/Cost | FinancialBudget/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FinancialBudget/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FinancialBudget/SIF_Metadata/RightsElements/RightsElement/Cost | TimeWorked/SIF_Metadata/TimeElements/TimeElement/IsCurrent | TimeWorked/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | TimeWorked/SIF_Metadata/RightsElements/RightsElement/Cost | VendorInfo/Send1099 | VendorInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | VendorInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | VendorInfo/SIF_Metadata/RightsElements/RightsElement/Cost | W4/Exempt | W4/SIF_Metadata/TimeElements/TimeElement/IsCurrent | W4/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | W4/SIF_Metadata/RightsElements/RightsElement/Cost | EmployeeWage/SIF_Metadata/TimeElements/TimeElement/IsCurrent | EmployeeWage/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | EmployeeWage/SIF_Metadata/RightsElements/RightsElement/Cost | LocationInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | LocationInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | LocationInfo/SIF_Metadata/RightsElements/RightsElement/Cost | Purchasing/SIF_Metadata/TimeElements/TimeElement/IsCurrent | Purchasing/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | Purchasing/SIF_Metadata/RightsElements/RightsElement/Cost | AccountingPeriod/SIF_Metadata/TimeElements/TimeElement/IsCurrent | AccountingPeriod/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | AccountingPeriod/SIF_Metadata/RightsElements/RightsElement/Cost | FinancialAccount/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FinancialAccount/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FinancialAccount/SIF_Metadata/RightsElements/RightsElement/Cost | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/RightsElements/RightsElement/Cost | FinancialClass/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FinancialClass/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FinancialClass/SIF_Metadata/RightsElements/RightsElement/Cost | FinancialIncomeStatement/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FinancialIncomeStatement/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FinancialIncomeStatement/SIF_Metadata/RightsElements/RightsElement/Cost | FinancialTransaction/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FinancialTransaction/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FinancialTransaction/SIF_Metadata/RightsElements/RightsElement/Cost | FiscalYear/SIF_Metadata/TimeElements/TimeElement/IsCurrent | FiscalYear/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | FiscalYear/SIF_Metadata/RightsElements/RightsElement/Cost | ActivityProvider/SIF_Metadata/TimeElements/TimeElement/IsCurrent | ActivityProvider/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | ActivityProvider/SIF_Metadata/RightsElements/RightsElement/Cost | EmployeeCredit/SIF_Metadata/TimeElements/TimeElement/IsCurrent | EmployeeCredit/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | EmployeeCredit/SIF_Metadata/RightsElements/RightsElement/Cost | EmployeeRecertification/SIF_Metadata/TimeElements/TimeElement/IsCurrent | EmployeeRecertification/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | EmployeeRecertification/SIF_Metadata/RightsElements/RightsElement/Cost | EmployeeCredential/SIF_Metadata/TimeElements/TimeElement/IsCurrent | EmployeeCredential/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | EmployeeCredential/SIF_Metadata/RightsElements/RightsElement/Cost | ProfessionalDevelopmentActivities/SIF_Metadata/TimeElements/TimeElement/IsCurrent | ProfessionalDevelopmentActivities/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | ProfessionalDevelopmentActivities/SIF_Metadata/RightsElements/RightsElement/Cost | ProfessionalDevelopmentProgram/SIF_Metadata/TimeElements/TimeElement/IsCurrent | ProfessionalDevelopmentProgram/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | ProfessionalDevelopmentProgram/SIF_Metadata/RightsElements/RightsElement/Cost | ProfessionalDevelopmentRegistration/SIF_Metadata/TimeElements/TimeElement/IsCurrent | ProfessionalDevelopmentRegistration/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | ProfessionalDevelopmentRegistration/SIF_Metadata/RightsElements/RightsElement/Cost | StudentParticipation/ExtendedSchoolYear | StudentParticipation/ExtendedDay | StudentParticipation/PrivateNotPlacedByPublic | StudentParticipation/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentParticipation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentParticipation/SIF_Metadata/RightsElements/RightsElement/Cost | StudentPlacement/IncludedInSpecialEducationFTE | StudentPlacement/SpecialNeedsTransportation | StudentPlacement/AssistiveTechnology | StudentPlacement/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentPlacement/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentPlacement/SIF_Metadata/RightsElements/RightsElement/Cost | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/Accommodations/Accommodation/SpecialMaterials | TestAccommodation/SIF_Metadata/TimeElements/TimeElement/IsCurrent | TestAccommodation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | TestAccommodation/SIF_Metadata/RightsElements/RightsElement/Cost | StudentSpecialEducationSummary/SpecificDisabilityIdentified | StudentSpecialEducationSummary/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentSpecialEducationSummary/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentSpecialEducationSummary/SIF_Metadata/RightsElements/RightsElement/Cost | Assessment/SIF_Metadata/TimeElements/TimeElement/IsCurrent | Assessment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | Assessment/SIF_Metadata/RightsElements/RightsElement/Cost | AssessmentItem/SIF_Metadata/TimeElements/TimeElement/IsCurrent | AssessmentItem/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | AssessmentItem/SIF_Metadata/RightsElements/RightsElement/Cost | ItemCharacteristics/SIF_Metadata/TimeElements/TimeElement/IsCurrent | ItemCharacteristics/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | ItemCharacteristics/SIF_Metadata/RightsElements/RightsElement/Cost | AssessmentSubTest/ContainerOnly | AssessmentSubTest/SIF_Metadata/TimeElements/TimeElement/IsCurrent | AssessmentSubTest/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | AssessmentSubTest/SIF_Metadata/RightsElements/RightsElement/Cost | AssessmentAdministration/SIF_Metadata/TimeElements/TimeElement/IsCurrent | AssessmentAdministration/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | AssessmentAdministration/SIF_Metadata/RightsElements/RightsElement/Cost | AssessmentForm/SIF_Metadata/TimeElements/TimeElement/IsCurrent | AssessmentForm/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | AssessmentForm/SIF_Metadata/RightsElements/RightsElement/Cost | AssessmentRegistration/SIF_Metadata/TimeElements/TimeElement/IsCurrent | AssessmentRegistration/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | AssessmentRegistration/SIF_Metadata/RightsElements/RightsElement/Cost | StudentResponseSet/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentResponseSet/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentResponseSet/SIF_Metadata/RightsElements/RightsElement/Cost | StudentScoreSet/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentScoreSet/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentScoreSet/SIF_Metadata/RightsElements/RightsElement/Cost | AssessmentPackage/SIF_Metadata/TimeElements/TimeElement/IsCurrent | AssessmentPackage/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | AssessmentPackage/SIF_Metadata/RightsElements/RightsElement/Cost | LearningStandardDocument/SIF_Metadata/TimeElements/TimeElement/IsCurrent | LearningStandardDocument/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | LearningStandardDocument/SIF_Metadata/RightsElements/RightsElement/Cost | LearningStandardItem/SIF_Metadata/TimeElements/TimeElement/IsCurrent | LearningStandardItem/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | LearningStandardItem/SIF_Metadata/RightsElements/RightsElement/Cost | CurriculumStructure/SIF_Metadata/TimeElements/TimeElement/IsCurrent | CurriculumStructure/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | CurriculumStructure/SIF_Metadata/RightsElements/RightsElement/Cost | Lesson/SIF_Metadata/TimeElements/TimeElement/IsCurrent | Lesson/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | Lesson/SIF_Metadata/RightsElements/RightsElement/Cost | Activity/SIF_Metadata/TimeElements/TimeElement/IsCurrent | Activity/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | Activity/SIF_Metadata/RightsElements/RightsElement/Cost | Assignment/AddToGradeBookFlag | Assignment/SIF_Metadata/TimeElements/TimeElement/IsCurrent | Assignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | Assignment/SIF_Metadata/RightsElements/RightsElement/Cost | LearningResource/SIF_Metadata/TimeElements/TimeElement/IsCurrent | LearningResource/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | LearningResource/SIF_Metadata/RightsElements/RightsElement/Cost | ContentCatalog/SIF_Metadata/TimeElements/TimeElement/IsCurrent | ContentCatalog/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | ContentCatalog/SIF_Metadata/RightsElements/RightsElement/Cost | PersonRoleAssociation/SIF_Metadata/TimeElements/TimeElement/IsCurrent | PersonRoleAssociation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | PersonRoleAssociation/SIF_Metadata/RightsElements/RightsElement/Cost | ResponseToIntervention/SIF_Metadata/TimeElements/TimeElement/IsCurrent | ResponseToIntervention/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | ResponseToIntervention/SIF_Metadata/RightsElements/RightsElement/Cost | RTIResults/SIF_Metadata/TimeElements/TimeElement/IsCurrent | RTIResults/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | RTIResults/SIF_Metadata/RightsElements/RightsElement/Cost | LearningStandardAssociation/SIF_Metadata/TimeElements/TimeElement/IsCurrent | LearningStandardAssociation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | LearningStandardAssociation/SIF_Metadata/RightsElements/RightsElement/Cost | LibraryPatronStatus/SIF_Metadata/TimeElements/TimeElement/IsCurrent | LibraryPatronStatus/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | LibraryPatronStatus/SIF_Metadata/RightsElements/RightsElement/Cost | StudentActivityInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentActivityInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentActivityInfo/SIF_Metadata/RightsElements/RightsElement/Cost | StudentActivityParticipation/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentActivityParticipation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentActivityParticipation/SIF_Metadata/RightsElements/RightsElement/Cost | DisciplineIncident/SIF_Metadata/TimeElements/TimeElement/IsCurrent | DisciplineIncident/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | DisciplineIncident/SIF_Metadata/RightsElements/RightsElement/Cost | CalendarSummary/SIF_Metadata/TimeElements/TimeElement/IsCurrent | CalendarSummary/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | CalendarSummary/SIF_Metadata/RightsElements/RightsElement/Cost | CalendarDate/SIF_Metadata/TimeElements/TimeElement/IsCurrent | CalendarDate/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | CalendarDate/SIF_Metadata/RightsElements/RightsElement/Cost | StudentAttendanceSummary/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentAttendanceSummary/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentAttendanceSummary/SIF_Metadata/RightsElements/RightsElement/Cost | AttendanceCodeInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | AttendanceCodeInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | AttendanceCodeInfo/SIF_Metadata/RightsElements/RightsElement/Cost | RoomInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | RoomInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | RoomInfo/SIF_Metadata/RightsElements/RightsElement/Cost | RoomType/SIF_Metadata/TimeElements/TimeElement/IsCurrent | RoomType/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | RoomType/SIF_Metadata/RightsElements/RightsElement/Cost | SchoolCourseInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | SchoolCourseInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | SchoolCourseInfo/SIF_Metadata/RightsElements/RightsElement/Cost | SchoolInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | SchoolInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | SchoolInfo/SIF_Metadata/RightsElements/RightsElement/Cost | SectionInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | SectionInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | SectionInfo/SIF_Metadata/RightsElements/RightsElement/Cost | StaffPersonal/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StaffPersonal/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StaffPersonal/SIF_Metadata/RightsElements/RightsElement/Cost | StudentContact/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentContact/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentContact/SIF_Metadata/RightsElements/RightsElement/Cost | StudentDailyAttendance/ExpectationsMet | StudentDailyAttendance/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentDailyAttendance/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentDailyAttendance/SIF_Metadata/RightsElements/RightsElement/Cost | StudentPersonal/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentPersonal/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentPersonal/SIF_Metadata/RightsElements/RightsElement/Cost | StudentPicture/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentPicture/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentPicture/SIF_Metadata/RightsElements/RightsElement/Cost | StudentSchoolEnrollment/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentSchoolEnrollment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentSchoolEnrollment/SIF_Metadata/RightsElements/RightsElement/Cost | StudentSectionEnrollment/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentSectionEnrollment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentSectionEnrollment/SIF_Metadata/RightsElements/RightsElement/Cost | TermInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | TermInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | TermInfo/SIF_Metadata/RightsElements/RightsElement/Cost | StudentSnapshot/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentSnapshot/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentSnapshot/SIF_Metadata/RightsElements/RightsElement/Cost | LEAInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | LEAInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | LEAInfo/SIF_Metadata/RightsElements/RightsElement/Cost | StaffAssignment/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StaffAssignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StaffAssignment/SIF_Metadata/RightsElements/RightsElement/Cost | BellSchedule/SIF_Metadata/TimeElements/TimeElement/IsCurrent | BellSchedule/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | BellSchedule/SIF_Metadata/RightsElements/RightsElement/Cost | StudentContactPersonal/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentContactPersonal/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentContactPersonal/SIF_Metadata/RightsElements/RightsElement/Cost | StudentContactRelationship/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentContactRelationship/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentContactRelationship/SIF_Metadata/RightsElements/RightsElement/Cost | StaffSectionAssignment/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StaffSectionAssignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StaffSectionAssignment/SIF_Metadata/RightsElements/RightsElement/Cost | StaffEvaluation/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StaffEvaluation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StaffEvaluation/SIF_Metadata/RightsElements/RightsElement/Cost | SectionCorrelation/SIF_Metadata/TimeElements/TimeElement/IsCurrent | SectionCorrelation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | SectionCorrelation/SIF_Metadata/RightsElements/RightsElement/Cost | BusEquipment/SIF_Metadata/TimeElements/TimeElement/IsCurrent | BusEquipment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | BusEquipment/SIF_Metadata/RightsElements/RightsElement/Cost | BusInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | BusInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | BusInfo/SIF_Metadata/RightsElements/RightsElement/Cost | BusRouteDetail/SIF_Metadata/TimeElements/TimeElement/IsCurrent | BusRouteDetail/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | BusRouteDetail/SIF_Metadata/RightsElements/RightsElement/Cost | BusRouteInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | BusRouteInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | BusRouteInfo/SIF_Metadata/RightsElements/RightsElement/Cost | BusStopInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | BusStopInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | BusStopInfo/SIF_Metadata/RightsElements/RightsElement/Cost | StudentTransportInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | StudentTransportInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | StudentTransportInfo/SIF_Metadata/RightsElements/RightsElement/Cost | BusPositionInfo/SIF_Metadata/TimeElements/TimeElement/IsCurrent | BusPositionInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | BusPositionInfo/SIF_Metadata/RightsElements/RightsElement/Cost | Authentication/SIF_Metadata/TimeElements/TimeElement/IsCurrent | Authentication/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | Authentication/SIF_Metadata/RightsElements/RightsElement/Cost | EnergyUsage/SIF_Metadata/TimeElements/TimeElement/IsCurrent | EnergyUsage/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | EnergyUsage/SIF_Metadata/RightsElements/RightsElement/Cost | IdMApplication/SIF_Metadata/TimeElements/TimeElement/IsCurrent | IdMApplication/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | IdMApplication/SIF_Metadata/RightsElements/RightsElement/Cost | IdMAuthentication/SIF_Metadata/TimeElements/TimeElement/IsCurrent | IdMAuthentication/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | IdMAuthentication/SIF_Metadata/RightsElements/RightsElement/Cost | IdMAuthorization/SIF_Metadata/TimeElements/TimeElement/IsCurrent | IdMAuthorization/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | IdMAuthorization/SIF_Metadata/RightsElements/RightsElement/Cost | UserOrganizationAssociation/SIF_Metadata/TimeElements/TimeElement/IsCurrent | UserOrganizationAssociation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/IsCurrent | UserOrganizationAssociation/SIF_Metadata/RightsElements/RightsElement/Cost" mode="value">
    <xsl:call-template name="encode-numeric-value">
      <xsl:with-param name="value" select="." />
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="* | @*" mode="attrvalue">
    <xsl:text>"</xsl:text><xsl:apply-templates select="."/><xsl:text>"</xsl:text>
  </xsl:template>

  <!-- numeric or boolean attribute -->
  <xsl:template match="NEVERMATCH | NEVERMATCH" mode="attrvalue">
    <xsl:call-template name="encode-numeric-value">
      <xsl:with-param name="value" select="." />
    </xsl:call-template>
  </xsl:template>

  <!-- simple content with attribute -->
  <xsl:template match="SEAInfo/CSSOContact/Address/StateProvince | SEAInfo/CSSOContact/Address/StateANSICode | SEAInfo/CSSOContact/Address/Country | SEAInfo/CSSOContact/EmailList/Email | SEAInfo/CSSOContact/EmailList/Email | SEAInfo/SEAContactList/SEAContact/PublishInDirectory | SEAInfo/SEAContactList/SEAContact/ContactInfo/Address/StateProvince | SEAInfo/SEAContactList/SEAContact/ContactInfo/Address/StateANSICode | SEAInfo/SEAContactList/SEAContact/ContactInfo/Address/Country | SEAInfo/SEAContactList/SEAContact/ContactInfo/EmailList/Email | SEAInfo/SEAContactList/SEAContact/ContactInfo/EmailList/Email | SEAInfo/AddressList/Address/StateProvince | SEAInfo/AddressList/Address/StateANSICode | SEAInfo/AddressList/Address/Country | SEAInfo/OperationalStatus | SEAInfo/EDENInfo/FIPSStateCode | SEAInfo/CTEGraduationRateInclusion | SEAInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SEAInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | SEAInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SEAInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | SEAInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SEAInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | SEAInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SEAInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SEAInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SEAInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SEAInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SEAInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentLEARelationship/MembershipType | StudentLEARelationship/LEARelationshipType/ResidencyStatus/Code | StudentLEARelationship/LEARelationshipType/ResidencyStatus/OtherCodeList/OtherCode | StudentLEARelationship/EntryType/Code | StudentLEARelationship/EntryType/OtherCodeList/OtherCode | StudentLEARelationship/ExitType/Code | StudentLEARelationship/ExitType/OtherCodeList/OtherCode | StudentLEARelationship/ExitStatus/Code | StudentLEARelationship/ExitStatus/OtherCodeList/OtherCode | StudentLEARelationship/NonResidentAttendReason | StudentLEARelationship/GradeLevel/Code | StudentLEARelationship/GradeLevel/OtherCodeList/OtherCode | StudentLEARelationship/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentLEARelationship/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentLEARelationship/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentLEARelationship/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentLEARelationship/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentLEARelationship/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentLEARelationship/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentLEARelationship/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentLEARelationship/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentLEARelationship/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentLEARelationship/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentLEARelationship/SIF_ExtendedElements/SIF_ExtendedElement | SEAAccountability/HighSchoolGraduationRateIndicatorStatus | AggregateStatisticInfo/CalculationRule | AggregateStatisticInfo/ExclusionRules/ExclusionRule | AggregateStatisticInfo/Location/LocationRefId | AggregateStatisticInfo/Measure | AggregateStatisticInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AggregateStatisticInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AggregateStatisticInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AggregateStatisticInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AggregateStatisticInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AggregateStatisticInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AggregateStatisticInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AggregateStatisticInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AggregateStatisticInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AggregateStatisticInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AggregateStatisticInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AggregateStatisticInfo/SIF_ExtendedElements/SIF_ExtendedElement | AggregateCharacteristicInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AggregateCharacteristicInfo/SIF_ExtendedElements/SIF_ExtendedElement | AggregateStatisticFact/Excluded | AggregateStatisticFact/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AggregateStatisticFact/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AggregateStatisticFact/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AggregateStatisticFact/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AggregateStatisticFact/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AggregateStatisticFact/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AggregateStatisticFact/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AggregateStatisticFact/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AggregateStatisticFact/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AggregateStatisticFact/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AggregateStatisticFact/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AggregateStatisticFact/SIF_ExtendedElements/SIF_ExtendedElement | StudentMeal/Amounts/Amount | StudentMeal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentMeal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentMeal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentMeal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentMeal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentMeal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentMeal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentMeal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentMeal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentMeal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentMeal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentMeal/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceItem/ElectronicIdList/ElectronicId | FoodserviceItem/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceItem/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceItem/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceItem/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceItem/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceItem/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceItemUnit/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceItemUnit/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceItemUnit/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItemUnit/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceItemUnit/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceItemUnit/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceItemUnit/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceItemUnit/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceItemUnit/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceItemUnit/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceItemUnit/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceItemUnit/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceItemPortion/ItemPortionType | FoodserviceItemPortion/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceItemPortion/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceItemPortion/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItemPortion/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceItemPortion/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceItemPortion/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceItemPortion/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceItemPortion/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceItemPortion/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceItemPortion/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceItemPortion/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceItemPortion/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceReimbursementRates/Program | FoodserviceReimbursementRates/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceReimbursementRates/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceMealPrices/Program | FoodserviceMealPrices/Prices/Price/Value | FoodserviceMealPrices/Prices/Price/MealType | FoodserviceMealPrices/Prices/Price/GradeLevels/GradeLevel/Code | FoodserviceMealPrices/Prices/Price/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMealPrices/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceMealPrices/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceMealPrices/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMealPrices/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceMealPrices/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceMealPrices/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceMealPrices/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceMealPrices/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceMealPrices/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceMealPrices/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceMealPrices/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceMealPrices/SIF_ExtendedElements/SIF_ExtendedElement | StaffMeal/Amounts/Amount | StaffMeal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffMeal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StaffMeal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffMeal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StaffMeal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffMeal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StaffMeal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffMeal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffMeal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffMeal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffMeal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffMeal/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceTransaction/Program | FoodserviceTransaction/TransactionTypes/TransactionType | FoodserviceTransaction/Amount | FoodserviceTransaction/Tax | FoodserviceTransaction/Voided | FoodserviceTransaction/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceTransaction/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceTransaction/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceTransaction/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceTransaction/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceTransaction/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceTransactionDetails/Amounts/Amount | FoodserviceTransactionDetails/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceTransactionDetails/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceTransactionPayMethod/TransactionPayMethods/TransactionPayMethod/Amounts/Amount | FoodserviceTransactionPayMethod/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceTransactionPayMethod/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceSales/Program | FoodserviceSales/SalesAmounts/SalesAmount | FoodserviceSales/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceSales/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceSales/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceSales/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceSales/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceSales/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceItemSales/Program | FoodserviceItemSales/ItemQuantities/ItemQuantity/MealType | FoodserviceItemSales/ItemQuantities/ItemQuantity/GradeLevels/GradeLevel/Code | FoodserviceItemSales/ItemQuantities/ItemQuantity/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItemSales/ItemQuantities/ItemQuantity/Cost | FoodserviceItemSales/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceItemSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceItemSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItemSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceItemSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceItemSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceItemSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceItemSales/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceItemSales/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceItemSales/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceItemSales/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceItemSales/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceMenuPlan/GradeLevels/GradeLevel/Code | FoodserviceMenuPlan/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMenuPlan/Program | FoodserviceMenuPlan/MenuPlanQuantities/MenuPlanQuantity | FoodserviceMenuPlan/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceMenuPlan/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceMilkSales/Program | FoodserviceMilkSales/SaleQuantities/SaleQuantity/ChargeToChild | FoodserviceMilkSales/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceMilkSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceMilkSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMilkSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceMilkSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceMilkSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceMilkSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceMilkSales/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceMilkSales/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceMilkSales/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceMilkSales/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceMilkSales/SIF_ExtendedElements/SIF_ExtendedElement | FoodservicePurchaseTransaction/PurchaseQuantities/PurchaseQuantity/MealType | FoodservicePurchaseTransaction/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodservicePurchaseTransaction/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceStaffEnrollmentCount/Program | FoodserviceStaffEnrollmentCount/Counts/Count/MealType | FoodserviceStaffEnrollmentCount/Counts/Count/Amount | FoodserviceStaffEnrollmentCount/Counts/Count/Tax | FoodserviceStaffEnrollmentCount/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceStaffEnrollmentCount/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceStaffMealCounts/Program | FoodserviceStaffMealCounts/Counts/Count/MealType | FoodserviceStaffMealCounts/Counts/Count/Amount | FoodserviceStaffMealCounts/Counts/Count/Tax | FoodserviceStaffMealCounts/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceStaffMealCounts/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceStudentEnrollmentCount/Program | FoodserviceStudentEnrollmentCount/Counts/Count/MealType | FoodserviceStudentEnrollmentCount/Counts/Count/Amount | FoodserviceStudentEnrollmentCount/Counts/Count/Tax | FoodserviceStudentEnrollmentCount/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceStudentEnrollmentCount/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceStudentMealCounts/Program | FoodserviceStudentMealCounts/Counts/Count/MealType | FoodserviceStudentMealCounts/Counts/Count/Amount | FoodserviceStudentMealCounts/Counts/Count/Tax | FoodserviceStudentMealCounts/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceStudentMealCounts/SIF_ExtendedElements/SIF_ExtendedElement | StudentRecordExchange/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentRecordExchange/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentRecordExchange/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentRecordExchange/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentRecordExchange/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentRecordExchange/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentRecordExchange/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentRecordExchange/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentRecordExchange/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentRecordExchange/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentRecordExchange/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentRecordExchange/SIF_ExtendedElements/SIF_ExtendedElement | StudentDemographicRecord/StudentPersonalData/OtherIdList/OtherId | StudentDemographicRecord/StudentPersonalData/DemographicsData/RaceList/Race/Code | StudentDemographicRecord/StudentPersonalData/DemographicsData/RaceList/Race/OtherCodeList/OtherCode | StudentDemographicRecord/StudentPersonalData/DemographicsData/Gender | StudentDemographicRecord/StudentPersonalData/DemographicsData/EnglishProficiency/Code | StudentDemographicRecord/StudentPersonalData/DemographicsData/EnglishProficiency/OtherCodeList/OtherCode | StudentDemographicRecord/StudentPersonalData/DemographicsData/LanguageList/Language/Code | StudentDemographicRecord/StudentPersonalData/DemographicsData/LanguageList/Language/OtherCodeList/OtherCode | StudentDemographicRecord/StudentPersonalData/DemographicsData/LanguageList/Language/LanguageType | StudentDemographicRecord/StudentPersonalData/DemographicsData/HispanicLatino | StudentDemographicRecord/StudentPersonalData/DemographicsData/CountryOfBirth | StudentDemographicRecord/StudentPersonalData/DemographicsData/DwellingArrangement/Code | StudentDemographicRecord/StudentPersonalData/DemographicsData/DwellingArrangement/OtherCodeList/OtherCode | StudentDemographicRecord/StudentPersonalData/AddressList/Address/StateProvince | StudentDemographicRecord/StudentPersonalData/AddressList/Address/StateANSICode | StudentDemographicRecord/StudentPersonalData/AddressList/Address/Country | StudentDemographicRecord/StudentPersonalData/IDEA | StudentDemographicRecord/StudentPersonalData/Migrant | StudentDemographicRecord/StudentPersonalData/Title1 | StudentDemographicRecord/StudentPersonalData/GiftedTalented | StudentDemographicRecord/StudentPersonalData/EconomicDisadvantage | StudentDemographicRecord/StudentPersonalData/ELL | StudentDemographicRecord/StudentPersonalData/Homeless | StudentDemographicRecord/StudentPersonalData/Section504 | StudentDemographicRecord/StudentPersonalData/VocationalConcentrator | StudentDemographicRecord/StudentPersonalData/Immigrant | StudentDemographicRecord/StudentPersonalData/NeglectedDelinquent | StudentDemographicRecord/StudentContactsSummary/ParentGuardian1/AddressList/Address/StateProvince | StudentDemographicRecord/StudentContactsSummary/ParentGuardian1/AddressList/Address/StateANSICode | StudentDemographicRecord/StudentContactsSummary/ParentGuardian1/AddressList/Address/Country | StudentDemographicRecord/StudentContactsSummary/ParentGuardian2/AddressList/Address/StateProvince | StudentDemographicRecord/StudentContactsSummary/ParentGuardian2/AddressList/Address/StateANSICode | StudentDemographicRecord/StudentContactsSummary/ParentGuardian2/AddressList/Address/Country | StudentDemographicRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentDemographicRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentDemographicRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentDemographicRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentDemographicRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentDemographicRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentDemographicRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentDemographicRecord/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentDemographicRecord/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentDemographicRecord/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentDemographicRecord/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentDemographicRecord/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/StudentSchoolEnrollmentData/GradeLevel/Code | StudentAcademicRecord/StudentSchoolEnrollmentData/GradeLevel/OtherCodeList/OtherCode | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/AddressList/Address/StateProvince | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/AddressList/Address/StateANSICode | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/AddressList/Address/Country | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/AddressList/Address/StateProvince | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/AddressList/Address/StateANSICode | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/AddressList/Address/Country | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/StudentSchoolEnrollmentData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/LEAInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/PublishInDirectory | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/StateProvince | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/StateANSICode | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/Country | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/AddressList/Address/StateProvince | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/AddressList/Address/StateANSICode | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/AddressList/Address/Country | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/IdentificationInfoList/IdentificationInfo | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/GradeLevels/GradeLevel/Code | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/EntryType/Code | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/EntryType/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/GradeLevel/Code | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/GradeLevel/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/ExitStatus/Code | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/ExitStatus/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/ExitType/Code | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/ExitType/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/MembershipType | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/LEARelationshipType/ResidencyStatus/Code | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/LEARelationshipType/ResidencyStatus/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentSchoolRelationship/MembershipType | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentSchoolRelationship/ResidencyStatus/Code | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentSchoolRelationship/NonResidentAttendReason | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentSchoolRelationship/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/TermInfoData/TermSpan/Code | StudentAcademicRecord/CurrentCourseActivity/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/SubjectAreaList/SubjectArea/Code | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/SubjectAreaList/SubjectArea/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/InstructionalLevel/Code | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/InstructionalLevel/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/GraduationRequirement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/TermInfoData/TermSpan/Code | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/GradeLevelWhenTaken/Code | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/GradeLevelWhenTaken/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/MarkData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/TermInfoData/TermSpan/Code | StudentAcademicRecord/CourseHistory/Term/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/SubjectAreaList/SubjectArea/Code | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/SubjectAreaList/SubjectArea/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/InstructionalLevel/Code | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/InstructionalLevel/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/GraduationRequirement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/TermInfoData/TermSpan/Code | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/GradeLevelWhenTaken/Code | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/GradeLevelWhenTaken/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/MarkData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/CreditType | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SectionInfoData/MediumOfInstruction/Code | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SectionInfoData/MediumOfInstruction/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/TermInfoData/TermSpan/Code | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/GradeLevelWhenTaken/Code | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/GradeLevelWhenTaken/OtherCodeList/OtherCode | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/ProgressLevel | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AcademicPerformanceSummary/GraduationRateSurveyIndicator | StudentAcademicRecord/AcademicPerformanceSummary/AcademicTrack | StudentAcademicRecord/AcademicPerformanceSummary/AcademicFoci/AcademicFocus/Code | StudentAcademicRecord/AcademicPerformanceSummary/AcademicFoci/AcademicFocus/OtherCodeList/OtherCode | StudentAcademicRecord/AcademicPerformanceSummary/AcademicSubjects/AcademicSubject/Code | StudentAcademicRecord/AcademicPerformanceSummary/AcademicSubjects/AcademicSubject/OtherCodeList/OtherCode | StudentAcademicRecord/AcademicPerformanceSummary/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AssessmentPerformanceHistory/Assessment/StudentGradeLevelWhenAssessed/Code | StudentAcademicRecord/AssessmentPerformanceHistory/Assessment/StudentGradeLevelWhenAssessed/OtherCodeList/OtherCode | StudentAcademicRecord/AssessmentPerformanceHistory/Assessment/TestScoreType | StudentAcademicRecord/AssessmentPerformanceHistory/Assessment/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AdditionalGraduationRequirementPerformanceHistory/Requirement/Status | StudentAcademicRecord/AdditionalGraduationRequirementPerformanceHistory/Requirement/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/ActivityAwardHistory/ActivityAward/InvolvementCode | StudentAcademicRecord/ActivityAwardHistory/ActivityAward/HonorsInformationCode | StudentAcademicRecord/ActivityAwardHistory/ActivityAward/DiplomaCredentialHonorsCode | StudentAcademicRecord/ActivityAwardHistory/ActivityAward/CredentialConferred | StudentAcademicRecord/ActivityAwardHistory/ActivityAward/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentAcademicRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentAcademicRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentAcademicRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentAcademicRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentAcademicRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentAcademicRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentAcademicRecord/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentAcademicRecord/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentAcademicRecord/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentAcademicRecord/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentAcademicRecord/SIF_ExtendedElements/SIF_ExtendedElement | StudentSpecialEducationRecord/StudentParticipationData/ProgramType/Code | StudentSpecialEducationRecord/StudentParticipationData/ProgramType/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/PublishInDirectory | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/StateProvince | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/StateANSICode | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/Country | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/AddressList/Address/StateProvince | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/AddressList/Address/StateANSICode | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/AddressList/Address/Country | StudentSpecialEducationRecord/StudentParticipationData/ProgramStatus/Code | StudentSpecialEducationRecord/StudentParticipationData/ProgramStatus/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/Code | StudentSpecialEducationRecord/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationData/PlannedAssessmentParticipation | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramType/Code | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramType/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramFundingSources/ProgramFundingSource/Code | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramFundingSources/ProgramFundingSource/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ManagingPublicAgency | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ManagingSchool | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramStatus/Code | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramStatus/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/GiftedEligibilityCriteria | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/Code | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/PlannedAssessmentParticipation | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/Service/Code | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/Service/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceCategory | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceFundingSources/ServiceFundingSource/Code | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceFundingSources/ServiceFundingSource/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServicingPublicAgency | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServicingSchool | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/SchoolWhereServiceDelivered | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceProviderType/Code | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceProviderType/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/FrequencyTime/Code | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/FrequencyTime/OtherCodeList/OtherCode | StudentSpecialEducationRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSpecialEducationRecord/SIF_ExtendedElements/SIF_ExtendedElement | MarkValueInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | MarkValueInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | MarkValueInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | MarkValueInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | MarkValueInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | MarkValueInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | MarkValueInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | MarkValueInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | MarkValueInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | MarkValueInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | MarkValueInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | MarkValueInfo/SIF_ExtendedElements/SIF_ExtendedElement | MarkInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | MarkInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | MarkInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | MarkInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | MarkInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | MarkInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | MarkInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | MarkInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | MarkInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | MarkInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | MarkInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | MarkInfo/SIF_ExtendedElements/SIF_ExtendedElement | SectionMarkInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SectionMarkInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | SectionMarkInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SectionMarkInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | SectionMarkInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SectionMarkInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | SectionMarkInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SectionMarkInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SectionMarkInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SectionMarkInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SectionMarkInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SectionMarkInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentSectionMarks/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSectionMarks/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentSectionMarks/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSectionMarks/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentSectionMarks/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSectionMarks/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentSectionMarks/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSectionMarks/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSectionMarks/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSectionMarks/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSectionMarks/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSectionMarks/SIF_ExtendedElements/SIF_ExtendedElement | GradingCategory/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | GradingCategory/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | GradingCategory/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | GradingCategory/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | GradingCategory/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | GradingCategory/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | GradingCategory/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | GradingCategory/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | GradingCategory/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | GradingCategory/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | GradingCategory/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | GradingCategory/SIF_ExtendedElements/SIF_ExtendedElement | GradingAssignment/DetailedDescription | GradingAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | GradingAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | GradingAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | GradingAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | GradingAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | GradingAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | GradingAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | GradingAssignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | GradingAssignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | GradingAssignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | GradingAssignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | GradingAssignment/SIF_ExtendedElements/SIF_ExtendedElement | GradingAssignmentScore/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | GradingAssignmentScore/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | GradingAssignmentScore/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | GradingAssignmentScore/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | GradingAssignmentScore/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | GradingAssignmentScore/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | GradingAssignmentScore/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | GradingAssignmentScore/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | GradingAssignmentScore/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | GradingAssignmentScore/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | GradingAssignmentScore/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | GradingAssignmentScore/SIF_ExtendedElements/SIF_ExtendedElement | StudentPeriodAttendance/AttendanceCode | StudentPeriodAttendance/InstructionalDeliveryMode | StudentPeriodAttendance/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentPeriodAttendance/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentPeriodAttendance/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentPeriodAttendance/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentPeriodAttendance/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentPeriodAttendance/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentPeriodAttendance/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentPeriodAttendance/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentPeriodAttendance/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentPeriodAttendance/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentPeriodAttendance/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentPeriodAttendance/SIF_ExtendedElements/SIF_ExtendedElement | StudentGrade/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentGrade/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentGrade/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentGrade/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentGrade/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentGrade/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentGrade/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentGrade/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentGrade/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentGrade/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentGrade/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentGrade/SIF_ExtendedElements/SIF_ExtendedElement | Billing/BilledEntity | Billing/BilledAmount | Billing/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Billing/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Billing/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Billing/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Billing/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Billing/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Billing/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Billing/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Billing/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Billing/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Billing/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Billing/SIF_ExtendedElements/SIF_ExtendedElement | Payment/ReceivedAmount | Payment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Payment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Payment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Payment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Payment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Payment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Payment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Payment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Payment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Payment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Payment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Payment/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeAssignment/PrimaryAssignment | EmployeeAssignment/JobClassification/Code | EmployeeAssignment/JobClassification/OtherCodeList/OtherCode | EmployeeAssignment/ProgramType/Code | EmployeeAssignment/ProgramType/OtherCodeList/OtherCode | EmployeeAssignment/FundingSource/Code | EmployeeAssignment/FundingSource/OtherCodeList/OtherCode | EmployeeAssignment/SpecialEducation/AgeGroupList/AgeGroup/AgeGroup | EmployeeAssignment/SpecialEducation/TitleList/TitleList/Title | EmployeeAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeeAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeeAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeeAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeAssignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeAssignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeAssignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeAssignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeAssignment/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeContract/BaseSalary | EmployeeContract/ContractTerm | EmployeeContract/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeContract/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeeContract/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeContract/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeeContract/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeContract/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeeContract/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeContract/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeContract/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeContract/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeContract/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeContract/SIF_ExtendedElements/SIF_ExtendedElement | EmploymentRecord/FullTimeStatus | EmploymentRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmploymentRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmploymentRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmploymentRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmploymentRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmploymentRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmploymentRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmploymentRecord/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmploymentRecord/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmploymentRecord/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmploymentRecord/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmploymentRecord/SIF_ExtendedElements/SIF_ExtendedElement | EmployeePersonal/OtherIdList/OtherId | EmployeePersonal/Demographics/RaceList/Race/Code | EmployeePersonal/Demographics/RaceList/Race/OtherCodeList/OtherCode | EmployeePersonal/Demographics/HispanicLatino | EmployeePersonal/Demographics/Gender | EmployeePersonal/Demographics/BirthDateVerification | EmployeePersonal/Demographics/StateOfBirth | EmployeePersonal/Demographics/CountryOfBirth | EmployeePersonal/Demographics/CountriesOfCitizenship/CountryOfCitizenship | EmployeePersonal/Demographics/CountriesOfResidency/CountryOfResidency | EmployeePersonal/Demographics/CitizenshipStatus | EmployeePersonal/Demographics/EnglishProficiency/Code | EmployeePersonal/Demographics/EnglishProficiency/OtherCodeList/OtherCode | EmployeePersonal/Demographics/LanguageList/Language/Code | EmployeePersonal/Demographics/LanguageList/Language/OtherCodeList/OtherCode | EmployeePersonal/Demographics/LanguageList/Language/LanguageType | EmployeePersonal/Demographics/DwellingArrangement/Code | EmployeePersonal/Demographics/DwellingArrangement/OtherCodeList/OtherCode | EmployeePersonal/AddressList/Address/StateProvince | EmployeePersonal/AddressList/Address/StateANSICode | EmployeePersonal/AddressList/Address/Country | EmployeePersonal/EmailList/Email | EmployeePersonal/EmailList/Email | EmployeePersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeePersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeePersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeePersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeePersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeePersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeePersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeePersonal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeePersonal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeePersonal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeePersonal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeePersonal/SIF_ExtendedElements/SIF_ExtendedElement | EmployeePicture/PictureSource | EmployeePicture/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeePicture/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeePicture/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeePicture/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeePicture/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeePicture/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeePicture/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeePicture/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeePicture/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeePicture/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeePicture/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeePicture/SIF_ExtendedElements/SIF_ExtendedElement | FinancialAnnual/AnnualItems/AnnualItem/AccountType | FinancialAnnual/AnnualItems/AnnualItem/AccountTypeDetail | FinancialAnnual/AnnualItems/AnnualItem/FundType | FinancialAnnual/AnnualItems/AnnualItem/ExpenditureArea | FinancialAnnual/AnnualItems/AnnualItem/SpecialAmountType | FinancialAnnual/AnnualItems/AnnualItem/GLAmountType | FinancialAnnual/AnnualItems/AnnualItem/SIF_ExtendedElements/SIF_ExtendedElement | FinancialAnnual/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialAnnual/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialAnnual/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialAnnual/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialAnnual/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialAnnual/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialAnnual/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialAnnual/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialAnnual/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialAnnual/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialAnnual/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialAnnual/SIF_ExtendedElements/SIF_ExtendedElement | FinancialBudget/BudgetAccounts/BudgetAccount/AccountClass | FinancialBudget/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialBudget/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialBudget/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialBudget/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialBudget/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialBudget/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialBudget/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialBudget/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialBudget/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialBudget/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialBudget/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialBudget/SIF_ExtendedElements/SIF_ExtendedElement | TimeWorked/JobFunction/Code | TimeWorked/JobFunction/OtherCodeList/OtherCode | TimeWorked/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | TimeWorked/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | TimeWorked/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | TimeWorked/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | TimeWorked/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | TimeWorked/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | TimeWorked/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | TimeWorked/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | TimeWorked/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | TimeWorked/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | TimeWorked/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | TimeWorked/SIF_ExtendedElements/SIF_ExtendedElement | VendorInfo/ContactInfo/Address/StateProvince | VendorInfo/ContactInfo/Address/StateANSICode | VendorInfo/ContactInfo/Address/Country | VendorInfo/ContactInfo/EmailList/Email | VendorInfo/ContactInfo/EmailList/Email | VendorInfo/FederalTaxId | VendorInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | VendorInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | VendorInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | VendorInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | VendorInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | VendorInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | VendorInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | VendorInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | VendorInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | VendorInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | VendorInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | VendorInfo/SIF_ExtendedElements/SIF_ExtendedElement | W4/MaritalStatusRate | W4/StateProvince | W4/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | W4/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | W4/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | W4/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | W4/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | W4/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | W4/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | W4/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | W4/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | W4/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | W4/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | W4/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeWage/PayRates/PayRate/Amount | EmployeeWage/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeWage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeeWage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeWage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeeWage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeWage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeeWage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeWage/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeWage/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeWage/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeWage/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeWage/SIF_ExtendedElements/SIF_ExtendedElement | LocationInfo/IdentificationInfoList/IdentificationInfo | LocationInfo/ParentLocationInfo | LocationInfo/AddressList/Address/StateProvince | LocationInfo/AddressList/Address/StateANSICode | LocationInfo/AddressList/Address/Country | LocationInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LocationInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LocationInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LocationInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LocationInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LocationInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LocationInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LocationInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LocationInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LocationInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LocationInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LocationInfo/SIF_ExtendedElements/SIF_ExtendedElement | Purchasing/FormType | Purchasing/PurchasingItems/PurchasingItem/UnitCost | Purchasing/PurchasingItems/PurchasingItem/ExpenseAccounts/ExpenseAccount/Amount | Purchasing/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Purchasing/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Purchasing/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Purchasing/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Purchasing/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Purchasing/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Purchasing/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Purchasing/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Purchasing/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Purchasing/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Purchasing/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Purchasing/SIF_ExtendedElements/SIF_ExtendedElement | AccountingPeriod/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AccountingPeriod/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AccountingPeriod/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AccountingPeriod/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AccountingPeriod/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AccountingPeriod/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AccountingPeriod/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AccountingPeriod/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AccountingPeriod/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AccountingPeriod/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AccountingPeriod/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AccountingPeriod/SIF_ExtendedElements/SIF_ExtendedElement | FinancialAccount/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialAccount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialAccount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialAccount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialAccount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialAccount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialAccount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialAccount/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialAccount/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialAccount/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialAccount/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialAccount/SIF_ExtendedElements/SIF_ExtendedElement | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialAccountAccountingPeriodLocationInfo/SIF_ExtendedElements/SIF_ExtendedElement | FinancialClass/ClassType | FinancialClass/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialClass/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialClass/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialClass/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialClass/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialClass/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialClass/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialClass/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialClass/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialClass/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialClass/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialClass/SIF_ExtendedElements/SIF_ExtendedElement | FinancialIncomeStatement/Amounts/Amount | FinancialIncomeStatement/Program | FinancialIncomeStatement/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialIncomeStatement/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialIncomeStatement/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialIncomeStatement/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialIncomeStatement/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialIncomeStatement/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialIncomeStatement/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialIncomeStatement/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialIncomeStatement/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialIncomeStatement/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialIncomeStatement/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialIncomeStatement/SIF_ExtendedElements/SIF_ExtendedElement | FinancialTransaction/Amounts/Amount | FinancialTransaction/Program | FinancialTransaction/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialTransaction/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialTransaction/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialTransaction/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialTransaction/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialTransaction/SIF_ExtendedElements/SIF_ExtendedElement | FiscalYear/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FiscalYear/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FiscalYear/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FiscalYear/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FiscalYear/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FiscalYear/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FiscalYear/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FiscalYear/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FiscalYear/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FiscalYear/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FiscalYear/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FiscalYear/SIF_ExtendedElements/SIF_ExtendedElement | ActivityProvider/Address/StateProvince | ActivityProvider/Address/StateANSICode | ActivityProvider/Address/Country | ActivityProvider/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ActivityProvider/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ActivityProvider/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ActivityProvider/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ActivityProvider/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ActivityProvider/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ActivityProvider/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ActivityProvider/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ActivityProvider/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ActivityProvider/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ActivityProvider/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ActivityProvider/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeCredit/Earned | EmployeeCredit/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeCredit/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeeCredit/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeCredit/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeeCredit/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeCredit/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeeCredit/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeCredit/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeCredit/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeCredit/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeCredit/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeCredit/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeRecertification/Demographics/RaceList/Race/Code | EmployeeRecertification/Demographics/RaceList/Race/OtherCodeList/OtherCode | EmployeeRecertification/Demographics/HispanicLatino | EmployeeRecertification/Demographics/Gender | EmployeeRecertification/Demographics/BirthDateVerification | EmployeeRecertification/Demographics/StateOfBirth | EmployeeRecertification/Demographics/CountryOfBirth | EmployeeRecertification/Demographics/CountriesOfCitizenship/CountryOfCitizenship | EmployeeRecertification/Demographics/CountriesOfResidency/CountryOfResidency | EmployeeRecertification/Demographics/CitizenshipStatus | EmployeeRecertification/Demographics/EnglishProficiency/Code | EmployeeRecertification/Demographics/EnglishProficiency/OtherCodeList/OtherCode | EmployeeRecertification/Demographics/LanguageList/Language/Code | EmployeeRecertification/Demographics/LanguageList/Language/OtherCodeList/OtherCode | EmployeeRecertification/Demographics/LanguageList/Language/LanguageType | EmployeeRecertification/Demographics/DwellingArrangement/Code | EmployeeRecertification/Demographics/DwellingArrangement/OtherCodeList/OtherCode | EmployeeRecertification/ActivityType | EmployeeRecertification/Earned | EmployeeRecertification/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeRecertification/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeeRecertification/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeRecertification/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeeRecertification/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeRecertification/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeeRecertification/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeRecertification/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeRecertification/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeRecertification/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeRecertification/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeRecertification/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeCredential/Demographics/RaceList/Race/Code | EmployeeCredential/Demographics/RaceList/Race/OtherCodeList/OtherCode | EmployeeCredential/Demographics/HispanicLatino | EmployeeCredential/Demographics/Gender | EmployeeCredential/Demographics/BirthDateVerification | EmployeeCredential/Demographics/StateOfBirth | EmployeeCredential/Demographics/CountryOfBirth | EmployeeCredential/Demographics/CountriesOfCitizenship/CountryOfCitizenship | EmployeeCredential/Demographics/CountriesOfResidency/CountryOfResidency | EmployeeCredential/Demographics/CitizenshipStatus | EmployeeCredential/Demographics/EnglishProficiency/Code | EmployeeCredential/Demographics/EnglishProficiency/OtherCodeList/OtherCode | EmployeeCredential/Demographics/LanguageList/Language/Code | EmployeeCredential/Demographics/LanguageList/Language/OtherCodeList/OtherCode | EmployeeCredential/Demographics/LanguageList/Language/LanguageType | EmployeeCredential/Demographics/DwellingArrangement/Code | EmployeeCredential/Demographics/DwellingArrangement/OtherCodeList/OtherCode | EmployeeCredential/Race | EmployeeCredential/Hispanic | EmployeeCredential/Certifications/Certification/AreaAuthorized | EmployeeCredential/Salary | EmployeeCredential/Status | EmployeeCredential/Leave | EmployeeCredential/Education | EmployeeCredential/TeachingCredentialType | EmployeeCredential/HighlyQualifiedTeacherIndicator | EmployeeCredential/ParaprofessionalQualificationStatus | EmployeeCredential/TerminationCode | EmployeeCredential/BackgroundChecks/BackgroundCheck/Type | EmployeeCredential/Assignments/Assignment/GradeLevels/GradeLevel/Code | EmployeeCredential/Assignments/Assignment/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeCredential/Assignments/Assignment/JobFunction/Code | EmployeeCredential/Assignments/Assignment/JobFunction/OtherCodeList/OtherCode | EmployeeCredential/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeCredential/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeeCredential/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeCredential/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeeCredential/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeCredential/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeeCredential/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeCredential/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeCredential/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeCredential/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeCredential/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeCredential/SIF_ExtendedElements/SIF_ExtendedElement | ProfessionalDevelopmentActivities/Stipend | ProfessionalDevelopmentActivities/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ProfessionalDevelopmentActivities/SIF_ExtendedElements/SIF_ExtendedElement | ProfessionalDevelopmentProgram/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ProfessionalDevelopmentProgram/SIF_ExtendedElements/SIF_ExtendedElement | ProfessionalDevelopmentRegistration/RegistrationStatus | ProfessionalDevelopmentRegistration/PaidAmount | ProfessionalDevelopmentRegistration/Stipend | ProfessionalDevelopmentRegistration/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ProfessionalDevelopmentRegistration/SIF_ExtendedElements/SIF_ExtendedElement | StudentParticipation/ProgramType/Code | StudentParticipation/ProgramType/OtherCodeList/OtherCode | StudentParticipation/ProgramFundingSources/ProgramFundingSource/Code | StudentParticipation/ProgramFundingSources/ProgramFundingSource/OtherCodeList/OtherCode | StudentParticipation/ManagingPublicAgency | StudentParticipation/ManagingSchool | StudentParticipation/PartCTransitionMeetingNotHeldReasons/PartCTransitionMeetingNotHeldReason/Code | StudentParticipation/PartCTransitionMeetingNotHeldReasons/PartCTransitionMeetingNotHeldReason/OtherCodeList/OtherCode | StudentParticipation/PartCTransitionMeetingOutcomes/PartCTransitionMeetingOutcome/Code | StudentParticipation/PartCTransitionMeetingOutcomes/PartCTransitionMeetingOutcome/OtherCodeList/OtherCode | StudentParticipation/ReferralSource/Code | StudentParticipation/ReferralSource/OtherCodeList/OtherCode | StudentParticipation/ProgramStatus/Code | StudentParticipation/ProgramStatus/OtherCodeList/OtherCode | StudentParticipation/ExceptionalityCategories/ExceptionalityCategory/Code | StudentParticipation/ExceptionalityCategories/ExceptionalityCategory/OtherCodeList/OtherCode | StudentParticipation/ProgramPlanType/Code | StudentParticipation/ProgramPlanType/OtherCodeList/OtherCode | StudentParticipation/LeastRestrictiveEnvironment/Code | StudentParticipation/LeastRestrictiveEnvironment/OtherCodeList/OtherCode | StudentParticipation/ProgramAvailability/Code | StudentParticipation/ProgramAvailability/OtherCodeList/OtherCode | StudentParticipation/ProgramExitReason/Code | StudentParticipation/ProgramExitReason/OtherCodeList/OtherCode | StudentParticipation/ProjectedExitReason | StudentParticipation/PlannedAssessmentParticipation | StudentParticipation/TransitionPlanning | StudentParticipation/AdditionalProgramAvailabilityList/ProgramAvailability/Code | StudentParticipation/AdditionalProgramAvailabilityList/ProgramAvailability/OtherCodeList/OtherCode | StudentParticipation/CertifiedLunchProgram | StudentParticipation/PerkinsLEPStatus | StudentParticipation/TitleIIIAccountabilityProgressStatus | StudentParticipation/TitleIIIImmigrantParticipationStatus | StudentParticipation/NeglectedOrDelinquentAchievementIndicator | StudentParticipation/NeglectedOrDelinquentAcademicOutcomeIndicator | StudentParticipation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentParticipation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentParticipation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentParticipation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentParticipation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentParticipation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentParticipation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentParticipation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentParticipation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentParticipation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentParticipation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentParticipation/SIF_ExtendedElements/SIF_ExtendedElement | StudentPlacement/Service/Code | StudentPlacement/Service/OtherCodeList/OtherCode | StudentPlacement/ServiceCategory | StudentPlacement/ServiceFundingSources/ServiceFundingSource/Code | StudentPlacement/ServiceFundingSources/ServiceFundingSource/OtherCodeList/OtherCode | StudentPlacement/ServicingPublicAgency | StudentPlacement/ServicingSchool | StudentPlacement/SchoolWhereServiceDelivered | StudentPlacement/ServiceProviderType/Code | StudentPlacement/ServiceProviderType/OtherCodeList/OtherCode | StudentPlacement/ServiceSetting/Code | StudentPlacement/ServiceSetting/OtherCodeList/OtherCode | StudentPlacement/WhenServiceProvided/Code | StudentPlacement/WhenServiceProvided/OtherCodeList/OtherCode | StudentPlacement/FrequencyTime/Code | StudentPlacement/FrequencyTime/OtherCodeList/OtherCode | StudentPlacement/DirectTime | StudentPlacement/IndirectTime | StudentPlacement/TotalServiceDuration | StudentPlacement/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentPlacement/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentPlacement/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentPlacement/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentPlacement/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentPlacement/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentPlacement/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentPlacement/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentPlacement/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentPlacement/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentPlacement/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentPlacement/SIF_ExtendedElements/SIF_ExtendedElement | TestAccommodation/GradeLevel/Code | TestAccommodation/GradeLevel/OtherCodeList/OtherCode | TestAccommodation/TestType | TestAccommodation/AuthorizedActual | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/StudentProgramType/OtherCodeList/OtherCode | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/Accommodations/Accommodation/OtherCodeList/OtherCode | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/Accommodations/Accommodation/AccommodationCategory/Code | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/Accommodations/Accommodation/AccommodationCategory/OtherCodeList/OtherCode | TestAccommodation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | TestAccommodation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | TestAccommodation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | TestAccommodation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | TestAccommodation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | TestAccommodation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | TestAccommodation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | TestAccommodation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | TestAccommodation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | TestAccommodation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | TestAccommodation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | TestAccommodation/SIF_ExtendedElements/SIF_ExtendedElement | StudentSpecialEducationSummary/PrimaryDisabilityCode | StudentSpecialEducationSummary/EnvironmentForSchoolAge | StudentSpecialEducationSummary/EnvironmentForEarlyChildhood | StudentSpecialEducationSummary/NeglectedOrDelinquentParticipationList/NeglectedOrDelinquentParticipation/Type | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramType/Code | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramType/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramFundingSources/ProgramFundingSource/Code | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramFundingSources/ProgramFundingSource/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ManagingPublicAgency | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ManagingSchool | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramStatus/Code | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramStatus/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/GiftedEligibilityCriteria | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/Code | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/PlannedAssessmentParticipation | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/Service/Code | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/Service/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceCategory | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceFundingSources/ServiceFundingSource/Code | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceFundingSources/ServiceFundingSource/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServicingPublicAgency | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServicingSchool | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/SchoolWhereServiceDelivered | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceProviderType/Code | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceProviderType/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/FrequencyTime/Code | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/FrequencyTime/OtherCodeList/OtherCode | StudentSpecialEducationSummary/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSpecialEducationSummary/SIF_ExtendedElements/SIF_ExtendedElement | StudentCareerTechnical/EducationCompleter | StudentCareerTechnical/Participant | StudentCareerTechnical/NontraditionalGenderStatus | StudentCareerTechnical/DisplacedHomemaker | StudentCareerTechnical/SingleParentOrSinglePregnantWoman | Assessment/AssessmentIdSystem | Assessment/AssessmentDescriptors/AssessmentDescriptor | Assessment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Assessment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Assessment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Assessment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Assessment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Assessment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Assessment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Assessment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Assessment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Assessment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Assessment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Assessment/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentItem/Stimulus/XMLData | AssessmentItem/Stimulus/TextData | AssessmentItem/Stimulus/BinaryData | AssessmentItem/Stem/XMLData | AssessmentItem/Stem/TextData | AssessmentItem/Stem/BinaryData | AssessmentItem/ResponseChoices/Choice/ChoiceContent/XMLData | AssessmentItem/ResponseChoices/Choice/ChoiceContent/TextData | AssessmentItem/ResponseChoices/Choice/ChoiceContent/BinaryData | AssessmentItem/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AssessmentItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AssessmentItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AssessmentItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentItem/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentItem/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentItem/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentItem/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentItem/SIF_ExtendedElements/SIF_ExtendedElement | ItemCharacteristics/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ItemCharacteristics/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ItemCharacteristics/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ItemCharacteristics/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ItemCharacteristics/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ItemCharacteristics/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ItemCharacteristics/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ItemCharacteristics/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ItemCharacteristics/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ItemCharacteristics/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ItemCharacteristics/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ItemCharacteristics/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentSubTest/GradeLevels/GradeLevel/Code | AssessmentSubTest/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentSubTest/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentSubTest/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AssessmentSubTest/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentSubTest/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AssessmentSubTest/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentSubTest/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AssessmentSubTest/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentSubTest/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentSubTest/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentSubTest/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentSubTest/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentSubTest/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentAdministration/SpecialConditions/SpecialCondition | AssessmentAdministration/Address/StateProvince | AssessmentAdministration/Address/StateANSICode | AssessmentAdministration/Address/Country | AssessmentAdministration/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentAdministration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AssessmentAdministration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentAdministration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AssessmentAdministration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentAdministration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AssessmentAdministration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentAdministration/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentAdministration/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentAdministration/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentAdministration/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentAdministration/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentForm/AssessmentType | AssessmentForm/GradeLevels/GradeLevel/Code | AssessmentForm/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentForm/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentForm/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AssessmentForm/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentForm/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AssessmentForm/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentForm/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AssessmentForm/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentForm/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentForm/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentForm/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentForm/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentForm/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentRegistration/StudentSpecialConditions/StudentSpecialCondition | AssessmentRegistration/StudentGradeLevel/Code | AssessmentRegistration/StudentGradeLevel/OtherCodeList/OtherCode | AssessmentRegistration/AssessmentGradeLevel/Code | AssessmentRegistration/AssessmentGradeLevel/OtherCodeList/OtherCode | AssessmentRegistration/AssessmentStudentSnapshot/RaceList/Race/Code | AssessmentRegistration/AssessmentStudentSnapshot/RaceList/Race/OtherCodeList/OtherCode | AssessmentRegistration/AssessmentStudentSnapshot/HispanicLatino | AssessmentRegistration/AssessmentStudentSnapshot/Gender | AssessmentRegistration/AssessmentStudentSnapshot/Title1 | AssessmentRegistration/AssessmentStudentSnapshot/ELL | AssessmentRegistration/StudentParticipation/Indicator | AssessmentRegistration/StudentParticipation/ReasonNotCompleting | AssessmentRegistration/StudentParticipation/ReasonNotTested | AssessmentRegistration/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentRegistration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AssessmentRegistration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentRegistration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AssessmentRegistration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentRegistration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AssessmentRegistration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentRegistration/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentRegistration/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentRegistration/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentRegistration/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentRegistration/SIF_ExtendedElements/SIF_ExtendedElement | StudentResponseSet/Items/Item/ResponseStatus | StudentResponseSet/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentResponseSet/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentResponseSet/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentResponseSet/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentResponseSet/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentResponseSet/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentResponseSet/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentResponseSet/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentResponseSet/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentResponseSet/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentResponseSet/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentResponseSet/SIF_ExtendedElements/SIF_ExtendedElement | StudentScoreSet/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentScoreSet/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentScoreSet/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentScoreSet/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentScoreSet/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentScoreSet/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentScoreSet/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentScoreSet/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentScoreSet/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentScoreSet/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentScoreSet/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentScoreSet/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentPackage/XMLData | AssessmentPackage/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentPackage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AssessmentPackage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentPackage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AssessmentPackage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentPackage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AssessmentPackage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentPackage/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentPackage/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentPackage/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentPackage/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentPackage/SIF_ExtendedElements/SIF_ExtendedElement | LearningStandardDocument/Source | LearningStandardDocument/SubjectAreas/SubjectArea/Code | LearningStandardDocument/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningStandardDocument/DocumentStatus | LearningStandardDocument/GradeLevels/GradeLevel/Code | LearningStandardDocument/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardDocument/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LearningStandardDocument/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LearningStandardDocument/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardDocument/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LearningStandardDocument/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningStandardDocument/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LearningStandardDocument/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LearningStandardDocument/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LearningStandardDocument/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LearningStandardDocument/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LearningStandardDocument/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LearningStandardDocument/SIF_ExtendedElements/SIF_ExtendedElement | LearningStandardItem/StandardSettingBody/Country | LearningStandardItem/StandardSettingBody/StateProvince | LearningStandardItem/GradeLevels/GradeLevel/Code | LearningStandardItem/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardItem/SubjectArea/Code | LearningStandardItem/SubjectArea/OtherCodeList/OtherCode | LearningStandardItem/StandardIdentifier/SubjectArea/Code | LearningStandardItem/StandardIdentifier/SubjectArea/OtherCodeList/OtherCode | LearningStandardItem/StandardIdentifier/GradeLevels/GradeLevel/Code | LearningStandardItem/StandardIdentifier/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardItem/StandardIdentifier/GradeLevel/Code | LearningStandardItem/StandardIdentifier/GradeLevel/OtherCodeList/OtherCode | LearningStandardItem/RelatedLearningStandardItems/LearningStandardItemRefId | LearningStandardItem/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LearningStandardItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LearningStandardItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LearningStandardItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningStandardItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LearningStandardItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LearningStandardItem/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LearningStandardItem/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LearningStandardItem/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LearningStandardItem/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LearningStandardItem/SIF_ExtendedElements/SIF_ExtendedElement | CurriculumStructure/SubjectArea/Code | CurriculumStructure/SubjectArea/OtherCodeList/OtherCode | CurriculumStructure/ComponentObjects/ComponentObject | CurriculumStructure/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | CurriculumStructure/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | CurriculumStructure/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | CurriculumStructure/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | CurriculumStructure/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | CurriculumStructure/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | CurriculumStructure/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | CurriculumStructure/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | CurriculumStructure/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | CurriculumStructure/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | CurriculumStructure/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | CurriculumStructure/SIF_ExtendedElements/SIF_ExtendedElement | Lesson/SourceObjects/SourceObject | Lesson/SubjectArea/Code | Lesson/SubjectArea/OtherCodeList/OtherCode | Lesson/Duration | Lesson/LessonSources/LessonSource/Author/Address/StateProvince | Lesson/LessonSources/LessonSource/Author/Address/StateANSICode | Lesson/LessonSources/LessonSource/Author/Address/Country | Lesson/LessonSources/LessonSource/Author/Email | Lesson/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Lesson/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Lesson/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Lesson/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Lesson/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Lesson/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Lesson/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Lesson/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Lesson/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Lesson/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Lesson/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Lesson/SIF_ExtendedElements/SIF_ExtendedElement | Activity/SubjectArea/Code | Activity/SubjectArea/OtherCodeList/OtherCode | Activity/SourceObjects/SourceObject | Activity/ActivityTime/Duration | Activity/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Activity/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Activity/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Activity/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Activity/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Activity/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Activity/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Activity/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Activity/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Activity/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Activity/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Activity/SIF_ExtendedElements/SIF_ExtendedElement | Assignment/SourceObjects/SourceObject | Assignment/AssignmentTime/Duration | Assignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Assignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Assignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Assignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Assignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Assignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Assignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Assignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Assignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Assignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Assignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Assignment/SIF_ExtendedElements/SIF_ExtendedElement | LearningResource/Contacts/Contact/Address/StateProvince | LearningResource/Contacts/Contact/Address/StateANSICode | LearningResource/Contacts/Contact/Address/Country | LearningResource/Contacts/Contact/Email | LearningResource/Location | LearningResource/GradeLevels/GradeLevel/Code | LearningResource/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningResource/SubjectAreas/SubjectArea/Code | LearningResource/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningResource/Components/Component/AssociatedObjects/AssociatedObject | LearningResource/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LearningResource/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LearningResource/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningResource/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LearningResource/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningResource/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LearningResource/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LearningResource/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LearningResource/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LearningResource/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LearningResource/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LearningResource/SIF_ExtendedElements/SIF_ExtendedElement | ContentCatalog/ContentObject/SourceObject | ContentCatalog/ContentObject/Location | ContentCatalog/LanguageCode | ContentCatalog/GradeLevels/GradeLevel/Code | ContentCatalog/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ContentCatalog/SubjectAreas/SubjectArea/Code | ContentCatalog/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ContentCatalog/LearningStandards/Document/StandardsSettingBody/Country | ContentCatalog/LearningStandards/Document/StandardsSettingBody/StateProvince | ContentCatalog/InstructionalLevel | ContentCatalog/Duration | ContentCatalog/Cost | ContentCatalog/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ContentCatalog/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ContentCatalog/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ContentCatalog/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ContentCatalog/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ContentCatalog/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ContentCatalog/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ContentCatalog/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ContentCatalog/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ContentCatalog/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ContentCatalog/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ContentCatalog/SIF_ExtendedElements/SIF_ExtendedElement | PersonRoleAssociation/AssociatedRoleRefId | PersonRoleAssociation/Creator | PersonRoleAssociation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | PersonRoleAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | PersonRoleAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | PersonRoleAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | PersonRoleAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | PersonRoleAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | PersonRoleAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | PersonRoleAssociation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | PersonRoleAssociation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | PersonRoleAssociation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | PersonRoleAssociation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | PersonRoleAssociation/SIF_ExtendedElements/SIF_ExtendedElement | ResponseToIntervention/Interventions/Intervention/InterventionType | ResponseToIntervention/Interventions/Intervention/InterventionDelivery | ResponseToIntervention/SubjectArea/Code | ResponseToIntervention/SubjectArea/OtherCodeList/OtherCode | ResponseToIntervention/Measurements/Measurement/FrequencyofMeasure | ResponseToIntervention/FrequencyTime/Duration | ResponseToIntervention/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ResponseToIntervention/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ResponseToIntervention/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ResponseToIntervention/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ResponseToIntervention/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ResponseToIntervention/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ResponseToIntervention/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ResponseToIntervention/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ResponseToIntervention/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ResponseToIntervention/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ResponseToIntervention/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ResponseToIntervention/SIF_ExtendedElements/SIF_ExtendedElement | RTIResults/Measurements/Measurement/FrequencyofMeasure | RTIResults/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | RTIResults/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | RTIResults/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | RTIResults/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | RTIResults/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | RTIResults/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | RTIResults/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | RTIResults/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | RTIResults/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | RTIResults/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | RTIResults/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | RTIResults/SIF_ExtendedElements/SIF_ExtendedElement | LearningStandardAssociation/LearningStandardRefId | LearningStandardAssociation/Creator | LearningStandardAssociation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LearningStandardAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LearningStandardAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LearningStandardAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningStandardAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LearningStandardAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LearningStandardAssociation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LearningStandardAssociation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LearningStandardAssociation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LearningStandardAssociation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LearningStandardAssociation/SIF_ExtendedElements/SIF_ExtendedElement | LibraryPatronStatus/ElectronicIdList/ElectronicId | LibraryPatronStatus/TransactionList/Transaction/ItemInfo/ElectronicId | LibraryPatronStatus/TransactionList/Transaction/ItemInfo/Price | LibraryPatronStatus/TransactionList/Transaction/FineInfoList/FineInfo/Amount | LibraryPatronStatus/FineAmount | LibraryPatronStatus/RefundAmount | LibraryPatronStatus/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LibraryPatronStatus/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LibraryPatronStatus/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LibraryPatronStatus/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LibraryPatronStatus/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LibraryPatronStatus/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LibraryPatronStatus/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LibraryPatronStatus/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LibraryPatronStatus/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LibraryPatronStatus/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LibraryPatronStatus/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LibraryPatronStatus/SIF_ExtendedElements/SIF_ExtendedElement | Address/AddressType | Address/LocalId/IdType | Address/Subregion | Address/StateProvince | Address/Country | StudentProgramAssociation/EntryType | StudentProgramAssociation/YearGroup | StudentProgramAssociation/ExitStatus | StudentProgramAssociation/ExitType | StudentProgramAssociation/PlacementType | StudentProgramAssociation/ManagingSchoolLocalId/IdType | StudentActivityInfo/StudentActivityType/Code | StudentActivityInfo/StudentActivityType/OtherCodeList/OtherCode | StudentActivityInfo/GradeLevels/GradeLevel/Code | StudentActivityInfo/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentActivityInfo/CurricularStatus | StudentActivityInfo/Location/LocationRefId | StudentActivityInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentActivityInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentActivityInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentActivityInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentActivityInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentActivityInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentActivityInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentActivityInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentActivityInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentActivityInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentActivityInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentActivityInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentActivityParticipation/RecognitionList/Recognition | StudentActivityParticipation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentActivityParticipation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentActivityParticipation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentActivityParticipation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentActivityParticipation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentActivityParticipation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentActivityParticipation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentActivityParticipation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentActivityParticipation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentActivityParticipation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentActivityParticipation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentActivityParticipation/SIF_ExtendedElements/SIF_ExtendedElement | DisciplineIncident/AgencyReporting | DisciplineIncident/IncidentTime | DisciplineIncident/IncidentLocation | DisciplineIncident/IncidentLocationRefId | DisciplineIncident/IncidentReporter/SIF_RefId | DisciplineIncident/RelatedToList/RelatedTo | DisciplineIncident/WeaponTypeList/WeaponType | DisciplineIncident/IncidentCategory/Code | DisciplineIncident/IncidentCategory/OtherCodeList/OtherCode | DisciplineIncident/OffenderList/Offender/SIF_RefId | DisciplineIncident/OffenderList/Offender/Injury | DisciplineIncident/OffenderList/Offender/ManifestationDetermination/MeetingHeld | DisciplineIncident/OffenderList/Offender/ManifestationDetermination/DueToDisability | DisciplineIncident/OffenderList/Offender/ActionList/Action/Code | DisciplineIncident/OffenderList/Offender/ActionList/Action/OtherCodeList/OtherCode | DisciplineIncident/OffenderList/Offender/ActionList/Action/ZeroTolerance | DisciplineIncident/OffenderList/Offender/ActionList/Action/FullYearExpulsion | DisciplineIncident/OffenderList/Offender/ActionList/Action/ShortenedExpulsion | DisciplineIncident/OffenderList/Offender/ActionList/Action/PoliceNotification | DisciplineIncident/OffenderList/Offender/ActionList/Action/Arrest | DisciplineIncident/OffenderList/Offender/ActionList/Action/AlternativeEducation | DisciplineIncident/OffenderList/Offender/WeaponTypeList/WeaponType | DisciplineIncident/OffenderList/Offender/RelatedToList/RelatedTo | DisciplineIncident/VictimList/Victim/SIF_RefId | DisciplineIncident/VictimList/Victim/Injury | DisciplineIncident/IncidentActionList/IncidentAction/ZeroTolerance | DisciplineIncident/IncidentActionList/IncidentAction/PoliceNotification | DisciplineIncident/IncidentActionList/IncidentAction/Arrest | DisciplineIncident/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | DisciplineIncident/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | DisciplineIncident/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | DisciplineIncident/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | DisciplineIncident/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | DisciplineIncident/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | DisciplineIncident/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | DisciplineIncident/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | DisciplineIncident/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | DisciplineIncident/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | DisciplineIncident/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | DisciplineIncident/SIF_ExtendedElements/SIF_ExtendedElement | CalendarSummary/GradeLevels/GradeLevel/Code | CalendarSummary/GradeLevels/GradeLevel/OtherCodeList/OtherCode | CalendarSummary/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | CalendarSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | CalendarSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | CalendarSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | CalendarSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | CalendarSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | CalendarSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | CalendarSummary/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | CalendarSummary/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | CalendarSummary/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | CalendarSummary/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | CalendarSummary/SIF_ExtendedElements/SIF_ExtendedElement | CalendarDate/CalendarDateType/Code | CalendarDate/CalendarDateType/OtherCodeList/OtherCode | CalendarDate/StudentAttendance/CountsTowardAttendance | CalendarDate/TeacherAttendance/CountsTowardAttendance | CalendarDate/AdministratorAttendance/CountsTowardAttendance | CalendarDate/InstructionalDeliveryModeList/InstructionalDeliveryMode | CalendarDate/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | CalendarDate/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | CalendarDate/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | CalendarDate/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | CalendarDate/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | CalendarDate/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | CalendarDate/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | CalendarDate/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | CalendarDate/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | CalendarDate/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | CalendarDate/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | CalendarDate/SIF_ExtendedElements/SIF_ExtendedElement | StudentAttendanceSummary/Resident | StudentAttendanceSummary/InstructionalDeliveryModeList/InstructionalDeliveryMode | StudentAttendanceSummary/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentAttendanceSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentAttendanceSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentAttendanceSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentAttendanceSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentAttendanceSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentAttendanceSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentAttendanceSummary/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentAttendanceSummary/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentAttendanceSummary/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentAttendanceSummary/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentAttendanceSummary/SIF_ExtendedElements/SIF_ExtendedElement | AttendanceCodeInfo/AttendanceType | AttendanceCodeInfo/AttendanceStatus | AttendanceCodeInfo/UsedForDailyAttendance | AttendanceCodeInfo/UsedForPeriodAttendance | AttendanceCodeInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AttendanceCodeInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AttendanceCodeInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AttendanceCodeInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AttendanceCodeInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AttendanceCodeInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AttendanceCodeInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AttendanceCodeInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AttendanceCodeInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AttendanceCodeInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AttendanceCodeInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AttendanceCodeInfo/SIF_ExtendedElements/SIF_ExtendedElement | RoomInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | RoomInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | RoomInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | RoomInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | RoomInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | RoomInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | RoomInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | RoomInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | RoomInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | RoomInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | RoomInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | RoomInfo/SIF_ExtendedElements/SIF_ExtendedElement | RoomType/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | RoomType/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | RoomType/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | RoomType/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | RoomType/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | RoomType/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | RoomType/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | RoomType/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | RoomType/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | RoomType/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | RoomType/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | RoomType/SIF_ExtendedElements/SIF_ExtendedElement | SchoolCourseInfo/SubjectAreaList/SubjectArea/Code | SchoolCourseInfo/SubjectAreaList/SubjectArea/OtherCodeList/OtherCode | SchoolCourseInfo/InstructionalLevel/Code | SchoolCourseInfo/InstructionalLevel/OtherCodeList/OtherCode | SchoolCourseInfo/CourseCredits | SchoolCourseInfo/CoreAcademicCourse | SchoolCourseInfo/GraduationRequirement | SchoolCourseInfo/SCEDCode/CourseDescription | SchoolCourseInfo/SCEDCode/CourseLevel | SchoolCourseInfo/DualCredit | SchoolCourseInfo/CTEConcentrator | SchoolCourseInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SchoolCourseInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | SchoolCourseInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SchoolCourseInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | SchoolCourseInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SchoolCourseInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | SchoolCourseInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SchoolCourseInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SchoolCourseInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SchoolCourseInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SchoolCourseInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SchoolCourseInfo/SIF_ExtendedElements/SIF_ExtendedElement | SchoolInfo/StateProvinceIdSystem | SchoolInfo/OtherLEA | SchoolInfo/SchoolType | SchoolInfo/SchoolFocusList/SchoolFocus | SchoolInfo/SchoolContactList/SchoolContact/PublishInDirectory | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/Address/StateProvince | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/Address/StateANSICode | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/Address/Country | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | SchoolInfo/AddressList/Address/StateProvince | SchoolInfo/AddressList/Address/StateANSICode | SchoolInfo/AddressList/Address/Country | SchoolInfo/AddressRefIdList/AddressRefId | SchoolInfo/IdentificationInfoList/IdentificationInfo | SchoolInfo/SessionType | SchoolInfo/GradeLevels/GradeLevel/Code | SchoolInfo/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SchoolInfo/Title1Status | SchoolInfo/TitleIProgramType | SchoolInfo/OperationalStatus | SchoolInfo/SchoolImprovementStatus | SchoolInfo/StatePovertyDesignation | SchoolInfo/NationalSchoolLunchProgramStatus | SchoolInfo/SchoolCharter/ApprovalAgencyType | SchoolInfo/SchoolCharter/ManagementOrganizationType | SchoolInfo/SharedTimeIndicator | SchoolInfo/VirtualSchoolStatus | SchoolInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SchoolInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | SchoolInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SchoolInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | SchoolInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SchoolInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | SchoolInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SchoolInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SchoolInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SchoolInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SchoolInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SchoolInfo/SIF_ExtendedElements/SIF_ExtendedElement | SectionInfo/MediumOfInstruction/Code | SectionInfo/MediumOfInstruction/OtherCodeList/OtherCode | SectionInfo/InstructionalDeliveryModeList/InstructionalDeliveryMode | SectionInfo/LanguageOfInstruction/Code | SectionInfo/LanguageOfInstruction/OtherCodeList/OtherCode | SectionInfo/LocationOfInstruction/Code | SectionInfo/LocationOfInstruction/OtherCodeList/OtherCode | SectionInfo/SummerSchool | SectionInfo/SchoolCourseInfoOverride/SubjectArea/Code | SectionInfo/SchoolCourseInfoOverride/SubjectArea/OtherCodeList/OtherCode | SectionInfo/SchoolCourseInfoOverride/InstructionalLevel/Code | SectionInfo/SchoolCourseInfoOverride/InstructionalLevel/OtherCodeList/OtherCode | SectionInfo/SchoolCourseInfoOverride/CourseCredits | SectionInfo/CountForAttendance | SectionInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SectionInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | SectionInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SectionInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | SectionInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SectionInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | SectionInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SectionInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SectionInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SectionInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SectionInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SectionInfo/SIF_ExtendedElements/SIF_ExtendedElement | StaffPersonal/ElectronicIdList/ElectronicId | StaffPersonal/OtherIdList/OtherId | StaffPersonal/Demographics/RaceList/Race/Code | StaffPersonal/Demographics/RaceList/Race/OtherCodeList/OtherCode | StaffPersonal/Demographics/HispanicLatino | StaffPersonal/Demographics/Gender | StaffPersonal/Demographics/BirthDateVerification | StaffPersonal/Demographics/StateOfBirth | StaffPersonal/Demographics/CountryOfBirth | StaffPersonal/Demographics/CountriesOfCitizenship/CountryOfCitizenship | StaffPersonal/Demographics/CountriesOfResidency/CountryOfResidency | StaffPersonal/Demographics/CitizenshipStatus | StaffPersonal/Demographics/EnglishProficiency/Code | StaffPersonal/Demographics/EnglishProficiency/OtherCodeList/OtherCode | StaffPersonal/Demographics/LanguageList/Language/Code | StaffPersonal/Demographics/LanguageList/Language/OtherCodeList/OtherCode | StaffPersonal/Demographics/LanguageList/Language/LanguageType | StaffPersonal/Demographics/DwellingArrangement/Code | StaffPersonal/Demographics/DwellingArrangement/OtherCodeList/OtherCode | StaffPersonal/AddressList/Address/StateProvince | StaffPersonal/AddressList/Address/StateANSICode | StaffPersonal/AddressList/Address/Country | StaffPersonal/AddressRefIdList/AddressRefId | StaffPersonal/EmailList/Email | StaffPersonal/EmailList/Email | StaffPersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StaffPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StaffPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StaffPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffPersonal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffPersonal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffPersonal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffPersonal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffPersonal/SIF_ExtendedElements/SIF_ExtendedElement | StudentContact/OtherIdList/OtherId | StudentContact/Demographics/RaceList/Race/Code | StudentContact/Demographics/RaceList/Race/OtherCodeList/OtherCode | StudentContact/Demographics/HispanicLatino | StudentContact/Demographics/Gender | StudentContact/Demographics/BirthDateVerification | StudentContact/Demographics/StateOfBirth | StudentContact/Demographics/CountryOfBirth | StudentContact/Demographics/CountriesOfCitizenship/CountryOfCitizenship | StudentContact/Demographics/CountriesOfResidency/CountryOfResidency | StudentContact/Demographics/CitizenshipStatus | StudentContact/Demographics/EnglishProficiency/Code | StudentContact/Demographics/EnglishProficiency/OtherCodeList/OtherCode | StudentContact/Demographics/LanguageList/Language/Code | StudentContact/Demographics/LanguageList/Language/OtherCodeList/OtherCode | StudentContact/Demographics/LanguageList/Language/LanguageType | StudentContact/Demographics/DwellingArrangement/Code | StudentContact/Demographics/DwellingArrangement/OtherCodeList/OtherCode | StudentContact/AddressList/Address/StateProvince | StudentContact/AddressList/Address/StateANSICode | StudentContact/AddressList/Address/Country | StudentContact/EmailList/Email | StudentContact/EmailList/Email | StudentContact/Relationship/Code | StudentContact/Relationship/OtherCodeList/OtherCode | StudentContact/EmployerType | StudentContact/EducationalLevel | StudentContact/ContactFlags/ParentLegalGuardian | StudentContact/ContactFlags/PickupRights | StudentContact/ContactFlags/LivesWith | StudentContact/ContactFlags/AccessToRecords | StudentContact/ContactFlags/EmergencyContact | StudentContact/ContactFlags/HasCustody | StudentContact/ContactFlags/DisciplinaryContact | StudentContact/ContactFlags/PrimaryCareProvider | StudentContact/ContactFlags/Other | StudentContact/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentContact/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentContact/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentContact/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentContact/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentContact/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentContact/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentContact/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentContact/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentContact/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentContact/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentContact/SIF_ExtendedElements/SIF_ExtendedElement | StudentDailyAttendance/InstructionalDeliveryMode | StudentDailyAttendance/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentDailyAttendance/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentDailyAttendance/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentDailyAttendance/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentDailyAttendance/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentDailyAttendance/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentDailyAttendance/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentDailyAttendance/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentDailyAttendance/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentDailyAttendance/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentDailyAttendance/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentDailyAttendance/SIF_ExtendedElements/SIF_ExtendedElement | StudentPersonal/AlertMessages/AlertMessage | StudentPersonal/MedicalAlertMessages/MedicalAlertMessage | StudentPersonal/ElectronicIdList/ElectronicId | StudentPersonal/OtherIdList/OtherId | StudentPersonal/Demographics/RaceList/Race/Code | StudentPersonal/Demographics/RaceList/Race/OtherCodeList/OtherCode | StudentPersonal/Demographics/HispanicLatino | StudentPersonal/Demographics/Gender | StudentPersonal/Demographics/BirthDateVerification | StudentPersonal/Demographics/StateOfBirth | StudentPersonal/Demographics/CountryOfBirth | StudentPersonal/Demographics/CountriesOfCitizenship/CountryOfCitizenship | StudentPersonal/Demographics/CountriesOfResidency/CountryOfResidency | StudentPersonal/Demographics/CitizenshipStatus | StudentPersonal/Demographics/EnglishProficiency/Code | StudentPersonal/Demographics/EnglishProficiency/OtherCodeList/OtherCode | StudentPersonal/Demographics/LanguageList/Language/Code | StudentPersonal/Demographics/LanguageList/Language/OtherCodeList/OtherCode | StudentPersonal/Demographics/LanguageList/Language/LanguageType | StudentPersonal/Demographics/DwellingArrangement/Code | StudentPersonal/Demographics/DwellingArrangement/OtherCodeList/OtherCode | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/PrimaryLearningDevice | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/PrimaryLearningDeviceAccess | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/PrimaryLearningDeviceProvider | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/InternetAccess | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/InternetAccessBarrier | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/InternetAccessType | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/InternetPerformance | StudentPersonal/AddressList/Address/StateProvince | StudentPersonal/AddressList/Address/StateANSICode | StudentPersonal/AddressList/Address/Country | StudentPersonal/AddressRefIdList/AddressRefId | StudentPersonal/EmailList/Email | StudentPersonal/EmailList/Email | StudentPersonal/MostRecent/GradeLevel/Code | StudentPersonal/MostRecent/GradeLevel/OtherCodeList/OtherCode | StudentPersonal/AcceptableUsePolicy | StudentPersonal/IDEA | StudentPersonal/Migrant | StudentPersonal/Title1 | StudentPersonal/GiftedTalented | StudentPersonal/EconomicDisadvantage | StudentPersonal/ELL | StudentPersonal/Homeless | StudentPersonal/HomelessServicedIndicator | StudentPersonal/Section504 | StudentPersonal/VocationalConcentrator | StudentPersonal/Immigrant | StudentPersonal/NeglectedDelinquent | StudentPersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentPersonal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentPersonal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentPersonal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentPersonal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentPersonal/SIF_ExtendedElements/SIF_ExtendedElement | StudentPicture/PictureSource | StudentPicture/OKToPublish | StudentPicture/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentPicture/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentPicture/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentPicture/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentPicture/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentPicture/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentPicture/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentPicture/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentPicture/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentPicture/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentPicture/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentPicture/SIF_ExtendedElements/SIF_ExtendedElement | StudentSchoolEnrollment/EntryType/Code | StudentSchoolEnrollment/EntryType/OtherCodeList/OtherCode | StudentSchoolEnrollment/GradeLevel/Code | StudentSchoolEnrollment/GradeLevel/OtherCodeList/OtherCode | StudentSchoolEnrollment/Homeroom | StudentSchoolEnrollment/Advisor | StudentSchoolEnrollment/Counselor | StudentSchoolEnrollment/Calendar | StudentSchoolEnrollment/ExitStatus/Code | StudentSchoolEnrollment/ExitStatus/OtherCodeList/OtherCode | StudentSchoolEnrollment/ExitType/Code | StudentSchoolEnrollment/ExitType/OtherCodeList/OtherCode | StudentSchoolEnrollment/ExitGradeLevel/Code | StudentSchoolEnrollment/ExitGradeLevel/OtherCodeList/OtherCode | StudentSchoolEnrollment/RecordClosureReason | StudentSchoolEnrollment/PromotionInfo/PromotionStatus | StudentSchoolEnrollment/PromotionInfo/Promotion/Code | StudentSchoolEnrollment/PromotionInfo/Promotion/OtherCodeList/OtherCode | StudentSchoolEnrollment/PromotionInfo/Nonpromotion/Code | StudentSchoolEnrollment/PromotionInfo/Nonpromotion/OtherCodeList/OtherCode | StudentSchoolEnrollment/FTPTStatus | StudentSchoolEnrollment/ResidencyStatus/Code | StudentSchoolEnrollment/ResidencyStatus/OtherCodeList/OtherCode | StudentSchoolEnrollment/NonResidentAttendReason | StudentSchoolEnrollment/ResponsableSchoolList/ResponsableSchool/Type | StudentSchoolEnrollment/ResponsableLEAList/ResponsableLEA/Type | StudentSchoolEnrollment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSchoolEnrollment/SIF_ExtendedElements/SIF_ExtendedElement | StudentSectionEnrollment/InstructionalDeliveryModeList/InstructionalDeliveryMode | StudentSectionEnrollment/CreditsAttempted | StudentSectionEnrollment/DualCredit | StudentSectionEnrollment/CTEConcentrator | StudentSectionEnrollment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSectionEnrollment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentSectionEnrollment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSectionEnrollment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentSectionEnrollment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSectionEnrollment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentSectionEnrollment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSectionEnrollment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSectionEnrollment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSectionEnrollment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSectionEnrollment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSectionEnrollment/SIF_ExtendedElements/SIF_ExtendedElement | TermInfo/TermSpan/Code | TermInfo/TermSpan/OtherCodeList/OtherCode | TermInfo/MarkingTerm | TermInfo/SchedulingTerm | TermInfo/AttendanceTerm | TermInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | TermInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | TermInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | TermInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | TermInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | TermInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | TermInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | TermInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | TermInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | TermInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | TermInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | TermInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentSnapshot/Address/StateProvince | StudentSnapshot/Address/StateANSICode | StudentSnapshot/Address/Country | StudentSnapshot/RaceList/Race/Code | StudentSnapshot/RaceList/Race/OtherCodeList/OtherCode | StudentSnapshot/HispanicLatino | StudentSnapshot/Gender | StudentSnapshot/GraduationAward | StudentSnapshot/GraduationOnTime | StudentSnapshot/HomeEnrollment/Status | StudentSnapshot/HomeEnrollment/GradeLevel/Code | StudentSnapshot/HomeEnrollment/GradeLevel/OtherCodeList/OtherCode | StudentSnapshot/HomeEnrollment/Homeroom | StudentSnapshot/HomeEnrollment/FullYearEnrollment | StudentSnapshot/IDEA | StudentSnapshot/Migrant | StudentSnapshot/Title1 | StudentSnapshot/GiftedTalented | StudentSnapshot/EconomicDisadvantage | StudentSnapshot/ELL | StudentSnapshot/Homeless | StudentSnapshot/Section504 | StudentSnapshot/VocationalConcentrator | StudentSnapshot/Immigrant | StudentSnapshot/NeglectedDelinquent | StudentSnapshot/FreeAndReducedStatus | StudentSnapshot/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSnapshot/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentSnapshot/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSnapshot/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentSnapshot/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSnapshot/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentSnapshot/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSnapshot/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSnapshot/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSnapshot/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSnapshot/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSnapshot/SIF_ExtendedElements/SIF_ExtendedElement | LEAInfo/EducationAgencyType/Code | LEAInfo/EducationAgencyType/OtherCodeList/OtherCode | LEAInfo/LEAContactList/LEAContact/PublishInDirectory | LEAInfo/LEAContactList/LEAContact/ContactInfo/Address/StateProvince | LEAInfo/LEAContactList/LEAContact/ContactInfo/Address/StateANSICode | LEAInfo/LEAContactList/LEAContact/ContactInfo/Address/Country | LEAInfo/LEAContactList/LEAContact/ContactInfo/EmailList/Email | LEAInfo/LEAContactList/LEAContact/ContactInfo/EmailList/Email | LEAInfo/AddressList/Address/StateProvince | LEAInfo/AddressList/Address/StateANSICode | LEAInfo/AddressList/Address/Country | LEAInfo/AddressRefIdList/AddressRefId | LEAInfo/IdentificationInfoList/IdentificationInfo | LEAInfo/GradeLevels/GradeLevel/Code | LEAInfo/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LEAInfo/OperationalStatus | LEAInfo/TitleIProgramType | LEAInfo/TitleIIILanguageInstructionProgramType | LEAInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LEAInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LEAInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LEAInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LEAInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LEAInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LEAInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LEAInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LEAInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LEAInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LEAInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LEAInfo/SIF_ExtendedElements/SIF_ExtendedElement | StaffAssignment/PrimaryAssignment | StaffAssignment/JobFunction/Code | StaffAssignment/JobFunction/OtherCodeList/OtherCode | StaffAssignment/TeachingAssignment/Code | StaffAssignment/TeachingAssignment/OtherCodeList/OtherCode | StaffAssignment/GradeLevels/GradeLevel/Code | StaffAssignment/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffAssignment/ItinerantTeacher | StaffAssignment/InstructionalLevel/Code | StaffAssignment/InstructionalLevel/OtherCodeList/OtherCode | StaffAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StaffAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StaffAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StaffAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffAssignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffAssignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffAssignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffAssignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffAssignment/SIF_ExtendedElements/SIF_ExtendedElement | BellSchedule/BellPeriodList/BellPeriod/RegularSchoolPeriod | BellSchedule/BellPeriodList/BellPeriod/UseInAttendanceCalculations | BellSchedule/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BellSchedule/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BellSchedule/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BellSchedule/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BellSchedule/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BellSchedule/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BellSchedule/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BellSchedule/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BellSchedule/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BellSchedule/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BellSchedule/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BellSchedule/SIF_ExtendedElements/SIF_ExtendedElement | StudentContactPersonal/PersonInfo/OtherIdList/OtherId | StudentContactPersonal/PersonInfo/Demographics/RaceList/Race/Code | StudentContactPersonal/PersonInfo/Demographics/RaceList/Race/OtherCodeList/OtherCode | StudentContactPersonal/PersonInfo/Demographics/HispanicLatino | StudentContactPersonal/PersonInfo/Demographics/Gender | StudentContactPersonal/PersonInfo/Demographics/BirthDateVerification | StudentContactPersonal/PersonInfo/Demographics/StateOfBirth | StudentContactPersonal/PersonInfo/Demographics/CountryOfBirth | StudentContactPersonal/PersonInfo/Demographics/CountriesOfCitizenship/CountryOfCitizenship | StudentContactPersonal/PersonInfo/Demographics/CountriesOfResidency/CountryOfResidency | StudentContactPersonal/PersonInfo/Demographics/CitizenshipStatus | StudentContactPersonal/PersonInfo/Demographics/EnglishProficiency/Code | StudentContactPersonal/PersonInfo/Demographics/EnglishProficiency/OtherCodeList/OtherCode | StudentContactPersonal/PersonInfo/Demographics/LanguageList/Language/Code | StudentContactPersonal/PersonInfo/Demographics/LanguageList/Language/OtherCodeList/OtherCode | StudentContactPersonal/PersonInfo/Demographics/LanguageList/Language/LanguageType | StudentContactPersonal/PersonInfo/Demographics/DwellingArrangement/Code | StudentContactPersonal/PersonInfo/Demographics/DwellingArrangement/OtherCodeList/OtherCode | StudentContactPersonal/PersonInfo/AddressList/Address/StateProvince | StudentContactPersonal/PersonInfo/AddressList/Address/StateANSICode | StudentContactPersonal/PersonInfo/AddressList/Address/Country | StudentContactPersonal/PersonInfo/EmailList/Email | StudentContactPersonal/PersonInfo/EmailList/Email | StudentContactPersonal/EmployerType | StudentContactPersonal/EducationLevel | StudentContactPersonal/OptOutEmail | StudentContactPersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentContactPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentContactPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentContactPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentContactPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentContactPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentContactPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentContactPersonal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentContactPersonal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentContactPersonal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentContactPersonal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentContactPersonal/SIF_ExtendedElements/SIF_ExtendedElement | StudentContactRelationship/Relationship/Code | StudentContactRelationship/Relationship/OtherCodeList/OtherCode | StudentContactRelationship/ContactFlags/ParentLegalGuardian | StudentContactRelationship/ContactFlags/PickupRights | StudentContactRelationship/ContactFlags/LivesWith | StudentContactRelationship/ContactFlags/AccessToRecords | StudentContactRelationship/ContactFlags/EmergencyContact | StudentContactRelationship/ContactFlags/HasCustody | StudentContactRelationship/ContactFlags/DisciplinaryContact | StudentContactRelationship/ContactFlags/PrimaryCareProvider | StudentContactRelationship/ContactFlags/Other | StudentContactRelationship/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentContactRelationship/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentContactRelationship/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentContactRelationship/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentContactRelationship/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentContactRelationship/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentContactRelationship/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentContactRelationship/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentContactRelationship/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentContactRelationship/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentContactRelationship/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentContactRelationship/SIF_ExtendedElements/SIF_ExtendedElement | StaffSectionAssignment/TeacherOfRecord | StaffSectionAssignment/Roles/Role | StaffSectionAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffSectionAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StaffSectionAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffSectionAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StaffSectionAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffSectionAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StaffSectionAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffSectionAssignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffSectionAssignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffSectionAssignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffSectionAssignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffSectionAssignment/SIF_ExtendedElements/SIF_ExtendedElement | StaffEvaluation/EvaluationRecommendation/OtherCodeList/OtherCode | StaffEvaluation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffEvaluation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StaffEvaluation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffEvaluation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StaffEvaluation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffEvaluation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StaffEvaluation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffEvaluation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffEvaluation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffEvaluation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffEvaluation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffEvaluation/SIF_ExtendedElements/SIF_ExtendedElement | SectionCorrelation/CorrelationType/Code | SectionCorrelation/CorrelationType/OtherCodeList/OtherCode | SectionCorrelation/CorrelationSectionList/CorrelationSection | SectionCorrelation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SectionCorrelation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | SectionCorrelation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SectionCorrelation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | SectionCorrelation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SectionCorrelation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | SectionCorrelation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SectionCorrelation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SectionCorrelation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SectionCorrelation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SectionCorrelation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SectionCorrelation/SIF_ExtendedElements/SIF_ExtendedElement | SchoolAccountability/GunFreeSchoolsActReportingStatus | SchoolAccountability/HighSchoolGraduationRateIndicatorStatus | SchoolAccountability/PersistentlyDangerousStatus | SchoolAccountability/ProficiencyTargetStatusForMath | SchoolAccountability/ProficiencyTargetStatusForReadingAndLanguageArts | SchoolAccountability/SchoolOperationalStatus | SchoolAccountability/ReconstitutedStatus | SchoolAccountability/SchoolImprovementFundsStatus | LEAAccountability/GunFreeSchoolsActReportingStatus | SchoolFederalFund/ConsolidatedMEPFundsStatus | SchoolFederalFund/SchoolImprovementGrantInterventionType | StudentMigrant/ServicesType | StudentMigrant/PrioritizedForServices | StudentMigrant/ContinuationOfServicesReason | StudentMigrant/ContinuationOfServicesStatus | StudentMigrant/EnrollmentType | StudentMigrant/ParticipationStatus | BusEquipment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusEquipment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BusEquipment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusEquipment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BusEquipment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusEquipment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BusEquipment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusEquipment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusEquipment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusEquipment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusEquipment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusEquipment/SIF_ExtendedElements/SIF_ExtendedElement | BusInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BusInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BusInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BusInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusInfo/SIF_ExtendedElements/SIF_ExtendedElement | BusRouteDetail/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusRouteDetail/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BusRouteDetail/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusRouteDetail/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BusRouteDetail/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusRouteDetail/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BusRouteDetail/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusRouteDetail/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusRouteDetail/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusRouteDetail/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusRouteDetail/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusRouteDetail/SIF_ExtendedElements/SIF_ExtendedElement | BusRouteInfo/RouteType | BusRouteInfo/RouteDistanceLoaded | BusRouteInfo/RouteDistanceTotal | BusRouteInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusRouteInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BusRouteInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusRouteInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BusRouteInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusRouteInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BusRouteInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusRouteInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusRouteInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusRouteInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusRouteInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusRouteInfo/SIF_ExtendedElements/SIF_ExtendedElement | BusStopInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusStopInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BusStopInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusStopInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BusStopInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusStopInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BusStopInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusStopInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusStopInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusStopInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusStopInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusStopInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentTransportInfo/Eligibility | StudentTransportInfo/HomeToSchoolDistance | StudentTransportInfo/WalkToStopDistance | StudentTransportInfo/StopToSchoolDistance | StudentTransportInfo/HomeBusRouteDetail | StudentTransportInfo/TransferPoints/TransferPoint/EmbarkBusRouteDetail | StudentTransportInfo/TransferPoints/TransferPoint/DisembarkBusRouteDetail | StudentTransportInfo/SchoolBusRouteDetail | StudentTransportInfo/StateAidQualification | StudentTransportInfo/TransportationStatus | StudentTransportInfo/PublicExpense | StudentTransportInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentTransportInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentTransportInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentTransportInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentTransportInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentTransportInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentTransportInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentTransportInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentTransportInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentTransportInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentTransportInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentTransportInfo/SIF_ExtendedElements/SIF_ExtendedElement | BusPositionInfo/BusDriver/Status | BusPositionInfo/BusStaffList/BusStaff/Status | BusPositionInfo/Odometer | BusPositionInfo/Speedometer | BusPositionInfo/Students/Student/Status | BusPositionInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusPositionInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BusPositionInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusPositionInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BusPositionInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusPositionInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BusPositionInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusPositionInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusPositionInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusPositionInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusPositionInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusPositionInfo/SIF_ExtendedElements/SIF_ExtendedElement | Authentication/AuthenticationInfo/System | Authentication/AuthenticationInfo/PasswordList/Password | Authentication/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Authentication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Authentication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Authentication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Authentication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Authentication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Authentication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Authentication/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Authentication/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Authentication/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Authentication/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Authentication/SIF_ExtendedElements/SIF_ExtendedElement | EnergyUsage/UsageLocationInfo/EnergyZone/Type/Facility | EnergyUsage/DataSource/ReadingDataList/ReadingData/Measurement | EnergyUsage/DataSource/ReadingDataList/ReadingData/EnergyUnits | EnergyUsage/DataSource/ReadingDataList/ReadingData/ReadingList/Reading | EnergyUsage/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EnergyUsage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EnergyUsage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EnergyUsage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EnergyUsage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EnergyUsage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EnergyUsage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EnergyUsage/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EnergyUsage/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EnergyUsage/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EnergyUsage/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EnergyUsage/SIF_ExtendedElements/SIF_ExtendedElement | IdMApplication/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | IdMApplication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | IdMApplication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | IdMApplication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | IdMApplication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | IdMApplication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | IdMApplication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | IdMApplication/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | IdMApplication/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | IdMApplication/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | IdMApplication/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | IdMApplication/SIF_ExtendedElements/SIF_ExtendedElement | IdMAuthentication/IdentityProviderType | IdMAuthentication/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | IdMAuthentication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | IdMAuthentication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | IdMAuthentication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | IdMAuthentication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | IdMAuthentication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | IdMAuthentication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | IdMAuthentication/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | IdMAuthentication/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | IdMAuthentication/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | IdMAuthentication/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | IdMAuthentication/SIF_ExtendedElements/SIF_ExtendedElement | IdMAuthorization/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | IdMAuthorization/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | IdMAuthorization/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | IdMAuthorization/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | IdMAuthorization/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | IdMAuthorization/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | IdMAuthorization/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | IdMAuthorization/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | IdMAuthorization/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | IdMAuthorization/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | IdMAuthorization/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | IdMAuthorization/SIF_ExtendedElements/SIF_ExtendedElement | UserOrganizationAssociation/PersonRefId | UserOrganizationAssociation/OrganizationRefId | UserOrganizationAssociation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | UserOrganizationAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | UserOrganizationAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | UserOrganizationAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | UserOrganizationAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | UserOrganizationAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | UserOrganizationAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | UserOrganizationAssociation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | UserOrganizationAssociation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | UserOrganizationAssociation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | UserOrganizationAssociation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | UserOrganizationAssociation/SIF_ExtendedElements/SIF_ExtendedElement | PersonPrivacyObligationDocument/LocationList/Location/LocationRefId" mode="detect" priority="1">
    <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="obj-content"/>
    <xsl:if test="count(following-sibling::*) &gt; 0">, </xsl:if>
  </xsl:template>

  <!-- list  - takes precedence when list of elements which are simple content with attributes -->
  <xsl:template match="SEAInfo/CSSOContact/EmailList/Email | SEAInfo/CSSOContact/PhoneNumberList/PhoneNumber | SEAInfo/SEAContactList/SEAContact | SEAInfo/SEAContactList/SEAContact/ContactInfo/EmailList/Email | SEAInfo/SEAContactList/SEAContact/ContactInfo/PhoneNumberList/PhoneNumber | SEAInfo/PhoneNumberList/PhoneNumber | SEAInfo/AddressList/Address | SEAInfo/SIF_Metadata/TimeElements/TimeElement | SEAInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | SEAInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | SEAInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | SEAInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | SEAInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | SEAInfo/SIF_Metadata/RightsElements/RightsElement | SEAInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | SEAInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | SEAInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | SEAInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SEAInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | SEAInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SEAInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | SEAInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SEAInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | SEAInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SEAInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SEAInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SEAInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | SEAInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SEAInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentLEARelationship/LEARelationshipType/ResidencyStatus/OtherCodeList/OtherCode | StudentLEARelationship/EntryType/OtherCodeList/OtherCode | StudentLEARelationship/ExitType/OtherCodeList/OtherCode | StudentLEARelationship/ExitStatus/OtherCodeList/OtherCode | StudentLEARelationship/GradeLevel/OtherCodeList/OtherCode | StudentLEARelationship/SIF_Metadata/TimeElements/TimeElement | StudentLEARelationship/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentLEARelationship/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentLEARelationship/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentLEARelationship/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentLEARelationship/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentLEARelationship/SIF_Metadata/RightsElements/RightsElement | StudentLEARelationship/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentLEARelationship/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentLEARelationship/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentLEARelationship/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentLEARelationship/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentLEARelationship/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentLEARelationship/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentLEARelationship/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentLEARelationship/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentLEARelationship/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentLEARelationship/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentLEARelationship/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentLEARelationship/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentLEARelationship/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentLEARelationship/SIF_ExtendedElements/SIF_ExtendedElement | SEAFederalFund/FederalProgramList/FederalProgram | xCalendar/sessions/session | xContact/otherNames/name | xContact/otherIds/otherId | xContact/otherPhoneNumbers/phoneNumber | xContact/otherEmails/email | xContact/relationships/relationship | xCourse/otherIds/otherId | xCourse/applicableEducationLevels/applicableEducationLevel | xIndividualizedEducationPlan/iepAdministrativeData/transferPermissionList/transmitPermission | xIndividualizedEducationPlan/iepEligibility/background/consentToEvaluation | xIndividualizedEducationPlan/iepEligibility/evaluationResultList | xIndividualizedEducationPlan/iepEligibility/evaluationResultList/evaluationResult | xIndividualizedEducationPlan/iepEligibility/ideaDisability/disabilityCodeList | xIndividualizedEducationPlan/iepEligibility/ideaDisability/analysis | xIndividualizedEducationPlan/iepEligibility/eligibilityParticipantReportList | xIndividualizedEducationPlan/iepEligibility/eligibilityParticipantReportList/participantReport/role | xIndividualizedEducationPlan/iepPlan/effectivePeriod | xIndividualizedEducationPlan/iepPlan/enrollmentGradeLevel | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/personal | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/personal/concerns | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/personal/evaluation | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/personal/evaluation/needsList | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/personal/evaluation/performance | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/personal/evaluation/performance/testResultList | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/personal/evaluation/personalGoalsList | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/personal/intention | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/personal/intention/desiredOutcomeList | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/academic | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/academic/deficitList | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/academic/deficitList/deficit/academicSubject | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/academic/deficitList/deficit/accommodation | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/academic/summary | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/academic/summary/accommodationList/accommodation | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/functional | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/functional/disabilityList | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/functional/disabilityList/disability/disabilityCodeList | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/functional/disabilityList/disability/accommodation | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/functional/summary | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/functional/summary/accommodationList/accommodation | xIndividualizedEducationPlan/iepPlan/presentLevelPerformance/consequenceOfDisability/specialCategoryList | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/goalType | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/facilitatorList | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/measurement | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/measurement/criterion/metric | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/measurement/criterion/metric/trialCountEvaluation | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/independentActionsList | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/servicesList | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/servicesList/service/serviceProvider | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/servicesList/service/frequency | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/servicesList/service/frequency/cycle | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/servicesList/service/frequency/duration | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/coursesList | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/progressReportList | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/progressReportList/progressReport/measurement | xIndividualizedEducationPlan/iepPlan/annualGoalsList/annualGoal/progressReportList/progressReport/measurement/dataValuesList | xIndividualizedEducationPlan/iepPlan/accommodationsList | xIndividualizedEducationPlan/iepPlan/accommodationsList/accommodation/accommodation | xIndividualizedEducationPlan/iepPlan/accommodationsList/accommodation/applicabilityList | xIndividualizedEducationPlan/iepPlan/standardizedAssessmentResultList | xIndividualizedEducationPlan/iepPlan/standardizedAssessmentResultList/standardizedAssessmentResult | xIndividualizedEducationPlan/iepPlan/standardizedAssessmentResultList/standardizedAssessmentResult/standardsReference | xIndividualizedEducationPlan/iepPlan/standardizedAssessmentResultList/standardizedAssessmentResult/accommodationList | xIndividualizedEducationPlan/iepPlan/standardizedAssessmentResultList/standardizedAssessmentResult/accommodationList/accommodation | xIndividualizedEducationPlan/iepPlan/standardizedAssessmentResultList/standardizedAssessmentResult/accommodationList/accommodation/accommodation | xIndividualizedEducationPlan/iepPlan/authorization/parentGuardianAuthorization/rejectedPlanElements | xIndividualizedEducationPlan/iepPlan/authorization/parentGuardianAuthorization/rejectedPlanElements/rejectedDetailList | xIndividualizedEducationPlan/iepPlan/amendmentList | xIndividualizedEducationPlan/iepPlan/amendmentList/amendment | xIndividualizedEducationPlan/iepPlan/amendmentList/amendment/changeList | xIndividualizedEducationPlan/iepPlan/amendmentList/amendment/changeList/change | xIndividualizedEducationPlan/iepPlan/amendmentList/amendment/authorization/parentGuardianAuthorization/rejectedPlanElements | xIndividualizedEducationPlan/iepPlan/amendmentList/amendment/authorization/parentGuardianAuthorization/rejectedPlanElements/rejectedDetailList | xLea/otherPhoneNumbers/phoneNumber | xRoster/meetingTimes/meetingTime | xRoster/students/studentReference | xRoster/otherStaffs/otherStaff | xSchool/otherIds/otherId | xSchool/gradeLevels/gradeLevel | xSchool/otherPhoneNumbers/phoneNumber | xStaff/otherIds/otherId | xStaff/otherAssignments/staffPersonAssignment | xStudent/otherNames/name | xStudent/otherIds/otherId | xStudent/otherAddresses/name | xStudent/otherPhoneNumbers/phoneNumber | xStudent/otherEmails/email | xStudent/demographics/races/race | xStudent/otherEnrollments/enrollment | xStudent/studentContacts/contactPersonRefId | xStudent/studentContacts/xContact | xStudent/languages/language | xTransferIep/referenceObjects/leaList/referenceLea | xTransferIep/referenceObjects/contactList/referenceContactPerson | xTransferIep/referenceObjects/staffList/referenceStaffPerson | xTransferIep/referenceObjects/organizationList/referenceOrganization | xTransferIep/iep/iepAdministrativeData/transferPermissionList/transmitPermission | xTransferIep/iep/iepEligibility/background/consentToEvaluation | xTransferIep/iep/iepEligibility/evaluationResultList | xTransferIep/iep/iepEligibility/evaluationResultList/evaluationResult | xTransferIep/iep/iepEligibility/ideaDisability/disabilityCodeList | xTransferIep/iep/iepEligibility/ideaDisability/analysis | xTransferIep/iep/iepEligibility/eligibilityParticipantReportList | xTransferIep/iep/iepEligibility/eligibilityParticipantReportList/participantReport/role | xTransferIep/iep/iepPlan/effectivePeriod | xTransferIep/iep/iepPlan/enrollmentGradeLevel | xTransferIep/iep/iepPlan/presentLevelPerformance/personal | xTransferIep/iep/iepPlan/presentLevelPerformance/personal/concerns | xTransferIep/iep/iepPlan/presentLevelPerformance/personal/evaluation | xTransferIep/iep/iepPlan/presentLevelPerformance/personal/evaluation/needsList | xTransferIep/iep/iepPlan/presentLevelPerformance/personal/evaluation/performance | xTransferIep/iep/iepPlan/presentLevelPerformance/personal/evaluation/performance/testResultList | xTransferIep/iep/iepPlan/presentLevelPerformance/personal/evaluation/personalGoalsList | xTransferIep/iep/iepPlan/presentLevelPerformance/personal/intention | xTransferIep/iep/iepPlan/presentLevelPerformance/personal/intention/desiredOutcomeList | xTransferIep/iep/iepPlan/presentLevelPerformance/academic | xTransferIep/iep/iepPlan/presentLevelPerformance/academic/deficitList | xTransferIep/iep/iepPlan/presentLevelPerformance/academic/deficitList/deficit/academicSubject | xTransferIep/iep/iepPlan/presentLevelPerformance/academic/deficitList/deficit/accommodation | xTransferIep/iep/iepPlan/presentLevelPerformance/academic/summary | xTransferIep/iep/iepPlan/presentLevelPerformance/academic/summary/accommodationList/accommodation | xTransferIep/iep/iepPlan/presentLevelPerformance/functional | xTransferIep/iep/iepPlan/presentLevelPerformance/functional/disabilityList | xTransferIep/iep/iepPlan/presentLevelPerformance/functional/disabilityList/disability/disabilityCodeList | xTransferIep/iep/iepPlan/presentLevelPerformance/functional/disabilityList/disability/accommodation | xTransferIep/iep/iepPlan/presentLevelPerformance/functional/summary | xTransferIep/iep/iepPlan/presentLevelPerformance/functional/summary/accommodationList/accommodation | xTransferIep/iep/iepPlan/presentLevelPerformance/consequenceOfDisability/specialCategoryList | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/goalType | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/facilitatorList | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/measurement | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/measurement/criterion/metric | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/measurableObjectiveList/measurableObjective/measurement/criterion/metric/trialCountEvaluation | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/independentActionsList | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/servicesList | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/servicesList/service/serviceProvider | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/servicesList/service/frequency | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/servicesList/service/frequency/cycle | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/servicesList/service/frequency/duration | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/coursesList | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/progressReportList | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/progressReportList/progressReport/measurement | xTransferIep/iep/iepPlan/annualGoalsList/annualGoal/progressReportList/progressReport/measurement/dataValuesList | xTransferIep/iep/iepPlan/accommodationsList | xTransferIep/iep/iepPlan/accommodationsList/accommodation/accommodation | xTransferIep/iep/iepPlan/accommodationsList/accommodation/applicabilityList | xTransferIep/iep/iepPlan/standardizedAssessmentResultList | xTransferIep/iep/iepPlan/standardizedAssessmentResultList/standardizedAssessmentResult | xTransferIep/iep/iepPlan/standardizedAssessmentResultList/standardizedAssessmentResult/standardsReference | xTransferIep/iep/iepPlan/standardizedAssessmentResultList/standardizedAssessmentResult/accommodationList | xTransferIep/iep/iepPlan/standardizedAssessmentResultList/standardizedAssessmentResult/accommodationList/accommodation | xTransferIep/iep/iepPlan/standardizedAssessmentResultList/standardizedAssessmentResult/accommodationList/accommodation/accommodation | xTransferIep/iep/iepPlan/authorization/parentGuardianAuthorization/rejectedPlanElements | xTransferIep/iep/iepPlan/authorization/parentGuardianAuthorization/rejectedPlanElements/rejectedDetailList | xTransferIep/iep/iepPlan/amendmentList | xTransferIep/iep/iepPlan/amendmentList/amendment | xTransferIep/iep/iepPlan/amendmentList/amendment/changeList | xTransferIep/iep/iepPlan/amendmentList/amendment/changeList/change | xTransferIep/iep/iepPlan/amendmentList/amendment/authorization/parentGuardianAuthorization/rejectedPlanElements | xTransferIep/iep/iepPlan/amendmentList/amendment/authorization/parentGuardianAuthorization/rejectedPlanElements/rejectedDetailList | xTransferIep/historyList/historyItem | AggregateStatisticInfo/ExclusionRules/ExclusionRule | AggregateStatisticInfo/SIF_Metadata/TimeElements/TimeElement | AggregateStatisticInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | AggregateStatisticInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | AggregateStatisticInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | AggregateStatisticInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | AggregateStatisticInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | AggregateStatisticInfo/SIF_Metadata/RightsElements/RightsElement | AggregateStatisticInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | AggregateStatisticInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | AggregateStatisticInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | AggregateStatisticInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AggregateStatisticInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | AggregateStatisticInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AggregateStatisticInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | AggregateStatisticInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AggregateStatisticInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | AggregateStatisticInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AggregateStatisticInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AggregateStatisticInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AggregateStatisticInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | AggregateStatisticInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AggregateStatisticInfo/SIF_ExtendedElements/SIF_ExtendedElement | AggregateCharacteristicInfo/SIF_Metadata/TimeElements/TimeElement | AggregateCharacteristicInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | AggregateCharacteristicInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | AggregateCharacteristicInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | AggregateCharacteristicInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | AggregateCharacteristicInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | AggregateCharacteristicInfo/SIF_Metadata/RightsElements/RightsElement | AggregateCharacteristicInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AggregateCharacteristicInfo/SIF_ExtendedElements/SIF_ExtendedElement | AggregateStatisticFact/Characteristics/AggregateCharacteristicInfoRefId | AggregateStatisticFact/SIF_Metadata/TimeElements/TimeElement | AggregateStatisticFact/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | AggregateStatisticFact/SIF_Metadata/LifeCycle/Created/Creators/Creator | AggregateStatisticFact/SIF_Metadata/LifeCycle/ModificationHistory/Modified | AggregateStatisticFact/SIF_Metadata/LifeCycle/TimeElements/TimeElement | AggregateStatisticFact/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | AggregateStatisticFact/SIF_Metadata/RightsElements/RightsElement | AggregateStatisticFact/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | AggregateStatisticFact/SIF_Metadata/EducationFilter/MediaTypes/MediaType | AggregateStatisticFact/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | AggregateStatisticFact/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AggregateStatisticFact/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | AggregateStatisticFact/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AggregateStatisticFact/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | AggregateStatisticFact/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AggregateStatisticFact/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | AggregateStatisticFact/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AggregateStatisticFact/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AggregateStatisticFact/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AggregateStatisticFact/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | AggregateStatisticFact/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AggregateStatisticFact/SIF_ExtendedElements/SIF_ExtendedElement | StudentMeal/HistoricalMealStatus/MealStatus | StudentMeal/Amounts/Amount | StudentMeal/SIF_Metadata/TimeElements/TimeElement | StudentMeal/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentMeal/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentMeal/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentMeal/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentMeal/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentMeal/SIF_Metadata/RightsElements/RightsElement | StudentMeal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentMeal/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentMeal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentMeal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentMeal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentMeal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentMeal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentMeal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentMeal/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentMeal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentMeal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentMeal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentMeal/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentMeal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentMeal/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceItem/ElectronicIdList/ElectronicId | FoodserviceItem/SIF_Metadata/TimeElements/TimeElement | FoodserviceItem/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceItem/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceItem/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceItem/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceItem/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceItem/SIF_Metadata/RightsElements/RightsElement | FoodserviceItem/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceItem/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceItem/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceItem/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceItem/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceItem/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceItem/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceItem/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceItem/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceItemUnit/SIF_Metadata/TimeElements/TimeElement | FoodserviceItemUnit/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceItemUnit/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceItemUnit/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceItemUnit/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceItemUnit/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceItemUnit/SIF_Metadata/RightsElements/RightsElement | FoodserviceItemUnit/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceItemUnit/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceItemUnit/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceItemUnit/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItemUnit/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceItemUnit/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceItemUnit/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceItemUnit/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceItemUnit/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceItemUnit/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceItemUnit/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceItemUnit/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceItemUnit/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceItemUnit/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceItemUnit/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceItemPortion/SIF_Metadata/TimeElements/TimeElement | FoodserviceItemPortion/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceItemPortion/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceItemPortion/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceItemPortion/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceItemPortion/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceItemPortion/SIF_Metadata/RightsElements/RightsElement | FoodserviceItemPortion/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceItemPortion/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceItemPortion/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceItemPortion/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItemPortion/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceItemPortion/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceItemPortion/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceItemPortion/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceItemPortion/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceItemPortion/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceItemPortion/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceItemPortion/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceItemPortion/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceItemPortion/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceItemPortion/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceReimbursementRates/Agencies/Agency | FoodserviceReimbursementRates/Agencies/Agency/Rates/Rate | FoodserviceReimbursementRates/SIF_Metadata/TimeElements/TimeElement | FoodserviceReimbursementRates/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceReimbursementRates/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceReimbursementRates/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceReimbursementRates/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceReimbursementRates/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceReimbursementRates/SIF_Metadata/RightsElements/RightsElement | FoodserviceReimbursementRates/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceReimbursementRates/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceMealPrices/Prices/Price | FoodserviceMealPrices/Prices/Price/GradeLevels/GradeLevel | FoodserviceMealPrices/Prices/Price/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMealPrices/SIF_Metadata/TimeElements/TimeElement | FoodserviceMealPrices/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceMealPrices/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceMealPrices/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceMealPrices/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceMealPrices/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceMealPrices/SIF_Metadata/RightsElements/RightsElement | FoodserviceMealPrices/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceMealPrices/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceMealPrices/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceMealPrices/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMealPrices/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceMealPrices/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceMealPrices/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceMealPrices/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceMealPrices/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceMealPrices/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceMealPrices/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceMealPrices/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceMealPrices/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceMealPrices/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceMealPrices/SIF_ExtendedElements/SIF_ExtendedElement | StaffMeal/Amounts/Amount | StaffMeal/SIF_Metadata/TimeElements/TimeElement | StaffMeal/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StaffMeal/SIF_Metadata/LifeCycle/Created/Creators/Creator | StaffMeal/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StaffMeal/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StaffMeal/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StaffMeal/SIF_Metadata/RightsElements/RightsElement | StaffMeal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StaffMeal/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StaffMeal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StaffMeal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffMeal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StaffMeal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffMeal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StaffMeal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffMeal/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StaffMeal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffMeal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffMeal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffMeal/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StaffMeal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffMeal/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceTransaction/TransactionTypes/TransactionType | FoodserviceTransaction/SIF_Metadata/TimeElements/TimeElement | FoodserviceTransaction/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceTransaction/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceTransaction/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceTransaction/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceTransaction/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceTransaction/SIF_Metadata/RightsElements/RightsElement | FoodserviceTransaction/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceTransaction/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceTransaction/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceTransaction/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceTransaction/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceTransaction/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceTransaction/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceTransaction/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceTransaction/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceTransactionDetails/Amounts/Amount | FoodserviceTransactionDetails/SIF_Metadata/TimeElements/TimeElement | FoodserviceTransactionDetails/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceTransactionDetails/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceTransactionDetails/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceTransactionDetails/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceTransactionDetails/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceTransactionDetails/SIF_Metadata/RightsElements/RightsElement | FoodserviceTransactionDetails/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceTransactionDetails/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceTransactionPayMethod/TransactionPayMethods/TransactionPayMethod | FoodserviceTransactionPayMethod/TransactionPayMethods/TransactionPayMethod/Amounts/Amount | FoodserviceTransactionPayMethod/SIF_Metadata/TimeElements/TimeElement | FoodserviceTransactionPayMethod/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceTransactionPayMethod/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceTransactionPayMethod/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceTransactionPayMethod/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceTransactionPayMethod/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceTransactionPayMethod/SIF_Metadata/RightsElements/RightsElement | FoodserviceTransactionPayMethod/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceTransactionPayMethod/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceSales/SalesAmounts/SalesAmount | FoodserviceSales/SIF_Metadata/TimeElements/TimeElement | FoodserviceSales/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceSales/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceSales/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceSales/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceSales/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceSales/SIF_Metadata/RightsElements/RightsElement | FoodserviceSales/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceSales/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceSales/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceSales/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceSales/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceSales/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceSales/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceSales/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceSales/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceItemSales/ItemQuantities/ItemQuantity | FoodserviceItemSales/ItemQuantities/ItemQuantity/GradeLevels/GradeLevel | FoodserviceItemSales/ItemQuantities/ItemQuantity/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItemSales/SIF_Metadata/TimeElements/TimeElement | FoodserviceItemSales/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceItemSales/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceItemSales/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceItemSales/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceItemSales/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceItemSales/SIF_Metadata/RightsElements/RightsElement | FoodserviceItemSales/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceItemSales/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceItemSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceItemSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItemSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceItemSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceItemSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceItemSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceItemSales/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceItemSales/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceItemSales/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceItemSales/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceItemSales/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceItemSales/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceItemSales/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceMenuPlan/GradeLevels/GradeLevel | FoodserviceMenuPlan/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMenuPlan/MenuPlanQuantities/MenuPlanQuantity | FoodserviceMenuPlan/SIF_Metadata/TimeElements/TimeElement | FoodserviceMenuPlan/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceMenuPlan/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceMenuPlan/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceMenuPlan/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceMenuPlan/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceMenuPlan/SIF_Metadata/RightsElements/RightsElement | FoodserviceMenuPlan/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceMenuPlan/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceMilkSales/SaleQuantities/SaleQuantity | FoodserviceMilkSales/SIF_Metadata/TimeElements/TimeElement | FoodserviceMilkSales/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceMilkSales/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceMilkSales/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceMilkSales/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceMilkSales/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceMilkSales/SIF_Metadata/RightsElements/RightsElement | FoodserviceMilkSales/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceMilkSales/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceMilkSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceMilkSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMilkSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceMilkSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceMilkSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceMilkSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceMilkSales/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceMilkSales/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceMilkSales/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceMilkSales/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceMilkSales/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceMilkSales/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceMilkSales/SIF_ExtendedElements/SIF_ExtendedElement | FoodservicePurchaseTransaction/PurchaseQuantities/PurchaseQuantity | FoodservicePurchaseTransaction/SIF_Metadata/TimeElements/TimeElement | FoodservicePurchaseTransaction/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodservicePurchaseTransaction/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodservicePurchaseTransaction/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodservicePurchaseTransaction/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodservicePurchaseTransaction/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodservicePurchaseTransaction/SIF_Metadata/RightsElements/RightsElement | FoodservicePurchaseTransaction/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodservicePurchaseTransaction/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceStaffEnrollmentCount/Counts/Count | FoodserviceStaffEnrollmentCount/SIF_Metadata/TimeElements/TimeElement | FoodserviceStaffEnrollmentCount/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceStaffEnrollmentCount/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceStaffEnrollmentCount/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceStaffEnrollmentCount/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceStaffEnrollmentCount/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceStaffEnrollmentCount/SIF_Metadata/RightsElements/RightsElement | FoodserviceStaffEnrollmentCount/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceStaffEnrollmentCount/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceStaffMealCounts/Counts/Count | FoodserviceStaffMealCounts/SIF_Metadata/TimeElements/TimeElement | FoodserviceStaffMealCounts/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceStaffMealCounts/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceStaffMealCounts/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceStaffMealCounts/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceStaffMealCounts/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceStaffMealCounts/SIF_Metadata/RightsElements/RightsElement | FoodserviceStaffMealCounts/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceStaffMealCounts/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceStudentEnrollmentCount/Counts/Count | FoodserviceStudentEnrollmentCount/SIF_Metadata/TimeElements/TimeElement | FoodserviceStudentEnrollmentCount/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceStudentEnrollmentCount/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceStudentEnrollmentCount/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceStudentEnrollmentCount/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceStudentEnrollmentCount/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceStudentEnrollmentCount/SIF_Metadata/RightsElements/RightsElement | FoodserviceStudentEnrollmentCount/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceStudentEnrollmentCount/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceStudentMealCounts/Counts/Count | FoodserviceStudentMealCounts/SIF_Metadata/TimeElements/TimeElement | FoodserviceStudentMealCounts/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceStudentMealCounts/SIF_Metadata/LifeCycle/Created/Creators/Creator | FoodserviceStudentMealCounts/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FoodserviceStudentMealCounts/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FoodserviceStudentMealCounts/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FoodserviceStudentMealCounts/SIF_Metadata/RightsElements/RightsElement | FoodserviceStudentMealCounts/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceStudentMealCounts/SIF_ExtendedElements/SIF_ExtendedElement | StudentRecordExchange/Records/OtherRecords/StudentRecordPackageRefId | StudentRecordExchange/SIF_Metadata/TimeElements/TimeElement | StudentRecordExchange/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentRecordExchange/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentRecordExchange/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentRecordExchange/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentRecordExchange/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentRecordExchange/SIF_Metadata/RightsElements/RightsElement | StudentRecordExchange/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentRecordExchange/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentRecordExchange/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentRecordExchange/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentRecordExchange/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentRecordExchange/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentRecordExchange/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentRecordExchange/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentRecordExchange/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentRecordExchange/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentRecordExchange/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentRecordExchange/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentRecordExchange/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentRecordExchange/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentRecordExchange/SIF_ExtendedElements/SIF_ExtendedElement | StudentDemographicRecord/StudentPersonalData/OtherIdList/OtherId | StudentDemographicRecord/StudentPersonalData/OtherNames/Name | StudentDemographicRecord/StudentPersonalData/DemographicsData/RaceList/Race | StudentDemographicRecord/StudentPersonalData/DemographicsData/RaceList/Race/OtherCodeList/OtherCode | StudentDemographicRecord/StudentPersonalData/DemographicsData/EnglishProficiency/OtherCodeList/OtherCode | StudentDemographicRecord/StudentPersonalData/DemographicsData/LanguageList/Language | StudentDemographicRecord/StudentPersonalData/DemographicsData/LanguageList/Language/OtherCodeList/OtherCode | StudentDemographicRecord/StudentPersonalData/DemographicsData/DwellingArrangement/OtherCodeList/OtherCode | StudentDemographicRecord/StudentPersonalData/AddressList/Address | StudentDemographicRecord/StudentPersonalData/PhoneNumberList/PhoneNumber | StudentDemographicRecord/StudentContactsSummary/ParentGuardian1/PhoneNumberList/PhoneNumber | StudentDemographicRecord/StudentContactsSummary/ParentGuardian1/AddressList/Address | StudentDemographicRecord/StudentContactsSummary/ParentGuardian2/PhoneNumberList/PhoneNumber | StudentDemographicRecord/StudentContactsSummary/ParentGuardian2/AddressList/Address | StudentDemographicRecord/SIF_Metadata/TimeElements/TimeElement | StudentDemographicRecord/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentDemographicRecord/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentDemographicRecord/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentDemographicRecord/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentDemographicRecord/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentDemographicRecord/SIF_Metadata/RightsElements/RightsElement | StudentDemographicRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentDemographicRecord/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentDemographicRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentDemographicRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentDemographicRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentDemographicRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentDemographicRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentDemographicRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentDemographicRecord/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentDemographicRecord/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentDemographicRecord/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentDemographicRecord/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentDemographicRecord/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentDemographicRecord/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentDemographicRecord/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/StudentSchoolEnrollmentData/GradeLevel/OtherCodeList/OtherCode | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/AddressList/Address | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/PhoneNumberList/PhoneNumber | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/AddressList/Address | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/PhoneNumberList/PhoneNumber | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/StudentSchoolEnrollmentData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/LEAInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/PhoneNumberList/PhoneNumber | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/AddressList/Address | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/PhoneNumberList/PhoneNumber | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/IdentificationInfoList/IdentificationInfo | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/GradeLevels/GradeLevel | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData/Letter/ValidMark | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/EntryType/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/GradeLevel/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/ExitStatus/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/ExitType/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/LEARelationshipType/ResidencyStatus/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentSchoolRelationship/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/SubjectAreaList/SubjectArea | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/SubjectAreaList/SubjectArea/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/InstructionalLevel/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/GradeLevelWhenTaken/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/MarkData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term | StudentAcademicRecord/CourseHistory/Term/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/SubjectAreaList/SubjectArea | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/SubjectAreaList/SubjectArea/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/InstructionalLevel/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/GradeLevelWhenTaken/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/MarkData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SectionInfoData/MediumOfInstruction/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/GradeLevelWhenTaken/OtherCodeList/OtherCode | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AcademicPerformanceSummary/AcademicFoci/AcademicFocus | StudentAcademicRecord/AcademicPerformanceSummary/AcademicFoci/AcademicFocus/OtherCodeList/OtherCode | StudentAcademicRecord/AcademicPerformanceSummary/AcademicSubjects/AcademicSubject | StudentAcademicRecord/AcademicPerformanceSummary/AcademicSubjects/AcademicSubject/OtherCodeList/OtherCode | StudentAcademicRecord/AcademicPerformanceSummary/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AssessmentPerformanceHistory/Assessment | StudentAcademicRecord/AssessmentPerformanceHistory/Assessment/StudentGradeLevelWhenAssessed/OtherCodeList/OtherCode | StudentAcademicRecord/AssessmentPerformanceHistory/Assessment/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AdditionalGraduationRequirementPerformanceHistory/Requirement | StudentAcademicRecord/AdditionalGraduationRequirementPerformanceHistory/Requirement/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/ActivityAwardHistory/ActivityAward | StudentAcademicRecord/ActivityAwardHistory/ActivityAward/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/SIF_Metadata/TimeElements/TimeElement | StudentAcademicRecord/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentAcademicRecord/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentAcademicRecord/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentAcademicRecord/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentAcademicRecord/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentAcademicRecord/SIF_Metadata/RightsElements/RightsElement | StudentAcademicRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentAcademicRecord/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentAcademicRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentAcademicRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentAcademicRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentAcademicRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentAcademicRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentAcademicRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentAcademicRecord/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentAcademicRecord/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentAcademicRecord/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentAcademicRecord/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentAcademicRecord/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentAcademicRecord/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentAcademicRecord/SIF_ExtendedElements/SIF_ExtendedElement | StudentSpecialEducationRecord/StudentParticipationData/ProgramType/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/PhoneNumberList/PhoneNumber | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/AddressList/Address | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/PhoneNumberList/PhoneNumber | StudentSpecialEducationRecord/StudentParticipationData/ProgramStatus/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory | StudentSpecialEducationRecord/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramType/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramFundingSources/ProgramFundingSource | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramFundingSources/ProgramFundingSource/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramStatus/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/Service/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceFundingSources/ServiceFundingSource | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceFundingSources/ServiceFundingSource/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceProviderType/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/FrequencyTime/OtherCodeList/OtherCode | StudentSpecialEducationRecord/SIF_Metadata/TimeElements/TimeElement | StudentSpecialEducationRecord/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentSpecialEducationRecord/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentSpecialEducationRecord/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentSpecialEducationRecord/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentSpecialEducationRecord/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentSpecialEducationRecord/SIF_Metadata/RightsElements/RightsElement | StudentSpecialEducationRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSpecialEducationRecord/SIF_ExtendedElements/SIF_ExtendedElement | MarkValueInfo/Letter/ValidMark | MarkValueInfo/SIF_Metadata/TimeElements/TimeElement | MarkValueInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | MarkValueInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | MarkValueInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | MarkValueInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | MarkValueInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | MarkValueInfo/SIF_Metadata/RightsElements/RightsElement | MarkValueInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | MarkValueInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | MarkValueInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | MarkValueInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | MarkValueInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | MarkValueInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | MarkValueInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | MarkValueInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | MarkValueInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | MarkValueInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | MarkValueInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | MarkValueInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | MarkValueInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | MarkValueInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | MarkValueInfo/SIF_ExtendedElements/SIF_ExtendedElement | MarkInfo/SIF_Metadata/TimeElements/TimeElement | MarkInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | MarkInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | MarkInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | MarkInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | MarkInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | MarkInfo/SIF_Metadata/RightsElements/RightsElement | MarkInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | MarkInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | MarkInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | MarkInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | MarkInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | MarkInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | MarkInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | MarkInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | MarkInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | MarkInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | MarkInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | MarkInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | MarkInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | MarkInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | MarkInfo/SIF_ExtendedElements/SIF_ExtendedElement | SectionMarkInfo/TermMarkLists/MarkInfoList | SectionMarkInfo/TermMarkLists/MarkInfoList/MarkInfoRefId | SectionMarkInfo/SIF_Metadata/TimeElements/TimeElement | SectionMarkInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | SectionMarkInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | SectionMarkInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | SectionMarkInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | SectionMarkInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | SectionMarkInfo/SIF_Metadata/RightsElements/RightsElement | SectionMarkInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | SectionMarkInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | SectionMarkInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | SectionMarkInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SectionMarkInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | SectionMarkInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SectionMarkInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | SectionMarkInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SectionMarkInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | SectionMarkInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SectionMarkInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SectionMarkInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SectionMarkInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | SectionMarkInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SectionMarkInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentSectionMarks/MarkList/Mark | StudentSectionMarks/SIF_Metadata/TimeElements/TimeElement | StudentSectionMarks/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentSectionMarks/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentSectionMarks/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentSectionMarks/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentSectionMarks/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentSectionMarks/SIF_Metadata/RightsElements/RightsElement | StudentSectionMarks/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentSectionMarks/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentSectionMarks/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentSectionMarks/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSectionMarks/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentSectionMarks/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSectionMarks/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentSectionMarks/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSectionMarks/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentSectionMarks/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSectionMarks/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSectionMarks/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSectionMarks/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentSectionMarks/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSectionMarks/SIF_ExtendedElements/SIF_ExtendedElement | GradingCategory/SIF_Metadata/TimeElements/TimeElement | GradingCategory/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | GradingCategory/SIF_Metadata/LifeCycle/Created/Creators/Creator | GradingCategory/SIF_Metadata/LifeCycle/ModificationHistory/Modified | GradingCategory/SIF_Metadata/LifeCycle/TimeElements/TimeElement | GradingCategory/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | GradingCategory/SIF_Metadata/RightsElements/RightsElement | GradingCategory/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | GradingCategory/SIF_Metadata/EducationFilter/MediaTypes/MediaType | GradingCategory/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | GradingCategory/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | GradingCategory/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | GradingCategory/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | GradingCategory/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | GradingCategory/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | GradingCategory/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | GradingCategory/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | GradingCategory/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | GradingCategory/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | GradingCategory/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | GradingCategory/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | GradingCategory/SIF_ExtendedElements/SIF_ExtendedElement | GradingAssignment/SIF_Metadata/TimeElements/TimeElement | GradingAssignment/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | GradingAssignment/SIF_Metadata/LifeCycle/Created/Creators/Creator | GradingAssignment/SIF_Metadata/LifeCycle/ModificationHistory/Modified | GradingAssignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement | GradingAssignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | GradingAssignment/SIF_Metadata/RightsElements/RightsElement | GradingAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | GradingAssignment/SIF_Metadata/EducationFilter/MediaTypes/MediaType | GradingAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | GradingAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | GradingAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | GradingAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | GradingAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | GradingAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | GradingAssignment/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | GradingAssignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | GradingAssignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | GradingAssignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | GradingAssignment/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | GradingAssignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | GradingAssignment/SIF_ExtendedElements/SIF_ExtendedElement | GradingAssignmentScore/SIF_Metadata/TimeElements/TimeElement | GradingAssignmentScore/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | GradingAssignmentScore/SIF_Metadata/LifeCycle/Created/Creators/Creator | GradingAssignmentScore/SIF_Metadata/LifeCycle/ModificationHistory/Modified | GradingAssignmentScore/SIF_Metadata/LifeCycle/TimeElements/TimeElement | GradingAssignmentScore/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | GradingAssignmentScore/SIF_Metadata/RightsElements/RightsElement | GradingAssignmentScore/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | GradingAssignmentScore/SIF_Metadata/EducationFilter/MediaTypes/MediaType | GradingAssignmentScore/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | GradingAssignmentScore/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | GradingAssignmentScore/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | GradingAssignmentScore/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | GradingAssignmentScore/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | GradingAssignmentScore/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | GradingAssignmentScore/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | GradingAssignmentScore/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | GradingAssignmentScore/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | GradingAssignmentScore/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | GradingAssignmentScore/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | GradingAssignmentScore/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | GradingAssignmentScore/SIF_ExtendedElements/SIF_ExtendedElement | StudentPeriodAttendance/SIF_Metadata/TimeElements/TimeElement | StudentPeriodAttendance/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentPeriodAttendance/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentPeriodAttendance/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentPeriodAttendance/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentPeriodAttendance/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentPeriodAttendance/SIF_Metadata/RightsElements/RightsElement | StudentPeriodAttendance/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentPeriodAttendance/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentPeriodAttendance/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentPeriodAttendance/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentPeriodAttendance/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentPeriodAttendance/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentPeriodAttendance/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentPeriodAttendance/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentPeriodAttendance/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentPeriodAttendance/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentPeriodAttendance/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentPeriodAttendance/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentPeriodAttendance/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentPeriodAttendance/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentPeriodAttendance/SIF_ExtendedElements/SIF_ExtendedElement | StudentGrade/SIF_Metadata/TimeElements/TimeElement | StudentGrade/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentGrade/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentGrade/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentGrade/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentGrade/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentGrade/SIF_Metadata/RightsElements/RightsElement | StudentGrade/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentGrade/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentGrade/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentGrade/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentGrade/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentGrade/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentGrade/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentGrade/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentGrade/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentGrade/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentGrade/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentGrade/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentGrade/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentGrade/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentGrade/SIF_ExtendedElements/SIF_ExtendedElement | Billing/SIF_Metadata/TimeElements/TimeElement | Billing/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | Billing/SIF_Metadata/LifeCycle/Created/Creators/Creator | Billing/SIF_Metadata/LifeCycle/ModificationHistory/Modified | Billing/SIF_Metadata/LifeCycle/TimeElements/TimeElement | Billing/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | Billing/SIF_Metadata/RightsElements/RightsElement | Billing/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | Billing/SIF_Metadata/EducationFilter/MediaTypes/MediaType | Billing/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | Billing/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Billing/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | Billing/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Billing/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | Billing/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Billing/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | Billing/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Billing/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Billing/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Billing/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | Billing/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Billing/SIF_ExtendedElements/SIF_ExtendedElement | Payment/SIF_Metadata/TimeElements/TimeElement | Payment/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | Payment/SIF_Metadata/LifeCycle/Created/Creators/Creator | Payment/SIF_Metadata/LifeCycle/ModificationHistory/Modified | Payment/SIF_Metadata/LifeCycle/TimeElements/TimeElement | Payment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | Payment/SIF_Metadata/RightsElements/RightsElement | Payment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | Payment/SIF_Metadata/EducationFilter/MediaTypes/MediaType | Payment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | Payment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Payment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | Payment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Payment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | Payment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Payment/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | Payment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Payment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Payment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Payment/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | Payment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Payment/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeAssignment/JobClassification/OtherCodeList/OtherCode | EmployeeAssignment/ProgramType/OtherCodeList/OtherCode | EmployeeAssignment/FundingSource/OtherCodeList/OtherCode | EmployeeAssignment/SpecialEducation/AgeGroupList/AgeGroup | EmployeeAssignment/SpecialEducation/TitleList/TitleList | EmployeeAssignment/SIF_Metadata/TimeElements/TimeElement | EmployeeAssignment/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeeAssignment/SIF_Metadata/LifeCycle/Created/Creators/Creator | EmployeeAssignment/SIF_Metadata/LifeCycle/ModificationHistory/Modified | EmployeeAssignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement | EmployeeAssignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeeAssignment/SIF_Metadata/RightsElements/RightsElement | EmployeeAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | EmployeeAssignment/SIF_Metadata/EducationFilter/MediaTypes/MediaType | EmployeeAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | EmployeeAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | EmployeeAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | EmployeeAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeAssignment/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | EmployeeAssignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeAssignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeAssignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeAssignment/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | EmployeeAssignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeAssignment/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeContract/SIF_Metadata/TimeElements/TimeElement | EmployeeContract/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeeContract/SIF_Metadata/LifeCycle/Created/Creators/Creator | EmployeeContract/SIF_Metadata/LifeCycle/ModificationHistory/Modified | EmployeeContract/SIF_Metadata/LifeCycle/TimeElements/TimeElement | EmployeeContract/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeeContract/SIF_Metadata/RightsElements/RightsElement | EmployeeContract/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | EmployeeContract/SIF_Metadata/EducationFilter/MediaTypes/MediaType | EmployeeContract/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | EmployeeContract/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeContract/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | EmployeeContract/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeContract/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | EmployeeContract/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeContract/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | EmployeeContract/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeContract/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeContract/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeContract/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | EmployeeContract/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeContract/SIF_ExtendedElements/SIF_ExtendedElement | EmploymentRecord/SIF_Metadata/TimeElements/TimeElement | EmploymentRecord/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | EmploymentRecord/SIF_Metadata/LifeCycle/Created/Creators/Creator | EmploymentRecord/SIF_Metadata/LifeCycle/ModificationHistory/Modified | EmploymentRecord/SIF_Metadata/LifeCycle/TimeElements/TimeElement | EmploymentRecord/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | EmploymentRecord/SIF_Metadata/RightsElements/RightsElement | EmploymentRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | EmploymentRecord/SIF_Metadata/EducationFilter/MediaTypes/MediaType | EmploymentRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | EmploymentRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmploymentRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | EmploymentRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmploymentRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | EmploymentRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmploymentRecord/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | EmploymentRecord/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmploymentRecord/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmploymentRecord/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmploymentRecord/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | EmploymentRecord/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmploymentRecord/SIF_ExtendedElements/SIF_ExtendedElement | EmployeePersonal/OtherIdList/OtherId | EmployeePersonal/Demographics/RaceList/Race | EmployeePersonal/Demographics/RaceList/Race/OtherCodeList/OtherCode | EmployeePersonal/Demographics/CountriesOfCitizenship/CountryOfCitizenship | EmployeePersonal/Demographics/CountriesOfResidency/CountryOfResidency | EmployeePersonal/Demographics/EnglishProficiency/OtherCodeList/OtherCode | EmployeePersonal/Demographics/LanguageList/Language | EmployeePersonal/Demographics/LanguageList/Language/OtherCodeList/OtherCode | EmployeePersonal/Demographics/DwellingArrangement/OtherCodeList/OtherCode | EmployeePersonal/AddressList/Address | EmployeePersonal/PhoneNumberList/PhoneNumber | EmployeePersonal/EmailList/Email | EmployeePersonal/SIF_Metadata/TimeElements/TimeElement | EmployeePersonal/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeePersonal/SIF_Metadata/LifeCycle/Created/Creators/Creator | EmployeePersonal/SIF_Metadata/LifeCycle/ModificationHistory/Modified | EmployeePersonal/SIF_Metadata/LifeCycle/TimeElements/TimeElement | EmployeePersonal/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeePersonal/SIF_Metadata/RightsElements/RightsElement | EmployeePersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | EmployeePersonal/SIF_Metadata/EducationFilter/MediaTypes/MediaType | EmployeePersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | EmployeePersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeePersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | EmployeePersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeePersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | EmployeePersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeePersonal/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | EmployeePersonal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeePersonal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeePersonal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeePersonal/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | EmployeePersonal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeePersonal/SIF_ExtendedElements/SIF_ExtendedElement | EmployeePicture/SIF_Metadata/TimeElements/TimeElement | EmployeePicture/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeePicture/SIF_Metadata/LifeCycle/Created/Creators/Creator | EmployeePicture/SIF_Metadata/LifeCycle/ModificationHistory/Modified | EmployeePicture/SIF_Metadata/LifeCycle/TimeElements/TimeElement | EmployeePicture/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeePicture/SIF_Metadata/RightsElements/RightsElement | EmployeePicture/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | EmployeePicture/SIF_Metadata/EducationFilter/MediaTypes/MediaType | EmployeePicture/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | EmployeePicture/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeePicture/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | EmployeePicture/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeePicture/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | EmployeePicture/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeePicture/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | EmployeePicture/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeePicture/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeePicture/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeePicture/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | EmployeePicture/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeePicture/SIF_ExtendedElements/SIF_ExtendedElement | FinancialAnnual/AnnualItems/AnnualItem | FinancialAnnual/AnnualItems/AnnualItem/SIF_ExtendedElements/SIF_ExtendedElement | FinancialAnnual/SIF_Metadata/TimeElements/TimeElement | FinancialAnnual/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialAnnual/SIF_Metadata/LifeCycle/Created/Creators/Creator | FinancialAnnual/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FinancialAnnual/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FinancialAnnual/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialAnnual/SIF_Metadata/RightsElements/RightsElement | FinancialAnnual/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FinancialAnnual/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FinancialAnnual/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FinancialAnnual/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialAnnual/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FinancialAnnual/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialAnnual/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FinancialAnnual/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialAnnual/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FinancialAnnual/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialAnnual/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialAnnual/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialAnnual/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FinancialAnnual/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialAnnual/SIF_ExtendedElements/SIF_ExtendedElement | FinancialBudget/BudgetAccounts/BudgetAccount | FinancialBudget/SIF_Metadata/TimeElements/TimeElement | FinancialBudget/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialBudget/SIF_Metadata/LifeCycle/Created/Creators/Creator | FinancialBudget/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FinancialBudget/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FinancialBudget/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialBudget/SIF_Metadata/RightsElements/RightsElement | FinancialBudget/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FinancialBudget/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FinancialBudget/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FinancialBudget/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialBudget/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FinancialBudget/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialBudget/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FinancialBudget/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialBudget/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FinancialBudget/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialBudget/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialBudget/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialBudget/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FinancialBudget/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialBudget/SIF_ExtendedElements/SIF_ExtendedElement | TimeWorked/JobFunction/OtherCodeList/OtherCode | TimeWorked/SIF_Metadata/TimeElements/TimeElement | TimeWorked/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | TimeWorked/SIF_Metadata/LifeCycle/Created/Creators/Creator | TimeWorked/SIF_Metadata/LifeCycle/ModificationHistory/Modified | TimeWorked/SIF_Metadata/LifeCycle/TimeElements/TimeElement | TimeWorked/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | TimeWorked/SIF_Metadata/RightsElements/RightsElement | TimeWorked/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | TimeWorked/SIF_Metadata/EducationFilter/MediaTypes/MediaType | TimeWorked/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | TimeWorked/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | TimeWorked/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | TimeWorked/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | TimeWorked/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | TimeWorked/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | TimeWorked/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | TimeWorked/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | TimeWorked/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | TimeWorked/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | TimeWorked/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | TimeWorked/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | TimeWorked/SIF_ExtendedElements/SIF_ExtendedElement | VendorInfo/ContactInfo/EmailList/Email | VendorInfo/ContactInfo/PhoneNumberList/PhoneNumber | VendorInfo/SIF_Metadata/TimeElements/TimeElement | VendorInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | VendorInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | VendorInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | VendorInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | VendorInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | VendorInfo/SIF_Metadata/RightsElements/RightsElement | VendorInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | VendorInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | VendorInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | VendorInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | VendorInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | VendorInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | VendorInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | VendorInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | VendorInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | VendorInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | VendorInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | VendorInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | VendorInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | VendorInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | VendorInfo/SIF_ExtendedElements/SIF_ExtendedElement | W4/SIF_Metadata/TimeElements/TimeElement | W4/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | W4/SIF_Metadata/LifeCycle/Created/Creators/Creator | W4/SIF_Metadata/LifeCycle/ModificationHistory/Modified | W4/SIF_Metadata/LifeCycle/TimeElements/TimeElement | W4/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | W4/SIF_Metadata/RightsElements/RightsElement | W4/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | W4/SIF_Metadata/EducationFilter/MediaTypes/MediaType | W4/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | W4/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | W4/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | W4/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | W4/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | W4/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | W4/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | W4/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | W4/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | W4/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | W4/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | W4/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | W4/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeWage/PayRates/PayRate | EmployeeWage/SIF_Metadata/TimeElements/TimeElement | EmployeeWage/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeeWage/SIF_Metadata/LifeCycle/Created/Creators/Creator | EmployeeWage/SIF_Metadata/LifeCycle/ModificationHistory/Modified | EmployeeWage/SIF_Metadata/LifeCycle/TimeElements/TimeElement | EmployeeWage/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeeWage/SIF_Metadata/RightsElements/RightsElement | EmployeeWage/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | EmployeeWage/SIF_Metadata/EducationFilter/MediaTypes/MediaType | EmployeeWage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | EmployeeWage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeWage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | EmployeeWage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeWage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | EmployeeWage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeWage/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | EmployeeWage/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeWage/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeWage/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeWage/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | EmployeeWage/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeWage/SIF_ExtendedElements/SIF_ExtendedElement | LocationInfo/IdentificationInfoList/IdentificationInfo | LocationInfo/OtherLEAs/LEAInfoRefId | LocationInfo/AddressList/Address | LocationInfo/PhoneNumberList/PhoneNumber | LocationInfo/SIF_Metadata/TimeElements/TimeElement | LocationInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | LocationInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | LocationInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | LocationInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | LocationInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | LocationInfo/SIF_Metadata/RightsElements/RightsElement | LocationInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | LocationInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | LocationInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | LocationInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LocationInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | LocationInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LocationInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | LocationInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LocationInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | LocationInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LocationInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LocationInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LocationInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | LocationInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LocationInfo/SIF_ExtendedElements/SIF_ExtendedElement | Purchasing/PurchasingItems/PurchasingItem | Purchasing/PurchasingItems/PurchasingItem/ExpenseAccounts/ExpenseAccount | Purchasing/SIF_Metadata/TimeElements/TimeElement | Purchasing/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | Purchasing/SIF_Metadata/LifeCycle/Created/Creators/Creator | Purchasing/SIF_Metadata/LifeCycle/ModificationHistory/Modified | Purchasing/SIF_Metadata/LifeCycle/TimeElements/TimeElement | Purchasing/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | Purchasing/SIF_Metadata/RightsElements/RightsElement | Purchasing/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | Purchasing/SIF_Metadata/EducationFilter/MediaTypes/MediaType | Purchasing/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | Purchasing/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Purchasing/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | Purchasing/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Purchasing/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | Purchasing/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Purchasing/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | Purchasing/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Purchasing/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Purchasing/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Purchasing/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | Purchasing/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Purchasing/SIF_ExtendedElements/SIF_ExtendedElement | AccountingPeriod/SIF_Metadata/TimeElements/TimeElement | AccountingPeriod/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | AccountingPeriod/SIF_Metadata/LifeCycle/Created/Creators/Creator | AccountingPeriod/SIF_Metadata/LifeCycle/ModificationHistory/Modified | AccountingPeriod/SIF_Metadata/LifeCycle/TimeElements/TimeElement | AccountingPeriod/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | AccountingPeriod/SIF_Metadata/RightsElements/RightsElement | AccountingPeriod/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | AccountingPeriod/SIF_Metadata/EducationFilter/MediaTypes/MediaType | AccountingPeriod/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | AccountingPeriod/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AccountingPeriod/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | AccountingPeriod/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AccountingPeriod/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | AccountingPeriod/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AccountingPeriod/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | AccountingPeriod/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AccountingPeriod/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AccountingPeriod/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AccountingPeriod/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | AccountingPeriod/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AccountingPeriod/SIF_ExtendedElements/SIF_ExtendedElement | FinancialAccount/SIF_Metadata/TimeElements/TimeElement | FinancialAccount/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialAccount/SIF_Metadata/LifeCycle/Created/Creators/Creator | FinancialAccount/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FinancialAccount/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FinancialAccount/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialAccount/SIF_Metadata/RightsElements/RightsElement | FinancialAccount/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FinancialAccount/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FinancialAccount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FinancialAccount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialAccount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FinancialAccount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialAccount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FinancialAccount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialAccount/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FinancialAccount/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialAccount/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialAccount/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialAccount/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FinancialAccount/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialAccount/SIF_ExtendedElements/SIF_ExtendedElement | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/TimeElements/TimeElement | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/RightsElements/RightsElement | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialAccountAccountingPeriodLocationInfo/SIF_ExtendedElements/SIF_ExtendedElement | FinancialClass/SIF_Metadata/TimeElements/TimeElement | FinancialClass/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialClass/SIF_Metadata/LifeCycle/Created/Creators/Creator | FinancialClass/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FinancialClass/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FinancialClass/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialClass/SIF_Metadata/RightsElements/RightsElement | FinancialClass/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FinancialClass/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FinancialClass/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FinancialClass/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialClass/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FinancialClass/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialClass/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FinancialClass/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialClass/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FinancialClass/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialClass/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialClass/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialClass/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FinancialClass/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialClass/SIF_ExtendedElements/SIF_ExtendedElement | FinancialIncomeStatement/Amounts/Amount | FinancialIncomeStatement/SIF_Metadata/TimeElements/TimeElement | FinancialIncomeStatement/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialIncomeStatement/SIF_Metadata/LifeCycle/Created/Creators/Creator | FinancialIncomeStatement/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FinancialIncomeStatement/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FinancialIncomeStatement/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialIncomeStatement/SIF_Metadata/RightsElements/RightsElement | FinancialIncomeStatement/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FinancialIncomeStatement/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FinancialIncomeStatement/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FinancialIncomeStatement/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialIncomeStatement/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FinancialIncomeStatement/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialIncomeStatement/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FinancialIncomeStatement/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialIncomeStatement/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FinancialIncomeStatement/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialIncomeStatement/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialIncomeStatement/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialIncomeStatement/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FinancialIncomeStatement/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialIncomeStatement/SIF_ExtendedElements/SIF_ExtendedElement | FinancialTransaction/Amounts/Amount | FinancialTransaction/SIF_Metadata/TimeElements/TimeElement | FinancialTransaction/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialTransaction/SIF_Metadata/LifeCycle/Created/Creators/Creator | FinancialTransaction/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FinancialTransaction/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FinancialTransaction/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FinancialTransaction/SIF_Metadata/RightsElements/RightsElement | FinancialTransaction/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FinancialTransaction/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FinancialTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FinancialTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FinancialTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FinancialTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialTransaction/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FinancialTransaction/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialTransaction/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialTransaction/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialTransaction/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FinancialTransaction/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialTransaction/SIF_ExtendedElements/SIF_ExtendedElement | FiscalYear/SIF_Metadata/TimeElements/TimeElement | FiscalYear/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | FiscalYear/SIF_Metadata/LifeCycle/Created/Creators/Creator | FiscalYear/SIF_Metadata/LifeCycle/ModificationHistory/Modified | FiscalYear/SIF_Metadata/LifeCycle/TimeElements/TimeElement | FiscalYear/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | FiscalYear/SIF_Metadata/RightsElements/RightsElement | FiscalYear/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | FiscalYear/SIF_Metadata/EducationFilter/MediaTypes/MediaType | FiscalYear/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | FiscalYear/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FiscalYear/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | FiscalYear/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FiscalYear/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | FiscalYear/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FiscalYear/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | FiscalYear/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FiscalYear/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FiscalYear/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FiscalYear/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | FiscalYear/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FiscalYear/SIF_ExtendedElements/SIF_ExtendedElement | ActivityProvider/SIF_Metadata/TimeElements/TimeElement | ActivityProvider/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | ActivityProvider/SIF_Metadata/LifeCycle/Created/Creators/Creator | ActivityProvider/SIF_Metadata/LifeCycle/ModificationHistory/Modified | ActivityProvider/SIF_Metadata/LifeCycle/TimeElements/TimeElement | ActivityProvider/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | ActivityProvider/SIF_Metadata/RightsElements/RightsElement | ActivityProvider/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | ActivityProvider/SIF_Metadata/EducationFilter/MediaTypes/MediaType | ActivityProvider/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | ActivityProvider/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ActivityProvider/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | ActivityProvider/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ActivityProvider/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | ActivityProvider/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ActivityProvider/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | ActivityProvider/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ActivityProvider/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ActivityProvider/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ActivityProvider/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | ActivityProvider/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ActivityProvider/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeCredit/SIF_Metadata/TimeElements/TimeElement | EmployeeCredit/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeeCredit/SIF_Metadata/LifeCycle/Created/Creators/Creator | EmployeeCredit/SIF_Metadata/LifeCycle/ModificationHistory/Modified | EmployeeCredit/SIF_Metadata/LifeCycle/TimeElements/TimeElement | EmployeeCredit/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeeCredit/SIF_Metadata/RightsElements/RightsElement | EmployeeCredit/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | EmployeeCredit/SIF_Metadata/EducationFilter/MediaTypes/MediaType | EmployeeCredit/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | EmployeeCredit/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeCredit/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | EmployeeCredit/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeCredit/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | EmployeeCredit/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeCredit/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | EmployeeCredit/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeCredit/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeCredit/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeCredit/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | EmployeeCredit/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeCredit/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeRecertification/Demographics/RaceList/Race | EmployeeRecertification/Demographics/RaceList/Race/OtherCodeList/OtherCode | EmployeeRecertification/Demographics/CountriesOfCitizenship/CountryOfCitizenship | EmployeeRecertification/Demographics/CountriesOfResidency/CountryOfResidency | EmployeeRecertification/Demographics/EnglishProficiency/OtherCodeList/OtherCode | EmployeeRecertification/Demographics/LanguageList/Language | EmployeeRecertification/Demographics/LanguageList/Language/OtherCodeList/OtherCode | EmployeeRecertification/Demographics/DwellingArrangement/OtherCodeList/OtherCode | EmployeeRecertification/SIF_Metadata/TimeElements/TimeElement | EmployeeRecertification/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeeRecertification/SIF_Metadata/LifeCycle/Created/Creators/Creator | EmployeeRecertification/SIF_Metadata/LifeCycle/ModificationHistory/Modified | EmployeeRecertification/SIF_Metadata/LifeCycle/TimeElements/TimeElement | EmployeeRecertification/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeeRecertification/SIF_Metadata/RightsElements/RightsElement | EmployeeRecertification/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | EmployeeRecertification/SIF_Metadata/EducationFilter/MediaTypes/MediaType | EmployeeRecertification/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | EmployeeRecertification/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeRecertification/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | EmployeeRecertification/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeRecertification/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | EmployeeRecertification/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeRecertification/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | EmployeeRecertification/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeRecertification/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeRecertification/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeRecertification/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | EmployeeRecertification/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeRecertification/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeCredential/Demographics/RaceList/Race | EmployeeCredential/Demographics/RaceList/Race/OtherCodeList/OtherCode | EmployeeCredential/Demographics/CountriesOfCitizenship/CountryOfCitizenship | EmployeeCredential/Demographics/CountriesOfResidency/CountryOfResidency | EmployeeCredential/Demographics/EnglishProficiency/OtherCodeList/OtherCode | EmployeeCredential/Demographics/LanguageList/Language | EmployeeCredential/Demographics/LanguageList/Language/OtherCodeList/OtherCode | EmployeeCredential/Demographics/DwellingArrangement/OtherCodeList/OtherCode | EmployeeCredential/Certifications/Certification | EmployeeCredential/TeachingCredentialType | EmployeeCredential/BackgroundChecks/BackgroundCheck | EmployeeCredential/Assignments/Assignment | EmployeeCredential/Assignments/Assignment/GradeLevels/GradeLevel | EmployeeCredential/Assignments/Assignment/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeCredential/Assignments/Assignment/JobFunction/OtherCodeList/OtherCode | EmployeeCredential/SIF_Metadata/TimeElements/TimeElement | EmployeeCredential/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeeCredential/SIF_Metadata/LifeCycle/Created/Creators/Creator | EmployeeCredential/SIF_Metadata/LifeCycle/ModificationHistory/Modified | EmployeeCredential/SIF_Metadata/LifeCycle/TimeElements/TimeElement | EmployeeCredential/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | EmployeeCredential/SIF_Metadata/RightsElements/RightsElement | EmployeeCredential/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | EmployeeCredential/SIF_Metadata/EducationFilter/MediaTypes/MediaType | EmployeeCredential/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | EmployeeCredential/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeCredential/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | EmployeeCredential/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeCredential/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | EmployeeCredential/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeCredential/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | EmployeeCredential/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeCredential/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeCredential/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeCredential/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | EmployeeCredential/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeCredential/SIF_ExtendedElements/SIF_ExtendedElement | ProfessionalDevelopmentActivities/LearningStandardItems/LearningStandardItemRefId | ProfessionalDevelopmentActivities/SIF_Metadata/TimeElements/TimeElement | ProfessionalDevelopmentActivities/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | ProfessionalDevelopmentActivities/SIF_Metadata/LifeCycle/Created/Creators/Creator | ProfessionalDevelopmentActivities/SIF_Metadata/LifeCycle/ModificationHistory/Modified | ProfessionalDevelopmentActivities/SIF_Metadata/LifeCycle/TimeElements/TimeElement | ProfessionalDevelopmentActivities/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | ProfessionalDevelopmentActivities/SIF_Metadata/RightsElements/RightsElement | ProfessionalDevelopmentActivities/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/MediaTypes/MediaType | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ProfessionalDevelopmentActivities/SIF_ExtendedElements/SIF_ExtendedElement | ProfessionalDevelopmentProgram/LearningStandardItems/LearningStandardItemRefId | ProfessionalDevelopmentProgram/SIF_Metadata/TimeElements/TimeElement | ProfessionalDevelopmentProgram/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | ProfessionalDevelopmentProgram/SIF_Metadata/LifeCycle/Created/Creators/Creator | ProfessionalDevelopmentProgram/SIF_Metadata/LifeCycle/ModificationHistory/Modified | ProfessionalDevelopmentProgram/SIF_Metadata/LifeCycle/TimeElements/TimeElement | ProfessionalDevelopmentProgram/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | ProfessionalDevelopmentProgram/SIF_Metadata/RightsElements/RightsElement | ProfessionalDevelopmentProgram/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/MediaTypes/MediaType | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ProfessionalDevelopmentProgram/SIF_ExtendedElements/SIF_ExtendedElement | ProfessionalDevelopmentRegistration/SIF_Metadata/TimeElements/TimeElement | ProfessionalDevelopmentRegistration/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | ProfessionalDevelopmentRegistration/SIF_Metadata/LifeCycle/Created/Creators/Creator | ProfessionalDevelopmentRegistration/SIF_Metadata/LifeCycle/ModificationHistory/Modified | ProfessionalDevelopmentRegistration/SIF_Metadata/LifeCycle/TimeElements/TimeElement | ProfessionalDevelopmentRegistration/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | ProfessionalDevelopmentRegistration/SIF_Metadata/RightsElements/RightsElement | ProfessionalDevelopmentRegistration/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/MediaTypes/MediaType | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ProfessionalDevelopmentRegistration/SIF_ExtendedElements/SIF_ExtendedElement | StudentParticipation/ProgramType/OtherCodeList/OtherCode | StudentParticipation/ProgramFundingSources/ProgramFundingSource | StudentParticipation/ProgramFundingSources/ProgramFundingSource/OtherCodeList/OtherCode | StudentParticipation/PartCTransitionMeetingNotHeldReasons/PartCTransitionMeetingNotHeldReason | StudentParticipation/PartCTransitionMeetingNotHeldReasons/PartCTransitionMeetingNotHeldReason/OtherCodeList/OtherCode | StudentParticipation/PartCTransitionMeetingOutcomes/PartCTransitionMeetingOutcome | StudentParticipation/PartCTransitionMeetingOutcomes/PartCTransitionMeetingOutcome/OtherCodeList/OtherCode | StudentParticipation/ReferralSource/OtherCodeList/OtherCode | StudentParticipation/ProgramStatus/OtherCodeList/OtherCode | StudentParticipation/ExceptionalityCategories/ExceptionalityCategory | StudentParticipation/ExceptionalityCategories/ExceptionalityCategory/OtherCodeList/OtherCode | StudentParticipation/ProgramPlanType/OtherCodeList/OtherCode | StudentParticipation/LeastRestrictiveEnvironment/OtherCodeList/OtherCode | StudentParticipation/ProgramAvailability/OtherCodeList/OtherCode | StudentParticipation/ProgramExitReason/OtherCodeList/OtherCode | StudentParticipation/AdditionalProgramAvailabilityList/ProgramAvailability | StudentParticipation/AdditionalProgramAvailabilityList/ProgramAvailability/OtherCodeList/OtherCode | StudentParticipation/SIF_Metadata/TimeElements/TimeElement | StudentParticipation/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentParticipation/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentParticipation/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentParticipation/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentParticipation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentParticipation/SIF_Metadata/RightsElements/RightsElement | StudentParticipation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentParticipation/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentParticipation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentParticipation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentParticipation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentParticipation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentParticipation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentParticipation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentParticipation/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentParticipation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentParticipation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentParticipation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentParticipation/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentParticipation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentParticipation/SIF_ExtendedElements/SIF_ExtendedElement | StudentPlacement/Service/OtherCodeList/OtherCode | StudentPlacement/ServiceFundingSources/ServiceFundingSource | StudentPlacement/ServiceFundingSources/ServiceFundingSource/OtherCodeList/OtherCode | StudentPlacement/ServiceProviderType/OtherCodeList/OtherCode | StudentPlacement/ServiceSetting/OtherCodeList/OtherCode | StudentPlacement/WhenServiceProvided/OtherCodeList/OtherCode | StudentPlacement/FrequencyTime/OtherCodeList/OtherCode | StudentPlacement/SIF_Metadata/TimeElements/TimeElement | StudentPlacement/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentPlacement/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentPlacement/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentPlacement/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentPlacement/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentPlacement/SIF_Metadata/RightsElements/RightsElement | StudentPlacement/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentPlacement/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentPlacement/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentPlacement/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentPlacement/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentPlacement/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentPlacement/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentPlacement/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentPlacement/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentPlacement/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentPlacement/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentPlacement/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentPlacement/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentPlacement/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentPlacement/SIF_ExtendedElements/SIF_ExtendedElement | TestAccommodation/GradeLevel/OtherCodeList/OtherCode | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/StudentProgramType/OtherCodeList/OtherCode | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/Accommodations/Accommodation | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/Accommodations/Accommodation/OtherCodeList/OtherCode | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/Accommodations/Accommodation/AccommodationCategory/OtherCodeList/OtherCode | TestAccommodation/SIF_Metadata/TimeElements/TimeElement | TestAccommodation/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | TestAccommodation/SIF_Metadata/LifeCycle/Created/Creators/Creator | TestAccommodation/SIF_Metadata/LifeCycle/ModificationHistory/Modified | TestAccommodation/SIF_Metadata/LifeCycle/TimeElements/TimeElement | TestAccommodation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | TestAccommodation/SIF_Metadata/RightsElements/RightsElement | TestAccommodation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | TestAccommodation/SIF_Metadata/EducationFilter/MediaTypes/MediaType | TestAccommodation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | TestAccommodation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | TestAccommodation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | TestAccommodation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | TestAccommodation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | TestAccommodation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | TestAccommodation/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | TestAccommodation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | TestAccommodation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | TestAccommodation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | TestAccommodation/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | TestAccommodation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | TestAccommodation/SIF_ExtendedElements/SIF_ExtendedElement | StudentSpecialEducationSummary/NeglectedOrDelinquentParticipationList/NeglectedOrDelinquentParticipation | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramType/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramFundingSources/ProgramFundingSource | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramFundingSources/ProgramFundingSource/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramStatus/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/Service/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceFundingSources/ServiceFundingSource | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceFundingSources/ServiceFundingSource/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceProviderType/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/FrequencyTime/OtherCodeList/OtherCode | StudentSpecialEducationSummary/SIF_Metadata/TimeElements/TimeElement | StudentSpecialEducationSummary/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentSpecialEducationSummary/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentSpecialEducationSummary/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentSpecialEducationSummary/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentSpecialEducationSummary/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentSpecialEducationSummary/SIF_Metadata/RightsElements/RightsElement | StudentSpecialEducationSummary/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSpecialEducationSummary/SIF_ExtendedElements/SIF_ExtendedElement | Assessment/AssessmentDescriptors/AssessmentDescriptor | Assessment/SIF_Metadata/TimeElements/TimeElement | Assessment/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | Assessment/SIF_Metadata/LifeCycle/Created/Creators/Creator | Assessment/SIF_Metadata/LifeCycle/ModificationHistory/Modified | Assessment/SIF_Metadata/LifeCycle/TimeElements/TimeElement | Assessment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | Assessment/SIF_Metadata/RightsElements/RightsElement | Assessment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | Assessment/SIF_Metadata/EducationFilter/MediaTypes/MediaType | Assessment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | Assessment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Assessment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | Assessment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Assessment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | Assessment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Assessment/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | Assessment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Assessment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Assessment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Assessment/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | Assessment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Assessment/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentItem/LearningStandardItems/LearningStandardItemRefId | AssessmentItem/ResponseChoices/Choice | AssessmentItem/PerformanceLevels/PerformanceLevel | AssessmentItem/SIF_Metadata/TimeElements/TimeElement | AssessmentItem/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | AssessmentItem/SIF_Metadata/LifeCycle/Created/Creators/Creator | AssessmentItem/SIF_Metadata/LifeCycle/ModificationHistory/Modified | AssessmentItem/SIF_Metadata/LifeCycle/TimeElements/TimeElement | AssessmentItem/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | AssessmentItem/SIF_Metadata/RightsElements/RightsElement | AssessmentItem/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | AssessmentItem/SIF_Metadata/EducationFilter/MediaTypes/MediaType | AssessmentItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | AssessmentItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | AssessmentItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | AssessmentItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentItem/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | AssessmentItem/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentItem/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentItem/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentItem/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | AssessmentItem/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentItem/SIF_ExtendedElements/SIF_ExtendedElement | ItemCharacteristics/Measurements/Measurement | ItemCharacteristics/ResponseChoicePattern/Choice | ItemCharacteristics/SIF_Metadata/TimeElements/TimeElement | ItemCharacteristics/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | ItemCharacteristics/SIF_Metadata/LifeCycle/Created/Creators/Creator | ItemCharacteristics/SIF_Metadata/LifeCycle/ModificationHistory/Modified | ItemCharacteristics/SIF_Metadata/LifeCycle/TimeElements/TimeElement | ItemCharacteristics/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | ItemCharacteristics/SIF_Metadata/RightsElements/RightsElement | ItemCharacteristics/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | ItemCharacteristics/SIF_Metadata/EducationFilter/MediaTypes/MediaType | ItemCharacteristics/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | ItemCharacteristics/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ItemCharacteristics/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | ItemCharacteristics/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ItemCharacteristics/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | ItemCharacteristics/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ItemCharacteristics/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | ItemCharacteristics/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ItemCharacteristics/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ItemCharacteristics/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ItemCharacteristics/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | ItemCharacteristics/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ItemCharacteristics/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentSubTest/PerformanceLevels/PerformanceLevel | AssessmentSubTest/GradeLevels/GradeLevel | AssessmentSubTest/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentSubTest/AssessmentSubTestRefIds/AssessmentSubTestRefId | AssessmentSubTest/LearningStandardItemRefIds/LearningStandardItemRefId | AssessmentSubTest/SIF_Metadata/TimeElements/TimeElement | AssessmentSubTest/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | AssessmentSubTest/SIF_Metadata/LifeCycle/Created/Creators/Creator | AssessmentSubTest/SIF_Metadata/LifeCycle/ModificationHistory/Modified | AssessmentSubTest/SIF_Metadata/LifeCycle/TimeElements/TimeElement | AssessmentSubTest/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | AssessmentSubTest/SIF_Metadata/RightsElements/RightsElement | AssessmentSubTest/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | AssessmentSubTest/SIF_Metadata/EducationFilter/MediaTypes/MediaType | AssessmentSubTest/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | AssessmentSubTest/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentSubTest/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | AssessmentSubTest/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentSubTest/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | AssessmentSubTest/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentSubTest/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | AssessmentSubTest/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentSubTest/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentSubTest/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentSubTest/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | AssessmentSubTest/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentSubTest/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentAdministration/SpecialConditions/SpecialCondition | AssessmentAdministration/SIF_Metadata/TimeElements/TimeElement | AssessmentAdministration/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | AssessmentAdministration/SIF_Metadata/LifeCycle/Created/Creators/Creator | AssessmentAdministration/SIF_Metadata/LifeCycle/ModificationHistory/Modified | AssessmentAdministration/SIF_Metadata/LifeCycle/TimeElements/TimeElement | AssessmentAdministration/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | AssessmentAdministration/SIF_Metadata/RightsElements/RightsElement | AssessmentAdministration/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | AssessmentAdministration/SIF_Metadata/EducationFilter/MediaTypes/MediaType | AssessmentAdministration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | AssessmentAdministration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentAdministration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | AssessmentAdministration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentAdministration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | AssessmentAdministration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentAdministration/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | AssessmentAdministration/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentAdministration/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentAdministration/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentAdministration/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | AssessmentAdministration/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentAdministration/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentForm/FormNumbers/FormNumber | AssessmentForm/GradeLevels/GradeLevel | AssessmentForm/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentForm/AssessmentSubTestRefIds/AssessmentSubTestRefId | AssessmentForm/SIF_Metadata/TimeElements/TimeElement | AssessmentForm/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | AssessmentForm/SIF_Metadata/LifeCycle/Created/Creators/Creator | AssessmentForm/SIF_Metadata/LifeCycle/ModificationHistory/Modified | AssessmentForm/SIF_Metadata/LifeCycle/TimeElements/TimeElement | AssessmentForm/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | AssessmentForm/SIF_Metadata/RightsElements/RightsElement | AssessmentForm/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | AssessmentForm/SIF_Metadata/EducationFilter/MediaTypes/MediaType | AssessmentForm/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | AssessmentForm/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentForm/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | AssessmentForm/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentForm/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | AssessmentForm/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentForm/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | AssessmentForm/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentForm/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentForm/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentForm/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | AssessmentForm/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentForm/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentRegistration/StudentSpecialConditions/StudentSpecialCondition | AssessmentRegistration/StudentGradeLevel/OtherCodeList/OtherCode | AssessmentRegistration/AssessmentGradeLevel/OtherCodeList/OtherCode | AssessmentRegistration/AssessmentStudentSnapshot/RaceList/Race | AssessmentRegistration/AssessmentStudentSnapshot/RaceList/Race/OtherCodeList/OtherCode | AssessmentRegistration/SIF_Metadata/TimeElements/TimeElement | AssessmentRegistration/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | AssessmentRegistration/SIF_Metadata/LifeCycle/Created/Creators/Creator | AssessmentRegistration/SIF_Metadata/LifeCycle/ModificationHistory/Modified | AssessmentRegistration/SIF_Metadata/LifeCycle/TimeElements/TimeElement | AssessmentRegistration/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | AssessmentRegistration/SIF_Metadata/RightsElements/RightsElement | AssessmentRegistration/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | AssessmentRegistration/SIF_Metadata/EducationFilter/MediaTypes/MediaType | AssessmentRegistration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | AssessmentRegistration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentRegistration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | AssessmentRegistration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentRegistration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | AssessmentRegistration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentRegistration/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | AssessmentRegistration/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentRegistration/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentRegistration/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentRegistration/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | AssessmentRegistration/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentRegistration/SIF_ExtendedElements/SIF_ExtendedElement | StudentResponseSet/Items/Item | StudentResponseSet/SIF_Metadata/TimeElements/TimeElement | StudentResponseSet/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentResponseSet/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentResponseSet/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentResponseSet/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentResponseSet/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentResponseSet/SIF_Metadata/RightsElements/RightsElement | StudentResponseSet/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentResponseSet/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentResponseSet/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentResponseSet/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentResponseSet/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentResponseSet/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentResponseSet/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentResponseSet/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentResponseSet/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentResponseSet/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentResponseSet/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentResponseSet/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentResponseSet/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentResponseSet/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentResponseSet/SIF_ExtendedElements/SIF_ExtendedElement | StudentScoreSet/Scores/Score | StudentScoreSet/SIF_Metadata/TimeElements/TimeElement | StudentScoreSet/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentScoreSet/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentScoreSet/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentScoreSet/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentScoreSet/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentScoreSet/SIF_Metadata/RightsElements/RightsElement | StudentScoreSet/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentScoreSet/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentScoreSet/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentScoreSet/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentScoreSet/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentScoreSet/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentScoreSet/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentScoreSet/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentScoreSet/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentScoreSet/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentScoreSet/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentScoreSet/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentScoreSet/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentScoreSet/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentScoreSet/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentPackage/SIF_Metadata/TimeElements/TimeElement | AssessmentPackage/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | AssessmentPackage/SIF_Metadata/LifeCycle/Created/Creators/Creator | AssessmentPackage/SIF_Metadata/LifeCycle/ModificationHistory/Modified | AssessmentPackage/SIF_Metadata/LifeCycle/TimeElements/TimeElement | AssessmentPackage/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | AssessmentPackage/SIF_Metadata/RightsElements/RightsElement | AssessmentPackage/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | AssessmentPackage/SIF_Metadata/EducationFilter/MediaTypes/MediaType | AssessmentPackage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | AssessmentPackage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentPackage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | AssessmentPackage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentPackage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | AssessmentPackage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentPackage/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | AssessmentPackage/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentPackage/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentPackage/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentPackage/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | AssessmentPackage/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentPackage/SIF_ExtendedElements/SIF_ExtendedElement | LearningStandardDocument/Organizations/Organization | LearningStandardDocument/Authors/Author | LearningStandardDocument/SubjectAreas/SubjectArea | LearningStandardDocument/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningStandardDocument/GradeLevels/GradeLevel | LearningStandardDocument/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardDocument/RelatedLearningStandards/LearningStandardDocumentRefId | LearningStandardDocument/SIF_Metadata/TimeElements/TimeElement | LearningStandardDocument/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | LearningStandardDocument/SIF_Metadata/LifeCycle/Created/Creators/Creator | LearningStandardDocument/SIF_Metadata/LifeCycle/ModificationHistory/Modified | LearningStandardDocument/SIF_Metadata/LifeCycle/TimeElements/TimeElement | LearningStandardDocument/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | LearningStandardDocument/SIF_Metadata/RightsElements/RightsElement | LearningStandardDocument/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | LearningStandardDocument/SIF_Metadata/EducationFilter/MediaTypes/MediaType | LearningStandardDocument/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | LearningStandardDocument/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardDocument/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | LearningStandardDocument/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningStandardDocument/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | LearningStandardDocument/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LearningStandardDocument/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | LearningStandardDocument/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LearningStandardDocument/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LearningStandardDocument/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LearningStandardDocument/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | LearningStandardDocument/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LearningStandardDocument/SIF_ExtendedElements/SIF_ExtendedElement | LearningStandardItem/PredecessorItems/LearningStandardItemRefId | LearningStandardItem/StatementCodes/StatementCode | LearningStandardItem/Statements/Statement | LearningStandardItem/GradeLevels/GradeLevel | LearningStandardItem/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardItem/SubjectArea/OtherCodeList/OtherCode | LearningStandardItem/StandardIdentifier/SubjectArea/OtherCodeList/OtherCode | LearningStandardItem/StandardIdentifier/GradeLevels/GradeLevel | LearningStandardItem/StandardIdentifier/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardItem/StandardIdentifier/GradeLevel/OtherCodeList/OtherCode | LearningStandardItem/StandardIdentifier/AlternateIdentificationCodes/AlternateIdentificationCode | LearningStandardItem/RelatedLearningStandardItems/LearningStandardItemRefId | LearningStandardItem/SIF_Metadata/TimeElements/TimeElement | LearningStandardItem/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | LearningStandardItem/SIF_Metadata/LifeCycle/Created/Creators/Creator | LearningStandardItem/SIF_Metadata/LifeCycle/ModificationHistory/Modified | LearningStandardItem/SIF_Metadata/LifeCycle/TimeElements/TimeElement | LearningStandardItem/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | LearningStandardItem/SIF_Metadata/RightsElements/RightsElement | LearningStandardItem/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | LearningStandardItem/SIF_Metadata/EducationFilter/MediaTypes/MediaType | LearningStandardItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | LearningStandardItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | LearningStandardItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningStandardItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | LearningStandardItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LearningStandardItem/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | LearningStandardItem/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LearningStandardItem/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LearningStandardItem/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LearningStandardItem/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | LearningStandardItem/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LearningStandardItem/SIF_ExtendedElements/SIF_ExtendedElement | CurriculumStructure/Titles/Title | CurriculumStructure/SubjectArea/OtherCodeList/OtherCode | CurriculumStructure/PredecessorObjects/CurriculumStructureRefId | CurriculumStructure/LearningObjectives/LearningObjective | CurriculumStructure/ComponentObjects/ComponentObject | CurriculumStructure/LearningStandards/LearningStandardItemRefId | CurriculumStructure/SIF_Metadata/TimeElements/TimeElement | CurriculumStructure/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | CurriculumStructure/SIF_Metadata/LifeCycle/Created/Creators/Creator | CurriculumStructure/SIF_Metadata/LifeCycle/ModificationHistory/Modified | CurriculumStructure/SIF_Metadata/LifeCycle/TimeElements/TimeElement | CurriculumStructure/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | CurriculumStructure/SIF_Metadata/RightsElements/RightsElement | CurriculumStructure/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | CurriculumStructure/SIF_Metadata/EducationFilter/MediaTypes/MediaType | CurriculumStructure/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | CurriculumStructure/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | CurriculumStructure/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | CurriculumStructure/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | CurriculumStructure/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | CurriculumStructure/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | CurriculumStructure/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | CurriculumStructure/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | CurriculumStructure/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | CurriculumStructure/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | CurriculumStructure/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | CurriculumStructure/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | CurriculumStructure/SIF_ExtendedElements/SIF_ExtendedElement | Lesson/SourceObjects/SourceObject | Lesson/CurriculumStructures/CurriculumStructureRefId | Lesson/SubjectArea/OtherCodeList/OtherCode | Lesson/Strategies/Strategy | Lesson/LearningObjectives/LearningObjective | Lesson/SupportingActivities/ActivityRefId | Lesson/LearningStandards/LearningStandardItemRefId | Lesson/LearningResources/LearningResourceRefId | Lesson/LessonSources/LessonSource | Lesson/LessonSources/LessonSource/Author | Lesson/SIF_Metadata/TimeElements/TimeElement | Lesson/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | Lesson/SIF_Metadata/LifeCycle/Created/Creators/Creator | Lesson/SIF_Metadata/LifeCycle/ModificationHistory/Modified | Lesson/SIF_Metadata/LifeCycle/TimeElements/TimeElement | Lesson/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | Lesson/SIF_Metadata/RightsElements/RightsElement | Lesson/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | Lesson/SIF_Metadata/EducationFilter/MediaTypes/MediaType | Lesson/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | Lesson/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Lesson/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | Lesson/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Lesson/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | Lesson/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Lesson/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | Lesson/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Lesson/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Lesson/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Lesson/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | Lesson/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Lesson/SIF_ExtendedElements/SIF_ExtendedElement | Activity/TechnicalRequirements/TechnicalRequirement | Activity/SoftwareRequirementList/SoftwareRequirement | Activity/EssentialMaterials/EssentialMaterial | Activity/LearningObjectives/LearningObjective | Activity/LearningStandards/LearningStandardItemRefId | Activity/SubjectArea/OtherCodeList/OtherCode | Activity/Prerequisites/Prerequisite | Activity/Students/StudentPersonalRefId | Activity/SourceObjects/SourceObject | Activity/LearningResources/LearningResourceRefId | Activity/SIF_Metadata/TimeElements/TimeElement | Activity/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | Activity/SIF_Metadata/LifeCycle/Created/Creators/Creator | Activity/SIF_Metadata/LifeCycle/ModificationHistory/Modified | Activity/SIF_Metadata/LifeCycle/TimeElements/TimeElement | Activity/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | Activity/SIF_Metadata/RightsElements/RightsElement | Activity/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | Activity/SIF_Metadata/EducationFilter/MediaTypes/MediaType | Activity/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | Activity/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Activity/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | Activity/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Activity/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | Activity/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Activity/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | Activity/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Activity/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Activity/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Activity/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | Activity/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Activity/SIF_ExtendedElements/SIF_ExtendedElement | Assignment/Students/StudentPersonalRefId | Assignment/TechnicalRequirements/TechnicalRequirement | Assignment/SoftwareRequirementList/SoftwareRequirement | Assignment/EssentialMaterials/EssentialMaterial | Assignment/LearningObjectives/LearningObjective | Assignment/LearningStandards/LearningStandardItemRefId | Assignment/Prerequisites/Prerequisite | Assignment/SourceObjects/SourceObject | Assignment/SIF_Metadata/TimeElements/TimeElement | Assignment/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | Assignment/SIF_Metadata/LifeCycle/Created/Creators/Creator | Assignment/SIF_Metadata/LifeCycle/ModificationHistory/Modified | Assignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement | Assignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | Assignment/SIF_Metadata/RightsElements/RightsElement | Assignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | Assignment/SIF_Metadata/EducationFilter/MediaTypes/MediaType | Assignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | Assignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Assignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | Assignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Assignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | Assignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Assignment/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | Assignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Assignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Assignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Assignment/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | Assignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Assignment/SIF_ExtendedElements/SIF_ExtendedElement | LearningResource/Contacts/Contact | LearningResource/GradeLevels/GradeLevel | LearningResource/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningResource/SubjectAreas/SubjectArea | LearningResource/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningResource/MediaTypes/MediaType | LearningResource/Approvals/Approval | LearningResource/Evaluations/Evaluation | LearningResource/Components/Component | LearningResource/Components/Component/Strategies/Strategy | LearningResource/Components/Component/AssociatedObjects/AssociatedObject | LearningResource/LearningStandards/LearningStandardItemRefId | LearningResource/SIF_Metadata/TimeElements/TimeElement | LearningResource/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | LearningResource/SIF_Metadata/LifeCycle/Created/Creators/Creator | LearningResource/SIF_Metadata/LifeCycle/ModificationHistory/Modified | LearningResource/SIF_Metadata/LifeCycle/TimeElements/TimeElement | LearningResource/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | LearningResource/SIF_Metadata/RightsElements/RightsElement | LearningResource/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | LearningResource/SIF_Metadata/EducationFilter/MediaTypes/MediaType | LearningResource/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | LearningResource/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningResource/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | LearningResource/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningResource/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | LearningResource/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LearningResource/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | LearningResource/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LearningResource/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LearningResource/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LearningResource/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | LearningResource/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LearningResource/SIF_ExtendedElements/SIF_ExtendedElement | ContentCatalog/GradeLevels/GradeLevel | ContentCatalog/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ContentCatalog/SubjectAreas/SubjectArea | ContentCatalog/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ContentCatalog/MediaTypes/MediaType | ContentCatalog/LearningStandards/Document | ContentCatalog/LearningStandards/Document/StatementCodes/StatementCode | ContentCatalog/TechnicalRequirements/TechnicalRequirement | ContentCatalog/CurriculumHierarchyList/CurriculumHierarchy | ContentCatalog/Prerequisites/Prerequisite | ContentCatalog/SIF_Metadata/TimeElements/TimeElement | ContentCatalog/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | ContentCatalog/SIF_Metadata/LifeCycle/Created/Creators/Creator | ContentCatalog/SIF_Metadata/LifeCycle/ModificationHistory/Modified | ContentCatalog/SIF_Metadata/LifeCycle/TimeElements/TimeElement | ContentCatalog/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | ContentCatalog/SIF_Metadata/RightsElements/RightsElement | ContentCatalog/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | ContentCatalog/SIF_Metadata/EducationFilter/MediaTypes/MediaType | ContentCatalog/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | ContentCatalog/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ContentCatalog/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | ContentCatalog/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ContentCatalog/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | ContentCatalog/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ContentCatalog/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | ContentCatalog/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ContentCatalog/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ContentCatalog/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ContentCatalog/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | ContentCatalog/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ContentCatalog/SIF_ExtendedElements/SIF_ExtendedElement | PersonRoleAssociation/SIF_Metadata/TimeElements/TimeElement | PersonRoleAssociation/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | PersonRoleAssociation/SIF_Metadata/LifeCycle/Created/Creators/Creator | PersonRoleAssociation/SIF_Metadata/LifeCycle/ModificationHistory/Modified | PersonRoleAssociation/SIF_Metadata/LifeCycle/TimeElements/TimeElement | PersonRoleAssociation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | PersonRoleAssociation/SIF_Metadata/RightsElements/RightsElement | PersonRoleAssociation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | PersonRoleAssociation/SIF_Metadata/EducationFilter/MediaTypes/MediaType | PersonRoleAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | PersonRoleAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | PersonRoleAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | PersonRoleAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | PersonRoleAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | PersonRoleAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | PersonRoleAssociation/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | PersonRoleAssociation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | PersonRoleAssociation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | PersonRoleAssociation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | PersonRoleAssociation/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | PersonRoleAssociation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | PersonRoleAssociation/SIF_ExtendedElements/SIF_ExtendedElement | ResponseToIntervention/InterventionProviderNames/InterventionProviderName | ResponseToIntervention/Interventions/Intervention | ResponseToIntervention/SubjectArea/OtherCodeList/OtherCode | ResponseToIntervention/LearningStandardItems/LearningStandardItemRefId | ResponseToIntervention/LearningObjectives/LearningObjective | ResponseToIntervention/Measurements/Measurement | ResponseToIntervention/Baselines/Baseline | ResponseToIntervention/Targets/Target | ResponseToIntervention/SIF_Metadata/TimeElements/TimeElement | ResponseToIntervention/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | ResponseToIntervention/SIF_Metadata/LifeCycle/Created/Creators/Creator | ResponseToIntervention/SIF_Metadata/LifeCycle/ModificationHistory/Modified | ResponseToIntervention/SIF_Metadata/LifeCycle/TimeElements/TimeElement | ResponseToIntervention/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | ResponseToIntervention/SIF_Metadata/RightsElements/RightsElement | ResponseToIntervention/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | ResponseToIntervention/SIF_Metadata/EducationFilter/MediaTypes/MediaType | ResponseToIntervention/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | ResponseToIntervention/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ResponseToIntervention/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | ResponseToIntervention/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ResponseToIntervention/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | ResponseToIntervention/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ResponseToIntervention/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | ResponseToIntervention/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ResponseToIntervention/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ResponseToIntervention/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ResponseToIntervention/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | ResponseToIntervention/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ResponseToIntervention/SIF_ExtendedElements/SIF_ExtendedElement | RTIResults/PerformanceIndicators/PerformanceIndicator | RTIResults/Measurements/Measurement | RTIResults/Baselines/Baseline | RTIResults/Targets/Target | RTIResults/Results/Result | RTIResults/SIF_Metadata/TimeElements/TimeElement | RTIResults/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | RTIResults/SIF_Metadata/LifeCycle/Created/Creators/Creator | RTIResults/SIF_Metadata/LifeCycle/ModificationHistory/Modified | RTIResults/SIF_Metadata/LifeCycle/TimeElements/TimeElement | RTIResults/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | RTIResults/SIF_Metadata/RightsElements/RightsElement | RTIResults/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | RTIResults/SIF_Metadata/EducationFilter/MediaTypes/MediaType | RTIResults/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | RTIResults/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | RTIResults/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | RTIResults/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | RTIResults/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | RTIResults/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | RTIResults/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | RTIResults/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | RTIResults/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | RTIResults/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | RTIResults/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | RTIResults/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | RTIResults/SIF_ExtendedElements/SIF_ExtendedElement | LearningStandardAssociation/TargetObjects/TargetObject | LearningStandardAssociation/SIF_Metadata/TimeElements/TimeElement | LearningStandardAssociation/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | LearningStandardAssociation/SIF_Metadata/LifeCycle/Created/Creators/Creator | LearningStandardAssociation/SIF_Metadata/LifeCycle/ModificationHistory/Modified | LearningStandardAssociation/SIF_Metadata/LifeCycle/TimeElements/TimeElement | LearningStandardAssociation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | LearningStandardAssociation/SIF_Metadata/RightsElements/RightsElement | LearningStandardAssociation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | LearningStandardAssociation/SIF_Metadata/EducationFilter/MediaTypes/MediaType | LearningStandardAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | LearningStandardAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | LearningStandardAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningStandardAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | LearningStandardAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LearningStandardAssociation/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | LearningStandardAssociation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LearningStandardAssociation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LearningStandardAssociation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LearningStandardAssociation/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | LearningStandardAssociation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LearningStandardAssociation/SIF_ExtendedElements/SIF_ExtendedElement | LibraryPatronStatus/ElectronicIdList/ElectronicId | LibraryPatronStatus/TransactionList/Transaction | LibraryPatronStatus/TransactionList/Transaction/FineInfoList/FineInfo | LibraryPatronStatus/TransactionList/Transaction/HoldInfoList/HoldInfo | LibraryPatronStatus/MessageList/Message | LibraryPatronStatus/SIF_Metadata/TimeElements/TimeElement | LibraryPatronStatus/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | LibraryPatronStatus/SIF_Metadata/LifeCycle/Created/Creators/Creator | LibraryPatronStatus/SIF_Metadata/LifeCycle/ModificationHistory/Modified | LibraryPatronStatus/SIF_Metadata/LifeCycle/TimeElements/TimeElement | LibraryPatronStatus/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | LibraryPatronStatus/SIF_Metadata/RightsElements/RightsElement | LibraryPatronStatus/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | LibraryPatronStatus/SIF_Metadata/EducationFilter/MediaTypes/MediaType | LibraryPatronStatus/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | LibraryPatronStatus/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LibraryPatronStatus/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | LibraryPatronStatus/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LibraryPatronStatus/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | LibraryPatronStatus/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LibraryPatronStatus/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | LibraryPatronStatus/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LibraryPatronStatus/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LibraryPatronStatus/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LibraryPatronStatus/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | LibraryPatronStatus/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LibraryPatronStatus/SIF_ExtendedElements/SIF_ExtendedElement | StudentProgramAssociation/FundingSourceList/FundingSource | StudentActivityInfo/StudentActivityType/OtherCodeList/OtherCode | StudentActivityInfo/GradeLevels/GradeLevel | StudentActivityInfo/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentActivityInfo/SIF_Metadata/TimeElements/TimeElement | StudentActivityInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentActivityInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentActivityInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentActivityInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentActivityInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentActivityInfo/SIF_Metadata/RightsElements/RightsElement | StudentActivityInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentActivityInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentActivityInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentActivityInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentActivityInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentActivityInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentActivityInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentActivityInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentActivityInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentActivityInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentActivityInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentActivityInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentActivityInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentActivityInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentActivityInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentActivityParticipation/RecognitionList/Recognition | StudentActivityParticipation/SIF_Metadata/TimeElements/TimeElement | StudentActivityParticipation/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentActivityParticipation/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentActivityParticipation/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentActivityParticipation/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentActivityParticipation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentActivityParticipation/SIF_Metadata/RightsElements/RightsElement | StudentActivityParticipation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentActivityParticipation/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentActivityParticipation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentActivityParticipation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentActivityParticipation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentActivityParticipation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentActivityParticipation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentActivityParticipation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentActivityParticipation/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentActivityParticipation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentActivityParticipation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentActivityParticipation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentActivityParticipation/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentActivityParticipation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentActivityParticipation/SIF_ExtendedElements/SIF_ExtendedElement | DisciplineIncident/RelatedToList/RelatedTo | DisciplineIncident/WeaponTypeList/WeaponType | DisciplineIncident/IncidentCategory/OtherCodeList/OtherCode | DisciplineIncident/OffenderList/Offender | DisciplineIncident/OffenderList/Offender/ActionList/Action | DisciplineIncident/OffenderList/Offender/ActionList/Action/OtherCodeList/OtherCode | DisciplineIncident/OffenderList/Offender/WeaponTypeList/WeaponType | DisciplineIncident/OffenderList/Offender/RelatedToList/RelatedTo | DisciplineIncident/VictimList/Victim | DisciplineIncident/IncidentActionList/IncidentAction | DisciplineIncident/SIF_Metadata/TimeElements/TimeElement | DisciplineIncident/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | DisciplineIncident/SIF_Metadata/LifeCycle/Created/Creators/Creator | DisciplineIncident/SIF_Metadata/LifeCycle/ModificationHistory/Modified | DisciplineIncident/SIF_Metadata/LifeCycle/TimeElements/TimeElement | DisciplineIncident/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | DisciplineIncident/SIF_Metadata/RightsElements/RightsElement | DisciplineIncident/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | DisciplineIncident/SIF_Metadata/EducationFilter/MediaTypes/MediaType | DisciplineIncident/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | DisciplineIncident/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | DisciplineIncident/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | DisciplineIncident/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | DisciplineIncident/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | DisciplineIncident/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | DisciplineIncident/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | DisciplineIncident/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | DisciplineIncident/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | DisciplineIncident/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | DisciplineIncident/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | DisciplineIncident/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | DisciplineIncident/SIF_ExtendedElements/SIF_ExtendedElement | CalendarSummary/GradeLevels/GradeLevel | CalendarSummary/GradeLevels/GradeLevel/OtherCodeList/OtherCode | CalendarSummary/SIF_Metadata/TimeElements/TimeElement | CalendarSummary/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | CalendarSummary/SIF_Metadata/LifeCycle/Created/Creators/Creator | CalendarSummary/SIF_Metadata/LifeCycle/ModificationHistory/Modified | CalendarSummary/SIF_Metadata/LifeCycle/TimeElements/TimeElement | CalendarSummary/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | CalendarSummary/SIF_Metadata/RightsElements/RightsElement | CalendarSummary/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | CalendarSummary/SIF_Metadata/EducationFilter/MediaTypes/MediaType | CalendarSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | CalendarSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | CalendarSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | CalendarSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | CalendarSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | CalendarSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | CalendarSummary/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | CalendarSummary/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | CalendarSummary/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | CalendarSummary/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | CalendarSummary/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | CalendarSummary/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | CalendarSummary/SIF_ExtendedElements/SIF_ExtendedElement | CalendarDate/CalendarDateType/OtherCodeList/OtherCode | CalendarDate/BellScheduleDayList/BellScheduleDay | CalendarDate/InstructionalDeliveryModeList/InstructionalDeliveryMode | CalendarDate/SIF_Metadata/TimeElements/TimeElement | CalendarDate/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | CalendarDate/SIF_Metadata/LifeCycle/Created/Creators/Creator | CalendarDate/SIF_Metadata/LifeCycle/ModificationHistory/Modified | CalendarDate/SIF_Metadata/LifeCycle/TimeElements/TimeElement | CalendarDate/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | CalendarDate/SIF_Metadata/RightsElements/RightsElement | CalendarDate/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | CalendarDate/SIF_Metadata/EducationFilter/MediaTypes/MediaType | CalendarDate/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | CalendarDate/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | CalendarDate/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | CalendarDate/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | CalendarDate/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | CalendarDate/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | CalendarDate/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | CalendarDate/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | CalendarDate/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | CalendarDate/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | CalendarDate/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | CalendarDate/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | CalendarDate/SIF_ExtendedElements/SIF_ExtendedElement | StudentAttendanceSummary/InstructionalDeliveryModeList/InstructionalDeliveryMode | StudentAttendanceSummary/SIF_Metadata/TimeElements/TimeElement | StudentAttendanceSummary/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentAttendanceSummary/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentAttendanceSummary/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentAttendanceSummary/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentAttendanceSummary/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentAttendanceSummary/SIF_Metadata/RightsElements/RightsElement | StudentAttendanceSummary/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentAttendanceSummary/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentAttendanceSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentAttendanceSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentAttendanceSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentAttendanceSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentAttendanceSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentAttendanceSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentAttendanceSummary/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentAttendanceSummary/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentAttendanceSummary/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentAttendanceSummary/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentAttendanceSummary/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentAttendanceSummary/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentAttendanceSummary/SIF_ExtendedElements/SIF_ExtendedElement | AttendanceCodeInfo/SIF_Metadata/TimeElements/TimeElement | AttendanceCodeInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | AttendanceCodeInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | AttendanceCodeInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | AttendanceCodeInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | AttendanceCodeInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | AttendanceCodeInfo/SIF_Metadata/RightsElements/RightsElement | AttendanceCodeInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | AttendanceCodeInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | AttendanceCodeInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | AttendanceCodeInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AttendanceCodeInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | AttendanceCodeInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AttendanceCodeInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | AttendanceCodeInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AttendanceCodeInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | AttendanceCodeInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AttendanceCodeInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AttendanceCodeInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AttendanceCodeInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | AttendanceCodeInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AttendanceCodeInfo/SIF_ExtendedElements/SIF_ExtendedElement | RoomInfo/StaffList/StaffPersonalRefId | RoomInfo/SIF_Metadata/TimeElements/TimeElement | RoomInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | RoomInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | RoomInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | RoomInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | RoomInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | RoomInfo/SIF_Metadata/RightsElements/RightsElement | RoomInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | RoomInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | RoomInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | RoomInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | RoomInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | RoomInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | RoomInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | RoomInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | RoomInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | RoomInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | RoomInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | RoomInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | RoomInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | RoomInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | RoomInfo/SIF_ExtendedElements/SIF_ExtendedElement | RoomType/SIF_Metadata/TimeElements/TimeElement | RoomType/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | RoomType/SIF_Metadata/LifeCycle/Created/Creators/Creator | RoomType/SIF_Metadata/LifeCycle/ModificationHistory/Modified | RoomType/SIF_Metadata/LifeCycle/TimeElements/TimeElement | RoomType/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | RoomType/SIF_Metadata/RightsElements/RightsElement | RoomType/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | RoomType/SIF_Metadata/EducationFilter/MediaTypes/MediaType | RoomType/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | RoomType/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | RoomType/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | RoomType/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | RoomType/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | RoomType/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | RoomType/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | RoomType/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | RoomType/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | RoomType/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | RoomType/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | RoomType/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | RoomType/SIF_ExtendedElements/SIF_ExtendedElement | SchoolCourseInfo/SubjectAreaList/SubjectArea | SchoolCourseInfo/SubjectAreaList/SubjectArea/OtherCodeList/OtherCode | SchoolCourseInfo/InstructionalLevel/OtherCodeList/OtherCode | SchoolCourseInfo/SIF_Metadata/TimeElements/TimeElement | SchoolCourseInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | SchoolCourseInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | SchoolCourseInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | SchoolCourseInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | SchoolCourseInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | SchoolCourseInfo/SIF_Metadata/RightsElements/RightsElement | SchoolCourseInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | SchoolCourseInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | SchoolCourseInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | SchoolCourseInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SchoolCourseInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | SchoolCourseInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SchoolCourseInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | SchoolCourseInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SchoolCourseInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | SchoolCourseInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SchoolCourseInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SchoolCourseInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SchoolCourseInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | SchoolCourseInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SchoolCourseInfo/SIF_ExtendedElements/SIF_ExtendedElement | SchoolInfo/SchoolFocusList/SchoolFocus | SchoolInfo/SchoolContactList/SchoolContact | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/PhoneNumberList/PhoneNumber | SchoolInfo/AddressList/Address | SchoolInfo/AddressRefIdList/AddressRefId | SchoolInfo/PhoneNumberList/PhoneNumber | SchoolInfo/IdentificationInfoList/IdentificationInfo | SchoolInfo/GradeLevels/GradeLevel | SchoolInfo/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SchoolInfo/SIF_Metadata/TimeElements/TimeElement | SchoolInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | SchoolInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | SchoolInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | SchoolInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | SchoolInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | SchoolInfo/SIF_Metadata/RightsElements/RightsElement | SchoolInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | SchoolInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | SchoolInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | SchoolInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SchoolInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | SchoolInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SchoolInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | SchoolInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SchoolInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | SchoolInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SchoolInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SchoolInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SchoolInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | SchoolInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SchoolInfo/SIF_ExtendedElements/SIF_ExtendedElement | SectionInfo/ScheduleInfoList/ScheduleInfo | SectionInfo/ScheduleInfoList/ScheduleInfo/TeacherList/StaffPersonalRefId | SectionInfo/ScheduleInfoList/ScheduleInfo/SectionRoomList/RoomInfoRefId | SectionInfo/ScheduleInfoList/ScheduleInfo/MeetingTimeList/MeetingTime | SectionInfo/MediumOfInstruction/OtherCodeList/OtherCode | SectionInfo/InstructionalDeliveryModeList/InstructionalDeliveryMode | SectionInfo/LanguageOfInstruction/OtherCodeList/OtherCode | SectionInfo/LocationOfInstruction/OtherCodeList/OtherCode | SectionInfo/SchoolCourseInfoOverride/SubjectArea/OtherCodeList/OtherCode | SectionInfo/SchoolCourseInfoOverride/InstructionalLevel/OtherCodeList/OtherCode | SectionInfo/SIF_Metadata/TimeElements/TimeElement | SectionInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | SectionInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | SectionInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | SectionInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | SectionInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | SectionInfo/SIF_Metadata/RightsElements/RightsElement | SectionInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | SectionInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | SectionInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | SectionInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SectionInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | SectionInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SectionInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | SectionInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SectionInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | SectionInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SectionInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SectionInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SectionInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | SectionInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SectionInfo/SIF_ExtendedElements/SIF_ExtendedElement | StaffPersonal/ElectronicIdList/ElectronicId | StaffPersonal/OtherIdList/OtherId | StaffPersonal/OtherNames/Name | StaffPersonal/Demographics/RaceList/Race | StaffPersonal/Demographics/RaceList/Race/OtherCodeList/OtherCode | StaffPersonal/Demographics/CountriesOfCitizenship/CountryOfCitizenship | StaffPersonal/Demographics/CountriesOfResidency/CountryOfResidency | StaffPersonal/Demographics/EnglishProficiency/OtherCodeList/OtherCode | StaffPersonal/Demographics/LanguageList/Language | StaffPersonal/Demographics/LanguageList/Language/OtherCodeList/OtherCode | StaffPersonal/Demographics/DwellingArrangement/OtherCodeList/OtherCode | StaffPersonal/AddressList/Address | StaffPersonal/AddressRefIdList/AddressRefId | StaffPersonal/PhoneNumberList/PhoneNumber | StaffPersonal/EmailList/Email | StaffPersonal/SIF_Metadata/TimeElements/TimeElement | StaffPersonal/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StaffPersonal/SIF_Metadata/LifeCycle/Created/Creators/Creator | StaffPersonal/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StaffPersonal/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StaffPersonal/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StaffPersonal/SIF_Metadata/RightsElements/RightsElement | StaffPersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StaffPersonal/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StaffPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StaffPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StaffPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StaffPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffPersonal/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StaffPersonal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffPersonal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffPersonal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffPersonal/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StaffPersonal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffPersonal/SIF_ExtendedElements/SIF_ExtendedElement | StudentContact/OtherIdList/OtherId | StudentContact/OtherNames/Name | StudentContact/Demographics/RaceList/Race | StudentContact/Demographics/RaceList/Race/OtherCodeList/OtherCode | StudentContact/Demographics/CountriesOfCitizenship/CountryOfCitizenship | StudentContact/Demographics/CountriesOfResidency/CountryOfResidency | StudentContact/Demographics/EnglishProficiency/OtherCodeList/OtherCode | StudentContact/Demographics/LanguageList/Language | StudentContact/Demographics/LanguageList/Language/OtherCodeList/OtherCode | StudentContact/Demographics/DwellingArrangement/OtherCodeList/OtherCode | StudentContact/AddressList/Address | StudentContact/PhoneNumberList/PhoneNumber | StudentContact/EmailList/Email | StudentContact/Relationship/OtherCodeList/OtherCode | StudentContact/SIF_Metadata/TimeElements/TimeElement | StudentContact/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentContact/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentContact/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentContact/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentContact/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentContact/SIF_Metadata/RightsElements/RightsElement | StudentContact/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentContact/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentContact/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentContact/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentContact/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentContact/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentContact/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentContact/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentContact/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentContact/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentContact/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentContact/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentContact/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentContact/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentContact/SIF_ExtendedElements/SIF_ExtendedElement | StudentDailyAttendance/SIF_Metadata/TimeElements/TimeElement | StudentDailyAttendance/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentDailyAttendance/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentDailyAttendance/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentDailyAttendance/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentDailyAttendance/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentDailyAttendance/SIF_Metadata/RightsElements/RightsElement | StudentDailyAttendance/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentDailyAttendance/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentDailyAttendance/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentDailyAttendance/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentDailyAttendance/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentDailyAttendance/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentDailyAttendance/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentDailyAttendance/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentDailyAttendance/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentDailyAttendance/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentDailyAttendance/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentDailyAttendance/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentDailyAttendance/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentDailyAttendance/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentDailyAttendance/SIF_ExtendedElements/SIF_ExtendedElement | StudentPersonal/AlertMessages/AlertMessage | StudentPersonal/MedicalAlertMessages/MedicalAlertMessage | StudentPersonal/ElectronicIdList/ElectronicId | StudentPersonal/OtherIdList/OtherId | StudentPersonal/OtherNames/Name | StudentPersonal/Demographics/RaceList/Race | StudentPersonal/Demographics/RaceList/Race/OtherCodeList/OtherCode | StudentPersonal/Demographics/CountriesOfCitizenship/CountryOfCitizenship | StudentPersonal/Demographics/CountriesOfResidency/CountryOfResidency | StudentPersonal/Demographics/EnglishProficiency/OtherCodeList/OtherCode | StudentPersonal/Demographics/LanguageList/Language | StudentPersonal/Demographics/LanguageList/Language/OtherCodeList/OtherCode | StudentPersonal/Demographics/DwellingArrangement/OtherCodeList/OtherCode | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile | StudentPersonal/AddressList/Address | StudentPersonal/AddressRefIdList/AddressRefId | StudentPersonal/PhoneNumberList/PhoneNumber | StudentPersonal/EmailList/Email | StudentPersonal/MostRecent/GradeLevel/OtherCodeList/OtherCode | StudentPersonal/SIF_Metadata/TimeElements/TimeElement | StudentPersonal/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentPersonal/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentPersonal/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentPersonal/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentPersonal/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentPersonal/SIF_Metadata/RightsElements/RightsElement | StudentPersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentPersonal/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentPersonal/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentPersonal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentPersonal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentPersonal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentPersonal/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentPersonal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentPersonal/SIF_ExtendedElements/SIF_ExtendedElement | StudentPicture/SIF_Metadata/TimeElements/TimeElement | StudentPicture/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentPicture/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentPicture/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentPicture/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentPicture/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentPicture/SIF_Metadata/RightsElements/RightsElement | StudentPicture/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentPicture/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentPicture/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentPicture/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentPicture/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentPicture/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentPicture/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentPicture/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentPicture/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentPicture/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentPicture/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentPicture/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentPicture/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentPicture/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentPicture/SIF_ExtendedElements/SIF_ExtendedElement | StudentSchoolEnrollment/EntryType/OtherCodeList/OtherCode | StudentSchoolEnrollment/GradeLevel/OtherCodeList/OtherCode | StudentSchoolEnrollment/ExitStatus/OtherCodeList/OtherCode | StudentSchoolEnrollment/ExitType/OtherCodeList/OtherCode | StudentSchoolEnrollment/ExitGradeLevel/OtherCodeList/OtherCode | StudentSchoolEnrollment/PromotionInfo/Promotion/OtherCodeList/OtherCode | StudentSchoolEnrollment/PromotionInfo/Nonpromotion/OtherCodeList/OtherCode | StudentSchoolEnrollment/ResidencyStatus/OtherCodeList/OtherCode | StudentSchoolEnrollment/ResponsableSchoolList/ResponsableSchool | StudentSchoolEnrollment/ResponsableLEAList/ResponsableLEA | StudentSchoolEnrollment/SIF_Metadata/TimeElements/TimeElement | StudentSchoolEnrollment/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentSchoolEnrollment/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentSchoolEnrollment/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentSchoolEnrollment/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentSchoolEnrollment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentSchoolEnrollment/SIF_Metadata/RightsElements/RightsElement | StudentSchoolEnrollment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSchoolEnrollment/SIF_ExtendedElements/SIF_ExtendedElement | StudentSectionEnrollment/ScheduleInfoOverrideList/ScheduleInfoOverride | StudentSectionEnrollment/ScheduleInfoOverrideList/ScheduleInfoOverride/MeetingTimeList/MeetingTime | StudentSectionEnrollment/InstructionalDeliveryModeList/InstructionalDeliveryMode | StudentSectionEnrollment/SIF_Metadata/TimeElements/TimeElement | StudentSectionEnrollment/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentSectionEnrollment/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentSectionEnrollment/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentSectionEnrollment/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentSectionEnrollment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentSectionEnrollment/SIF_Metadata/RightsElements/RightsElement | StudentSectionEnrollment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentSectionEnrollment/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentSectionEnrollment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentSectionEnrollment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSectionEnrollment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentSectionEnrollment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSectionEnrollment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentSectionEnrollment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSectionEnrollment/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentSectionEnrollment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSectionEnrollment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSectionEnrollment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSectionEnrollment/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentSectionEnrollment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSectionEnrollment/SIF_ExtendedElements/SIF_ExtendedElement | TermInfo/TermSpan/OtherCodeList/OtherCode | TermInfo/SIF_Metadata/TimeElements/TimeElement | TermInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | TermInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | TermInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | TermInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | TermInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | TermInfo/SIF_Metadata/RightsElements/RightsElement | TermInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | TermInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | TermInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | TermInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | TermInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | TermInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | TermInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | TermInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | TermInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | TermInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | TermInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | TermInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | TermInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | TermInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | TermInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentSnapshot/RaceList/Race | StudentSnapshot/RaceList/Race/OtherCodeList/OtherCode | StudentSnapshot/HomeEnrollment/GradeLevel/OtherCodeList/OtherCode | StudentSnapshot/SIF_Metadata/TimeElements/TimeElement | StudentSnapshot/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentSnapshot/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentSnapshot/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentSnapshot/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentSnapshot/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentSnapshot/SIF_Metadata/RightsElements/RightsElement | StudentSnapshot/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentSnapshot/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentSnapshot/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentSnapshot/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSnapshot/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentSnapshot/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSnapshot/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentSnapshot/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSnapshot/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentSnapshot/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSnapshot/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSnapshot/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSnapshot/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentSnapshot/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSnapshot/SIF_ExtendedElements/SIF_ExtendedElement | LEAInfo/EducationAgencyType/OtherCodeList/OtherCode | LEAInfo/LEAContactList/LEAContact | LEAInfo/LEAContactList/LEAContact/ContactInfo/EmailList/Email | LEAInfo/LEAContactList/LEAContact/ContactInfo/PhoneNumberList/PhoneNumber | LEAInfo/PhoneNumberList/PhoneNumber | LEAInfo/AddressList/Address | LEAInfo/AddressRefIdList/AddressRefId | LEAInfo/IdentificationInfoList/IdentificationInfo | LEAInfo/GradeLevels/GradeLevel | LEAInfo/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LEAInfo/SIF_Metadata/TimeElements/TimeElement | LEAInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | LEAInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | LEAInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | LEAInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | LEAInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | LEAInfo/SIF_Metadata/RightsElements/RightsElement | LEAInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | LEAInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | LEAInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | LEAInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LEAInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | LEAInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LEAInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | LEAInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LEAInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | LEAInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LEAInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LEAInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LEAInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | LEAInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LEAInfo/SIF_ExtendedElements/SIF_ExtendedElement | StaffAssignment/JobFunction/OtherCodeList/OtherCode | StaffAssignment/TeachingAssignment/OtherCodeList/OtherCode | StaffAssignment/GradeLevels/GradeLevel | StaffAssignment/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffAssignment/InstructionalLevel/OtherCodeList/OtherCode | StaffAssignment/SIF_Metadata/TimeElements/TimeElement | StaffAssignment/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StaffAssignment/SIF_Metadata/LifeCycle/Created/Creators/Creator | StaffAssignment/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StaffAssignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StaffAssignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StaffAssignment/SIF_Metadata/RightsElements/RightsElement | StaffAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StaffAssignment/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StaffAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StaffAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StaffAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StaffAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffAssignment/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StaffAssignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffAssignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffAssignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffAssignment/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StaffAssignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffAssignment/SIF_ExtendedElements/SIF_ExtendedElement | BellSchedule/TimetableDayList/TimetableDay | BellSchedule/TimetablePeriodList/TimetablePeriod | BellSchedule/BellPeriodList/BellPeriod | BellSchedule/SIF_Metadata/TimeElements/TimeElement | BellSchedule/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | BellSchedule/SIF_Metadata/LifeCycle/Created/Creators/Creator | BellSchedule/SIF_Metadata/LifeCycle/ModificationHistory/Modified | BellSchedule/SIF_Metadata/LifeCycle/TimeElements/TimeElement | BellSchedule/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | BellSchedule/SIF_Metadata/RightsElements/RightsElement | BellSchedule/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | BellSchedule/SIF_Metadata/EducationFilter/MediaTypes/MediaType | BellSchedule/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | BellSchedule/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BellSchedule/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | BellSchedule/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BellSchedule/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | BellSchedule/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BellSchedule/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | BellSchedule/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BellSchedule/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BellSchedule/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BellSchedule/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | BellSchedule/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BellSchedule/SIF_ExtendedElements/SIF_ExtendedElement | StudentContactPersonal/PersonInfo/OtherIdList/OtherId | StudentContactPersonal/PersonInfo/OtherNames/Name | StudentContactPersonal/PersonInfo/Demographics/RaceList/Race | StudentContactPersonal/PersonInfo/Demographics/RaceList/Race/OtherCodeList/OtherCode | StudentContactPersonal/PersonInfo/Demographics/CountriesOfCitizenship/CountryOfCitizenship | StudentContactPersonal/PersonInfo/Demographics/CountriesOfResidency/CountryOfResidency | StudentContactPersonal/PersonInfo/Demographics/EnglishProficiency/OtherCodeList/OtherCode | StudentContactPersonal/PersonInfo/Demographics/LanguageList/Language | StudentContactPersonal/PersonInfo/Demographics/LanguageList/Language/OtherCodeList/OtherCode | StudentContactPersonal/PersonInfo/Demographics/DwellingArrangement/OtherCodeList/OtherCode | StudentContactPersonal/PersonInfo/AddressList/Address | StudentContactPersonal/PersonInfo/PhoneNumberList/PhoneNumber | StudentContactPersonal/PersonInfo/EmailList/Email | StudentContactPersonal/SIF_Metadata/TimeElements/TimeElement | StudentContactPersonal/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentContactPersonal/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentContactPersonal/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentContactPersonal/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentContactPersonal/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentContactPersonal/SIF_Metadata/RightsElements/RightsElement | StudentContactPersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentContactPersonal/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentContactPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentContactPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentContactPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentContactPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentContactPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentContactPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentContactPersonal/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentContactPersonal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentContactPersonal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentContactPersonal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentContactPersonal/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentContactPersonal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentContactPersonal/SIF_ExtendedElements/SIF_ExtendedElement | StudentContactRelationship/Relationship/OtherCodeList/OtherCode | StudentContactRelationship/SIF_Metadata/TimeElements/TimeElement | StudentContactRelationship/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentContactRelationship/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentContactRelationship/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentContactRelationship/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentContactRelationship/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentContactRelationship/SIF_Metadata/RightsElements/RightsElement | StudentContactRelationship/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentContactRelationship/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentContactRelationship/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentContactRelationship/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentContactRelationship/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentContactRelationship/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentContactRelationship/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentContactRelationship/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentContactRelationship/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentContactRelationship/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentContactRelationship/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentContactRelationship/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentContactRelationship/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentContactRelationship/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentContactRelationship/SIF_ExtendedElements/SIF_ExtendedElement | StaffSectionAssignment/Roles/Role | StaffSectionAssignment/SIF_Metadata/TimeElements/TimeElement | StaffSectionAssignment/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StaffSectionAssignment/SIF_Metadata/LifeCycle/Created/Creators/Creator | StaffSectionAssignment/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StaffSectionAssignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StaffSectionAssignment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StaffSectionAssignment/SIF_Metadata/RightsElements/RightsElement | StaffSectionAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StaffSectionAssignment/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StaffSectionAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StaffSectionAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffSectionAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StaffSectionAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffSectionAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StaffSectionAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffSectionAssignment/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StaffSectionAssignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffSectionAssignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffSectionAssignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffSectionAssignment/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StaffSectionAssignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffSectionAssignment/SIF_ExtendedElements/SIF_ExtendedElement | StaffEvaluation/EvaluationParts/EvaluationPart | StaffEvaluation/EvaluationRecommendation/OtherCodeList/OtherCode | StaffEvaluation/SIF_Metadata/TimeElements/TimeElement | StaffEvaluation/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StaffEvaluation/SIF_Metadata/LifeCycle/Created/Creators/Creator | StaffEvaluation/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StaffEvaluation/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StaffEvaluation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StaffEvaluation/SIF_Metadata/RightsElements/RightsElement | StaffEvaluation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StaffEvaluation/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StaffEvaluation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StaffEvaluation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffEvaluation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StaffEvaluation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffEvaluation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StaffEvaluation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffEvaluation/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StaffEvaluation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffEvaluation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffEvaluation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffEvaluation/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StaffEvaluation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffEvaluation/SIF_ExtendedElements/SIF_ExtendedElement | SectionCorrelation/CorrelationType/OtherCodeList/OtherCode | SectionCorrelation/CorrelationSectionList/CorrelationSection | SectionCorrelation/SIF_Metadata/TimeElements/TimeElement | SectionCorrelation/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | SectionCorrelation/SIF_Metadata/LifeCycle/Created/Creators/Creator | SectionCorrelation/SIF_Metadata/LifeCycle/ModificationHistory/Modified | SectionCorrelation/SIF_Metadata/LifeCycle/TimeElements/TimeElement | SectionCorrelation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | SectionCorrelation/SIF_Metadata/RightsElements/RightsElement | SectionCorrelation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | SectionCorrelation/SIF_Metadata/EducationFilter/MediaTypes/MediaType | SectionCorrelation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | SectionCorrelation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SectionCorrelation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | SectionCorrelation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SectionCorrelation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | SectionCorrelation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SectionCorrelation/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | SectionCorrelation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SectionCorrelation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SectionCorrelation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SectionCorrelation/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | SectionCorrelation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SectionCorrelation/SIF_ExtendedElements/SIF_ExtendedElement | LEAFederalFund/FederalProgramList/FederalProgram | BusEquipment/SIF_Metadata/TimeElements/TimeElement | BusEquipment/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | BusEquipment/SIF_Metadata/LifeCycle/Created/Creators/Creator | BusEquipment/SIF_Metadata/LifeCycle/ModificationHistory/Modified | BusEquipment/SIF_Metadata/LifeCycle/TimeElements/TimeElement | BusEquipment/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | BusEquipment/SIF_Metadata/RightsElements/RightsElement | BusEquipment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | BusEquipment/SIF_Metadata/EducationFilter/MediaTypes/MediaType | BusEquipment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | BusEquipment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusEquipment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | BusEquipment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusEquipment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | BusEquipment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusEquipment/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | BusEquipment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusEquipment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusEquipment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusEquipment/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | BusEquipment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusEquipment/SIF_ExtendedElements/SIF_ExtendedElement | BusInfo/EquipmentList/Equipment | BusInfo/SIF_Metadata/TimeElements/TimeElement | BusInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | BusInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | BusInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | BusInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | BusInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | BusInfo/SIF_Metadata/RightsElements/RightsElement | BusInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | BusInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | BusInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | BusInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | BusInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | BusInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | BusInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | BusInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusInfo/SIF_ExtendedElements/SIF_ExtendedElement | BusRouteDetail/SIF_Metadata/TimeElements/TimeElement | BusRouteDetail/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | BusRouteDetail/SIF_Metadata/LifeCycle/Created/Creators/Creator | BusRouteDetail/SIF_Metadata/LifeCycle/ModificationHistory/Modified | BusRouteDetail/SIF_Metadata/LifeCycle/TimeElements/TimeElement | BusRouteDetail/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | BusRouteDetail/SIF_Metadata/RightsElements/RightsElement | BusRouteDetail/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | BusRouteDetail/SIF_Metadata/EducationFilter/MediaTypes/MediaType | BusRouteDetail/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | BusRouteDetail/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusRouteDetail/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | BusRouteDetail/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusRouteDetail/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | BusRouteDetail/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusRouteDetail/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | BusRouteDetail/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusRouteDetail/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusRouteDetail/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusRouteDetail/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | BusRouteDetail/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusRouteDetail/SIF_ExtendedElements/SIF_ExtendedElement | BusRouteInfo/SIF_Metadata/TimeElements/TimeElement | BusRouteInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | BusRouteInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | BusRouteInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | BusRouteInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | BusRouteInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | BusRouteInfo/SIF_Metadata/RightsElements/RightsElement | BusRouteInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | BusRouteInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | BusRouteInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | BusRouteInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusRouteInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | BusRouteInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusRouteInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | BusRouteInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusRouteInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | BusRouteInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusRouteInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusRouteInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusRouteInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | BusRouteInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusRouteInfo/SIF_ExtendedElements/SIF_ExtendedElement | BusStopInfo/SIF_Metadata/TimeElements/TimeElement | BusStopInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | BusStopInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | BusStopInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | BusStopInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | BusStopInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | BusStopInfo/SIF_Metadata/RightsElements/RightsElement | BusStopInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | BusStopInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | BusStopInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | BusStopInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusStopInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | BusStopInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusStopInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | BusStopInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusStopInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | BusStopInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusStopInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusStopInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusStopInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | BusStopInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusStopInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentTransportInfo/TransferPoints/TransferPoint | StudentTransportInfo/SIF_Metadata/TimeElements/TimeElement | StudentTransportInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | StudentTransportInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | StudentTransportInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | StudentTransportInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | StudentTransportInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | StudentTransportInfo/SIF_Metadata/RightsElements/RightsElement | StudentTransportInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | StudentTransportInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | StudentTransportInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | StudentTransportInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentTransportInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | StudentTransportInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentTransportInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | StudentTransportInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentTransportInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | StudentTransportInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentTransportInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentTransportInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentTransportInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | StudentTransportInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentTransportInfo/SIF_ExtendedElements/SIF_ExtendedElement | BusPositionInfo/TelemetryList/Telemetry | BusPositionInfo/BusStaffList/BusStaff | BusPositionInfo/Students/Student | BusPositionInfo/SIF_Metadata/TimeElements/TimeElement | BusPositionInfo/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | BusPositionInfo/SIF_Metadata/LifeCycle/Created/Creators/Creator | BusPositionInfo/SIF_Metadata/LifeCycle/ModificationHistory/Modified | BusPositionInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement | BusPositionInfo/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | BusPositionInfo/SIF_Metadata/RightsElements/RightsElement | BusPositionInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | BusPositionInfo/SIF_Metadata/EducationFilter/MediaTypes/MediaType | BusPositionInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | BusPositionInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusPositionInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | BusPositionInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusPositionInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | BusPositionInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusPositionInfo/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | BusPositionInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusPositionInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusPositionInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusPositionInfo/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | BusPositionInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusPositionInfo/SIF_ExtendedElements/SIF_ExtendedElement | Authentication/AuthenticationInfo/PasswordList/Password | Authentication/SIF_Metadata/TimeElements/TimeElement | Authentication/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | Authentication/SIF_Metadata/LifeCycle/Created/Creators/Creator | Authentication/SIF_Metadata/LifeCycle/ModificationHistory/Modified | Authentication/SIF_Metadata/LifeCycle/TimeElements/TimeElement | Authentication/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | Authentication/SIF_Metadata/RightsElements/RightsElement | Authentication/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | Authentication/SIF_Metadata/EducationFilter/MediaTypes/MediaType | Authentication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | Authentication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Authentication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | Authentication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Authentication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | Authentication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Authentication/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | Authentication/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Authentication/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Authentication/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Authentication/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | Authentication/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Authentication/SIF_ExtendedElements/SIF_ExtendedElement | EnergyUsage/UsageLocationInfo/EnergyZone/TagList/Tag | EnergyUsage/DataSource/ReadingDataList/ReadingData | EnergyUsage/DataSource/ReadingDataList/ReadingData/ReadingList/Reading | EnergyUsage/SIF_Metadata/TimeElements/TimeElement | EnergyUsage/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | EnergyUsage/SIF_Metadata/LifeCycle/Created/Creators/Creator | EnergyUsage/SIF_Metadata/LifeCycle/ModificationHistory/Modified | EnergyUsage/SIF_Metadata/LifeCycle/TimeElements/TimeElement | EnergyUsage/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | EnergyUsage/SIF_Metadata/RightsElements/RightsElement | EnergyUsage/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | EnergyUsage/SIF_Metadata/EducationFilter/MediaTypes/MediaType | EnergyUsage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | EnergyUsage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EnergyUsage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | EnergyUsage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EnergyUsage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | EnergyUsage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EnergyUsage/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | EnergyUsage/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EnergyUsage/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EnergyUsage/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EnergyUsage/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | EnergyUsage/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EnergyUsage/SIF_ExtendedElements/SIF_ExtendedElement | IdMApplication/FunctionList/Function | IdMApplication/IdentityProviderList/IdentityProvider | IdMApplication/SIF_Metadata/TimeElements/TimeElement | IdMApplication/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | IdMApplication/SIF_Metadata/LifeCycle/Created/Creators/Creator | IdMApplication/SIF_Metadata/LifeCycle/ModificationHistory/Modified | IdMApplication/SIF_Metadata/LifeCycle/TimeElements/TimeElement | IdMApplication/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | IdMApplication/SIF_Metadata/RightsElements/RightsElement | IdMApplication/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | IdMApplication/SIF_Metadata/EducationFilter/MediaTypes/MediaType | IdMApplication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | IdMApplication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | IdMApplication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | IdMApplication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | IdMApplication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | IdMApplication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | IdMApplication/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | IdMApplication/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | IdMApplication/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | IdMApplication/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | IdMApplication/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | IdMApplication/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | IdMApplication/SIF_ExtendedElements/SIF_ExtendedElement | IdMAuthentication/SIF_Metadata/TimeElements/TimeElement | IdMAuthentication/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | IdMAuthentication/SIF_Metadata/LifeCycle/Created/Creators/Creator | IdMAuthentication/SIF_Metadata/LifeCycle/ModificationHistory/Modified | IdMAuthentication/SIF_Metadata/LifeCycle/TimeElements/TimeElement | IdMAuthentication/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | IdMAuthentication/SIF_Metadata/RightsElements/RightsElement | IdMAuthentication/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | IdMAuthentication/SIF_Metadata/EducationFilter/MediaTypes/MediaType | IdMAuthentication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | IdMAuthentication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | IdMAuthentication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | IdMAuthentication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | IdMAuthentication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | IdMAuthentication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | IdMAuthentication/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | IdMAuthentication/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | IdMAuthentication/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | IdMAuthentication/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | IdMAuthentication/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | IdMAuthentication/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | IdMAuthentication/SIF_ExtendedElements/SIF_ExtendedElement | IdMAuthorization/SIF_Metadata/TimeElements/TimeElement | IdMAuthorization/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | IdMAuthorization/SIF_Metadata/LifeCycle/Created/Creators/Creator | IdMAuthorization/SIF_Metadata/LifeCycle/ModificationHistory/Modified | IdMAuthorization/SIF_Metadata/LifeCycle/TimeElements/TimeElement | IdMAuthorization/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | IdMAuthorization/SIF_Metadata/RightsElements/RightsElement | IdMAuthorization/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | IdMAuthorization/SIF_Metadata/EducationFilter/MediaTypes/MediaType | IdMAuthorization/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | IdMAuthorization/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | IdMAuthorization/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | IdMAuthorization/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | IdMAuthorization/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | IdMAuthorization/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | IdMAuthorization/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | IdMAuthorization/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | IdMAuthorization/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | IdMAuthorization/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | IdMAuthorization/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | IdMAuthorization/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | IdMAuthorization/SIF_ExtendedElements/SIF_ExtendedElement | UserOrganizationAssociation/SIF_Metadata/TimeElements/TimeElement | UserOrganizationAssociation/SIF_Metadata/TimeElements/TimeElement/SpanGaps/SpanGap | UserOrganizationAssociation/SIF_Metadata/LifeCycle/Created/Creators/Creator | UserOrganizationAssociation/SIF_Metadata/LifeCycle/ModificationHistory/Modified | UserOrganizationAssociation/SIF_Metadata/LifeCycle/TimeElements/TimeElement | UserOrganizationAssociation/SIF_Metadata/LifeCycle/TimeElements/TimeElement/SpanGaps/SpanGap | UserOrganizationAssociation/SIF_Metadata/RightsElements/RightsElement | UserOrganizationAssociation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse | UserOrganizationAssociation/SIF_Metadata/EducationFilter/MediaTypes/MediaType | UserOrganizationAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel | UserOrganizationAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | UserOrganizationAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea | UserOrganizationAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | UserOrganizationAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel | UserOrganizationAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | UserOrganizationAssociation/SIF_Metadata/EducationFilter/LearningStandardItems/LearningStandardItemRefId | UserOrganizationAssociation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | UserOrganizationAssociation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | UserOrganizationAssociation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | UserOrganizationAssociation/SIF_Metadata/EducationFilter/LearningObjectives/LearningObjective | UserOrganizationAssociation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | UserOrganizationAssociation/SIF_ExtendedElements/SIF_ExtendedElement | PersonPrivacyObligationDocument/LocationList/Location | PersonPrivacyObligationDocument/ConsentToSharingOfData/DataDomainObligationList/DataDomainObligation | PersonPrivacyObligationDocument/ConsentToSharingOfData/DataDomainObligationList/DataDomainObligation/ShareWithList/ShareWith | PersonPrivacyObligationDocument/ConsentToSharingOfData/DataDomainObligationList/DataDomainObligation/DoNotShareWithList/DoNotShareWith | PersonPrivacyObligationDocument/ConsentToSharingOfData/NeverShareWithList/NeverShareWith | PersonPrivacyObligationDocument/PermissionToParticipateList/PermissionToParticipate | PersonPrivacyObligationDocument/ApplicableLawList/ApplicableLaw" mode="detect" priority="2">
  <!-- repeating item may not be wrapped up in a List element (so check names of preceding-siblings) -->
  <xsl:if test="count(preceding-sibling::*) = 0 or not(name(preceding-sibling::*[1]) = name(.))">
      <xsl:text>"</xsl:text><xsl:value-of select="name()"/><xsl:text>" : [</xsl:text>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="count(./child::*) > 0 or count(@*) > 0">
        <xsl:apply-templates select="." mode="obj-content" />
      </xsl:when>
      <xsl:when test="count(./child::*) = 0">
        <xsl:apply-templates select="." mode="value"/>
      </xsl:when>
    </xsl:choose>
    <!-- repeating item may not be wrapped up in a List element (so check names of following-siblings) -->
    <xsl:if test="count(following-sibling::*) &gt; 0 and name(following-sibling::*[1]) = name(.)">, </xsl:if>
    <xsl:if test="count(following-sibling::*) = 0 or not(name(following-sibling::*[1]) = name(.))"><xsl:text>]</xsl:text><xsl:if test="count(following-sibling::*) &gt; 0"><xsl:text>,</xsl:text></xsl:if></xsl:if>
  </xsl:template>  

  <xsl:template match="*" mode="obj-content">
    <xsl:text>{</xsl:text>
    <xsl:apply-templates select="@*" mode="attr" />
    <xsl:if test="count(@*) &gt; 0">, </xsl:if>
    <xsl:apply-templates select="./*" mode="detect" />
    <xsl:if test="count(child::*) = 0 and text() and not(@*)">
      <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="value"/>
    </xsl:if>
    <xsl:if test="count(child::*) = 0 and text() and @*">
      <xsl:text>"value" : </xsl:text><xsl:apply-templates select="." mode="value"/>
    </xsl:if>
    <xsl:if test="count(child::*) = 0 and not(text()) and @*">
      <xsl:text>"value" : ""</xsl:text>
    </xsl:if>
    <xsl:text>}</xsl:text>
    <xsl:if test="position() &lt; last()">, </xsl:if>
  </xsl:template>

  <!-- simple content with attribute -->
  <xsl:template match="SEAInfo/CSSOContact/Address/StateProvince | SEAInfo/CSSOContact/Address/StateANSICode | SEAInfo/CSSOContact/Address/Country | SEAInfo/CSSOContact/EmailList/Email | SEAInfo/CSSOContact/EmailList/Email | SEAInfo/SEAContactList/SEAContact/PublishInDirectory | SEAInfo/SEAContactList/SEAContact/ContactInfo/Address/StateProvince | SEAInfo/SEAContactList/SEAContact/ContactInfo/Address/StateANSICode | SEAInfo/SEAContactList/SEAContact/ContactInfo/Address/Country | SEAInfo/SEAContactList/SEAContact/ContactInfo/EmailList/Email | SEAInfo/SEAContactList/SEAContact/ContactInfo/EmailList/Email | SEAInfo/AddressList/Address/StateProvince | SEAInfo/AddressList/Address/StateANSICode | SEAInfo/AddressList/Address/Country | SEAInfo/OperationalStatus | SEAInfo/EDENInfo/FIPSStateCode | SEAInfo/CTEGraduationRateInclusion | SEAInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SEAInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | SEAInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SEAInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | SEAInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SEAInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | SEAInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SEAInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SEAInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SEAInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SEAInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SEAInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentLEARelationship/MembershipType | StudentLEARelationship/LEARelationshipType/ResidencyStatus/Code | StudentLEARelationship/LEARelationshipType/ResidencyStatus/OtherCodeList/OtherCode | StudentLEARelationship/EntryType/Code | StudentLEARelationship/EntryType/OtherCodeList/OtherCode | StudentLEARelationship/ExitType/Code | StudentLEARelationship/ExitType/OtherCodeList/OtherCode | StudentLEARelationship/ExitStatus/Code | StudentLEARelationship/ExitStatus/OtherCodeList/OtherCode | StudentLEARelationship/NonResidentAttendReason | StudentLEARelationship/GradeLevel/Code | StudentLEARelationship/GradeLevel/OtherCodeList/OtherCode | StudentLEARelationship/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentLEARelationship/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentLEARelationship/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentLEARelationship/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentLEARelationship/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentLEARelationship/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentLEARelationship/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentLEARelationship/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentLEARelationship/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentLEARelationship/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentLEARelationship/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentLEARelationship/SIF_ExtendedElements/SIF_ExtendedElement | SEAAccountability/HighSchoolGraduationRateIndicatorStatus | AggregateStatisticInfo/CalculationRule | AggregateStatisticInfo/ExclusionRules/ExclusionRule | AggregateStatisticInfo/Location/LocationRefId | AggregateStatisticInfo/Measure | AggregateStatisticInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AggregateStatisticInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AggregateStatisticInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AggregateStatisticInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AggregateStatisticInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AggregateStatisticInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AggregateStatisticInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AggregateStatisticInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AggregateStatisticInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AggregateStatisticInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AggregateStatisticInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AggregateStatisticInfo/SIF_ExtendedElements/SIF_ExtendedElement | AggregateCharacteristicInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AggregateCharacteristicInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AggregateCharacteristicInfo/SIF_ExtendedElements/SIF_ExtendedElement | AggregateStatisticFact/Excluded | AggregateStatisticFact/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AggregateStatisticFact/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AggregateStatisticFact/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AggregateStatisticFact/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AggregateStatisticFact/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AggregateStatisticFact/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AggregateStatisticFact/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AggregateStatisticFact/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AggregateStatisticFact/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AggregateStatisticFact/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AggregateStatisticFact/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AggregateStatisticFact/SIF_ExtendedElements/SIF_ExtendedElement | StudentMeal/Amounts/Amount | StudentMeal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentMeal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentMeal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentMeal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentMeal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentMeal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentMeal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentMeal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentMeal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentMeal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentMeal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentMeal/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceItem/ElectronicIdList/ElectronicId | FoodserviceItem/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceItem/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceItem/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceItem/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceItem/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceItem/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceItemUnit/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceItemUnit/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceItemUnit/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItemUnit/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceItemUnit/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceItemUnit/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceItemUnit/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceItemUnit/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceItemUnit/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceItemUnit/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceItemUnit/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceItemUnit/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceItemPortion/ItemPortionType | FoodserviceItemPortion/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceItemPortion/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceItemPortion/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItemPortion/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceItemPortion/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceItemPortion/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceItemPortion/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceItemPortion/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceItemPortion/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceItemPortion/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceItemPortion/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceItemPortion/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceReimbursementRates/Program | FoodserviceReimbursementRates/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceReimbursementRates/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceReimbursementRates/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceMealPrices/Program | FoodserviceMealPrices/Prices/Price/Value | FoodserviceMealPrices/Prices/Price/MealType | FoodserviceMealPrices/Prices/Price/GradeLevels/GradeLevel/Code | FoodserviceMealPrices/Prices/Price/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMealPrices/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceMealPrices/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceMealPrices/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMealPrices/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceMealPrices/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceMealPrices/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceMealPrices/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceMealPrices/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceMealPrices/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceMealPrices/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceMealPrices/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceMealPrices/SIF_ExtendedElements/SIF_ExtendedElement | StaffMeal/Amounts/Amount | StaffMeal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffMeal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StaffMeal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffMeal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StaffMeal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffMeal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StaffMeal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffMeal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffMeal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffMeal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffMeal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffMeal/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceTransaction/Program | FoodserviceTransaction/TransactionTypes/TransactionType | FoodserviceTransaction/Amount | FoodserviceTransaction/Tax | FoodserviceTransaction/Voided | FoodserviceTransaction/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceTransaction/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceTransaction/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceTransaction/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceTransaction/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceTransaction/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceTransactionDetails/Amounts/Amount | FoodserviceTransactionDetails/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceTransactionDetails/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceTransactionDetails/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceTransactionPayMethod/TransactionPayMethods/TransactionPayMethod/Amounts/Amount | FoodserviceTransactionPayMethod/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceTransactionPayMethod/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceTransactionPayMethod/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceSales/Program | FoodserviceSales/SalesAmounts/SalesAmount | FoodserviceSales/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceSales/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceSales/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceSales/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceSales/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceSales/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceItemSales/Program | FoodserviceItemSales/ItemQuantities/ItemQuantity/MealType | FoodserviceItemSales/ItemQuantities/ItemQuantity/GradeLevels/GradeLevel/Code | FoodserviceItemSales/ItemQuantities/ItemQuantity/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItemSales/ItemQuantities/ItemQuantity/Cost | FoodserviceItemSales/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceItemSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceItemSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceItemSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceItemSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceItemSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceItemSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceItemSales/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceItemSales/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceItemSales/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceItemSales/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceItemSales/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceMenuPlan/GradeLevels/GradeLevel/Code | FoodserviceMenuPlan/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMenuPlan/Program | FoodserviceMenuPlan/MenuPlanQuantities/MenuPlanQuantity | FoodserviceMenuPlan/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceMenuPlan/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceMenuPlan/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceMilkSales/Program | FoodserviceMilkSales/SaleQuantities/SaleQuantity/ChargeToChild | FoodserviceMilkSales/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceMilkSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceMilkSales/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceMilkSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceMilkSales/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceMilkSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceMilkSales/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceMilkSales/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceMilkSales/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceMilkSales/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceMilkSales/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceMilkSales/SIF_ExtendedElements/SIF_ExtendedElement | FoodservicePurchaseTransaction/PurchaseQuantities/PurchaseQuantity/MealType | FoodservicePurchaseTransaction/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodservicePurchaseTransaction/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodservicePurchaseTransaction/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceStaffEnrollmentCount/Program | FoodserviceStaffEnrollmentCount/Counts/Count/MealType | FoodserviceStaffEnrollmentCount/Counts/Count/Amount | FoodserviceStaffEnrollmentCount/Counts/Count/Tax | FoodserviceStaffEnrollmentCount/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceStaffEnrollmentCount/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceStaffEnrollmentCount/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceStaffMealCounts/Program | FoodserviceStaffMealCounts/Counts/Count/MealType | FoodserviceStaffMealCounts/Counts/Count/Amount | FoodserviceStaffMealCounts/Counts/Count/Tax | FoodserviceStaffMealCounts/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceStaffMealCounts/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceStaffMealCounts/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceStudentEnrollmentCount/Program | FoodserviceStudentEnrollmentCount/Counts/Count/MealType | FoodserviceStudentEnrollmentCount/Counts/Count/Amount | FoodserviceStudentEnrollmentCount/Counts/Count/Tax | FoodserviceStudentEnrollmentCount/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceStudentEnrollmentCount/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceStudentEnrollmentCount/SIF_ExtendedElements/SIF_ExtendedElement | FoodserviceStudentMealCounts/Program | FoodserviceStudentMealCounts/Counts/Count/MealType | FoodserviceStudentMealCounts/Counts/Count/Amount | FoodserviceStudentMealCounts/Counts/Count/Tax | FoodserviceStudentMealCounts/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FoodserviceStudentMealCounts/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FoodserviceStudentMealCounts/SIF_ExtendedElements/SIF_ExtendedElement | StudentRecordExchange/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentRecordExchange/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentRecordExchange/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentRecordExchange/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentRecordExchange/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentRecordExchange/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentRecordExchange/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentRecordExchange/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentRecordExchange/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentRecordExchange/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentRecordExchange/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentRecordExchange/SIF_ExtendedElements/SIF_ExtendedElement | StudentDemographicRecord/StudentPersonalData/OtherIdList/OtherId | StudentDemographicRecord/StudentPersonalData/DemographicsData/RaceList/Race/Code | StudentDemographicRecord/StudentPersonalData/DemographicsData/RaceList/Race/OtherCodeList/OtherCode | StudentDemographicRecord/StudentPersonalData/DemographicsData/Gender | StudentDemographicRecord/StudentPersonalData/DemographicsData/EnglishProficiency/Code | StudentDemographicRecord/StudentPersonalData/DemographicsData/EnglishProficiency/OtherCodeList/OtherCode | StudentDemographicRecord/StudentPersonalData/DemographicsData/LanguageList/Language/Code | StudentDemographicRecord/StudentPersonalData/DemographicsData/LanguageList/Language/OtherCodeList/OtherCode | StudentDemographicRecord/StudentPersonalData/DemographicsData/LanguageList/Language/LanguageType | StudentDemographicRecord/StudentPersonalData/DemographicsData/HispanicLatino | StudentDemographicRecord/StudentPersonalData/DemographicsData/CountryOfBirth | StudentDemographicRecord/StudentPersonalData/DemographicsData/DwellingArrangement/Code | StudentDemographicRecord/StudentPersonalData/DemographicsData/DwellingArrangement/OtherCodeList/OtherCode | StudentDemographicRecord/StudentPersonalData/AddressList/Address/StateProvince | StudentDemographicRecord/StudentPersonalData/AddressList/Address/StateANSICode | StudentDemographicRecord/StudentPersonalData/AddressList/Address/Country | StudentDemographicRecord/StudentPersonalData/IDEA | StudentDemographicRecord/StudentPersonalData/Migrant | StudentDemographicRecord/StudentPersonalData/Title1 | StudentDemographicRecord/StudentPersonalData/GiftedTalented | StudentDemographicRecord/StudentPersonalData/EconomicDisadvantage | StudentDemographicRecord/StudentPersonalData/ELL | StudentDemographicRecord/StudentPersonalData/Homeless | StudentDemographicRecord/StudentPersonalData/Section504 | StudentDemographicRecord/StudentPersonalData/VocationalConcentrator | StudentDemographicRecord/StudentPersonalData/Immigrant | StudentDemographicRecord/StudentPersonalData/NeglectedDelinquent | StudentDemographicRecord/StudentContactsSummary/ParentGuardian1/AddressList/Address/StateProvince | StudentDemographicRecord/StudentContactsSummary/ParentGuardian1/AddressList/Address/StateANSICode | StudentDemographicRecord/StudentContactsSummary/ParentGuardian1/AddressList/Address/Country | StudentDemographicRecord/StudentContactsSummary/ParentGuardian2/AddressList/Address/StateProvince | StudentDemographicRecord/StudentContactsSummary/ParentGuardian2/AddressList/Address/StateANSICode | StudentDemographicRecord/StudentContactsSummary/ParentGuardian2/AddressList/Address/Country | StudentDemographicRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentDemographicRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentDemographicRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentDemographicRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentDemographicRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentDemographicRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentDemographicRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentDemographicRecord/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentDemographicRecord/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentDemographicRecord/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentDemographicRecord/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentDemographicRecord/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/StudentSchoolEnrollmentData/GradeLevel/Code | StudentAcademicRecord/StudentSchoolEnrollmentData/GradeLevel/OtherCodeList/OtherCode | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/AddressList/Address/StateProvince | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/AddressList/Address/StateANSICode | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/AddressList/Address/Country | StudentAcademicRecord/StudentSchoolEnrollmentData/Advisor/StaffPersonalData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/AddressList/Address/StateProvince | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/AddressList/Address/StateANSICode | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/AddressList/Address/Country | StudentAcademicRecord/StudentSchoolEnrollmentData/Counselor/StaffPersonalData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/StudentSchoolEnrollmentData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/LEAInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/PublishInDirectory | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/StateProvince | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/StateANSICode | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/Country | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/AddressList/Address/StateProvince | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/AddressList/Address/StateANSICode | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/AddressList/Address/Country | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/IdentificationInfoList/IdentificationInfo | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/GradeLevels/GradeLevel/Code | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/SchoolInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/SchoolAttendanceHistory/SchoolAttended/MarkingSystems/MarkValueInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/EntryType/Code | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/EntryType/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/GradeLevel/Code | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/GradeLevel/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/ExitStatus/Code | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/ExitStatus/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/ExitType/Code | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/ExitType/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/MembershipType | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/LEARelationshipType/ResidencyStatus/Code | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/LEARelationshipType/ResidencyStatus/OtherCodeList/OtherCode | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentLEARelationship/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentSchoolRelationship/MembershipType | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentSchoolRelationship/ResidencyStatus/Code | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentSchoolRelationship/NonResidentAttendReason | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/StudentSchoolRelationship/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/EnrollmentHistory/StudentSchoolEnrollmentData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/TermInfoData/TermSpan/Code | StudentAcademicRecord/CurrentCourseActivity/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/SubjectAreaList/SubjectArea/Code | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/SubjectAreaList/SubjectArea/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/InstructionalLevel/Code | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/InstructionalLevel/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/GraduationRequirement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SchoolCourseInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/TermInfoData/TermSpan/Code | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/GradeLevelWhenTaken/Code | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/GradeLevelWhenTaken/OtherCodeList/OtherCode | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/MarkData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/MarkingPeriod/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CurrentCourseActivity/Courses/Course/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/TermInfoData/TermSpan/Code | StudentAcademicRecord/CourseHistory/Term/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/SubjectAreaList/SubjectArea/Code | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/SubjectAreaList/SubjectArea/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/InstructionalLevel/Code | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/InstructionalLevel/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/GraduationRequirement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SchoolCourseInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/TermInfoData/TermSpan/Code | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/GradeLevelWhenTaken/Code | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/GradeLevelWhenTaken/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/MarkData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/CreditType | StudentAcademicRecord/CourseHistory/Term/Courses/Course/MarkingPeriods/MarkingPeriod/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SectionInfoData/MediumOfInstruction/Code | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SectionInfoData/MediumOfInstruction/OtherCodeList/OtherCode | StudentAcademicRecord/CourseHistory/Term/Courses/Course/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/TermInfoData/TermSpan/Code | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/TermInfoData/TermSpan/OtherCodeList/OtherCode | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/TermInfoData/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/GradeLevelWhenTaken/Code | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/GradeLevelWhenTaken/OtherCodeList/OtherCode | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/ProgressLevel | StudentAcademicRecord/AcademicPerformanceHistory/TermPerformance/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AcademicPerformanceSummary/GraduationRateSurveyIndicator | StudentAcademicRecord/AcademicPerformanceSummary/AcademicTrack | StudentAcademicRecord/AcademicPerformanceSummary/AcademicFoci/AcademicFocus/Code | StudentAcademicRecord/AcademicPerformanceSummary/AcademicFoci/AcademicFocus/OtherCodeList/OtherCode | StudentAcademicRecord/AcademicPerformanceSummary/AcademicSubjects/AcademicSubject/Code | StudentAcademicRecord/AcademicPerformanceSummary/AcademicSubjects/AcademicSubject/OtherCodeList/OtherCode | StudentAcademicRecord/AcademicPerformanceSummary/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AssessmentPerformanceHistory/Assessment/StudentGradeLevelWhenAssessed/Code | StudentAcademicRecord/AssessmentPerformanceHistory/Assessment/StudentGradeLevelWhenAssessed/OtherCodeList/OtherCode | StudentAcademicRecord/AssessmentPerformanceHistory/Assessment/TestScoreType | StudentAcademicRecord/AssessmentPerformanceHistory/Assessment/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/AdditionalGraduationRequirementPerformanceHistory/Requirement/Status | StudentAcademicRecord/AdditionalGraduationRequirementPerformanceHistory/Requirement/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/ActivityAwardHistory/ActivityAward/InvolvementCode | StudentAcademicRecord/ActivityAwardHistory/ActivityAward/HonorsInformationCode | StudentAcademicRecord/ActivityAwardHistory/ActivityAward/DiplomaCredentialHonorsCode | StudentAcademicRecord/ActivityAwardHistory/ActivityAward/CredentialConferred | StudentAcademicRecord/ActivityAwardHistory/ActivityAward/SIF_ExtendedElements/SIF_ExtendedElement | StudentAcademicRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentAcademicRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentAcademicRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentAcademicRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentAcademicRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentAcademicRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentAcademicRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentAcademicRecord/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentAcademicRecord/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentAcademicRecord/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentAcademicRecord/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentAcademicRecord/SIF_ExtendedElements/SIF_ExtendedElement | StudentSpecialEducationRecord/StudentParticipationData/ProgramType/Code | StudentSpecialEducationRecord/StudentParticipationData/ProgramType/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/PublishInDirectory | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/StateProvince | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/StateANSICode | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/Address/Country | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/AddressList/Address/StateProvince | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/AddressList/Address/StateANSICode | StudentSpecialEducationRecord/StudentParticipationData/SchoolInfoData/AddressList/Address/Country | StudentSpecialEducationRecord/StudentParticipationData/ProgramStatus/Code | StudentSpecialEducationRecord/StudentParticipationData/ProgramStatus/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/Code | StudentSpecialEducationRecord/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationData/PlannedAssessmentParticipation | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramType/Code | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramType/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramFundingSources/ProgramFundingSource/Code | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramFundingSources/ProgramFundingSource/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ManagingPublicAgency | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ManagingSchool | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramStatus/Code | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ProgramStatus/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/GiftedEligibilityCriteria | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/Code | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentParticipationList/StudentParticipationData/PlannedAssessmentParticipation | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/Service/Code | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/Service/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceCategory | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceFundingSources/ServiceFundingSource/Code | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceFundingSources/ServiceFundingSource/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServicingPublicAgency | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServicingSchool | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/SchoolWhereServiceDelivered | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceProviderType/Code | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/ServiceProviderType/OtherCodeList/OtherCode | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/FrequencyTime/Code | StudentSpecialEducationRecord/StudentPlacementList/StudentPlacementData/FrequencyTime/OtherCodeList/OtherCode | StudentSpecialEducationRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSpecialEducationRecord/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSpecialEducationRecord/SIF_ExtendedElements/SIF_ExtendedElement | MarkValueInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | MarkValueInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | MarkValueInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | MarkValueInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | MarkValueInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | MarkValueInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | MarkValueInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | MarkValueInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | MarkValueInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | MarkValueInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | MarkValueInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | MarkValueInfo/SIF_ExtendedElements/SIF_ExtendedElement | MarkInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | MarkInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | MarkInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | MarkInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | MarkInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | MarkInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | MarkInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | MarkInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | MarkInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | MarkInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | MarkInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | MarkInfo/SIF_ExtendedElements/SIF_ExtendedElement | SectionMarkInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SectionMarkInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | SectionMarkInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SectionMarkInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | SectionMarkInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SectionMarkInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | SectionMarkInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SectionMarkInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SectionMarkInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SectionMarkInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SectionMarkInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SectionMarkInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentSectionMarks/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSectionMarks/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentSectionMarks/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSectionMarks/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentSectionMarks/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSectionMarks/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentSectionMarks/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSectionMarks/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSectionMarks/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSectionMarks/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSectionMarks/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSectionMarks/SIF_ExtendedElements/SIF_ExtendedElement | GradingCategory/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | GradingCategory/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | GradingCategory/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | GradingCategory/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | GradingCategory/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | GradingCategory/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | GradingCategory/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | GradingCategory/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | GradingCategory/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | GradingCategory/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | GradingCategory/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | GradingCategory/SIF_ExtendedElements/SIF_ExtendedElement | GradingAssignment/DetailedDescription | GradingAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | GradingAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | GradingAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | GradingAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | GradingAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | GradingAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | GradingAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | GradingAssignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | GradingAssignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | GradingAssignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | GradingAssignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | GradingAssignment/SIF_ExtendedElements/SIF_ExtendedElement | GradingAssignmentScore/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | GradingAssignmentScore/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | GradingAssignmentScore/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | GradingAssignmentScore/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | GradingAssignmentScore/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | GradingAssignmentScore/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | GradingAssignmentScore/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | GradingAssignmentScore/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | GradingAssignmentScore/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | GradingAssignmentScore/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | GradingAssignmentScore/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | GradingAssignmentScore/SIF_ExtendedElements/SIF_ExtendedElement | StudentPeriodAttendance/AttendanceCode | StudentPeriodAttendance/InstructionalDeliveryMode | StudentPeriodAttendance/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentPeriodAttendance/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentPeriodAttendance/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentPeriodAttendance/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentPeriodAttendance/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentPeriodAttendance/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentPeriodAttendance/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentPeriodAttendance/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentPeriodAttendance/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentPeriodAttendance/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentPeriodAttendance/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentPeriodAttendance/SIF_ExtendedElements/SIF_ExtendedElement | StudentGrade/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentGrade/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentGrade/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentGrade/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentGrade/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentGrade/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentGrade/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentGrade/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentGrade/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentGrade/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentGrade/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentGrade/SIF_ExtendedElements/SIF_ExtendedElement | Billing/BilledEntity | Billing/BilledAmount | Billing/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Billing/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Billing/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Billing/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Billing/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Billing/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Billing/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Billing/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Billing/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Billing/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Billing/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Billing/SIF_ExtendedElements/SIF_ExtendedElement | Payment/ReceivedAmount | Payment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Payment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Payment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Payment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Payment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Payment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Payment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Payment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Payment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Payment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Payment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Payment/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeAssignment/PrimaryAssignment | EmployeeAssignment/JobClassification/Code | EmployeeAssignment/JobClassification/OtherCodeList/OtherCode | EmployeeAssignment/ProgramType/Code | EmployeeAssignment/ProgramType/OtherCodeList/OtherCode | EmployeeAssignment/FundingSource/Code | EmployeeAssignment/FundingSource/OtherCodeList/OtherCode | EmployeeAssignment/SpecialEducation/AgeGroupList/AgeGroup/AgeGroup | EmployeeAssignment/SpecialEducation/TitleList/TitleList/Title | EmployeeAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeeAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeeAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeeAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeAssignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeAssignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeAssignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeAssignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeAssignment/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeContract/BaseSalary | EmployeeContract/ContractTerm | EmployeeContract/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeContract/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeeContract/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeContract/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeeContract/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeContract/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeeContract/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeContract/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeContract/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeContract/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeContract/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeContract/SIF_ExtendedElements/SIF_ExtendedElement | EmploymentRecord/FullTimeStatus | EmploymentRecord/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmploymentRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmploymentRecord/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmploymentRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmploymentRecord/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmploymentRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmploymentRecord/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmploymentRecord/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmploymentRecord/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmploymentRecord/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmploymentRecord/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmploymentRecord/SIF_ExtendedElements/SIF_ExtendedElement | EmployeePersonal/OtherIdList/OtherId | EmployeePersonal/Demographics/RaceList/Race/Code | EmployeePersonal/Demographics/RaceList/Race/OtherCodeList/OtherCode | EmployeePersonal/Demographics/HispanicLatino | EmployeePersonal/Demographics/Gender | EmployeePersonal/Demographics/BirthDateVerification | EmployeePersonal/Demographics/StateOfBirth | EmployeePersonal/Demographics/CountryOfBirth | EmployeePersonal/Demographics/CountriesOfCitizenship/CountryOfCitizenship | EmployeePersonal/Demographics/CountriesOfResidency/CountryOfResidency | EmployeePersonal/Demographics/CitizenshipStatus | EmployeePersonal/Demographics/EnglishProficiency/Code | EmployeePersonal/Demographics/EnglishProficiency/OtherCodeList/OtherCode | EmployeePersonal/Demographics/LanguageList/Language/Code | EmployeePersonal/Demographics/LanguageList/Language/OtherCodeList/OtherCode | EmployeePersonal/Demographics/LanguageList/Language/LanguageType | EmployeePersonal/Demographics/DwellingArrangement/Code | EmployeePersonal/Demographics/DwellingArrangement/OtherCodeList/OtherCode | EmployeePersonal/AddressList/Address/StateProvince | EmployeePersonal/AddressList/Address/StateANSICode | EmployeePersonal/AddressList/Address/Country | EmployeePersonal/EmailList/Email | EmployeePersonal/EmailList/Email | EmployeePersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeePersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeePersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeePersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeePersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeePersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeePersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeePersonal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeePersonal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeePersonal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeePersonal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeePersonal/SIF_ExtendedElements/SIF_ExtendedElement | EmployeePicture/PictureSource | EmployeePicture/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeePicture/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeePicture/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeePicture/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeePicture/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeePicture/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeePicture/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeePicture/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeePicture/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeePicture/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeePicture/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeePicture/SIF_ExtendedElements/SIF_ExtendedElement | FinancialAnnual/AnnualItems/AnnualItem/AccountType | FinancialAnnual/AnnualItems/AnnualItem/AccountTypeDetail | FinancialAnnual/AnnualItems/AnnualItem/FundType | FinancialAnnual/AnnualItems/AnnualItem/ExpenditureArea | FinancialAnnual/AnnualItems/AnnualItem/SpecialAmountType | FinancialAnnual/AnnualItems/AnnualItem/GLAmountType | FinancialAnnual/AnnualItems/AnnualItem/SIF_ExtendedElements/SIF_ExtendedElement | FinancialAnnual/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialAnnual/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialAnnual/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialAnnual/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialAnnual/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialAnnual/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialAnnual/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialAnnual/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialAnnual/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialAnnual/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialAnnual/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialAnnual/SIF_ExtendedElements/SIF_ExtendedElement | FinancialBudget/BudgetAccounts/BudgetAccount/AccountClass | FinancialBudget/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialBudget/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialBudget/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialBudget/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialBudget/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialBudget/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialBudget/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialBudget/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialBudget/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialBudget/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialBudget/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialBudget/SIF_ExtendedElements/SIF_ExtendedElement | TimeWorked/JobFunction/Code | TimeWorked/JobFunction/OtherCodeList/OtherCode | TimeWorked/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | TimeWorked/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | TimeWorked/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | TimeWorked/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | TimeWorked/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | TimeWorked/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | TimeWorked/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | TimeWorked/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | TimeWorked/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | TimeWorked/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | TimeWorked/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | TimeWorked/SIF_ExtendedElements/SIF_ExtendedElement | VendorInfo/ContactInfo/Address/StateProvince | VendorInfo/ContactInfo/Address/StateANSICode | VendorInfo/ContactInfo/Address/Country | VendorInfo/ContactInfo/EmailList/Email | VendorInfo/ContactInfo/EmailList/Email | VendorInfo/FederalTaxId | VendorInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | VendorInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | VendorInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | VendorInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | VendorInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | VendorInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | VendorInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | VendorInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | VendorInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | VendorInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | VendorInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | VendorInfo/SIF_ExtendedElements/SIF_ExtendedElement | W4/MaritalStatusRate | W4/StateProvince | W4/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | W4/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | W4/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | W4/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | W4/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | W4/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | W4/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | W4/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | W4/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | W4/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | W4/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | W4/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeWage/PayRates/PayRate/Amount | EmployeeWage/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeWage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeeWage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeWage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeeWage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeWage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeeWage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeWage/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeWage/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeWage/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeWage/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeWage/SIF_ExtendedElements/SIF_ExtendedElement | LocationInfo/IdentificationInfoList/IdentificationInfo | LocationInfo/ParentLocationInfo | LocationInfo/AddressList/Address/StateProvince | LocationInfo/AddressList/Address/StateANSICode | LocationInfo/AddressList/Address/Country | LocationInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LocationInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LocationInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LocationInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LocationInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LocationInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LocationInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LocationInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LocationInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LocationInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LocationInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LocationInfo/SIF_ExtendedElements/SIF_ExtendedElement | Purchasing/FormType | Purchasing/PurchasingItems/PurchasingItem/UnitCost | Purchasing/PurchasingItems/PurchasingItem/ExpenseAccounts/ExpenseAccount/Amount | Purchasing/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Purchasing/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Purchasing/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Purchasing/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Purchasing/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Purchasing/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Purchasing/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Purchasing/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Purchasing/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Purchasing/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Purchasing/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Purchasing/SIF_ExtendedElements/SIF_ExtendedElement | AccountingPeriod/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AccountingPeriod/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AccountingPeriod/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AccountingPeriod/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AccountingPeriod/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AccountingPeriod/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AccountingPeriod/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AccountingPeriod/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AccountingPeriod/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AccountingPeriod/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AccountingPeriod/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AccountingPeriod/SIF_ExtendedElements/SIF_ExtendedElement | FinancialAccount/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialAccount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialAccount/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialAccount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialAccount/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialAccount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialAccount/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialAccount/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialAccount/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialAccount/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialAccount/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialAccount/SIF_ExtendedElements/SIF_ExtendedElement | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialAccountAccountingPeriodLocationInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialAccountAccountingPeriodLocationInfo/SIF_ExtendedElements/SIF_ExtendedElement | FinancialClass/ClassType | FinancialClass/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialClass/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialClass/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialClass/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialClass/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialClass/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialClass/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialClass/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialClass/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialClass/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialClass/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialClass/SIF_ExtendedElements/SIF_ExtendedElement | FinancialIncomeStatement/Amounts/Amount | FinancialIncomeStatement/Program | FinancialIncomeStatement/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialIncomeStatement/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialIncomeStatement/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialIncomeStatement/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialIncomeStatement/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialIncomeStatement/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialIncomeStatement/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialIncomeStatement/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialIncomeStatement/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialIncomeStatement/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialIncomeStatement/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialIncomeStatement/SIF_ExtendedElements/SIF_ExtendedElement | FinancialTransaction/Amounts/Amount | FinancialTransaction/Program | FinancialTransaction/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FinancialTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FinancialTransaction/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FinancialTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FinancialTransaction/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FinancialTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FinancialTransaction/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FinancialTransaction/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FinancialTransaction/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FinancialTransaction/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FinancialTransaction/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FinancialTransaction/SIF_ExtendedElements/SIF_ExtendedElement | FiscalYear/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | FiscalYear/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | FiscalYear/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | FiscalYear/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | FiscalYear/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | FiscalYear/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | FiscalYear/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | FiscalYear/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | FiscalYear/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | FiscalYear/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | FiscalYear/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | FiscalYear/SIF_ExtendedElements/SIF_ExtendedElement | ActivityProvider/Address/StateProvince | ActivityProvider/Address/StateANSICode | ActivityProvider/Address/Country | ActivityProvider/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ActivityProvider/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ActivityProvider/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ActivityProvider/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ActivityProvider/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ActivityProvider/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ActivityProvider/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ActivityProvider/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ActivityProvider/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ActivityProvider/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ActivityProvider/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ActivityProvider/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeCredit/Earned | EmployeeCredit/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeCredit/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeeCredit/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeCredit/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeeCredit/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeCredit/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeeCredit/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeCredit/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeCredit/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeCredit/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeCredit/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeCredit/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeRecertification/Demographics/RaceList/Race/Code | EmployeeRecertification/Demographics/RaceList/Race/OtherCodeList/OtherCode | EmployeeRecertification/Demographics/HispanicLatino | EmployeeRecertification/Demographics/Gender | EmployeeRecertification/Demographics/BirthDateVerification | EmployeeRecertification/Demographics/StateOfBirth | EmployeeRecertification/Demographics/CountryOfBirth | EmployeeRecertification/Demographics/CountriesOfCitizenship/CountryOfCitizenship | EmployeeRecertification/Demographics/CountriesOfResidency/CountryOfResidency | EmployeeRecertification/Demographics/CitizenshipStatus | EmployeeRecertification/Demographics/EnglishProficiency/Code | EmployeeRecertification/Demographics/EnglishProficiency/OtherCodeList/OtherCode | EmployeeRecertification/Demographics/LanguageList/Language/Code | EmployeeRecertification/Demographics/LanguageList/Language/OtherCodeList/OtherCode | EmployeeRecertification/Demographics/LanguageList/Language/LanguageType | EmployeeRecertification/Demographics/DwellingArrangement/Code | EmployeeRecertification/Demographics/DwellingArrangement/OtherCodeList/OtherCode | EmployeeRecertification/ActivityType | EmployeeRecertification/Earned | EmployeeRecertification/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeRecertification/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeeRecertification/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeRecertification/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeeRecertification/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeRecertification/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeeRecertification/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeRecertification/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeRecertification/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeRecertification/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeRecertification/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeRecertification/SIF_ExtendedElements/SIF_ExtendedElement | EmployeeCredential/Demographics/RaceList/Race/Code | EmployeeCredential/Demographics/RaceList/Race/OtherCodeList/OtherCode | EmployeeCredential/Demographics/HispanicLatino | EmployeeCredential/Demographics/Gender | EmployeeCredential/Demographics/BirthDateVerification | EmployeeCredential/Demographics/StateOfBirth | EmployeeCredential/Demographics/CountryOfBirth | EmployeeCredential/Demographics/CountriesOfCitizenship/CountryOfCitizenship | EmployeeCredential/Demographics/CountriesOfResidency/CountryOfResidency | EmployeeCredential/Demographics/CitizenshipStatus | EmployeeCredential/Demographics/EnglishProficiency/Code | EmployeeCredential/Demographics/EnglishProficiency/OtherCodeList/OtherCode | EmployeeCredential/Demographics/LanguageList/Language/Code | EmployeeCredential/Demographics/LanguageList/Language/OtherCodeList/OtherCode | EmployeeCredential/Demographics/LanguageList/Language/LanguageType | EmployeeCredential/Demographics/DwellingArrangement/Code | EmployeeCredential/Demographics/DwellingArrangement/OtherCodeList/OtherCode | EmployeeCredential/Race | EmployeeCredential/Hispanic | EmployeeCredential/Certifications/Certification/AreaAuthorized | EmployeeCredential/Salary | EmployeeCredential/Status | EmployeeCredential/Leave | EmployeeCredential/Education | EmployeeCredential/TeachingCredentialType | EmployeeCredential/HighlyQualifiedTeacherIndicator | EmployeeCredential/ParaprofessionalQualificationStatus | EmployeeCredential/TerminationCode | EmployeeCredential/BackgroundChecks/BackgroundCheck/Type | EmployeeCredential/Assignments/Assignment/GradeLevels/GradeLevel/Code | EmployeeCredential/Assignments/Assignment/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeCredential/Assignments/Assignment/JobFunction/Code | EmployeeCredential/Assignments/Assignment/JobFunction/OtherCodeList/OtherCode | EmployeeCredential/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EmployeeCredential/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EmployeeCredential/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EmployeeCredential/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EmployeeCredential/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EmployeeCredential/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EmployeeCredential/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EmployeeCredential/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EmployeeCredential/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EmployeeCredential/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EmployeeCredential/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EmployeeCredential/SIF_ExtendedElements/SIF_ExtendedElement | ProfessionalDevelopmentActivities/Stipend | ProfessionalDevelopmentActivities/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ProfessionalDevelopmentActivities/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ProfessionalDevelopmentActivities/SIF_ExtendedElements/SIF_ExtendedElement | ProfessionalDevelopmentProgram/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ProfessionalDevelopmentProgram/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ProfessionalDevelopmentProgram/SIF_ExtendedElements/SIF_ExtendedElement | ProfessionalDevelopmentRegistration/RegistrationStatus | ProfessionalDevelopmentRegistration/PaidAmount | ProfessionalDevelopmentRegistration/Stipend | ProfessionalDevelopmentRegistration/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ProfessionalDevelopmentRegistration/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ProfessionalDevelopmentRegistration/SIF_ExtendedElements/SIF_ExtendedElement | StudentParticipation/ProgramType/Code | StudentParticipation/ProgramType/OtherCodeList/OtherCode | StudentParticipation/ProgramFundingSources/ProgramFundingSource/Code | StudentParticipation/ProgramFundingSources/ProgramFundingSource/OtherCodeList/OtherCode | StudentParticipation/ManagingPublicAgency | StudentParticipation/ManagingSchool | StudentParticipation/PartCTransitionMeetingNotHeldReasons/PartCTransitionMeetingNotHeldReason/Code | StudentParticipation/PartCTransitionMeetingNotHeldReasons/PartCTransitionMeetingNotHeldReason/OtherCodeList/OtherCode | StudentParticipation/PartCTransitionMeetingOutcomes/PartCTransitionMeetingOutcome/Code | StudentParticipation/PartCTransitionMeetingOutcomes/PartCTransitionMeetingOutcome/OtherCodeList/OtherCode | StudentParticipation/ReferralSource/Code | StudentParticipation/ReferralSource/OtherCodeList/OtherCode | StudentParticipation/ProgramStatus/Code | StudentParticipation/ProgramStatus/OtherCodeList/OtherCode | StudentParticipation/ExceptionalityCategories/ExceptionalityCategory/Code | StudentParticipation/ExceptionalityCategories/ExceptionalityCategory/OtherCodeList/OtherCode | StudentParticipation/ProgramPlanType/Code | StudentParticipation/ProgramPlanType/OtherCodeList/OtherCode | StudentParticipation/LeastRestrictiveEnvironment/Code | StudentParticipation/LeastRestrictiveEnvironment/OtherCodeList/OtherCode | StudentParticipation/ProgramAvailability/Code | StudentParticipation/ProgramAvailability/OtherCodeList/OtherCode | StudentParticipation/ProgramExitReason/Code | StudentParticipation/ProgramExitReason/OtherCodeList/OtherCode | StudentParticipation/ProjectedExitReason | StudentParticipation/PlannedAssessmentParticipation | StudentParticipation/TransitionPlanning | StudentParticipation/AdditionalProgramAvailabilityList/ProgramAvailability/Code | StudentParticipation/AdditionalProgramAvailabilityList/ProgramAvailability/OtherCodeList/OtherCode | StudentParticipation/CertifiedLunchProgram | StudentParticipation/PerkinsLEPStatus | StudentParticipation/TitleIIIAccountabilityProgressStatus | StudentParticipation/TitleIIIImmigrantParticipationStatus | StudentParticipation/NeglectedOrDelinquentAchievementIndicator | StudentParticipation/NeglectedOrDelinquentAcademicOutcomeIndicator | StudentParticipation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentParticipation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentParticipation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentParticipation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentParticipation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentParticipation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentParticipation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentParticipation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentParticipation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentParticipation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentParticipation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentParticipation/SIF_ExtendedElements/SIF_ExtendedElement | StudentPlacement/Service/Code | StudentPlacement/Service/OtherCodeList/OtherCode | StudentPlacement/ServiceCategory | StudentPlacement/ServiceFundingSources/ServiceFundingSource/Code | StudentPlacement/ServiceFundingSources/ServiceFundingSource/OtherCodeList/OtherCode | StudentPlacement/ServicingPublicAgency | StudentPlacement/ServicingSchool | StudentPlacement/SchoolWhereServiceDelivered | StudentPlacement/ServiceProviderType/Code | StudentPlacement/ServiceProviderType/OtherCodeList/OtherCode | StudentPlacement/ServiceSetting/Code | StudentPlacement/ServiceSetting/OtherCodeList/OtherCode | StudentPlacement/WhenServiceProvided/Code | StudentPlacement/WhenServiceProvided/OtherCodeList/OtherCode | StudentPlacement/FrequencyTime/Code | StudentPlacement/FrequencyTime/OtherCodeList/OtherCode | StudentPlacement/DirectTime | StudentPlacement/IndirectTime | StudentPlacement/TotalServiceDuration | StudentPlacement/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentPlacement/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentPlacement/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentPlacement/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentPlacement/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentPlacement/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentPlacement/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentPlacement/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentPlacement/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentPlacement/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentPlacement/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentPlacement/SIF_ExtendedElements/SIF_ExtendedElement | TestAccommodation/GradeLevel/Code | TestAccommodation/GradeLevel/OtherCodeList/OtherCode | TestAccommodation/TestType | TestAccommodation/AuthorizedActual | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/StudentProgramType/OtherCodeList/OtherCode | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/Accommodations/Accommodation/OtherCodeList/OtherCode | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/Accommodations/Accommodation/AccommodationCategory/Code | TestAccommodation/StudentProgramAccommodations/StudentProgramAccommodation/Accommodations/Accommodation/AccommodationCategory/OtherCodeList/OtherCode | TestAccommodation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | TestAccommodation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | TestAccommodation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | TestAccommodation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | TestAccommodation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | TestAccommodation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | TestAccommodation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | TestAccommodation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | TestAccommodation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | TestAccommodation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | TestAccommodation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | TestAccommodation/SIF_ExtendedElements/SIF_ExtendedElement | StudentSpecialEducationSummary/PrimaryDisabilityCode | StudentSpecialEducationSummary/EnvironmentForSchoolAge | StudentSpecialEducationSummary/EnvironmentForEarlyChildhood | StudentSpecialEducationSummary/NeglectedOrDelinquentParticipationList/NeglectedOrDelinquentParticipation/Type | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramType/Code | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramType/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramFundingSources/ProgramFundingSource/Code | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramFundingSources/ProgramFundingSource/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ManagingPublicAgency | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ManagingSchool | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramStatus/Code | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ProgramStatus/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/GiftedEligibilityCriteria | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/Code | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/ExceptionalityCategories/ExceptionalityCategory/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentParticipationList/StudentParticipationData/PlannedAssessmentParticipation | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/Service/Code | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/Service/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceCategory | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceFundingSources/ServiceFundingSource/Code | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceFundingSources/ServiceFundingSource/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServicingPublicAgency | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServicingSchool | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/SchoolWhereServiceDelivered | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceProviderType/Code | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/ServiceProviderType/OtherCodeList/OtherCode | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/FrequencyTime/Code | StudentSpecialEducationSummary/StudentPlacementList/StudentPlacementData/FrequencyTime/OtherCodeList/OtherCode | StudentSpecialEducationSummary/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSpecialEducationSummary/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSpecialEducationSummary/SIF_ExtendedElements/SIF_ExtendedElement | StudentCareerTechnical/EducationCompleter | StudentCareerTechnical/Participant | StudentCareerTechnical/NontraditionalGenderStatus | StudentCareerTechnical/DisplacedHomemaker | StudentCareerTechnical/SingleParentOrSinglePregnantWoman | Assessment/AssessmentIdSystem | Assessment/AssessmentDescriptors/AssessmentDescriptor | Assessment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Assessment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Assessment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Assessment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Assessment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Assessment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Assessment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Assessment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Assessment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Assessment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Assessment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Assessment/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentItem/Stimulus/XMLData | AssessmentItem/Stimulus/TextData | AssessmentItem/Stimulus/BinaryData | AssessmentItem/Stem/XMLData | AssessmentItem/Stem/TextData | AssessmentItem/Stem/BinaryData | AssessmentItem/ResponseChoices/Choice/ChoiceContent/XMLData | AssessmentItem/ResponseChoices/Choice/ChoiceContent/TextData | AssessmentItem/ResponseChoices/Choice/ChoiceContent/BinaryData | AssessmentItem/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AssessmentItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AssessmentItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AssessmentItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentItem/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentItem/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentItem/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentItem/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentItem/SIF_ExtendedElements/SIF_ExtendedElement | ItemCharacteristics/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ItemCharacteristics/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ItemCharacteristics/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ItemCharacteristics/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ItemCharacteristics/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ItemCharacteristics/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ItemCharacteristics/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ItemCharacteristics/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ItemCharacteristics/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ItemCharacteristics/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ItemCharacteristics/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ItemCharacteristics/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentSubTest/GradeLevels/GradeLevel/Code | AssessmentSubTest/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentSubTest/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentSubTest/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AssessmentSubTest/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentSubTest/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AssessmentSubTest/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentSubTest/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AssessmentSubTest/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentSubTest/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentSubTest/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentSubTest/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentSubTest/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentSubTest/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentAdministration/SpecialConditions/SpecialCondition | AssessmentAdministration/Address/StateProvince | AssessmentAdministration/Address/StateANSICode | AssessmentAdministration/Address/Country | AssessmentAdministration/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentAdministration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AssessmentAdministration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentAdministration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AssessmentAdministration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentAdministration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AssessmentAdministration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentAdministration/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentAdministration/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentAdministration/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentAdministration/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentAdministration/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentForm/AssessmentType | AssessmentForm/GradeLevels/GradeLevel/Code | AssessmentForm/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentForm/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentForm/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AssessmentForm/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentForm/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AssessmentForm/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentForm/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AssessmentForm/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentForm/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentForm/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentForm/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentForm/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentForm/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentRegistration/StudentSpecialConditions/StudentSpecialCondition | AssessmentRegistration/StudentGradeLevel/Code | AssessmentRegistration/StudentGradeLevel/OtherCodeList/OtherCode | AssessmentRegistration/AssessmentGradeLevel/Code | AssessmentRegistration/AssessmentGradeLevel/OtherCodeList/OtherCode | AssessmentRegistration/AssessmentStudentSnapshot/RaceList/Race/Code | AssessmentRegistration/AssessmentStudentSnapshot/RaceList/Race/OtherCodeList/OtherCode | AssessmentRegistration/AssessmentStudentSnapshot/HispanicLatino | AssessmentRegistration/AssessmentStudentSnapshot/Gender | AssessmentRegistration/AssessmentStudentSnapshot/Title1 | AssessmentRegistration/AssessmentStudentSnapshot/ELL | AssessmentRegistration/StudentParticipation/Indicator | AssessmentRegistration/StudentParticipation/ReasonNotCompleting | AssessmentRegistration/StudentParticipation/ReasonNotTested | AssessmentRegistration/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentRegistration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AssessmentRegistration/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentRegistration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AssessmentRegistration/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentRegistration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AssessmentRegistration/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentRegistration/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentRegistration/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentRegistration/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentRegistration/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentRegistration/SIF_ExtendedElements/SIF_ExtendedElement | StudentResponseSet/Items/Item/ResponseStatus | StudentResponseSet/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentResponseSet/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentResponseSet/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentResponseSet/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentResponseSet/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentResponseSet/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentResponseSet/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentResponseSet/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentResponseSet/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentResponseSet/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentResponseSet/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentResponseSet/SIF_ExtendedElements/SIF_ExtendedElement | StudentScoreSet/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentScoreSet/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentScoreSet/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentScoreSet/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentScoreSet/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentScoreSet/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentScoreSet/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentScoreSet/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentScoreSet/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentScoreSet/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentScoreSet/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentScoreSet/SIF_ExtendedElements/SIF_ExtendedElement | AssessmentPackage/XMLData | AssessmentPackage/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AssessmentPackage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AssessmentPackage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AssessmentPackage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AssessmentPackage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AssessmentPackage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AssessmentPackage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AssessmentPackage/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AssessmentPackage/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AssessmentPackage/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AssessmentPackage/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AssessmentPackage/SIF_ExtendedElements/SIF_ExtendedElement | LearningStandardDocument/Source | LearningStandardDocument/SubjectAreas/SubjectArea/Code | LearningStandardDocument/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningStandardDocument/DocumentStatus | LearningStandardDocument/GradeLevels/GradeLevel/Code | LearningStandardDocument/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardDocument/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LearningStandardDocument/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LearningStandardDocument/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardDocument/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LearningStandardDocument/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningStandardDocument/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LearningStandardDocument/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LearningStandardDocument/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LearningStandardDocument/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LearningStandardDocument/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LearningStandardDocument/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LearningStandardDocument/SIF_ExtendedElements/SIF_ExtendedElement | LearningStandardItem/StandardSettingBody/Country | LearningStandardItem/StandardSettingBody/StateProvince | LearningStandardItem/GradeLevels/GradeLevel/Code | LearningStandardItem/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardItem/SubjectArea/Code | LearningStandardItem/SubjectArea/OtherCodeList/OtherCode | LearningStandardItem/StandardIdentifier/SubjectArea/Code | LearningStandardItem/StandardIdentifier/SubjectArea/OtherCodeList/OtherCode | LearningStandardItem/StandardIdentifier/GradeLevels/GradeLevel/Code | LearningStandardItem/StandardIdentifier/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardItem/StandardIdentifier/GradeLevel/Code | LearningStandardItem/StandardIdentifier/GradeLevel/OtherCodeList/OtherCode | LearningStandardItem/RelatedLearningStandardItems/LearningStandardItemRefId | LearningStandardItem/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LearningStandardItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LearningStandardItem/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LearningStandardItem/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningStandardItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LearningStandardItem/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LearningStandardItem/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LearningStandardItem/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LearningStandardItem/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LearningStandardItem/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LearningStandardItem/SIF_ExtendedElements/SIF_ExtendedElement | CurriculumStructure/SubjectArea/Code | CurriculumStructure/SubjectArea/OtherCodeList/OtherCode | CurriculumStructure/ComponentObjects/ComponentObject | CurriculumStructure/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | CurriculumStructure/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | CurriculumStructure/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | CurriculumStructure/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | CurriculumStructure/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | CurriculumStructure/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | CurriculumStructure/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | CurriculumStructure/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | CurriculumStructure/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | CurriculumStructure/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | CurriculumStructure/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | CurriculumStructure/SIF_ExtendedElements/SIF_ExtendedElement | Lesson/SourceObjects/SourceObject | Lesson/SubjectArea/Code | Lesson/SubjectArea/OtherCodeList/OtherCode | Lesson/Duration | Lesson/LessonSources/LessonSource/Author/Address/StateProvince | Lesson/LessonSources/LessonSource/Author/Address/StateANSICode | Lesson/LessonSources/LessonSource/Author/Address/Country | Lesson/LessonSources/LessonSource/Author/Email | Lesson/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Lesson/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Lesson/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Lesson/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Lesson/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Lesson/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Lesson/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Lesson/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Lesson/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Lesson/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Lesson/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Lesson/SIF_ExtendedElements/SIF_ExtendedElement | Activity/SubjectArea/Code | Activity/SubjectArea/OtherCodeList/OtherCode | Activity/SourceObjects/SourceObject | Activity/ActivityTime/Duration | Activity/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Activity/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Activity/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Activity/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Activity/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Activity/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Activity/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Activity/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Activity/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Activity/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Activity/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Activity/SIF_ExtendedElements/SIF_ExtendedElement | Assignment/SourceObjects/SourceObject | Assignment/AssignmentTime/Duration | Assignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Assignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Assignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Assignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Assignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Assignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Assignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Assignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Assignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Assignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Assignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Assignment/SIF_ExtendedElements/SIF_ExtendedElement | LearningResource/Contacts/Contact/Address/StateProvince | LearningResource/Contacts/Contact/Address/StateANSICode | LearningResource/Contacts/Contact/Address/Country | LearningResource/Contacts/Contact/Email | LearningResource/Location | LearningResource/GradeLevels/GradeLevel/Code | LearningResource/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningResource/SubjectAreas/SubjectArea/Code | LearningResource/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningResource/Components/Component/AssociatedObjects/AssociatedObject | LearningResource/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LearningResource/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LearningResource/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningResource/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LearningResource/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningResource/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LearningResource/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LearningResource/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LearningResource/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LearningResource/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LearningResource/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LearningResource/SIF_ExtendedElements/SIF_ExtendedElement | ContentCatalog/ContentObject/SourceObject | ContentCatalog/ContentObject/Location | ContentCatalog/LanguageCode | ContentCatalog/GradeLevels/GradeLevel/Code | ContentCatalog/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ContentCatalog/SubjectAreas/SubjectArea/Code | ContentCatalog/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ContentCatalog/LearningStandards/Document/StandardsSettingBody/Country | ContentCatalog/LearningStandards/Document/StandardsSettingBody/StateProvince | ContentCatalog/InstructionalLevel | ContentCatalog/Duration | ContentCatalog/Cost | ContentCatalog/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ContentCatalog/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ContentCatalog/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ContentCatalog/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ContentCatalog/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ContentCatalog/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ContentCatalog/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ContentCatalog/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ContentCatalog/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ContentCatalog/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ContentCatalog/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ContentCatalog/SIF_ExtendedElements/SIF_ExtendedElement | PersonRoleAssociation/AssociatedRoleRefId | PersonRoleAssociation/Creator | PersonRoleAssociation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | PersonRoleAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | PersonRoleAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | PersonRoleAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | PersonRoleAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | PersonRoleAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | PersonRoleAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | PersonRoleAssociation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | PersonRoleAssociation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | PersonRoleAssociation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | PersonRoleAssociation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | PersonRoleAssociation/SIF_ExtendedElements/SIF_ExtendedElement | ResponseToIntervention/Interventions/Intervention/InterventionType | ResponseToIntervention/Interventions/Intervention/InterventionDelivery | ResponseToIntervention/SubjectArea/Code | ResponseToIntervention/SubjectArea/OtherCodeList/OtherCode | ResponseToIntervention/Measurements/Measurement/FrequencyofMeasure | ResponseToIntervention/FrequencyTime/Duration | ResponseToIntervention/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | ResponseToIntervention/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | ResponseToIntervention/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | ResponseToIntervention/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | ResponseToIntervention/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | ResponseToIntervention/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | ResponseToIntervention/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | ResponseToIntervention/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | ResponseToIntervention/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | ResponseToIntervention/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | ResponseToIntervention/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | ResponseToIntervention/SIF_ExtendedElements/SIF_ExtendedElement | RTIResults/Measurements/Measurement/FrequencyofMeasure | RTIResults/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | RTIResults/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | RTIResults/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | RTIResults/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | RTIResults/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | RTIResults/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | RTIResults/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | RTIResults/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | RTIResults/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | RTIResults/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | RTIResults/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | RTIResults/SIF_ExtendedElements/SIF_ExtendedElement | LearningStandardAssociation/LearningStandardRefId | LearningStandardAssociation/Creator | LearningStandardAssociation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LearningStandardAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LearningStandardAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LearningStandardAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LearningStandardAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LearningStandardAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LearningStandardAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LearningStandardAssociation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LearningStandardAssociation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LearningStandardAssociation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LearningStandardAssociation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LearningStandardAssociation/SIF_ExtendedElements/SIF_ExtendedElement | LibraryPatronStatus/ElectronicIdList/ElectronicId | LibraryPatronStatus/TransactionList/Transaction/ItemInfo/ElectronicId | LibraryPatronStatus/TransactionList/Transaction/ItemInfo/Price | LibraryPatronStatus/TransactionList/Transaction/FineInfoList/FineInfo/Amount | LibraryPatronStatus/FineAmount | LibraryPatronStatus/RefundAmount | LibraryPatronStatus/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LibraryPatronStatus/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LibraryPatronStatus/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LibraryPatronStatus/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LibraryPatronStatus/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LibraryPatronStatus/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LibraryPatronStatus/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LibraryPatronStatus/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LibraryPatronStatus/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LibraryPatronStatus/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LibraryPatronStatus/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LibraryPatronStatus/SIF_ExtendedElements/SIF_ExtendedElement | Address/AddressType | Address/LocalId/IdType | Address/Subregion | Address/StateProvince | Address/Country | StudentProgramAssociation/EntryType | StudentProgramAssociation/YearGroup | StudentProgramAssociation/ExitStatus | StudentProgramAssociation/ExitType | StudentProgramAssociation/PlacementType | StudentProgramAssociation/ManagingSchoolLocalId/IdType | StudentActivityInfo/StudentActivityType/Code | StudentActivityInfo/StudentActivityType/OtherCodeList/OtherCode | StudentActivityInfo/GradeLevels/GradeLevel/Code | StudentActivityInfo/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentActivityInfo/CurricularStatus | StudentActivityInfo/Location/LocationRefId | StudentActivityInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentActivityInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentActivityInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentActivityInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentActivityInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentActivityInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentActivityInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentActivityInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentActivityInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentActivityInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentActivityInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentActivityInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentActivityParticipation/RecognitionList/Recognition | StudentActivityParticipation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentActivityParticipation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentActivityParticipation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentActivityParticipation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentActivityParticipation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentActivityParticipation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentActivityParticipation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentActivityParticipation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentActivityParticipation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentActivityParticipation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentActivityParticipation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentActivityParticipation/SIF_ExtendedElements/SIF_ExtendedElement | DisciplineIncident/AgencyReporting | DisciplineIncident/IncidentTime | DisciplineIncident/IncidentLocation | DisciplineIncident/IncidentLocationRefId | DisciplineIncident/IncidentReporter/SIF_RefId | DisciplineIncident/RelatedToList/RelatedTo | DisciplineIncident/WeaponTypeList/WeaponType | DisciplineIncident/IncidentCategory/Code | DisciplineIncident/IncidentCategory/OtherCodeList/OtherCode | DisciplineIncident/OffenderList/Offender/SIF_RefId | DisciplineIncident/OffenderList/Offender/Injury | DisciplineIncident/OffenderList/Offender/ManifestationDetermination/MeetingHeld | DisciplineIncident/OffenderList/Offender/ManifestationDetermination/DueToDisability | DisciplineIncident/OffenderList/Offender/ActionList/Action/Code | DisciplineIncident/OffenderList/Offender/ActionList/Action/OtherCodeList/OtherCode | DisciplineIncident/OffenderList/Offender/ActionList/Action/ZeroTolerance | DisciplineIncident/OffenderList/Offender/ActionList/Action/FullYearExpulsion | DisciplineIncident/OffenderList/Offender/ActionList/Action/ShortenedExpulsion | DisciplineIncident/OffenderList/Offender/ActionList/Action/PoliceNotification | DisciplineIncident/OffenderList/Offender/ActionList/Action/Arrest | DisciplineIncident/OffenderList/Offender/ActionList/Action/AlternativeEducation | DisciplineIncident/OffenderList/Offender/WeaponTypeList/WeaponType | DisciplineIncident/OffenderList/Offender/RelatedToList/RelatedTo | DisciplineIncident/VictimList/Victim/SIF_RefId | DisciplineIncident/VictimList/Victim/Injury | DisciplineIncident/IncidentActionList/IncidentAction/ZeroTolerance | DisciplineIncident/IncidentActionList/IncidentAction/PoliceNotification | DisciplineIncident/IncidentActionList/IncidentAction/Arrest | DisciplineIncident/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | DisciplineIncident/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | DisciplineIncident/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | DisciplineIncident/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | DisciplineIncident/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | DisciplineIncident/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | DisciplineIncident/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | DisciplineIncident/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | DisciplineIncident/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | DisciplineIncident/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | DisciplineIncident/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | DisciplineIncident/SIF_ExtendedElements/SIF_ExtendedElement | CalendarSummary/GradeLevels/GradeLevel/Code | CalendarSummary/GradeLevels/GradeLevel/OtherCodeList/OtherCode | CalendarSummary/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | CalendarSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | CalendarSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | CalendarSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | CalendarSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | CalendarSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | CalendarSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | CalendarSummary/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | CalendarSummary/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | CalendarSummary/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | CalendarSummary/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | CalendarSummary/SIF_ExtendedElements/SIF_ExtendedElement | CalendarDate/CalendarDateType/Code | CalendarDate/CalendarDateType/OtherCodeList/OtherCode | CalendarDate/StudentAttendance/CountsTowardAttendance | CalendarDate/TeacherAttendance/CountsTowardAttendance | CalendarDate/AdministratorAttendance/CountsTowardAttendance | CalendarDate/InstructionalDeliveryModeList/InstructionalDeliveryMode | CalendarDate/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | CalendarDate/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | CalendarDate/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | CalendarDate/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | CalendarDate/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | CalendarDate/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | CalendarDate/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | CalendarDate/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | CalendarDate/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | CalendarDate/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | CalendarDate/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | CalendarDate/SIF_ExtendedElements/SIF_ExtendedElement | StudentAttendanceSummary/Resident | StudentAttendanceSummary/InstructionalDeliveryModeList/InstructionalDeliveryMode | StudentAttendanceSummary/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentAttendanceSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentAttendanceSummary/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentAttendanceSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentAttendanceSummary/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentAttendanceSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentAttendanceSummary/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentAttendanceSummary/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentAttendanceSummary/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentAttendanceSummary/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentAttendanceSummary/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentAttendanceSummary/SIF_ExtendedElements/SIF_ExtendedElement | AttendanceCodeInfo/AttendanceType | AttendanceCodeInfo/AttendanceStatus | AttendanceCodeInfo/UsedForDailyAttendance | AttendanceCodeInfo/UsedForPeriodAttendance | AttendanceCodeInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | AttendanceCodeInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | AttendanceCodeInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | AttendanceCodeInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | AttendanceCodeInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | AttendanceCodeInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | AttendanceCodeInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | AttendanceCodeInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | AttendanceCodeInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | AttendanceCodeInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | AttendanceCodeInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | AttendanceCodeInfo/SIF_ExtendedElements/SIF_ExtendedElement | RoomInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | RoomInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | RoomInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | RoomInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | RoomInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | RoomInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | RoomInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | RoomInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | RoomInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | RoomInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | RoomInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | RoomInfo/SIF_ExtendedElements/SIF_ExtendedElement | RoomType/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | RoomType/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | RoomType/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | RoomType/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | RoomType/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | RoomType/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | RoomType/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | RoomType/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | RoomType/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | RoomType/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | RoomType/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | RoomType/SIF_ExtendedElements/SIF_ExtendedElement | SchoolCourseInfo/SubjectAreaList/SubjectArea/Code | SchoolCourseInfo/SubjectAreaList/SubjectArea/OtherCodeList/OtherCode | SchoolCourseInfo/InstructionalLevel/Code | SchoolCourseInfo/InstructionalLevel/OtherCodeList/OtherCode | SchoolCourseInfo/CourseCredits | SchoolCourseInfo/CoreAcademicCourse | SchoolCourseInfo/GraduationRequirement | SchoolCourseInfo/SCEDCode/CourseDescription | SchoolCourseInfo/SCEDCode/CourseLevel | SchoolCourseInfo/DualCredit | SchoolCourseInfo/CTEConcentrator | SchoolCourseInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SchoolCourseInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | SchoolCourseInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SchoolCourseInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | SchoolCourseInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SchoolCourseInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | SchoolCourseInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SchoolCourseInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SchoolCourseInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SchoolCourseInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SchoolCourseInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SchoolCourseInfo/SIF_ExtendedElements/SIF_ExtendedElement | SchoolInfo/StateProvinceIdSystem | SchoolInfo/OtherLEA | SchoolInfo/SchoolType | SchoolInfo/SchoolFocusList/SchoolFocus | SchoolInfo/SchoolContactList/SchoolContact/PublishInDirectory | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/Address/StateProvince | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/Address/StateANSICode | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/Address/Country | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | SchoolInfo/SchoolContactList/SchoolContact/ContactInfo/EmailList/Email | SchoolInfo/AddressList/Address/StateProvince | SchoolInfo/AddressList/Address/StateANSICode | SchoolInfo/AddressList/Address/Country | SchoolInfo/AddressRefIdList/AddressRefId | SchoolInfo/IdentificationInfoList/IdentificationInfo | SchoolInfo/SessionType | SchoolInfo/GradeLevels/GradeLevel/Code | SchoolInfo/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SchoolInfo/Title1Status | SchoolInfo/TitleIProgramType | SchoolInfo/OperationalStatus | SchoolInfo/SchoolImprovementStatus | SchoolInfo/StatePovertyDesignation | SchoolInfo/NationalSchoolLunchProgramStatus | SchoolInfo/SchoolCharter/ApprovalAgencyType | SchoolInfo/SchoolCharter/ManagementOrganizationType | SchoolInfo/SharedTimeIndicator | SchoolInfo/VirtualSchoolStatus | SchoolInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SchoolInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | SchoolInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SchoolInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | SchoolInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SchoolInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | SchoolInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SchoolInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SchoolInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SchoolInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SchoolInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SchoolInfo/SIF_ExtendedElements/SIF_ExtendedElement | SectionInfo/MediumOfInstruction/Code | SectionInfo/MediumOfInstruction/OtherCodeList/OtherCode | SectionInfo/InstructionalDeliveryModeList/InstructionalDeliveryMode | SectionInfo/LanguageOfInstruction/Code | SectionInfo/LanguageOfInstruction/OtherCodeList/OtherCode | SectionInfo/LocationOfInstruction/Code | SectionInfo/LocationOfInstruction/OtherCodeList/OtherCode | SectionInfo/SummerSchool | SectionInfo/SchoolCourseInfoOverride/SubjectArea/Code | SectionInfo/SchoolCourseInfoOverride/SubjectArea/OtherCodeList/OtherCode | SectionInfo/SchoolCourseInfoOverride/InstructionalLevel/Code | SectionInfo/SchoolCourseInfoOverride/InstructionalLevel/OtherCodeList/OtherCode | SectionInfo/SchoolCourseInfoOverride/CourseCredits | SectionInfo/CountForAttendance | SectionInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SectionInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | SectionInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SectionInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | SectionInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SectionInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | SectionInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SectionInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SectionInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SectionInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SectionInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SectionInfo/SIF_ExtendedElements/SIF_ExtendedElement | StaffPersonal/ElectronicIdList/ElectronicId | StaffPersonal/OtherIdList/OtherId | StaffPersonal/Demographics/RaceList/Race/Code | StaffPersonal/Demographics/RaceList/Race/OtherCodeList/OtherCode | StaffPersonal/Demographics/HispanicLatino | StaffPersonal/Demographics/Gender | StaffPersonal/Demographics/BirthDateVerification | StaffPersonal/Demographics/StateOfBirth | StaffPersonal/Demographics/CountryOfBirth | StaffPersonal/Demographics/CountriesOfCitizenship/CountryOfCitizenship | StaffPersonal/Demographics/CountriesOfResidency/CountryOfResidency | StaffPersonal/Demographics/CitizenshipStatus | StaffPersonal/Demographics/EnglishProficiency/Code | StaffPersonal/Demographics/EnglishProficiency/OtherCodeList/OtherCode | StaffPersonal/Demographics/LanguageList/Language/Code | StaffPersonal/Demographics/LanguageList/Language/OtherCodeList/OtherCode | StaffPersonal/Demographics/LanguageList/Language/LanguageType | StaffPersonal/Demographics/DwellingArrangement/Code | StaffPersonal/Demographics/DwellingArrangement/OtherCodeList/OtherCode | StaffPersonal/AddressList/Address/StateProvince | StaffPersonal/AddressList/Address/StateANSICode | StaffPersonal/AddressList/Address/Country | StaffPersonal/AddressRefIdList/AddressRefId | StaffPersonal/EmailList/Email | StaffPersonal/EmailList/Email | StaffPersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StaffPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StaffPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StaffPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffPersonal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffPersonal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffPersonal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffPersonal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffPersonal/SIF_ExtendedElements/SIF_ExtendedElement | StudentContact/OtherIdList/OtherId | StudentContact/Demographics/RaceList/Race/Code | StudentContact/Demographics/RaceList/Race/OtherCodeList/OtherCode | StudentContact/Demographics/HispanicLatino | StudentContact/Demographics/Gender | StudentContact/Demographics/BirthDateVerification | StudentContact/Demographics/StateOfBirth | StudentContact/Demographics/CountryOfBirth | StudentContact/Demographics/CountriesOfCitizenship/CountryOfCitizenship | StudentContact/Demographics/CountriesOfResidency/CountryOfResidency | StudentContact/Demographics/CitizenshipStatus | StudentContact/Demographics/EnglishProficiency/Code | StudentContact/Demographics/EnglishProficiency/OtherCodeList/OtherCode | StudentContact/Demographics/LanguageList/Language/Code | StudentContact/Demographics/LanguageList/Language/OtherCodeList/OtherCode | StudentContact/Demographics/LanguageList/Language/LanguageType | StudentContact/Demographics/DwellingArrangement/Code | StudentContact/Demographics/DwellingArrangement/OtherCodeList/OtherCode | StudentContact/AddressList/Address/StateProvince | StudentContact/AddressList/Address/StateANSICode | StudentContact/AddressList/Address/Country | StudentContact/EmailList/Email | StudentContact/EmailList/Email | StudentContact/Relationship/Code | StudentContact/Relationship/OtherCodeList/OtherCode | StudentContact/EmployerType | StudentContact/EducationalLevel | StudentContact/ContactFlags/ParentLegalGuardian | StudentContact/ContactFlags/PickupRights | StudentContact/ContactFlags/LivesWith | StudentContact/ContactFlags/AccessToRecords | StudentContact/ContactFlags/EmergencyContact | StudentContact/ContactFlags/HasCustody | StudentContact/ContactFlags/DisciplinaryContact | StudentContact/ContactFlags/PrimaryCareProvider | StudentContact/ContactFlags/Other | StudentContact/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentContact/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentContact/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentContact/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentContact/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentContact/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentContact/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentContact/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentContact/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentContact/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentContact/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentContact/SIF_ExtendedElements/SIF_ExtendedElement | StudentDailyAttendance/InstructionalDeliveryMode | StudentDailyAttendance/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentDailyAttendance/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentDailyAttendance/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentDailyAttendance/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentDailyAttendance/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentDailyAttendance/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentDailyAttendance/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentDailyAttendance/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentDailyAttendance/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentDailyAttendance/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentDailyAttendance/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentDailyAttendance/SIF_ExtendedElements/SIF_ExtendedElement | StudentPersonal/AlertMessages/AlertMessage | StudentPersonal/MedicalAlertMessages/MedicalAlertMessage | StudentPersonal/ElectronicIdList/ElectronicId | StudentPersonal/OtherIdList/OtherId | StudentPersonal/Demographics/RaceList/Race/Code | StudentPersonal/Demographics/RaceList/Race/OtherCodeList/OtherCode | StudentPersonal/Demographics/HispanicLatino | StudentPersonal/Demographics/Gender | StudentPersonal/Demographics/BirthDateVerification | StudentPersonal/Demographics/StateOfBirth | StudentPersonal/Demographics/CountryOfBirth | StudentPersonal/Demographics/CountriesOfCitizenship/CountryOfCitizenship | StudentPersonal/Demographics/CountriesOfResidency/CountryOfResidency | StudentPersonal/Demographics/CitizenshipStatus | StudentPersonal/Demographics/EnglishProficiency/Code | StudentPersonal/Demographics/EnglishProficiency/OtherCodeList/OtherCode | StudentPersonal/Demographics/LanguageList/Language/Code | StudentPersonal/Demographics/LanguageList/Language/OtherCodeList/OtherCode | StudentPersonal/Demographics/LanguageList/Language/LanguageType | StudentPersonal/Demographics/DwellingArrangement/Code | StudentPersonal/Demographics/DwellingArrangement/OtherCodeList/OtherCode | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/PrimaryLearningDevice | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/PrimaryLearningDeviceAccess | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/PrimaryLearningDeviceProvider | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/InternetAccess | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/InternetAccessBarrier | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/InternetAccessType | StudentPersonal/RemoteLearningLocationProfileList/RemoteLearningLocationProfile/InternetPerformance | StudentPersonal/AddressList/Address/StateProvince | StudentPersonal/AddressList/Address/StateANSICode | StudentPersonal/AddressList/Address/Country | StudentPersonal/AddressRefIdList/AddressRefId | StudentPersonal/EmailList/Email | StudentPersonal/EmailList/Email | StudentPersonal/MostRecent/GradeLevel/Code | StudentPersonal/MostRecent/GradeLevel/OtherCodeList/OtherCode | StudentPersonal/AcceptableUsePolicy | StudentPersonal/IDEA | StudentPersonal/Migrant | StudentPersonal/Title1 | StudentPersonal/GiftedTalented | StudentPersonal/EconomicDisadvantage | StudentPersonal/ELL | StudentPersonal/Homeless | StudentPersonal/HomelessServicedIndicator | StudentPersonal/Section504 | StudentPersonal/VocationalConcentrator | StudentPersonal/Immigrant | StudentPersonal/NeglectedDelinquent | StudentPersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentPersonal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentPersonal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentPersonal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentPersonal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentPersonal/SIF_ExtendedElements/SIF_ExtendedElement | StudentPicture/PictureSource | StudentPicture/OKToPublish | StudentPicture/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentPicture/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentPicture/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentPicture/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentPicture/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentPicture/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentPicture/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentPicture/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentPicture/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentPicture/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentPicture/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentPicture/SIF_ExtendedElements/SIF_ExtendedElement | StudentSchoolEnrollment/EntryType/Code | StudentSchoolEnrollment/EntryType/OtherCodeList/OtherCode | StudentSchoolEnrollment/GradeLevel/Code | StudentSchoolEnrollment/GradeLevel/OtherCodeList/OtherCode | StudentSchoolEnrollment/Homeroom | StudentSchoolEnrollment/Advisor | StudentSchoolEnrollment/Counselor | StudentSchoolEnrollment/Calendar | StudentSchoolEnrollment/ExitStatus/Code | StudentSchoolEnrollment/ExitStatus/OtherCodeList/OtherCode | StudentSchoolEnrollment/ExitType/Code | StudentSchoolEnrollment/ExitType/OtherCodeList/OtherCode | StudentSchoolEnrollment/ExitGradeLevel/Code | StudentSchoolEnrollment/ExitGradeLevel/OtherCodeList/OtherCode | StudentSchoolEnrollment/RecordClosureReason | StudentSchoolEnrollment/PromotionInfo/PromotionStatus | StudentSchoolEnrollment/PromotionInfo/Promotion/Code | StudentSchoolEnrollment/PromotionInfo/Promotion/OtherCodeList/OtherCode | StudentSchoolEnrollment/PromotionInfo/Nonpromotion/Code | StudentSchoolEnrollment/PromotionInfo/Nonpromotion/OtherCodeList/OtherCode | StudentSchoolEnrollment/FTPTStatus | StudentSchoolEnrollment/ResidencyStatus/Code | StudentSchoolEnrollment/ResidencyStatus/OtherCodeList/OtherCode | StudentSchoolEnrollment/NonResidentAttendReason | StudentSchoolEnrollment/ResponsableSchoolList/ResponsableSchool/Type | StudentSchoolEnrollment/ResponsableLEAList/ResponsableLEA/Type | StudentSchoolEnrollment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSchoolEnrollment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSchoolEnrollment/SIF_ExtendedElements/SIF_ExtendedElement | StudentSectionEnrollment/InstructionalDeliveryModeList/InstructionalDeliveryMode | StudentSectionEnrollment/CreditsAttempted | StudentSectionEnrollment/DualCredit | StudentSectionEnrollment/CTEConcentrator | StudentSectionEnrollment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSectionEnrollment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentSectionEnrollment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSectionEnrollment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentSectionEnrollment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSectionEnrollment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentSectionEnrollment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSectionEnrollment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSectionEnrollment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSectionEnrollment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSectionEnrollment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSectionEnrollment/SIF_ExtendedElements/SIF_ExtendedElement | TermInfo/TermSpan/Code | TermInfo/TermSpan/OtherCodeList/OtherCode | TermInfo/MarkingTerm | TermInfo/SchedulingTerm | TermInfo/AttendanceTerm | TermInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | TermInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | TermInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | TermInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | TermInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | TermInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | TermInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | TermInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | TermInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | TermInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | TermInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | TermInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentSnapshot/Address/StateProvince | StudentSnapshot/Address/StateANSICode | StudentSnapshot/Address/Country | StudentSnapshot/RaceList/Race/Code | StudentSnapshot/RaceList/Race/OtherCodeList/OtherCode | StudentSnapshot/HispanicLatino | StudentSnapshot/Gender | StudentSnapshot/GraduationAward | StudentSnapshot/GraduationOnTime | StudentSnapshot/HomeEnrollment/Status | StudentSnapshot/HomeEnrollment/GradeLevel/Code | StudentSnapshot/HomeEnrollment/GradeLevel/OtherCodeList/OtherCode | StudentSnapshot/HomeEnrollment/Homeroom | StudentSnapshot/HomeEnrollment/FullYearEnrollment | StudentSnapshot/IDEA | StudentSnapshot/Migrant | StudentSnapshot/Title1 | StudentSnapshot/GiftedTalented | StudentSnapshot/EconomicDisadvantage | StudentSnapshot/ELL | StudentSnapshot/Homeless | StudentSnapshot/Section504 | StudentSnapshot/VocationalConcentrator | StudentSnapshot/Immigrant | StudentSnapshot/NeglectedDelinquent | StudentSnapshot/FreeAndReducedStatus | StudentSnapshot/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentSnapshot/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentSnapshot/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentSnapshot/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentSnapshot/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentSnapshot/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentSnapshot/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentSnapshot/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentSnapshot/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentSnapshot/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentSnapshot/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentSnapshot/SIF_ExtendedElements/SIF_ExtendedElement | LEAInfo/EducationAgencyType/Code | LEAInfo/EducationAgencyType/OtherCodeList/OtherCode | LEAInfo/LEAContactList/LEAContact/PublishInDirectory | LEAInfo/LEAContactList/LEAContact/ContactInfo/Address/StateProvince | LEAInfo/LEAContactList/LEAContact/ContactInfo/Address/StateANSICode | LEAInfo/LEAContactList/LEAContact/ContactInfo/Address/Country | LEAInfo/LEAContactList/LEAContact/ContactInfo/EmailList/Email | LEAInfo/LEAContactList/LEAContact/ContactInfo/EmailList/Email | LEAInfo/AddressList/Address/StateProvince | LEAInfo/AddressList/Address/StateANSICode | LEAInfo/AddressList/Address/Country | LEAInfo/AddressRefIdList/AddressRefId | LEAInfo/IdentificationInfoList/IdentificationInfo | LEAInfo/GradeLevels/GradeLevel/Code | LEAInfo/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LEAInfo/OperationalStatus | LEAInfo/TitleIProgramType | LEAInfo/TitleIIILanguageInstructionProgramType | LEAInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | LEAInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | LEAInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | LEAInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | LEAInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | LEAInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | LEAInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | LEAInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | LEAInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | LEAInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | LEAInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | LEAInfo/SIF_ExtendedElements/SIF_ExtendedElement | StaffAssignment/PrimaryAssignment | StaffAssignment/JobFunction/Code | StaffAssignment/JobFunction/OtherCodeList/OtherCode | StaffAssignment/TeachingAssignment/Code | StaffAssignment/TeachingAssignment/OtherCodeList/OtherCode | StaffAssignment/GradeLevels/GradeLevel/Code | StaffAssignment/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffAssignment/ItinerantTeacher | StaffAssignment/InstructionalLevel/Code | StaffAssignment/InstructionalLevel/OtherCodeList/OtherCode | StaffAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StaffAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StaffAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StaffAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffAssignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffAssignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffAssignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffAssignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffAssignment/SIF_ExtendedElements/SIF_ExtendedElement | BellSchedule/BellPeriodList/BellPeriod/RegularSchoolPeriod | BellSchedule/BellPeriodList/BellPeriod/UseInAttendanceCalculations | BellSchedule/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BellSchedule/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BellSchedule/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BellSchedule/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BellSchedule/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BellSchedule/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BellSchedule/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BellSchedule/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BellSchedule/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BellSchedule/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BellSchedule/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BellSchedule/SIF_ExtendedElements/SIF_ExtendedElement | StudentContactPersonal/PersonInfo/OtherIdList/OtherId | StudentContactPersonal/PersonInfo/Demographics/RaceList/Race/Code | StudentContactPersonal/PersonInfo/Demographics/RaceList/Race/OtherCodeList/OtherCode | StudentContactPersonal/PersonInfo/Demographics/HispanicLatino | StudentContactPersonal/PersonInfo/Demographics/Gender | StudentContactPersonal/PersonInfo/Demographics/BirthDateVerification | StudentContactPersonal/PersonInfo/Demographics/StateOfBirth | StudentContactPersonal/PersonInfo/Demographics/CountryOfBirth | StudentContactPersonal/PersonInfo/Demographics/CountriesOfCitizenship/CountryOfCitizenship | StudentContactPersonal/PersonInfo/Demographics/CountriesOfResidency/CountryOfResidency | StudentContactPersonal/PersonInfo/Demographics/CitizenshipStatus | StudentContactPersonal/PersonInfo/Demographics/EnglishProficiency/Code | StudentContactPersonal/PersonInfo/Demographics/EnglishProficiency/OtherCodeList/OtherCode | StudentContactPersonal/PersonInfo/Demographics/LanguageList/Language/Code | StudentContactPersonal/PersonInfo/Demographics/LanguageList/Language/OtherCodeList/OtherCode | StudentContactPersonal/PersonInfo/Demographics/LanguageList/Language/LanguageType | StudentContactPersonal/PersonInfo/Demographics/DwellingArrangement/Code | StudentContactPersonal/PersonInfo/Demographics/DwellingArrangement/OtherCodeList/OtherCode | StudentContactPersonal/PersonInfo/AddressList/Address/StateProvince | StudentContactPersonal/PersonInfo/AddressList/Address/StateANSICode | StudentContactPersonal/PersonInfo/AddressList/Address/Country | StudentContactPersonal/PersonInfo/EmailList/Email | StudentContactPersonal/PersonInfo/EmailList/Email | StudentContactPersonal/EmployerType | StudentContactPersonal/EducationLevel | StudentContactPersonal/OptOutEmail | StudentContactPersonal/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentContactPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentContactPersonal/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentContactPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentContactPersonal/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentContactPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentContactPersonal/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentContactPersonal/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentContactPersonal/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentContactPersonal/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentContactPersonal/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentContactPersonal/SIF_ExtendedElements/SIF_ExtendedElement | StudentContactRelationship/Relationship/Code | StudentContactRelationship/Relationship/OtherCodeList/OtherCode | StudentContactRelationship/ContactFlags/ParentLegalGuardian | StudentContactRelationship/ContactFlags/PickupRights | StudentContactRelationship/ContactFlags/LivesWith | StudentContactRelationship/ContactFlags/AccessToRecords | StudentContactRelationship/ContactFlags/EmergencyContact | StudentContactRelationship/ContactFlags/HasCustody | StudentContactRelationship/ContactFlags/DisciplinaryContact | StudentContactRelationship/ContactFlags/PrimaryCareProvider | StudentContactRelationship/ContactFlags/Other | StudentContactRelationship/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentContactRelationship/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentContactRelationship/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentContactRelationship/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentContactRelationship/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentContactRelationship/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentContactRelationship/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentContactRelationship/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentContactRelationship/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentContactRelationship/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentContactRelationship/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentContactRelationship/SIF_ExtendedElements/SIF_ExtendedElement | StaffSectionAssignment/TeacherOfRecord | StaffSectionAssignment/Roles/Role | StaffSectionAssignment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffSectionAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StaffSectionAssignment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffSectionAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StaffSectionAssignment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffSectionAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StaffSectionAssignment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffSectionAssignment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffSectionAssignment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffSectionAssignment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffSectionAssignment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffSectionAssignment/SIF_ExtendedElements/SIF_ExtendedElement | StaffEvaluation/EvaluationRecommendation/OtherCodeList/OtherCode | StaffEvaluation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StaffEvaluation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StaffEvaluation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StaffEvaluation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StaffEvaluation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StaffEvaluation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StaffEvaluation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StaffEvaluation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StaffEvaluation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StaffEvaluation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StaffEvaluation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StaffEvaluation/SIF_ExtendedElements/SIF_ExtendedElement | SectionCorrelation/CorrelationType/Code | SectionCorrelation/CorrelationType/OtherCodeList/OtherCode | SectionCorrelation/CorrelationSectionList/CorrelationSection | SectionCorrelation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | SectionCorrelation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | SectionCorrelation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | SectionCorrelation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | SectionCorrelation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | SectionCorrelation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | SectionCorrelation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | SectionCorrelation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | SectionCorrelation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | SectionCorrelation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | SectionCorrelation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | SectionCorrelation/SIF_ExtendedElements/SIF_ExtendedElement | SchoolAccountability/GunFreeSchoolsActReportingStatus | SchoolAccountability/HighSchoolGraduationRateIndicatorStatus | SchoolAccountability/PersistentlyDangerousStatus | SchoolAccountability/ProficiencyTargetStatusForMath | SchoolAccountability/ProficiencyTargetStatusForReadingAndLanguageArts | SchoolAccountability/SchoolOperationalStatus | SchoolAccountability/ReconstitutedStatus | SchoolAccountability/SchoolImprovementFundsStatus | LEAAccountability/GunFreeSchoolsActReportingStatus | SchoolFederalFund/ConsolidatedMEPFundsStatus | SchoolFederalFund/SchoolImprovementGrantInterventionType | StudentMigrant/ServicesType | StudentMigrant/PrioritizedForServices | StudentMigrant/ContinuationOfServicesReason | StudentMigrant/ContinuationOfServicesStatus | StudentMigrant/EnrollmentType | StudentMigrant/ParticipationStatus | BusEquipment/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusEquipment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BusEquipment/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusEquipment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BusEquipment/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusEquipment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BusEquipment/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusEquipment/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusEquipment/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusEquipment/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusEquipment/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusEquipment/SIF_ExtendedElements/SIF_ExtendedElement | BusInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BusInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BusInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BusInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusInfo/SIF_ExtendedElements/SIF_ExtendedElement | BusRouteDetail/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusRouteDetail/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BusRouteDetail/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusRouteDetail/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BusRouteDetail/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusRouteDetail/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BusRouteDetail/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusRouteDetail/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusRouteDetail/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusRouteDetail/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusRouteDetail/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusRouteDetail/SIF_ExtendedElements/SIF_ExtendedElement | BusRouteInfo/RouteType | BusRouteInfo/RouteDistanceLoaded | BusRouteInfo/RouteDistanceTotal | BusRouteInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusRouteInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BusRouteInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusRouteInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BusRouteInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusRouteInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BusRouteInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusRouteInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusRouteInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusRouteInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusRouteInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusRouteInfo/SIF_ExtendedElements/SIF_ExtendedElement | BusStopInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusStopInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BusStopInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusStopInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BusStopInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusStopInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BusStopInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusStopInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusStopInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusStopInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusStopInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusStopInfo/SIF_ExtendedElements/SIF_ExtendedElement | StudentTransportInfo/Eligibility | StudentTransportInfo/HomeToSchoolDistance | StudentTransportInfo/WalkToStopDistance | StudentTransportInfo/StopToSchoolDistance | StudentTransportInfo/HomeBusRouteDetail | StudentTransportInfo/TransferPoints/TransferPoint/EmbarkBusRouteDetail | StudentTransportInfo/TransferPoints/TransferPoint/DisembarkBusRouteDetail | StudentTransportInfo/SchoolBusRouteDetail | StudentTransportInfo/StateAidQualification | StudentTransportInfo/TransportationStatus | StudentTransportInfo/PublicExpense | StudentTransportInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | StudentTransportInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | StudentTransportInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | StudentTransportInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | StudentTransportInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | StudentTransportInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | StudentTransportInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | StudentTransportInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | StudentTransportInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | StudentTransportInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | StudentTransportInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | StudentTransportInfo/SIF_ExtendedElements/SIF_ExtendedElement | BusPositionInfo/BusDriver/Status | BusPositionInfo/BusStaffList/BusStaff/Status | BusPositionInfo/Odometer | BusPositionInfo/Speedometer | BusPositionInfo/Students/Student/Status | BusPositionInfo/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | BusPositionInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | BusPositionInfo/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | BusPositionInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | BusPositionInfo/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | BusPositionInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | BusPositionInfo/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | BusPositionInfo/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | BusPositionInfo/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | BusPositionInfo/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | BusPositionInfo/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | BusPositionInfo/SIF_ExtendedElements/SIF_ExtendedElement | Authentication/AuthenticationInfo/System | Authentication/AuthenticationInfo/PasswordList/Password | Authentication/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | Authentication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | Authentication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | Authentication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | Authentication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | Authentication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | Authentication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | Authentication/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | Authentication/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | Authentication/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | Authentication/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | Authentication/SIF_ExtendedElements/SIF_ExtendedElement | EnergyUsage/UsageLocationInfo/EnergyZone/Type/Facility | EnergyUsage/DataSource/ReadingDataList/ReadingData/Measurement | EnergyUsage/DataSource/ReadingDataList/ReadingData/EnergyUnits | EnergyUsage/DataSource/ReadingDataList/ReadingData/ReadingList/Reading | EnergyUsage/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | EnergyUsage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | EnergyUsage/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | EnergyUsage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | EnergyUsage/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | EnergyUsage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | EnergyUsage/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | EnergyUsage/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | EnergyUsage/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | EnergyUsage/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | EnergyUsage/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | EnergyUsage/SIF_ExtendedElements/SIF_ExtendedElement | IdMApplication/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | IdMApplication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | IdMApplication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | IdMApplication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | IdMApplication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | IdMApplication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | IdMApplication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | IdMApplication/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | IdMApplication/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | IdMApplication/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | IdMApplication/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | IdMApplication/SIF_ExtendedElements/SIF_ExtendedElement | IdMAuthentication/IdentityProviderType | IdMAuthentication/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | IdMAuthentication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | IdMAuthentication/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | IdMAuthentication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | IdMAuthentication/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | IdMAuthentication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | IdMAuthentication/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | IdMAuthentication/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | IdMAuthentication/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | IdMAuthentication/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | IdMAuthentication/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | IdMAuthentication/SIF_ExtendedElements/SIF_ExtendedElement | IdMAuthorization/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | IdMAuthorization/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | IdMAuthorization/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | IdMAuthorization/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | IdMAuthorization/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | IdMAuthorization/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | IdMAuthorization/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | IdMAuthorization/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | IdMAuthorization/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | IdMAuthorization/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | IdMAuthorization/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | IdMAuthorization/SIF_ExtendedElements/SIF_ExtendedElement | UserOrganizationAssociation/PersonRefId | UserOrganizationAssociation/OrganizationRefId | UserOrganizationAssociation/SIF_Metadata/RightsElements/RightsElement/FeesForUse/FeeForUse/PerUseCharge | UserOrganizationAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/Code | UserOrganizationAssociation/SIF_Metadata/EducationFilter/GradeLevels/GradeLevel/OtherCodeList/OtherCode | UserOrganizationAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/Code | UserOrganizationAssociation/SIF_Metadata/EducationFilter/SubjectAreas/SubjectArea/OtherCodeList/OtherCode | UserOrganizationAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/Code | UserOrganizationAssociation/SIF_Metadata/EducationFilter/InterestLevels/InterestLevel/OtherCodeList/OtherCode | UserOrganizationAssociation/SIF_Metadata/EducationFilter/BloomsTaxonomyLevels/BloomsTaxonomyLevel | UserOrganizationAssociation/SIF_Metadata/EducationFilter/MultipleIntelligences/MultipleIntelligence | UserOrganizationAssociation/SIF_Metadata/EducationFilter/InstructionalStrategies/InstructionalStrategy | UserOrganizationAssociation/SIF_Metadata/EducationFilter/ResourceTypes/ResourceType | UserOrganizationAssociation/SIF_ExtendedElements/SIF_ExtendedElement | PersonPrivacyObligationDocument/LocationList/Location/LocationRefId" mode="obj-content">
    <xsl:text>{</xsl:text>
    <xsl:apply-templates select="@*" mode="attr" />
    <xsl:if test="count(@*) &gt; 0">, </xsl:if>
    <xsl:apply-templates select="./*" mode="detect" />
    <xsl:if test="count(child::*) = 0 and text()">
      <xsl:text>"value" : </xsl:text><xsl:apply-templates select="." mode="value"/>
    </xsl:if>
    <xsl:if test="count(child::*) = 0 and not(text())">
      <xsl:text>"value" : ""</xsl:text>
    </xsl:if>
    <xsl:text>}</xsl:text>
    <xsl:if test="position() &lt; last()">, </xsl:if>
  </xsl:template>

  <xsl:template match="@*" mode="attr">
    <xsl:text>"</xsl:text><xsl:value-of select="name()"/>" : <xsl:apply-templates select="." mode="attrvalue"/>
    <xsl:if test="position() &lt; last()">, </xsl:if>
  </xsl:template>

  <!-- https://github.com/bramstein/xsltjson/blob/master/conf/xml-to-jsonml.xsl -->
  <json:search name="string">
		<json:replace src="\" dst="\\"/>
		<json:replace src="&quot;" dst="\&quot;"/>
		<json:replace src="&#xA;" dst="\n"/>
		<json:replace src="&#xD;" dst="\r"/>
		<json:replace src="&#x9;" dst="\t"/>
		<json:replace src="\n" dst="\n"/>
		<json:replace src="\r" dst="\r"/>
		<json:replace src="\t" dst="\t"/>
  </json:search>

  <xsl:template name="replace-string">
		<xsl:param name="input"/>
		<xsl:param name="src"/>
		<xsl:param name="dst"/>
		<xsl:choose>
			<xsl:when test="contains($input, $src)">
				<xsl:value-of select="concat(substring-before($input, $src), $dst)"/>
				<xsl:call-template name="replace-string">
					<xsl:with-param name="input" select="substring-after($input, $src)"/>
					<xsl:with-param name="src" select="$src"/>
					<xsl:with-param name="dst" select="$dst"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$input"/>
			</xsl:otherwise>
		</xsl:choose>
  </xsl:template>

  <xsl:template name="encode">
		<xsl:param name="input"/>
		<xsl:param name="index">1</xsl:param>

		<xsl:variable name="text">
			<xsl:call-template name="replace-string">
				<xsl:with-param name="input" select="$input"/>
				<xsl:with-param name="src" select="document('')//json:search/json:replace[$index]/@src"/>
				<xsl:with-param name="dst" select="document('')//json:search/json:replace[$index]/@dst"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:choose>
			<xsl:when test="$index &lt; count(document('')//json:search/json:replace)">
				<xsl:call-template name="encode">
					<xsl:with-param name="input" select="$text"/>
					<xsl:with-param name="index" select="$index + 1"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
  </xsl:template>

  <xsl:template name="encode-value">
                <xsl:param name="value"/>
                <!--
                <xsl:choose>
                        <xsl:when test="normalize-space($value) != $value">
                -->
                <!-- no, we always call encode, because we escape  as well -->
                                <xsl:call-template name="encode">
                                        <xsl:with-param name="input" select="$value"/>
                                </xsl:call-template>
                <!--
                        </xsl:when>
                        <xsl:otherwise>
                                <xsl:value-of select="$value"/>
                        </xsl:otherwise>
                </xsl:choose>
                -->
  </xsl:template>

  <xsl:template match="node/@TEXT | text()" name="removeBreaks" priority="10">
    <xsl:call-template name="encode-value">
      <xsl:with-param name="value" select="." />
    </xsl:call-template>
  </xsl:template>

  <xsl:template name="encode-numeric-value">
                <xsl:param name="value"/>
                <xsl:choose>
                        <xsl:when test="substring(normalize-space($value), 1, 1) = '.'">
                                <xsl:text>0</xsl:text><xsl:value-of select="$value"/>
                        </xsl:when>
                        <xsl:otherwise>
                                <xsl:value-of select="$value"/>
                        </xsl:otherwise>
                </xsl:choose>
  </xsl:template>

</xsl:stylesheet>
